' ########################################################################################
' Microsoft Windows
' File: AfxGdiplus.bas
' Content: Gdi Plus wrapper functions
' Compiler: Ported to bc9Basic jcfuller 08/23/2016  
' Copyright (c) 2016 José Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
!typedef POINTF GpPointF ;
!typedef RectF GpRectF; 
Union GDIP_COLORMAP
	Type
		oldColor As COLORREF
		newColor As COLORREF
	End Type
	Type
		from As COLORREF
		to As COLORREF
	End Type
End Union

Union GDIP_BGRAU
	color As COLORREF
	Type
		blue As BYTE
		green As BYTE
		red As BYTE
		alpha As BYTE
	End Type
End Union

Type GDIP_PATHDATA
	Count As LONG
	Points As GpPointF Ptr
	Types As BYTE Ptr
End Type
'==============================================================================
$IFUSE USE_GDIP_ARGB
'------------------------------------------------------------------------------
' Returns an ARGB color value initialized with the specified values for the alpha, red,
' green, and blue components.
' ========================================================================================
FUNCTION GDIP_ARGB (a AS BYTE, r AS BYTE, g AS BYTE, b AS BYTE) AS COLORREF
	DIM AS GDIP_BGRAU clr 
	clr.alpha = a : clr.red   = r : clr.green = g : clr.blue  = b
	FUNCTION  = clr.color
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_GDIP_COLOR
'------------------------------------------------------------------------------
FUNCTION GDIP_COLOR (a AS BYTE, r AS BYTE, g AS BYTE, b AS BYTE) AS COLORREF
	DIM AS GDIP_BGRAU clr 
	clr.alpha = a : clr.red   = r : clr.green = g : clr.blue  = b
	FUNCTION  = clr.color
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_GDIP_XRGB
'------------------------------------------------------------------------------
' Returns an XRGB color value initialized with the specified values for the red, green,
' and blue components.
' ========================================================================================
FUNCTION GDIP_XRGB (r AS BYTE, g AS BYTE, b AS BYTE) AS COLORREF
	FUNCTION = GDIP_ARGB(0xFF, r, g, b)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_GDIP_BGRA
'------------------------------------------------------------------------------
' Returns a BGRA color value initialized with the specified values for the  blue, green,
' red and alpha components.
' ========================================================================================
FUNCTION GDIP_BGRA (b AS BYTE, g AS BYTE, r AS BYTE, a AS BYTE) AS COLORREF
	DIM AS GDIP_BGRAU clr
	clr.blue  = b : clr.green = g : clr.red   = r : clr.alpha = a
	FUNCTION  = clr.color
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_GDIP_RGBA
'------------------------------------------------------------------------------
' Returns an RGBA color value initialized with the specified values for the red, green,
' blue and alpha components.
' ========================================================================================
FUNCTION GDIP_RGBA (r AS BYTE, g AS BYTE, b AS BYTE, a AS BYTE) AS COLORREF
	FUNCTION = GDIP_ARGB(a, r, g, b)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_GDIP_GetAlpha
'------------------------------------------------------------------------------
' Returns the alpha component of an ARGB color.
' ========================================================================================
FUNCTION GDIP_GetAlpha ( argbcolor AS COLORREF) AS BYTE
	DIM AS GDIP_BGRAU clr 
	clr.color = argbcolor
	Function =  clr.alpha
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_GDIP_GetRed
'------------------------------------------------------------------------------
' Returns the red component of an ARGB color.
' ========================================================================================
FUNCTION GDIP_GetRed ( argbcolor AS COLORREF) AS BYTE
	DIM AS GDIP_BGRAU clr
	clr.color = argbcolor
	Function =  clr.red
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_GDIP_GetGreen
'------------------------------------------------------------------------------
' Returns the green component of an ARGB color.
' ========================================================================================
FUNCTION GDIP_GetGreen ( argbcolor AS COLORREF) AS BYTE
	DIM AS GDIP_BGRAU clr
	clr.color = argbcolor
	Function =  clr.green
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_GDIP_GetBlue
'------------------------------------------------------------------------------
' Returns the blue component of an ARGB color.
' ========================================================================================
FUNCTION GDIP_GetBlue ( argbcolor AS COLORREF) AS BYTE
	DIM AS GDIP_BGRAU clr
	clr.color = argbcolor
	Function = clr.blue
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_GDIP_RECTF
'------------------------------------------------------------------------------
' Fills a RECTF structure
' ========================================================================================
FUNCTION GDIP_RECTF ( x AS SINGLE, y AS SINGLE, nWidth AS SINGLE, nHeight AS SINGLE) AS GpRectF
	DIM AS GpRectF rcf
	rcf.x = x : rcf.y = y : rcf.Width = nWidth : rcf.Height = nHeight
	Function =  rcf
END FUNCTION

'------------------------------------------------------------------------------
$ENDUSE

