' ########################################################################################
' Microsoft Windows
' File: AfxTime.inc
' Contents: Date and time functions.
' Compiler: C/C++ Optimizing Compiler Version 19.00.23506 for x64
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
'Ported to bc9Basic -> c/c++ by James c. Fuller
$typedef double DATE_ 
'==============================================================================
$IFUSE USE_AfxLocalFileTime
'------------------------------------------------------------------------------
' Returns the current local time as a FILETIME structure.
' ========================================================================================
Function AfxLocalFileTime () AS FILETIME
	DIM AS SYSTEMTIME ST 
	Dim AS FILETIME FT 
	GetLocalTime(&ST)
	SystemTimeToFileTime( &ST, &FT)
	Function =  FT
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxLocalSystemTime
'------------------------------------------------------------------------------
' Returns the current local time as a SYSTEMTIME structure.
' ========================================================================================
Function AfxLocalSystemTime () AS SYSTEMTIME
	DIM AS SYSTEMTIME ST 
	GetLocalTime(&ST)
	Function = ST
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxLocalYear
'------------------------------------------------------------------------------
' Returns the current local year. The valid values are 1601 through 30827.
' ========================================================================================
Function AfxLocalYear () AS WORD
	DIM AS SYSTEMTIME ST 
	GetLocalTime( &ST)
	Function = ST.wYear
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxLocalMonth
'------------------------------------------------------------------------------
' Returns the current local month. The valid values are 1 thorugh 12 (1 = January, etc.).
' ========================================================================================
Function AfxLocalMonth () AS WORD
	DIM AS SYSTEMTIME ST 
	GetLocalTime(&ST)
	Function = ST.wMonth
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxLocalDay
'------------------------------------------------------------------------------
' Returns the current local day. The valid values are 1 through 31.
' ========================================================================================
Function AfxLocalDay () AS WORD
	DIM AS SYSTEMTIME ST
	GetLocalTime(&ST)
	Function = ST.wDay
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxLocalHour
'------------------------------------------------------------------------------
' Retrieves the current local hour. The valid values are 0 through 23.
' ========================================================================================
Function AfxLocalHour () AS WORD
	DIM AS SYSTEMTIME ST
	GetLocalTime(&ST)
	Function = ST.wHour
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxLocalMonthName
'------------------------------------------------------------------------------
' Retrieves the localized name of today's month.
' ========================================================================================
Function AfxLocalMonthName ( lcid AS LCID = LOCALE_USER_DEFAULT) AS string
	DIM AS SYSTEMTIME ST 
	Dim sDate$ * 260
	
	GetSystemTime(&ST)
	GetDateFormat(lcid, NULL, &ST, "MMMM", sDate, 260)
	Function = sDate$
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxLocalShortMonthName
'------------------------------------------------------------------------------
' Retrieves the localized short name of today's month.
' ========================================================================================
Function AfxLocalShortMonthName ( lcid AS LCID = LOCALE_USER_DEFAULT) As string
	DIM AS SYSTEMTIME ST 
	Dim sDate$ * 260
	GetSystemTime(&ST)
	GetDateFormat(lcid, NULL, &ST, "MMM", sDate, 260)
	Function = sDate$
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxLocalDayName
'------------------------------------------------------------------------------
' Retrieves the localized name of today.
' ========================================================================================
Function AfxLocalDayName ( lcid AS LCID = LOCALE_USER_DEFAULT) As string
	DIM AS SYSTEMTIME ST 
	Dim sDate$ * 260
	GetSystemTime(&ST)
	If lcid = 0 Then
		lcid = LOCALE_USER_DEFAULT
	EndIf
	GetDateFormat(lcid, NULL, &ST, "dddd", sDate, 260)
	Function = sDate$
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxLocalDayShortName
'------------------------------------------------------------------------------
' Retrieves the localized short name of today.
' ========================================================================================
Function AfxLocalDayShortName ( lcid AS LCID = LOCALE_USER_DEFAULT) AS string
	DIM AS SYSTEMTIME ST
	Dim sDate$ * 260
	GetSystemTime(&ST)
	GetDateFormat(lcid, NULL, &ST, "ddd", sDate, 260)
	Function = sDate$
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxLocalDayOfWeek
'------------------------------------------------------------------------------
' Returns the current day of week. It is a numeric value in the range of 0-6 representing
' Sunday through Saturday: 0 = Sunday, 1 = Monday, etc.
' ========================================================================================
Function AfxLocalDayOfWeek () AS WORD
	DIM AS SYSTEMTIME ST 
	GetLocalTime(&ST)
	Function =  ST.wDayOfWeek
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxLocalDayOfWeekName
'------------------------------------------------------------------------------
' Returns the localized name of the day of the week.
' Parameters:
' - nDay: A number between 1-31.
' - nMonth: A number between 1-12.
' - nYear: A four digit year, e.g. 2011.
' Return Value:
' - The localized day of week name.
' ========================================================================================
Function AfxLocalDayOfWeekName ( nDay AS LONG,  nMonth AS LONG,  nYear AS LONG,  lcid AS LCID = LOCALE_USER_DEFAULT) As string
	DIM AS SYSTEMTIME ST 
	DIM sDate$ * 260
	ST.wYear = (WORD)nYear
	ST.wMonth = (WORD)nMonth
	ST.wDay = (WORD)nDay
	GetDateFormat(lcid, NULL, &ST, "dddd", sDate, 260)
	Function = sDate$
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxLocalDayOfWeekShortName
'------------------------------------------------------------------------------
' Retrieves the localized short name of the day of the week.
' Parameters:
' - nDay: A number between 1-31.
' - nMonth; A number between 1-12.
' - nYear: A four digit year, e.g. 2011.
' Return Value:
' - The localized day of week short name.
' ========================================================================================
Function AfxLocalDayOfWeekShortName ( nDay AS LONG,  nMonth AS LONG,  nYear AS LONG,  lcid AS LCID = LOCALE_USER_DEFAULT) As string
	DIM AS SYSTEMTIME ST
	DIM wszDate$ * 260
	ST.wYear = nYear
	ST.wMonth = nMonth
	ST.wDay = nDay
	GetDateFormat(lcid, NULL, &ST, "ddd", wszDate, 260)
	Function = wszDate$
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxLocalDateStr
'------------------------------------------------------------------------------
' Retuns the current local date based on the specified mask, e.g. "dd-MM-yyyy".
' ========================================================================================
Function AfxLocalDateStr (wszMask AS char ptr,  lcid AS LCID = LOCALE_USER_DEFAULT) As string
	Dim wszDateStr$ * 260
	GetDateFormat(lcid, NULL, NULL, wszMask, wszDateStr, 260)
	Function = wszDateStr$
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxLocalTimeStr
'------------------------------------------------------------------------------
' Retuns the current local time based on the specified mask, e.g. "hh':'mm':'ss".
' ========================================================================================
Function AfxLocalTimeStr (wszMask AS char ptr,  lcid AS LCID = LOCALE_USER_DEFAULT) AS string
	Dim wszDateStr$ * 260
	GetTimeFormat(lcid, NULL, NULL, wszMask, wszDateStr, 260)
	Function = wszDateStr$
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxMonthName
'------------------------------------------------------------------------------
' Retrieves the localized name of the specified month.
' ========================================================================================
Function AfxMonthName ( nMonth AS LONG,  lcid AS LCID = LOCALE_USER_DEFAULT) AS string
	DIM AS SYSTEMTIME ST
	Dim wszDate$ * 260
	GetSystemTime(&ST)
	ST.wMonth = nMonth
	GetDateFormat(lcid, NULL, &ST, "MMMM", wszDate, 260)
	Function = wszDate
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxShortMonthName
'------------------------------------------------------------------------------
' Retrieves the localized short name of the specified month.
' ========================================================================================
Function AfxShortMonthName ( nMonth AS LONG,  lcid AS LCID = LOCALE_USER_DEFAULT) AS string
	DIM AS SYSTEMTIME ST
	Dim wszDate$  * 260
	GetSystemTime(&ST)
	ST.wMonth = nMonth
	GetDateFormat(lcid, NULL, &ST, "MMM", wszDate, 260)
	Function = wszDate
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxAstroDay
'------------------------------------------------------------------------------
' Returns the Astronomical Day for any given date.
' Parameters:
' - nDay: A number between 1-31.
' - nMonth; A number between 1-12.
' - nYear: A four digit year, e.g. 2011.
' Return Value:
' - The Astronomical Day.
' See: http://support.microsoft.com/kb/109451/en-us
' Note: Among other things, can be used to find the number of days between any two dates, e.g.:
' PRINT AfxAstroDay(1, 3, -12400) - AfxAstroDay(28, 2, -12400)  ' Prints 2
' PRINT AfxAstroDay(1, 3, 12000) - AfxAstroDay(28, 2, -12000) ' Prints 8765822
' PRINT AfxAstroDay(28, 2, 1902) - AfxAstroDay(1, 3, 1898)  ' Prints 1459 days
' ========================================================================================
Function AfxAstroDay ( nDay AS LONG,  nMonth AS LONG,  nYear AS LONG) AS LONG
	DIM AS DOUBLE y  = nYear + (nMonth - 2.85) / 12
	'RETURN INT(INT(INT(367 * y) - 1.75 * INT(y) + nDay) - 0.75 * INT(0.01 * y)) + 1721116
	Function = INT(INT(INT(367 * y) - 1.75 * INT(y) + nDay) - 0.75 * INT(0.01 * y)) + 1721116
End Function
' ========================================================================================
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxAstroDayOfWeek
'------------------------------------------------------------------------------
' Calculates the day of the week, Sunday through Monday, of a given date.
' Parameters:
' - nDay: A number between 1-31.
' - nMonth; A number between 1-12.
' - nYear: A four digit year, e.g. 2011.
' Return Value:
' - A number between 0-6, where 0 = Sunday, 1 = Monday, 2 = Tuesday, 3 = Wednesday,
'   4 = Thursday, 5 = Friday, 6 = Saturday.
' ========================================================================================
Function AfxAstroDayOfWeek ( nDay AS LONG,  nMonth AS LONG,  nYear AS LONG) AS LONG
	Function = IMOD(AfxAstroDay(nDay, nMonth, nYear),7)
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxGregorianToJulian
'------------------------------------------------------------------------------
' Converts a Gregorian date to a Julian date.
' Parameters:
' - nDay: A number between 1-31.
' - nMonth: A number between 1-12.
' - nYear: A four digit year, e.g. 2011.
' Return Value:
' - The converted date.
' ========================================================================================
Function AfxGregorianToJulian ( nDay AS LONG,  nMonth AS LONG,  nYear AS LONG) AS LONG

	DIM AS LONG DaysElapsed, InvalidLeapYears, ValidLeapYears, DaysOfMonths 
	
	' // January or February? 13 or 14th month of the previous year.
	If nMonth < 3 Then
		nMonth += 12 : nYear -=1
	EndIf
	' // Day 1 of julian calendar is 1/1/-4712 and there are 365.25 days per year
	DaysElapsed = INT((nYear + 4712) * 365.25)
	' // Substract invalid leap years
	InvalidLeapYears = nYear / 100
	' // Add valid leap years
	ValidLeapYears = nYear / 400
	' // Days of months
	DaysOfMonths = INT(30.6 * (nMonth - 1) + .2)
	
	Function = DaysElapsed - InvalidLeapYears + ValidLeapYears + DaysOfMonths + nDay
	
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxDateDiff
'------------------------------------------------------------------------------
' Calculates the days of difference between two dates.
' Parameters:
' - nDay1, nMonth1, nYear1 : The first date
' - nDay2, nMonth2, nYear2 : The second date
' Return Value:
' - The days of difference.
' ========================================================================================
Function AfxDateDiff ( nDay1 AS LONG,  nMonth1 AS LONG,  nYear1 AS LONG, _
	 nDay2 AS LONG,  nMonth2 AS LONG,  nYear2 AS LONG) AS LONG
	
	Dim As LONG t1 = AfxGregorianToJulian(nDay1, nMonth1, nYear1)
	Dim As LONG t2 = AfxGregorianToJulian(nDay2, nMonth2, nYear2)
	Function = t2 - t1
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxDateAddDays
'------------------------------------------------------------------------------
' Adds the specified number of days to a given date.
' Parameters:
' - nDay: A number between 1-31.
' - nMonth:s A number between 1-12.
' - nYear: A four digit year, e.g. 2011.
' - nDays: The number of days to add (or substract, if the number is negative).
' Return Value:
' - The new date in Julian format. To convert it to Gregorian, call functions such
'   AfxJulianToGregorian or AfxJulianToGregorianStr.
' ========================================================================================
Function AfxDateAddDays ( nDay AS LONG,  nMonth AS LONG,  nYear AS LONG,  nDays AS LONG) AS LONG
	Function =  AfxGregorianToJulian(nDay, nMonth, nYear) + nDays
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxWeekOne
'------------------------------------------------------------------------------
' Returns the first day of the first week of a year. The year must be a 4 digit year.
' Please note that the result can be one of the last days of the previous year, e.g. the
' first day of the first week of year 2002 is 31 December 2001.
' To convert the returned julian date to gregorian use AfxJulianToGregorian or AfxJulianToGreorianStr.
' ========================================================================================
Function AfxWeekOne ( nYear AS LONG) AS LONG
	Dim As LONG nFirstDay = AfxGregorianToJulian(1, 1, nYear) - 1  ' Dec. 31 of prev. year
	Do
		nFirstDay += 1
	'Fb -> LOOP UNTIL (nFirstDay MOD 7 + 1) = 4    ' until first Thursday of the year is found	
	'Loop Until (IMOD(nFirstDay, 7 + 1) = 4    ' until first Thursday of the year is found
	Loop Until (IMOD(nFirstDay, 8) = 4)    ' until first Thursday of the year is found
	Function = nFirstDay - 3                ' first day of week 1 is a Monday
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxWeekNumber
'------------------------------------------------------------------------------
' Returns the week number for a given date. The year must be a 4 digit year.
' ========================================================================================
Function AfxWeekNumber ( nDay AS LONG,  nMonth AS LONG,  nYear AS LONG) AS LONG
	DIM AS LONG nFirstDay = AfxWeekOne(nYear)
	Dim As LONG nFinalDay = AfxWeekOne(nYear + 1) - 1
	Dim As LONG nToDay = AfxGregorianToJulian(nDay, nMonth, nYear)
	Select Case nToDay
		Case IS < nFirstDay
			' it is week 52 or 53, but which one?
			' therefore we need week one of previous year as a starting point
			nFirstDay = AfxWeekOne(nYear - 1)
		Case IS > nFinalDay
			' there is only one possibility: week number 1
			Function = 1
	End Select
	Function =  ((nToDay - nFirstDay) / 7) + 1
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxWeeksInYear
'------------------------------------------------------------------------------
' Returns the number of weeks in the year, where weeks are taken to start on Monday. Will be 52 or 53.
' ========================================================================================
Function AfxWeeksInYear ( nYear AS LONG) AS LONG
	Dim As LONG nWeeks = AfxWeekNumber(31, 12, nYear)
	If nWeeks = 53 Then
		Function = 53
	Else
		Function = 52
	EndIf
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxIsLeapYear
'------------------------------------------------------------------------------
' Determines if a given year is a leap year or not.
' Parameters:
' - nYear: A four digit year, e.g. 2011.
' Return Value:
' - TRUE or FALSE.
' Note: A leap year is defined as all years divisible by 4, except for years divisible by
' 100 that are not also divisible by 400. Years divisible by 400 are leap years. 2000 is a
' leap year. 1900 is not a leap year.
' ========================================================================================
Function AfxIsLeapYear ( nYear AS LONG) AS BOOL
'	IF (nYear MOD 4 = 0 AND nYear MOD 100 <> 0) OR nYear MOD 400 = 0 THEN RETURN TRUE
	If (IMOD(nYear,4) = 0 AND IMOD(nYear,100)<> 0) OR IMOD(nYear,400) = 0 Then
		Function = TRUE
	EndIf
	Function = FALSE
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxDaysInMonth
'------------------------------------------------------------------------------
' Returns the number of days in the specified month.
' Parameters:
' - nMonth: A two digit month (1-12).
' - nYear: A four digit year, e.g. 2011.
' Return Value:
' - The number of days.
' ========================================================================================
Function AfxDaysInMonth ( nMonth AS LONG,  nYear AS LONG) AS LONG
	Select Case nMonth
		Case 2
			If AfxIsLeapYear(nYear) Then
				Function = 29
			Else
				Function = 28
			EndIf
		Case 4, 6, 9, 11
			Function =  30
		Case 1, 3, 5, 7, 8, 10, 12
			Function = 31
	End Select
	Function = 0
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxWeeksInMonth
'------------------------------------------------------------------------------
' Returns the number of weeks in the specified month. Will be 4 or 5.
' ========================================================================================
Function AfxWeeksInMonth ( nMonth AS LONG,  nYear AS LONG) AS LONG
	Dim As LONG wim = AfxAstroDayOfWeek(1, nMonth, nYear) - 1
	If wim = -1 Then
		wim = 6
	EndIf
	Dim As LONG nWeeks = (AfxDaysInMonth(nMonth, nYear) + wim) / 7
	Function = nWeeks
End Function

'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxDaysInYear
'------------------------------------------------------------------------------
' Returns the number of days in the specified year.
' Parameters:
' - nYear: A four digit year, e.g. 2011.
' Return Value:
' - The number of days. Will be 365 or 366 (for leap years).
' ========================================================================================
Function AfxDaysInYear ( nYear AS LONG) AS LONG
	If AfxIsLeapYear(nYear) Then
		Function = 366
	Else
		Function =  365
	EndIf
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_IsFirstDayOfMonth
'------------------------------------------------------------------------------
' Returns TRUE if today is the first day of the month; False, otherwise.
' ========================================================================================
Function IsFirstDayOfMonth () AS BOOL
	DIM AS SYSTEMTIME ST 
	GetLocalTime(&ST)
	Function =  (ST.wDay = 1)
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_IsLastDayOfMonth
'------------------------------------------------------------------------------
' Returns TRUE if the date is the last day of the month; False, otherwise.
' ========================================================================================
Function IsLastDayOfMonth () AS BOOL
	DIM  AS SYSTEMTIME ST
	GetLocalTime(&ST)
	Function = (ST.wDay = AfxDaysInMonth(ST.wMonth, ST.wYear))
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxJulianDayOfWeek
'------------------------------------------------------------------------------
' Given a Julian date, returns the day of week.
' ========================================================================================
Function AfxJulianDayOfWeek ( nJulian AS LONG) AS LONG
	Dim As LONG dow = IMOD((nJulian + 1), 7)
	If dow >= 0 Then
		Function =  dow
	Else	
		Function = dow + 7
	EndIf
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxJulianToGregorian
'------------------------------------------------------------------------------
' Converts a Julian date to a Gregorian date.
' Parameters:
' - nJulian [in] = The julian date to convert
' - nDay [out] = The day
' - nMonth [out] = The month
' - nYear [out] = The year
' ========================================================================================
SUB AfxJulianToGregorian (nJulian AS LONG, wDay AS WORD Ref, wMonth AS WORD Ref, wYear AS WORD Ref)
	nJulian = nJulian + 68569
	Dim As LONG nHelp  = 4 * nJulian / 146097
	nJulian = nJulian - ((146097 * nHelp + 3) / 4)
	Dim As LONG nTmpYear = 4000 * (nJulian + 1) / 1461001
	nJulian = nJulian - (1461 * nTmpYear / 4) + 31
	Dim As LONG nTmpMonth = 80 * nJulian / 2447
	wDay = nJulian - (2447 * nTmpMonth / 80)
	wMonth = nTmpMonth + 2 - (12 * (nTmpMonth / 11))
	wYear = 100 * (nHelp - 49) + nTmpYear + (nTmpMonth / 11)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxJulianToGregorianStr
'------------------------------------------------------------------------------
' Converts a Julian date to a Gregorian date based on the specified mask, e.g. "dd-MM-yyyy".
' Parameters:
' - bstrMask = The format string.
' - nJulian = The Julian date to convert.
' Return Value:
' - The converted date.
' ========================================================================================
Function AfxJulianToGregorianStr (wszMask AS char Ptr,  nJulian AS LONG,  lcid AS LCID = LOCALE_USER_DEFAULT) AS string
	DIM AS SYSTEMTIME ST 
	DIM wszDate$ * 260
	AfxJulianToGregorian(nJulian, ST.wDay, ST.wMonth, ST.wYear)
	GetDateFormat(lcid, NULL, &ST, wszMask, wszDate, 260)
	Function = wszDate
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxDayOfYear
'------------------------------------------------------------------------------
' Returns the day of the year, where Jan 1 is the first day of the year.
' ========================================================================================
Function AfxDayOfYear ( nDay AS LONG,  nMonth AS LONG,  nYear AS LONG) AS LONG
	Function = AfxAstroDay(nDay, nMonth, nYear) - AfxAstroDay(1, 1, nYear) + 1
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxDaysBetween
'------------------------------------------------------------------------------
' Returns the number of days between two given dates.
' ========================================================================================
Function AfxDaysBetween ( nDay1 AS LONG,  nMonth1 AS LONG,  nYear1 AS LONG,  nDay2 AS LONG,  nMonth2 AS LONG,  nYear2 AS LONG) AS LONG
	Function = AfxAstroDay(nDay1, nMonth1, nYear1) - AfxAstroDay(nDay2, nMonth2, nYear2)
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxLongDate
'------------------------------------------------------------------------------
' Returns the current date in long format.
' ========================================================================================
Function AfxLongDate ( lcid AS LCID = LOCALE_USER_DEFAULT) AS string
	Dim AS SYSTEMTIME ST
	Dim wszDate$ * 260
	GetLocalTime(&ST)
	GetDateFormat(lcid, DATE_LONGDATE, &ST,  NULL, wszDate, 260)
	Function =  wszDate
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxShortDate
'------------------------------------------------------------------------------
' Returns the current date in short format.
' ========================================================================================
Function AfxShortDate ( lcid AS LCID = LOCALE_USER_DEFAULT) AS string
	Dim AS SYSTEMTIME ST
	Dim wszDate$ * 260
	GetLocalTime(&ST)
	GetDateFormat(lcid, DATE_SHORTDATE, &ST, NULL, wszDate, 260)
	Function = wszDate
End Function
'------------------------------------------------------------------------------
$ENDUSE

$IFUSE USE_AfxQuadDateTime
'------------------------------------------------------------------------------
' Returns the curent date and time as a QUAD (8 bytes). IN FB, a QUAD is an ULONGLONG.
'------------------------------------------------------------------------------
Function AfxQuadDateTime () AS ULONGLONG
   DIM AS SYSTEMTIME ST
   Dim AS FILETIME FT 
   GetLocalTime(&ST)
   SystemTimeToFileTime( &ST, &FT)
   DIM AS ULARGE_INTEGER uli 
   uli.LowPart = FT.dwLowDateTime
   uli.HighPart = FT.dwHighDateTime
   Function =  uli.QuadPart
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxQuadDateToStr
'------------------------------------------------------------------------------
' Converts a date stored in a QUAD into a formatted date string. For example, to get a date
' string formated like "Wed, Aug 31 2016" use the following picture string: "ddd',' MMM dd yyy".
' IN FB, a QUAD is an ULONGLONG.
' ========================================================================================
Function AfxQuadDateToStr ( wszMask AS char Ptr,  ullTime AS ULONGLONG,  lcid AS LCID = LOCALE_USER_DEFAULT) AS string
	DIM AS SYSTEMTIME ST
	Dim AS FILETIME FT
	DIM AS ULARGE_INTEGER uli 
	uli.QuadPart = ullTime
	FT.dwLowDateTime = uli.LowPart
	FT.dwHighDateTime = uli.HighPart
	FileTimeToSystemTime(&FT, &ST)
	DIM wszDate$ * 260
	GetDateFormat(lcid, NULL, &ST, wszMask, wszDate, 260)
	Function = wszDate
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxQuadTimeToStr
'------------------------------------------------------------------------------
' Converts a time stored in a QUAD into a formatted time string. For example, to get a time
' string like "11:29:40 PM" use the following picture string: "hh':'mm':'ss tt".
' IN FB, a QUAD is an ULONGLONG.
' ========================================================================================
Function AfxQuadTimeToStr (wszMask AS char Ptr,  ullTime AS ULONGLONG,  lcid AS LCID = LOCALE_USER_DEFAULT) AS string
	DIM AS SYSTEMTIME ST
	Dim AS FILETIME  FT
	DIM AS ULARGE_INTEGER uli
	uli.QuadPart = ullTime
	FT.dwLowDateTime = uli.LowPart
	FT.dwHighDateTime = uli.HighPart
	FileTimeToSystemTime(&FT, &ST)
	DIM wszDate$ * 260
	GetTimeFormat(lcid, NULL, &ST, wszMask, wszDate, 260)
	Function = wszDate
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxTimeZoneIsDaylightSavingTime
'------------------------------------------------------------------------------
' Indicates whether the the system is operating in the range of daylight saving time
' for the current time zone.
' ========================================================================================
Function AfxTimeZoneIsDaylightSavingTime () AS BOOL
	DIM AS TIME_ZONE_INFORMATION tzi
	DIM AS DWORD r = GetTimeZoneInformation(&tzi)
	Function = (r = TIME_ZONE_ID_DAYLIGHT)
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxTimeZoneBias
'------------------------------------------------------------------------------
' Current bias for local time translation. The bias is the difference between Coordinated
' Universal Time (UTC) and local time. All translations between UTC and local time are
' based on the following formula: UTC = local time + bias. Units = minutes.
' ========================================================================================
Function AfxTimeZoneBias () AS DWORD
	DIM AS TIME_ZONE_INFORMATION tzi
	DIM  AS DWORD r = GetTimeZoneInformation(&tzi)
	If r = TIME_ZONE_ID_INVALID Then
		Function = 0
	EndIf
	Function = tzi.Bias
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxTimeZoneDaylightBias
'------------------------------------------------------------------------------
' Bias value to be used during local time translations that occur during daylight saving
' time. This property is ignored if a value for the DaylightDay property is not supplied.
' The value of this property is added to the Bias property to form the bias used during
' daylight time. In most time zones, the value of this property is 60. Units = minutes.
' ========================================================================================
Function AfxTimeZoneDaylightBias () AS DWORD
	DIM AS TIME_ZONE_INFORMATION tzi
	DIM AS DWORD r = GetTimeZoneInformation(&tzi)
	If r = TIME_ZONE_ID_INVALID Then
		Function =  0
	EndIf
	Function = tzi.DaylightBias
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxTimeZoneStandardName
'------------------------------------------------------------------------------
' A description for standard time. For example, "EST" could indicate Eastern Standard Time.
' The string will be returned unchanged by the GetTimeZoneInformation function.
' This string can be empty.
' ========================================================================================
Function AfxTimeZoneStandardName () AS string
	DIM AS TIME_ZONE_INFORMATION tzi
	DIM AS DWORD r = GetTimeZoneInformation(&tzi)
	If r = TIME_ZONE_ID_INVALID Then
		Function = ""
	EndIf
	Function = tzi.StandardName
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxTimeZoneDaylightName
'------------------------------------------------------------------------------
' A description for daylight saving time. For example, "PDT" could indicate Pacific
' Daylight Time. The string will be returned unchanged by the GetTimeZoneInformation
' function. This string can be empty.
' ========================================================================================
Function AfxTimeZoneDaylightName () AS string
	DIM AS TIME_ZONE_INFORMATION tzi
	DIM AS DWORD r = GetTimeZoneInformation(&tzi)
	If r = TIME_ZONE_ID_INVALID Then
		Function = ""
	EndIf
	Function = tzi.DaylightName
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxTimeZoneDaylightDay
'------------------------------------------------------------------------------
' DaylightDayOfWeek of the DaylightMonth when the transition from standard time to daylight
' saving time occurs on this operating system.
' Example: If the transition day (DaylightDayOfWeek) occurs on a Sunday, then the value
' "1" indicates the first Sunday of the DaylightMonth, "2" indicates the second Sunday,
' and so on. The value "5" indicates the last DaylightDayOfWeek in the month.
' ========================================================================================
Function AfxTimeZoneDaylightDay () AS WORD
	DIM AS TIME_ZONE_INFORMATION tzi
	DIM AS DWORD r = GetTimeZoneInformation(&tzi)
	If r = TIME_ZONE_ID_INVALID Then
		Function = 0
	EndIf
	Function = tzi.DaylightDate.wDay
End Function

'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxTimeZoneDaylightDayOfWeek
'------------------------------------------------------------------------------
' Day of the week when the transition from standard time to daylight saving time occurs on
' an operating system. 0 = Sunday, 1 = Monday, and so on.
' ========================================================================================
Function AfxTimeZoneDaylightDayOfWeek () AS WORD
	DIM AS TIME_ZONE_INFORMATION tzi
	DIM AS DWORD r = GetTimeZoneInformation(&tzi)
	If r = TIME_ZONE_ID_INVALID Then
		Function = 0
	EndIf
	Function = tzi.DaylightDate.wDayOfWeek
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxTimeZoneDaylightHour
'------------------------------------------------------------------------------
' Hour of the day when the transition from standard time to daylight saving time occurs on
' an operating system.
' ========================================================================================
Function AfxTimeZoneDaylightHour () AS WORD
	DIM AS TIME_ZONE_INFORMATION tzi
	DIM AS DWORD r = GetTimeZoneInformation(&tzi)
	If r = TIME_ZONE_ID_INVALID Then
		Function = 0
	EndIf
	Function =  tzi.DaylightDate.wHour
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxTimeZoneDaylightMonth
'------------------------------------------------------------------------------
' Month when the transition from standard time to daylight saving time occurs on an
' operating system.
' ========================================================================================
Function AfxTimeZoneDaylightMonth () AS WORD
	DIM AS TIME_ZONE_INFORMATION tzi
	DIM AS DWORD r = GetTimeZoneInformation(&tzi)
	If r = TIME_ZONE_ID_INVALID Then
		Function = 0
	EndIf
	Function = tzi.DaylightDate.wMonth
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
'These need OleAut32.lib DATE_ typedef at the top
'==============================================================================
$IFUSE USE_AfxLocalVariantTime
'------------------------------------------------------------------------------
' Returns the local date and time as a DATE_ (double).
' ========================================================================================
Function AfxLocalVariantTime () AS DATE_
	DIM AS SYSTEMTIME ST
	Dim AS DATE_  dt
	GetLocalTime(&ST)
	SystemTimeToVariantTime(&ST, &dt)
	Function = dt
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxSystemTimeToVariantTime
'------------------------------------------------------------------------------
' Converts a SYSTEMTIME to a DATE_ (double).
' ========================================================================================
Function AfxSystemTimeToVariantTime (ST AS SYSTEMTIME Ref) AS DATE_
	DIM AS DATE_ dt
	SystemTimeToVariantTime(&ST, &dt)
	Function =  dt
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxVariantTimeToSystemTime
'------------------------------------------------------------------------------
' Converts a DATE_ (double) to a SYSTEMTIME.
' ========================================================================================
Function AfxVariantTimeToSystemTime ( dt AS DATE_) AS SYSTEMTIME
	DIM AS SYSTEMTIME ST
	VariantTimeToSystemTime(dt, &ST)
	Function =  ST
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxFileTimeToVariantTime
'------------------------------------------------------------------------------
' Converts a FILETIME to a DATE_ (double).
' ========================================================================================
Function AfxFileTimeToVariantTime (FT AS FILETIME Ref) AS DATE_
	DIM AS DATE_ dt
	Dim AS SYSTEMTIME ST
	FileTimeToSystemTime(&FT, &ST)
	SystemTimeToVariantTime(&ST, &dt)
	Function = dt
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxVariantDateTimeToStr
'------------------------------------------------------------------------------
' Converts a DATE_ type to a string containing the date and the time.
' ========================================================================================
Function AfxVariantDateTimeToStr ( vbDate AS DATE_,  lcid AS LCID = LOCALE_USER_DEFAULT,  dwFlags AS DWORD = 0) AS BSTR
	DIM AS BSTR bstrOut = bNew(_T(""))
	VarBstrFromDate(vbDate, lcid, dwFlags, (BSTR PTR) &bstrOut)
	Function = bstrOut
End Function

'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxVariantDateToStr
'------------------------------------------------------------------------------
' Converts a DATE_ type to a string containing only the date.
' ========================================================================================
Function AfxVariantDateToStr ( vbDate AS DATE_,  lcid AS LCID = LOCALE_USER_DEFAULT) AS BSTR
	Dim As BSTR bstrOut = bNew(_T(""))
	VarBstrFromDate(vbDate, lcid, VAR_DATEVALUEONLY, (BSTR PTR) &bstrOut)
	Function =  bstrOut
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxVariantTimeToStr
'------------------------------------------------------------------------------
' Converts a DATE_ type to a string containing only the time.
' ========================================================================================
Function AfxVariantTimeToStr ( vbDate AS DATE_,  lcid AS LCID = LOCALE_USER_DEFAULT) AS BSTR
	DIM As BSTR bstrOut = bNew(L"")
	VarBstrFromDate(vbDate, lcid, VAR_TIMEVALUEONLY, (BSTR PTR) &bstrOut)
	Function = bstrOut
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxFileTimeToDateStr
'------------------------------------------------------------------------------
' Converts a FILETIME type to a string containing the date based on the specified mask, e.g. "dd-MM-yyyy"
' ========================================================================================
Function AfxFileTimeToDateStr (FT AS FILETIME Ref, wszMask AS const char Ptr,  lcid AS LCID = LOCALE_USER_DEFAULT) AS string
	DIM AS SYSTEMTIME ST
	Dim wszDateStr$ * 260
	FileTimeToSystemTime(&FT, &ST)
	GetDateFormat(lcid, NULL, &ST, wszMask, wszDateStr, 260)
	Function = wszDateStr
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxFileTimeToTimeStr
'------------------------------------------------------------------------------
' Converts a FILETIME type to a string containing the time based on the specified mask, e.g. "hh':'mm':'ss".
' ========================================================================================
Function AfxFileTimeToTimeStr (FT AS FILETIME Ref, wszMask AS const char Ptr,  lcid AS LCID = LOCALE_USER_DEFAULT) AS string
	DIM AS SYSTEMTIME ST
	Dim wszDateStr$  * 260
	FileTimeToSystemTime(&FT, &ST)
	GetTimeFormat(lcid, NULL, &ST, wszMask, wszDateStr, 260)
	Function = wszDateStr
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxSystemTimeToDateStr
'------------------------------------------------------------------------------
' Converts a SYSTEMTIME type to a string containing the date and the time. based on the
' specified mask, e.g. "dd-MM-yyyy"
' ========================================================================================
Function AfxSystemTimeToDateStr (ST AS SYSTEMTIME Ref, wszMask AS const char ptr,  lcid AS LCID = LOCALE_USER_DEFAULT) AS string
	DIM wszDateStr$ * 260
	GetDateFormat(lcid, NULL, &ST, wszMask, wszDateStr, 260)
	Function = wszDateStr
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxSystemTimeToTimeStr
'------------------------------------------------------------------------------
' Converts a FILETIME type to a string containing the date and the time. based on the
' specified mask, e.g. "hh':'mm':'ss".
' ========================================================================================
Function AfxSystemTimeToTimeStr (ST AS SYSTEMTIME Ref,wszMask AS const char ptr,  lcid AS LCID = LOCALE_USER_DEFAULT) AS string
	DIM wszDateStr$ * 260
	GetTimeFormat(lcid, NULL, &ST, wszMask, wszDateStr, 260)
	Function = wszDateStr
End Function

'------------------------------------------------------------------------------
$ENDUSE





