'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'AfxWin.bi Ported from Jos Rocca's FreeBasic version
'------------------------------------------------------------------------------
'Notes:
'   Clipboard funcs need work
'     10/27/2016
'       did some work on Text functions.
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'Windows wrapper functions
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'Note: I don't need the AfxUCode as bc9 has the SYSSTR function
'==============================================================================
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'Libraries needed:
'#pragma comment(lib,"version.lib") 
'==============================================================================


$IFUSE USE_AfxMsg
Function AfxMsg(pwszText As const char Ptr,uType As DWORD = 0) As Long
	If pwszText <> NULL Then
		Function = MessageBox((HWND)GetActiveWindow(), pwszText, _T("Message"), MB_APPLMODAL | uType)
	Else 
		Function = MessageBox((HWND)GetActiveWindow(), _T(""), _T(""), MB_APPLMODAL | uType)
	EndIf
End Function
$ENDUSE
'==============================================================================
' Processes pending Windows messages.
' Call this procedure if you are performing a tight FOR/NEXT or DO/LOOP and need to allow
' your application to be responsive to user input.
' ========================================================================================
$IFUSE USE_AfxDoEvents
Sub AfxDoEvents(hwnd As HWND = NULL)
	Dim As MSG uMsg
	If hwnd = NULL Then
		hwnd = GetActiveWindow()
	EndIf
	While PeekMessage(&uMsg, NULL, 0, 0, PM_REMOVE)
		' // Determines whether a message is intended for the specified
		' // dialog box and, if it is, processes the message.
		If IsDialogMessage(hwnd, &uMsg) = 0 THEN
			' // Translates virtual-key messages into character messages.
			TranslateMessage(&uMsg)
			' // Dispatches a message to a window procedure.
			DispatchMessage(&uMsg)
		End If
	Wend
End Sub
$ENDUSE
' ========================================================================================
' Processes pending Windows messages.
' Call this procedure if you are performing a tight FOR/NEXT or DO/LOOP and need to allow
' your application to be responsive to user input.
' ========================================================================================
$IFUSE USE_AfxPumpMessages
Sub AfxPumpMessages()
	Dim uMsg As MSG
	While PeekMessage(&uMsg, NULL, 0, 0, PM_REMOVE)
		' // Translates virtual-key messages into character messages.
		TranslateMessage(&uMsg)
		' // Dispatches a message to a window procedure.
		DispatchMessage(&uMsg)
	Wend
End Sub
$ENDUSE
'==============================================================================
'==============================================================================
' Returns the Windows build
' ========================================================================================
$IFUSE USE_AfxWindowsBuild
Function AfxWindowsBuild () AS LONG
   Dim dwVersion AS DWORD
   dwVersion = GetVersion()
   If dwVersion < 0x80000000 Then
		Function = HIWORD(dwVersion)
   EndIf
   Function = dwVersion
End Function
$ENDUSE
'==============================================================================
' Returns TRUE if the Windows Platform is NT; FALSE, otherwise.
' ========================================================================================
$IFUSE USE_AfxIsPlatformNT
Function AfxIsPlatformNT () AS BOOL
	Dim osvi As OSVERSIONINFOW
	osvi.dwOSVersionInfoSize = SIZEOF(osvi)
	GetVersionEx(&osvi)
	'Function = (VER_PLATFORM_WIN32_NT = osvi.dwPlatformId)
	If VER_PLATFORM_WIN32_NT = osvi.dwPlatformId Then
		Function = TRUE
	Else
		Function = FALSE
	EndIf
End Function
$ENDUSE
' ========================================================================================
' Returns the version of specified file multiplied by 100, e.g. 601 for version 6.01.
' Example: DIM ver AS LONG = AfxGetFileVersion("COMCTL32.DLL")
' ========================================================================================
$IFUSE USE_AfxGetFileVersion
Function AfxGetFileVersion (pwszFileName As const char Ptr) AS LONG
	Dim As VS_FIXEDFILEINFO PTR pvsffi 
	Dim As DWORD dwHandle
	'Dim As DWORD cbLen = GetFileVersionInfoSizeW(pwszFileName, &dwHandle)
	Dim As DWORD cbLen = GetFileVersionInfoSize(pwszFileName, &dwHandle)
	Dim As Long RetVal
	If cbLen = 0 Then
		Exit Function
	EndIf
	Dim As HANDLE pVerInfo  = HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, cbLen)
	If pVerInfo = NULL Then
		Exit Function
	EndIf
	If GetFileVersionInfo(pwszFileName, dwHandle, cbLen, pVerInfo) Then
		'If VerQueryValueW(pVerInfo, "\", &pvsffi, &cbLen) Then
			'Dim As WORD wMajor = HIWORD(pvsffi->dwFileVersionMS)
			'Dim As WORD wMinor  = LOWORD(pvsffi->dwFileVersionMS)
			'Function = (wMajor + wMinor / 100) * 100
        !if(VerQueryValue(pVerInfo, _T("\\"), (LPVOID*)&pvsffi,(PUINT) &cbLen))
        !{
        !    WORD     wMajor = HIWORD(pvsffi->dwFileVersionMS);
        !    WORD     wMinor = LOWORD(pvsffi->dwFileVersionMS);
        !    RetVal = (wMajor + wMinor / 100) * 100;
        !}
			
		'End If
		
	End If
	HeapFree(GetProcessHeap(), 0, pVerInfo)
	Function = RetVal
END FUNCTION
$ENDUSE
$IFUSE USE_AfxGetWinDir
' ========================================================================================
' Retrieves the path of the Windows directory.
' ========================================================================================
Function AfxGetWinDir () As string
   	Dim wszWinDir$
   	GetWindowsDirectory( wszWinDir,cSizeOfDefaultString )
   	Function = wszWinDir
END FUNCTION
$ENDUSE
' ========================================================================================
' Retrieves the name of the user associated with the current thread.
' ========================================================================================
$IFUSE USE_AfxGetUserName 
Function AfxGetUserName() As string
	Dim buffer$
	Dim As DWORD dwBufLen  = cSizeOfDefaultString
	GetUserName(buffer, &dwBufLen)
	Function = buffer$
END FUNCTION
$ENDUSE
'==============================================================================
' Retrieves the computer name of the current system.
' ========================================================================================
$IFUSE USE_AfxGetComputerName
Function AfxGetComputerName () As string
	Dim buffer$
	Dim As DWORD dwBufLen  = cSizeOfDefaultString
	GetComputerName(buffer, &dwBufLen)
	Function = buffer$
End Function
' ========================================================================================
$ENDUSE
' Returns the path of the program which is currently executing.
' ========================================================================================
$IFUSE USE_AfxGetExePathName
$USE USE_InstrAnyRev
Function AfxGetExePathName () As string
    Dim buffer$
    Dim As Long p
   	GetModuleFileName(NULL, buffer, cSizeOfDefaultString)
   	p = InstrAnyRev(buffer,vchr$(3,58,47,92))
   	If p Then
   		Function = Left$(buffer, p)
   	End If
   	
   	Function = ""
END FUNCTION
$ENDUSE
'==============================================================================
' Returns the file name of the program which is currently executing.
' ========================================================================================
$IFUSE USE_AfxGetExeFileName
$USE USE_InstrAnyRev
Function AfxGetExeFileName () As string
	Dim buffer$
	Dim As Long p
	GetModuleFileName(NULL, buffer, cSizeOfDefaultString)
	p = InstrAnyRev(buffer,vchr$(3,58,47,92))
	If p Then
		buffer = Mid$(buffer$, p + 1)
	EndIf
	p = INSTRREV(buffer, ".")
	If p Then
		buffer = Left$(buffer$, p - 1)
	EndIf
	Function =  buffer
End Function
$ENDUSE
'==============================================================================
' Returns the file name and extension of the program which is currently executing.
' ========================================================================================
$IFUSE USE_AfxGetExeFileNameX
$USE USE_InstrAnyRev
Function AfxGetExeFileNameX() As string
	Dim buffer$
	Dim As Long p
	GetModuleFileName(NULL, buffer, cSizeOfDefaultString)
	'p = INSTRREV(buffer, ANY ":/\")
	p = InstrAnyRev(buffer,vchr$(3,58,47,92))
	If p Then
		buffer = Mid$(buffer, p + 1)
	EndIf
	Function = buffer$
END FUNCTION
$ENDUSE
'==============================================================================
$IFUSE USE_AfxGetExeFileExt
' Returns the extension (with a leading period) of the program which is currently executing.
' ========================================================================================
Function AfxGetExeFileExt() As string
	Dim buffer$
	Dim As Long p
	GetModuleFileName(NULL, buffer, cSizeOfDefaultString)
	p = INSTRREV(buffer, ".")
	If p Then
		Function = Mid$(buffer$, p) 
	EndIf
	Function = buffer$
End Function 
$ENDUSE
'==============================================================================
$IFUSE USE_AfxGetExeFullPath
' Returns the full path of the program which is currently executing.
' ========================================================================================
Function AfxGetExeFullPath () As string
   Dim buffer$
   Dim As Long cb
   cb = GetModuleFileName(NULL, buffer, cSizeOfDefaultString)
   Function = Left$(buffer, cb)
End Function
$ENDUSE
'==============================================================================
$IFUSE USE_AfxGetFileName
' Parses a path/filename and returns the file name portion. That is the text to the right
' of the last backslash (\) or colon (:), ending just before the last period (.). The file
' extension is excluded.
' ========================================================================================
Function AfxGetFileName (szPath As char Ptr) As string
	Dim As Long p
	'p = INSTRREV(wszPath, ANY ":/\")
	p = InstrAnyRev(szPath,vchr$(3,58,47,92))
	If p Then
		szPath = Mid$(szPath,p +1)
	EndIf
	p = INSTRREV(szPath, ".")
	If p Then
		szPath = Left$(szPath,p - 1)
	EndIf
	Function = szPath
End Function
$ENDUSE
'==============================================================================
$IFUSE USE_AfxGetFileNameX 
' ========================================================================================
' Parses a path/filename and returns the file name portion. That is the text to the right
' of the last backslash (\) or colon (:), ending just before the last period (.).
' ========================================================================================
Function AfxGetFileNameX (szPath As char Ptr) As string
	Dim As Long p
	'p = INSTRREV(wszPath, ANY ":/\")
	p = InstrAnyRev(szPath,vchr$(3,58,47,92))
	If p Then
		Function =  Mid$(szPath, p + 1)
	EndIf
	Function = szPath
End Function
$ENDUSE
'==============================================================================
$IFUSE USE_AfxGetFileExt
' Parses a path/filename and returns the extension portion of the path/file name. That is
' the last period (.) in the string plus the text to the right of it.
' ========================================================================================
Function AfxGetFileExt (szPath As char Ptr) As string
	Dim As Long p
	p = INSTRREV(szPath, ".")
	If p Then
		Function =  Mid$(szPath, p)
	EndIf
	Function = szPath
End Function
$ENDUSE
'==============================================================================
$IFUSE USE_AfxGetCurDir
' Retrieves the current directory for the current process.
' ========================================================================================
Function AfxGetCurDir () As string
	DIM sCurDir$
	GetCurrentDirectory(MAX_PATH, sCurDir$)
	Function = sCurDir$
End Function
$ENDUSE
'==============================================================================
$IFUSE USE_AfxGetLongPathName
' Converts the specified path to its long form.
' ========================================================================================
Function AfxGetLongPathName (szPath As char Ptr) As string
	Dim sLongPath$
	GetLongPathName(szPath, sLongPath, cSizeOfDefaultString)
	Function = sLongPath$
END FUNCTION
$ENDUSE
'==============================================================================
$IFUSE USE_AfxGetShortPathName
' Retrieves the short path form of the specified path.
' ========================================================================================
Function AfxGetShortPathName (szPath As char Ptr) As string
	Dim sShortPath$
	GetShortPathName(szPath, sShortPath, cSizeOfDefaultString)
	Function = sShortPath$
End Function
$ENDUSE
'==============================================================================
$IFUSE USE_AfxGetPathName
' ========================================================================================
' Parses a path/filename and returns the path portion. That is the text up to and including
' the last backslash (\) or colon (:).
' ========================================================================================
Function AfxGetPathName (szPath As char Ptr) As string
	DIM p AS LONG
	'p = INSTRREV(wszPath, ANY ":\/")
	p = InstrAnyRev(szPath,vchr$(3,58,47,92)) 
	If p Then
		Function = Left$(szPath, p)
	EndIf
	Function = szPath
End Function
$ENDUSE
'==============================================================================
$IFUSE USE_AfxGetSystemDllPath
' Retrieves the path of the specified system DLL.
' ========================================================================================
Function AfxGetSystemDllPath (szDllName As char Ptr) As string
	Dim  sPath$
	Dim As HMODULE  hLib = LoadLibrary(szDllName)
	If hLib Then
		GetModuleFileName(hLib, sPath$, cSizeOfDefaultString)
		FreeLibrary(hLib)
	End If
	Function = sPath$
END FUNCTION
$ENDUSE
'==============================================================================
$IFUSE USE_AfxGetPathFromProcessId
' ========================================================================================
' Retrieves the path of the executable file given its process identifier.
' ========================================================================================
Function AfxGetPathFromProcessId (dwProcessId As DWORD) As string
	Dim As HANDLE hProcess 
	Dim sPath$
	hProcess = OpenProcess(PROCESS_QUERY_INFORMATION BOR PROCESS_VM_READ, FALSE, dwProcessId)
	If hProcess <> NULL Then
		GetModuleFileNameEx(hProcess, NULL, sPath$, cSizeOfDefaultString)
		CloseHandle(hProcess)
	End If
	Function = sPath$
END FUNCTION
$ENDUSE
'==============================================================================
$IFUSE USE_AfxGetPathFromWindowHandle
' ========================================================================================
' Retrieves the path of the executable file that created the specified window.
' ========================================================================================
Function AfxGetPathFromWindowHandle (hwnd AS HWND) As string
	Dim As DWORD idProc 
	Dim As HANDLE hProcess 
	Dim sPath$
	GetWindowThreadProcessId(hwnd, &idProc)
	If idProc Then
		hProcess = OpenProcess(PROCESS_QUERY_INFORMATION BOR PROCESS_VM_READ, FALSE, idProc)
		If hProcess Then
			GetModuleFileNameEx(hProcess, NULL, sPath$, cSizeOfDefaultString)
			CloseHandle(hProcess)
			Function = sPath$
		End If
	End If
	Function = ""
End Function
' ========================================================================================
$ENDUSE
'==============================================================================
$IFUSE USE_AfxGetKnowFolderPath
'==============================================================================
'Needs:
'	#include <psapi.h>
'	#include <Shlobj.h>
'	#pragma comment(lib,"ole32.lib")
'	#pragma comment(lib,"shell32.lib")
'==============================================================================
' Retrieves the path of an special folder. Requires Windows Vista/Windows 7 or superior.
' - rfid: A reference to the KNOWNFOLDERID that identifies the folder. The folders associated
'   with the known folder IDs might not exist on a particular system.
' - dwFlags: Flags that specify special retrieval options. This value can be 0; otherwise,
'   it is one or more of the KNOWN_FOLDER_FLAG values.
' - hToken: An access token used to represent a particular user. This parameter is usually
'   set to NULL, in which case the function tries to access the current user's instance of
'   the folder. However, you may need to assign a value to hToken for those folders that can
'   have multiple users but are treated as belonging to a single user. The most commonly used
'   folder of this type is Documents.
'   The calling application is responsible for correct impersonation when hToken is non-null.
'   It must have appropriate security privileges for the particular user, including TOKEN_QUERY
'   and TOKEN_IMPERSONATE, and the user's registry hive must be currently mounted. See Access
'   Control for further discussion of access control issues.
'   https://msdn.microsoft.com/en-us/library/windows/desktop/aa374860(v=vs.85).aspx
'   Assigning the hToken parameter a value of -1 indicates the Default User. This allows
'   clients of SHGetKnownFolderIDList to find folder locations (such as the Desktop folder)
'   for the Default User. The Default User user profile is duplicated when any new user
'   account is created, and includes special folders such as Documents and Desktop.
'   Any items added to the Default User folder also appear in any new user account.
'   Note that access to the Default User folders requires administrator privileges.
' Return value:
'   The path of the requested folder on success, or an empty string on failure.
' Remarks: For a list of KNOWNFOLDERID constants see:
'   https://msdn.microsoft.com/en-us/library/windows/desktop/dd378457(v=vs.85).aspx
' Usage example: AfxGetKnowFolderPath(@FOLDERID_CommonPrograms)
' ========================================================================================
Function AfxGetKnowFolderPath (rfid As const KNOWNFOLDERID Ref,  dwFlags As DWORD = 0,  hToken As HANDLE = NULL) As string
	Dim As ITEMIDLIST PTR pidl           ' // Pointer to an item identifier list (PIDL)
	Dim sPath$   ' // Folder's path
	If SHGetKnownFolderIDList(rfid, dwFlags, hToken, &pidl) = S_OK Then
		SHGetPathFromIDList(pidl, sPath$)
		CoTaskMemFree(pidl)
		Function =  sPath$
	End If
	Function = ""
End Function
$ENDUSE
'==============================================================================
$IFUSE USE_AfxGetSpecialFolderLocation
' Retrieves the path of an special folder.
' - nFolder: A CSIDL value that identifies the folder of interest.
' For a list of CSIDL values see:
' https://msdn.microsoft.com/en-us/library/windows/desktop/bb762494(v=vs.85).aspx
' ========================================================================================
Function AfxGetSpecialFolderLocation (nFolder As LONG) As string
	Dim As ITEMIDLIST PTR pidl           ' // Pointer to an item identifier list (PIDL)
	Dim sPath$						   ' // Folder's path
	If SHGetSpecialFolderLocation(0, nFolder, &pidl) = S_OK THEN
		SHGetPathFromIDList( pidl, sPath$)
		CoTaskMemFree(pidl)
		Function = sPath$
	End If
	Function = ""
End Function
' ========================================================================================
$ENDUSE
'==============================================================================
$IFUSE USE_AfxControlRunDLL
	$TYPEDEF BOOL (*BC9_AfxControlRunDLL)(HWND,HINSTANCE,WCHAR*,LONG)
' ========================================================================================
' // Control_RunDLL is an undocumented procedure in the Shell32.dll which can be used
' // to launch control panel applications. Youve to pass the name of the control panel
' // file (.cpl) and the tool represented by it will be launched. For launching some
' // control panel applications, youve to provide a valid windows handle (hwnd parameter)
' // and program instance (hinstance parameter).
' // This opens the control panel: AfxControlRunDLL(0, 0, "", %SW_SHOWNORMAL)
' // This opens the applications wizard: AfxControlRunDLL(0, 0, "appwiz.cpl", %SW_SHOWNORMAL)
' Return value: TRUE or FALSE.
' ========================================================================================
Function AfxControlRunDLL (hwnd AS HWND, hInst AS HINSTANCE, cmd$, nCmdShow AS LONG) AS BOOL
   'DIM AS ANY PTR pLib = DyLibLoad("shell32.dll")
   'IF pLib = 0 THEN EXIT FUNCTION
   'DIM pProc AS FUNCTION (BYVAL hwnd AS HWND, BYVAL hInst AS HINSTANCE, BYVAL cmd AS WSTRING PTR, BYVAL nCmdShow AS LONG) AS BOOLEAN
   'pProc = DyLibSymbol(pLib, "Control_RunDLLW")
   'IF pProc = 0 THEN EXIT FUNCTION
   'FUNCTION = pProc(hwnd, hInst, cmd, nCmdShow)
   'DyLibFree(pLib)


	Dim As BC9_AfxControlRunDLL pProc
	Dim As HMODULE H_SHELL32 = LoadLibrary("shell32.dll")
	pProc = (BC9_AfxControlRunDLL)GetProcAddress(H_SHELL32,"Control_RunDLLW")
	Function = pProc(hwnd,hInst,cmd,nCmdShow)
End Function
$ENDUSE
'==============================================================================
$IFUSE USE_AfxSaveTempFile
' 'This needs work as we might be using TLibs File IO or my API approach??
' Saves the contents of a string buffer in a temporary file and returns the name of the file.
' ========================================================================================
Function AfxSaveTempFile ( sBuffer As char Ptr, sExtension$) As String
	'Dim sTmpFileName$
	'Dim sTmpPath$
	'Dim AS DWORD dwRes
	'Dim AS Long fn 
	'dwRes = GetTempPathW(MAX_PATH - 14, sTmpPath)
	'If dwRes > 0 AND dwRes <= MAX_PATH - 14 Then
	'	dwRes = GetTempFileNameW(sTmpPath, "TMP", 0, sTmpFileName)
	'	If dwRes Then
	'		If Len(sExtension$) Then
	'			sTmpFileName = LEFT$(sTmpFileName, LEN(sTmpFileName) -  3) & sExtension$
	'		EndIf
	'		$FILETEST ON
	'		'fn = FREEFILE
	'		OPEN sTmpFileName For Output As fn
	'		PUT fn,sBuffer$,Len(sBuffer$)
	'		CLOSE fn
	'		$FILETEST OFF		
	'				'RETURN wszTmpFileName
	'			'END IF
	'			
	'	End If
	'End If
	Function = ""
End Function
$ENDUSE
'==============================================================================
$IFUSE USE_AfxBrowseForFolder
' ========================================================================================
' Displays a dialog box that enables the user to select a folder.
' - pwszTitle       = A string value that represents the title displayed inside the Browse dialog box.
' - pwszStartFolder = The initial folder that the dialog will show.
' - nFlags          = Optional. A LONG value that contains the options for the method. This can be a
'                     combination of the values listed under the ulFlags member of the BROWSEINFO structure.
'                     See: http://msdn.microsoft.com/en-us/library/windows/desktop/bb773205%28v=vs.85%29.aspx
'                     Default value = BIF_RETURNONLYFSDIRS OR BIF_DONTGOBELOWDOMAIN OR BIF_USENEWUI OR BIF_RETURNFSANCESTORS
' Note: To display the old style dialog, pass -1 in the dwFlags parameter.
' ========================================================================================
' // Browse for folder dialog procedure
Function AfxBrowseForFolderProc (hwnd AS HWND, uMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
	Dim sBuffer$
	
	If uMsg = BFFM_INITIALIZED Then
		SendMessage(hwnd, BFFM_SETSELECTIONW, TRUE, (LPARAM) lParam)
	ElseIf uMsg = BFFM_SELCHANGED Then
		SHGetPathFromIDList((ITEMIDLIST PTR) wParam, sBuffer$)
		If wParam = 0 OR Len(sBuffer) = 0 Then
			SendMessage(hwnd, BFFM_ENABLEOK, FALSE, FALSE)
		EndIf
		'If ((GetFileAttributesW(sBuffer)) AND (FILE_ATTRIBUTE_DIRECTORY)) <> FILE_ATTRIBUTE_DIRECTORY Then
		'	SendMessageW(hwnd, BFFM_ENABLEOK, FALSE, FALSE)
		'EndIf
		If Mid$(sBuffer$, 2, 1) <> ":" Then
			SendMessage(hwnd, BFFM_ENABLEOK, FALSE, FALSE)
		EndIf
	End If
	
	Function = 0
	
END FUNCTION
'==============================================================================
Function AfxBrowseForFolder (hwnd AS HWND, szTitle As char ptr = NULL, szStartFolder As char Ptr = NULL, nFlags AS LONG = 0) As string

	Dim sBuffer$
	Dim As  BROWSEINFOW bi
	Dim AS ITEMIDLIST Ptr pidl 
	If nFlags = 0 Then
		nFlags = BIF_RETURNONLYFSDIRS|BIF_DONTGOBELOWDOMAIN|BIF_USENEWUI|BIF_RETURNFSANCESTORS
	EndIf
	If nFlags = -1 Then
		nFlags = BIF_RETURNONLYFSDIRS|BIF_DONTGOBELOWDOMAIN|BIF_RETURNFSANCESTORS
	EndIf
	
	bi.hwndOwner = hwnd
	bi.lpszTitle = szTitle
	bi.ulFlags   = nFlags
	bi.lpfn      = (BFFCALLBACK) &AfxBrowseForFolderProc
	bi.lParam    = (LPARAM) szStartFolder
	pidl         = (ITEMIDLIST Ptr)SHBrowseForFolder(&bi)
	
	If pidl Then
		SHGetPathFromIDList(pidl, sBuffer$)
		CoTaskMemFree(pidl)
	End If

	Function = sBuffer$
End Function

$ENDUSE
'==============================================================================
' ########################################################################################
'                                      *** WINDOW ***
' ########################################################################################

$IFUSE USE_AfxGetWindowClassName
' ========================================================================================
' Gets the class name of the specified window
' ========================================================================================
Function AfxGetWindowClassName ( hwnd AS HWND) As String
   DIM sClassName$
   GetClassName(hwnd, sClassName$, cSizeOfDefaultString)
   Function = sClassName$
End Function
$ENDUSE
'==============================================================================
$IFUSE USE_AfxGetWindowText
' ========================================================================================
' Gets the text of a window. This function can also be used to retrieve the text of buttons,
' and edit and static controls.
' Remarks: The function uses the WM_GETTEXT message because GetWindowText cannot retrieve
' the text of a window in another application.
' Example: DIM cws AS CWSTR = AfxGetWindowText(hwnd)
' ========================================================================================
Function AfxGetWindowText ( hwnd AS HWND) As String
   Dim As Long nLen  = SendMessage(hwnd, WM_GETTEXTLENGTH, 0, 0)
   DIM sText$ 
   sText$ = Space$(nLen+1)
   SendMessage(hwnd, WM_GETTEXT, nLen + 1, (LPARAM) sText$)
   Function = sText$
End Function
$ENDUSE
'==============================================================================
$IFUSE USE_AfxGetWindowTextLength
' Gets the length of the text of a window.
' Usage example: nLen = AfxGetWindowTextLength(hwnd)
' ========================================================================================
Function AfxGetWindowTextLength ( hwnd AS HWND) AS LONG
   Function = SendMessage(hwnd, WM_GETTEXTLENGTH, 0, 0)
End Function
$ENDUSE
'==============================================================================
$IFUSE USE_AfxSetWindowText
' ========================================================================================
' Sets the text of a window. This function can also be used to set the text of buttons,
' edit and static controls. The return value is TRUE if the text is set or FALSE if it is not.
' Remarks: The function uses the WM_SETTEXT message because SetWindowText cannot retrieve
' the text of a window in another application.
' Usage examples:
'   DIM wszText AS WSTRING * 260 = "Some text"
'   AfxSetWindowText(hwnd, @wszText)
' -or-
'   AfxSetWindowText(hwnd, "Some text")
' ========================================================================================
Function AfxSetWindowText (hwnd AS HWND, szText AS char ptr) AS BOOL
   Function = SendMessage(hwnd, WM_SETTEXT, 0, (LPARAM) szText)
End Function
$ENDUSE
'==============================================================================
'$IFUSE USE_
''------------------------------------------------------------------------------
'' Sets the text of a window using UTF8 encoded strings. This function can also be used to
'' set the text of buttons, edit and static controls. The return value is TRUE if the text
'' is set or FALSE if it is not.
'' Note: The target window must be an unicode window.
'' Usage example: AfxSetWindowTextUtf8(hwnd, "Дми́трий Дми́триевич")
'' ========================================================================================
'FUNCTION AfxSetWindowUtf8Text (hwnd AS HWND, strUtf8Text AS const char ptr) AS LONG
'	DIM pbstrText$
'	pbstrText$ = AfxUcode(strUtf8Text, CP_UTF8)
'	IF Len(pbstrText$) THEN
'		FUNCTION = SendMessage(hwnd, WM_SETTEXT, 0, (LPARAM) pbstrText)
'		SysFreeString pbstrText
'	END IF
'END FUNCTION
'
''------------------------------------------------------------------------------
'$ENDUSE

' ========================================================================================
$IFUSE USE_AfxGetWindowStyle
' ========================================================================================
' Retrieves the window styles.
' ========================================================================================
Function AfxGetWindowStyle (hwnd AS HWND) AS DWORD
   Function = GetWindowLongPtr(hwnd, GWL_STYLE)
End Function
$ENDUSE
'==============================================================================
$IFUSE USE_AfxGetWindowExStyle
'------------------------------------------------------------------------------
' Retrieves the extended window styles.
' ========================================================================================
Function AfxGetWindowExStyle (hwnd AS HWND) AS DWORD
   Function = GetWindowLongPtr(hwnd, GWL_EXSTYLE)
End Function
$ENDUSE
'==============================================================================
$IFUSE USE_AfxSetWindowStyle
'------------------------------------------------------------------------------
' Sets the window styles
' ========================================================================================
Function AfxSetWindowStyle ( hwnd AS HWND,  dwStyle AS DWORD) AS DWORD
   Raw As DWORD dwOldStyle = GetWindowLongPtr(hwnd, GWL_STYLE)
   SetWindowLongPtr(hwnd, GWL_STYLE, dwStyle)
   Function = dwOldStyle
End Function
$ENDUSE
'==============================================================================
$IFUSE USE_AfxSetWindowExStyle
'------------------------------------------------------------------------------
' Sets the window extended styles
' ========================================================================================
Function AfxSetWindowExStyle(hwnd AS HWND,dwExStyle AS DWORD) AS DWORD
   Raw As DWORD dwOldExStyle = GetWindowLongPtr(hwnd, GWL_EXSTYLE)
   SetWindowLongPtr(hwnd, GWL_EXSTYLE, dwExStyle)
   Function = dwOldExStyle
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxAddWindowStyle
' Adds a new style to the specified window.
' - hwnd  = Window handle
' - dwStyle = Style to add
' Return value:
'   The previous window styles
' ========================================================================================
Function AfxAddWindowStyle (hwnd AS HWND,dwStyle AS DWORD) AS DWORD
	Raw As DWORD dwOldStyle = GetWindowLongPtr(hwnd, GWL_STYLE)
	SetWindowLongPtr(hwnd, GWL_STYLE, dwOldStyle BOR dwStyle)
	Function = dwOldStyle
End Function
$ENDUSE
'==============================================================================
$IFUSE USE_AfxAddWindowExStyle
'------------------------------------------------------------------------------
' Adds a new extended style to the specified window.
' - hwnd  = Window handle
' - dwExStyle = Style to add
' Return value:
'   The previous extended window styles
' ========================================================================================
Function AfxAddWindowExStyle (hwnd AS HWND,dwExStyle AS DWORD) AS DWORD
	Raw As DWORD dwOldExStyle = GetWindowLongPtr(hwnd, GWL_EXSTYLE)
	SetWindowLongPtr(hwnd, GWL_EXSTYLE, dwOldExStyle BOR dwExStyle)
	Function = dwOldExStyle
End Function
$ENDUSE
' ========================================================================================
$IFUSE USE_AfxRemoveWindowStyle
' ========================================================================================
' Removes an style from the specified window.
' - hwnd  = Window handle
' - dwStyle = Style to remove
' Return value:
'   The previous window styles
' ========================================================================================
Function AfxRemoveWindowStyle (hwnd AS HWND,dwStyle AS DWORD) As DWORD
   Dim As DWORD dwOldStyle  = GetWindowLongPtr(hwnd, GWL_STYLE)
   SetWindowLongPtr(hwnd, GWL_STYLE, dwOldStyle XOR dwStyle)
   Function = dwOldStyle
End Function
$ENDUSE
'==============================================================================
$IFUSE USE_AfxRemoveWindowExStyle
' ========================================================================================
' Removes an extended style from the specified window.
' - hwnd  = Window handle
' - dwExStyle = Style to remove
' Return value:
'   The previous window styles
' ========================================================================================
Function AfxRemoveWindowExStyle (hwnd AS HWND,dwExStyle AS DWORD) AS DWORD
   Dim As DWORD dwOldExStyle = GetWindowLongPtr(hwnd, GWL_EXSTYLE)
   SetWindowLongPtr(hwnd, GWL_EXSTYLE, dwOldExStyle XOR dwExStyle)
   Function = dwOldExStyle
End Function
$ENDUSE
'==============================================================================
$IFUSE USE_AfxGetWindowRect
' ========================================================================================
' Retrieves the dimensions of the bounding rectangle of the specified window. The dimensions
' are given in screen coordinates that are relative to the upper-left corner of the screen.
' Note: To retrieve the height of the desktop window pass the handle returned by the
' API function GetDesktopWindow.
' ========================================================================================
Function AfxGetWindowRect ( hwnd AS HWND) AS RECT
	Dim As RECT rc
	GetWindowRect(hwnd, &rc)
	Function = rc
End Function
$ENDUSE
'==============================================================================
$IFUSE USE_AfxGetWindowWidth
' ========================================================================================
' Gets the width in pixels of a window.
' Note: To retrieve the height of the desktop window pass the handle returned by the
' API function GetDesktopWindow.
' ========================================================================================
Function AfxGetWindowWidth (hwnd AS HWND) As Long
	Dim As RECT rc 
	GetWindowRect(hwnd, &rc)
	Function = rc.right - rc.left
End Function
$ENDUSE
'==============================================================================
$IFUSE USE_AfxGetWindowHeight
' ========================================================================================
' Gets the height in pixels of a window.
' Note: To retrieve the height of the desktop window pass the handle returned by the
' API function GetDesktopWindow.
' ========================================================================================
Function AfxGetWindowHeight (hwnd AS HWND) As Long
	Dim As RECT rc
	GetWindowRect(hwnd, &rc)
	Function = rc.bottom - rc.top
End Function
' ========================================================================================
$ENDUSE
'==============================================================================
$IFUSE USE_AfxGetWindowClientRect
'------------------------------------------------------------------------------
' Retrieves the coordinates of a window's client area. The client coordinates specify the
' upper-left and lower-right corners of the client area. Because client coordinates are
' relative to the upper-left corner of a window's client area, the coordinates of the
' upper-left corner are (0,0).
' Note: To retrieve the height of the desktop window pass the handle returned by the
' API function GetDesktopWindow.
' ========================================================================================
Function AfxGetWindowClientRect (hwnd AS HWND) AS RECT
	Dim As RECT rc
	GetClientRect(hwnd, &rc)
	Function = rc
End Function
'------------------------------------------------------------------------------
$ENDUSE
' ========================================================================================
$IFUSE USE_AfxGetWindowClientWidth
'------------------------------------------------------------------------------
' Gets the width in pixels of the client area of a window.
' Note: To retrieve the height of the desktop window pass the handle returned by the
' API function GetDesktopWindow.
'==============================================================================
Function AfxGetWindowClientWidth (hwnd AS HWND) AS LONG
	Dim As RECT rc
	GetClientRect(hwnd, &rc)
	Function = rc.right - rc.left
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxGetWindowClientHeight
'------------------------------------------------------------------------------
' Gets the height in pixels of the client area of a window.
' Note: To retrieve the height of the desktop window pass the handle returned by the
' API function GetDesktopWindow.
' ========================================================================================
Function AfxGetWindowClientHeight ( hwnd AS HWND) AS LONG
	Dim As RECT rc
	GetClientRect(hwnd, &rc)
	Function = rc.bottom - rc.top
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxGetWorkAreaRect
'------------------------------------------------------------------------------
' Retrieves the coordinates of the work area on the primary display monitor expressed in
' virtual screen coordinates. The work area is the portion of the screen not obscured by
' the system taskbar or by application desktop toolbars. To get the work area of a monitor
' other than the primary display monitor, call the GetMonitorInfo function.
' ========================================================================================
Function AfxGetWorkAreaRect () AS RECT
	Dim As RECT rcWrk
	SystemParametersInfo(SPI_GETWORKAREA, 0, &rcWrk, 0)
	Function = rcWrk
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxGetWorkAreaWidth
'------------------------------------------------------------------------------
Function AfxGetWorkAreaWidth () AS LONG
	Dim As RECT rcWrk
	SystemParametersInfo(SPI_GETWORKAREA, 0, &rcWrk, 0)
	Function = rcWrk.right - rcWrk.left
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxGetWorkAreaHeight
'------------------------------------------------------------------------------
Function AfxGetWorkAreaHeight () AS LONG
	Dim As RECT rcWrk
	SystemParametersInfo(SPI_GETWORKAREA, 0, &rcWrk, 0)
	Function = rcWrk.bottom - rcWrk.top
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxCenterWindow
'------------------------------------------------------------------------------
' Centers a window on the screen or over another window.
' It also ensures that the placement is done within the work area.
' Parameters:
' - hwnd = Handle of the window.
' - hwndParent = [optional] Handle of the parent window.
'------------------------------------------------------------------------------
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'Modified 10/20/2016 to do normal center along with HORZ and VERT
'------------------------------------------------------------------------------
CONST VCENTER = 1
CONST HCENTER = 2
Sub AfxCenterWindow(hwnd As HWND,hwndParent As HWND,vh = 0)
	Dim As RECT rc,rcParent,rcWorkArea
	Dim As POINT pt
   ' // Get the coordinates of the window
	GetWindowRect(hwnd, &rc)
   ' // Calculate the width and height of the window
	Raw As Long nWidth = rc.right - rc.left
	Raw As Long nHeight = rc.bottom - rc.top
	' // Get the coordinates of the work area
   	If SystemParametersInfo(SPI_GETWORKAREA, SIZEOF(rcWorkArea), &rcWorkArea, 0) = 0 Then
		rcWorkArea.right  = GetSystemMetrics(SM_CXSCREEN)
		rcWorkArea.bottom = GetSystemMetrics(SM_CYSCREEN)
   	EndIf
	' // Get the coordinates of the parent window
	If hwndParent Then
		GetWindowRect(hwndParent, &rcParent)
	Else
		rcParent.left   = rcWorkArea.left
		rcParent.top    = rcWorkArea.top
		rcParent.right  = rcWorkArea.right
		rcParent.bottom = rcWorkArea.bottom
	End If
	' // Calculate the width and height of the parent window
	Raw As LONG nParentWidth = rcParent.right - rcParent.left
	Raw As LONG nParentHeight = rcParent.bottom - rcParent.top
	' // Calculate the new x coordinate and adjust for work area
	If vh = 2 Then
		pt.x = rc.left
	Else	
		pt.x = rcParent.left + ((nParentWidth - nWidth) / 2)
		If (pt.x < rcWorkArea.left) Then
			pt.x = rcWorkArea.left
		ElseIf ((pt.x + nWidth) > rcWorkArea.right) Then
			pt.x = rcWorkArea.right - nWidth
		End If
	End If	
'==============================================================================	
	If vh = 1 Then
		pt.y = rc.top
	Else
		' // Calculate the new y coordinate and adjust for work area
		pt.y = rcParent.top  + ((nParentHeight - nHeight) / 2)
		If (pt.y < rcWorkArea.top) Then
			pt.y = rcWorkArea.top
		ElseIf ((pt.y + nHeight) > rcWorkArea.bottom) Then
			pt.y = rcWorkArea.bottom - nHeight
		End If
	End If
	' // Convert screen coordinates to client area coordinates
	IF (GetWindowLongPtr(hwnd, GWL_STYLE) BAND WS_CHILD) = WS_CHILD Then
		ScreenToClient(hwndParent, &pt)
	EndIf
	' // Reposition the window retaining its size and Z order
	SetWindowPos(hwnd, NULL, pt.x, pt.y, 0, 0, SWP_NOSIZE BOR SWP_NOZORDER)
	
End Sub

'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxSetWindowClientSize
'------------------------------------------------------------------------------
' Adjusts the bounding rectangle of a window based on the desired size of the client area.
' Parameters:
' - hwnd = The window handle.
' - nWidth and nHeight = The desired size of the client area.
' - rxRatio and ryRatio = Scaling ratios.
'------------------------------------------------------------------------------
Sub AfxSetWindowClientSize(hwnd As HWND,nWidth As Long,nHeight As Long,rxRatio = 1 As Single,ryRatio = 1 As Single)
	Dim As RECT rc,rcTemp
   ' // Convert the client rectangle to a window rectangle.
   ' // The AdjustWindowRectEx function cannot take menu wrapping into account
   ' // because it doesn't know which menu we are using.
	SetRect(&rc,0,0,nWidth * rxRatio,nHeight * ryRatio)
	Raw As HANDLE hMenu = GetMenu(hwnd)
	Raw As DWORD dwStyle = GetWindowLongPtr(hwnd, GWL_STYLE)
	AdjustWindowRectEx(&rc, dwStyle, (hMenu <> NULL), GetWindowLongPtr(hwnd, GWL_EXSTYLE))
   ' // If there is a menu, we need to check how much wrapping occurs when we set
   ' // the window to the width specified by AdjustWindowRectEX and an infinite
   ' // amount of height. An infinite height allows us to see every single menu wrap.
	If hMenu <> NULL Then
		rcTemp = rc
		rcTemp.bottom = 0x7FFF   ' // "Infinite" height
		SendMessage(hwnd, WM_NCCALCSIZE, 0, (LPARAM) &rcTemp)
		' // Adjust our previous calculation to compensate for menu wrapping.
		rc.bottom = rc.bottom + rcTemp.top
	EndIf
   ' // The AdjustWindowRectEx function does not take the WS_VSCROLL or WS_HSCROLL
   ' // styles into account. To account for the scroll bars, we need to call the
   ' // GetSystemMetrics function with SM_CXVSCROLL or SM_CYHSCROLL.
	If (dwStyle BAND WS_HSCROLL) = WS_HSCROLL Then
		rc.bottom = rc.bottom + GetSystemMetrics(SM_CYHSCROLL)
	End If
	If (dwStyle BAND WS_VSCROLL) = WS_VSCROLL THEN
		rc.right = rc.right + GetSystemMetrics(SM_CXVSCROLL)
	End If
	Raw As Long cx  = rc.right - rc.left,cy = rc.bottom - rc.top 

	SetWindowPos(hwnd, NULL, 0, 0, cx, cy, SWP_NOZORDER BOR SWP_NOMOVE BOR SWP_NOACTIVATE)
	
End Sub
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxRedrawWindow
'------------------------------------------------------------------------------
' Redraws the specified window.
' Do not use it from within a WM_PAINT message.
'------------------------------------------------------------------------------
Sub AfxRedrawWindow (hwnd AS HWND)
	InvalidateRect(hwnd, NULL, TRUE)
	UpdateWindow(hwnd)
End Sub
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxRedrawNonClientArea
'------------------------------------------------------------------------------
' Redraws the non-client area of the specified window.
' Return value: TRUE or FALSE. To get extended error information, call GetLastError.
'------------------------------------------------------------------------------
Function AfxRedrawNonClientArea (hwnd AS HWND) AS BOOL
	Function = SetWindowPos(hwnd, 0, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE | SWP_FRAMECHANGED | SWP_DRAWFRAME)
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxForwardSizeMessage
'------------------------------------------------------------------------------
' Sends a WM_SIZE message to the specified window.
' Parameters:
' - hwnd = Handle of the window.
' - nResizeType = Type of resizing requested.
' - nWidth = The new width of the client area.
' - nHeight = The new height of the client ara.
' Return value:
' If an application processes this message, it should return zero.
' ========================================================================================
Function AfxForwardSizeMessage (hwnd AS HWND, nResizeType AS DWORD, nWidth AS LONG,  nHeight AS LONG) AS LRESULT
	Function = SendMessage(hwnd, WM_SIZE, nResizeType, MAKELONG(nWidth, nHeight))
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxSetWindowLocation
'------------------------------------------------------------------------------
' Sets the location of the top left corner of the window, in pixels.
' The location is relative to the upper-left corner of the client area in the parent window.
' Return value: TRUE or FALSE. To get extended error information, call GetLastError.
' ========================================================================================
Function AfxSetWindowLocation (hwnd AS HWND, nLeft AS LONG, nTop AS LONG) AS BOOL
	Function = SetWindowPos(hwnd, 0, nLeft, nTop, 0, 0, SWP_NOSIZE BOR SWP_NOZORDER)
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxSetWindowSize
'------------------------------------------------------------------------------
' Sets the size in pixels of the specified window.
' - hwnd = Handle of the window.
' - nWidth = The new width of the client area.
' - nHeight = The new height of the client ara.
' Return value: TRUE or FALSE. To get extended error information, call GetLastError.
' ========================================================================================
Function AfxSetWindowSize (hwnd AS HWND, nWidth AS LONG, nHeight AS LONG) AS BOOL
	Function = SetWindowPos(hwnd, NULL, 0, 0, nWidth, nHeight, SWP_NOZORDER BOR SWP_NOMOVE)
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxShowWindowState
'------------------------------------------------------------------------------
' Change the visible state of a window.
' Parameters:
' - hwnd = The handle of the window.
' - nShowState
'   SW_FORCEMINIMIZE : Minimizes a window, even if the thread that owns the window is not
'   responding. This flag should only be used when minimizing windows from a different thread.
'   SW_HIDE : Hides the window and activates another window.
'   SW_MAXIMIZE : Maximizes the specified window.
'   SW_MINIMIZE : Minimizes the specified window and activates the next top-level window in the Z order.
'   SW_RESTORE : Activates and displays the window. If the window is minimized or maximized,
'   the system restores it to its original size and position. An application should specify
'   this flag when restoring a minimized window.
'   SW_SHOW : Activates the window and displays it in its current size and position.
'   SW_SHOWDEFAULT : Sets the show state based on the SW_ value specified in the STARTUPINFO
'   structure passed to the CreateProcess function by the program that started the application.
'   SW_SHOWMAXIMIZED : Activates the window and displays it as a maximized window.
'   SW_SHOWMINIMIZED : Activates the window and displays it as a minimized window.
'   SW_SHOWMINNOACTIVE : Displays the window as a minimized window. This value is similar
'   to SW_SHOWMINIMIZED, except the window is not activated.
'   SW_SHOWNA : Displays the window in its current size and position. This value is similar
'   to SW_SHOW, except that the window is not activated.
'   SW_SHOWNOACTIVATE : Displays a window in its most recent size and position. This value is
'   similar to SW_SHOWNORMAL, except that the window is not activated.
'   SW_SHOWNORMAL : Activates and displays a window. If the window is minimized or maximized,
'   the system restores it to its original size and position. An application should specify
'   this flag when displaying the window for the first time.
' Return value:
' TRUE if the window was previously visible.
' FALSE if the window was previously hidden.
' ========================================================================================
Function AfxShowWindowState (hwnd AS HWND, nShowState AS LONG) AS BOOL
	Function = ShowWindow(hwnd, nShowState)
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxSetWindowIcon
'------------------------------------------------------------------------------
' Associates a new icon with a window. The system displays the large icon in the
' ALT+TAB dialog box and the small icon in the window caption.
' Parameters:
' - hwnd  = Window handle
' - hIcon = Handle to the new icon. If this parameter is NULL, the icon is removed.
' - nIconType = ICON_BIG (1) or ICON_SMALL (0).
' The return value is a handle to the previous large or small icon, depending on the value of
' nIconType It is NULL if the window previously had no icon of the type indicated by nIconType.
' ========================================================================================
Function AfxSetWindowIcon (hwnd AS HWND,nIconType AS LONG, hIcon AS HICON) AS HICON
	Function = (HICON) SendMessage(hwnd, WM_SETICON, nIconType, (LPARAM) hIcon)
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxForceSetForegroundWindow
'------------------------------------------------------------------------------
' Brings the thread that created the specified window into the foreground and activates
' the window. Keyboard input is directed to the window, and various visual cues are changed
' for the user. The system assigns a slightly higher priority to the thread that created
' the foreground window than it does to other threads.
' Replacement for the SetForegroundWindow API function, that sometimes fails.
' ========================================================================================
Sub AfxForceSetForegroundWindow ( hwnd AS HWND)
	Dim As DWORD dwProcessId 
	Dim As HWND hwndForeground  = GetForegroundWindow()
	Dim As DWORD dwThreadId  = GetWindowThreadProcessId(hwndForeground, &dwProcessId)
	Dim As DWORD dwCurThreadId = GetCurrentThreadId()
	AttachThreadInput(dwCurThreadId, dwThreadId, TRUE)
	SetForegroundWindow(hwnd)
	BringWindowToTop(hwnd)
	SetFocus(hwnd)
	AttachThreadInput(dwCurThreadId, dwThreadId, FALSE)
End Sub
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
'==============================================================================
$IFUSE USE_AfxForceVisibleDisplay
'------------------------------------------------------------------------------
' If you use dual (or even triple/quad) displays then you have undoubtedly encountered the
' following situation: You change the physical order of your displays, or otherwise
' reconfigure the logical ordering using your display software. This sometimes has the
' side-effect of changing your desktop coordinates from zero-based to negative starting
' coordinates (i.e. the top-left coordinate of your desktop changes from 0,0 to -1024,-768).
' This effects many Windows programs which restore their last on-screen position whenever
' they are started. Should the user reorder their display configuration this can sometimes
' result in a Windows program subsequently starting in an off-screen position (i.e. at a
' location that used to be visible) - and is now effectively invisible, preventing the
' user from closing it down or otherwise moving it back on-screen.
' The ForceVisibleDisplay function can be called at program start-time right after the
' main window has been created and positioned 'on-screen'. Should the window be positioned
' in an off-screen position, it is forced back onto the nearest display to its last
' position. The user will be unaware this is happening and won't even realise to thank you
' for keeping their user-interface visible, even though they changed their display
' settings.
' Source: http://www.catch22.net/tuts/tips2
' ========================================================================================
Sub AfxForceVisibleDisplay ( hwnd AS HWND)
	' // Check if the specified window-rectangle is visible on any display
	DIM As RECT rc 
	GetWindowRect(hwnd, &rc)
	If MonitorFromRect(&rc, MONITOR_DEFAULTTONULL) <> NULL Then
		Exit Sub
	EndIf
	' // Find the nearest display to the rectangle
	Dim As HMONITOR hMonitor 
	Dim As MONITORINFO mi 
	mi.cbSize = SIZEOF(mi)
	hMonitor = MonitorFromRect(&rc, MONITOR_DEFAULTTONEAREST)
	GetMonitorInfo(hMonitor, &mi)
	' // Center window rectangle
	rc.left = mi.rcWork.left + ((mi.rcWork.right - mi.rcWork.left) - (rc.right-rc.left)) /2
	rc.top = mi.rcWork.top + ((mi.rcWork.bottom - mi.rcWork.top) - (rc.bottom-rc.top)) /2
	SetWindowPos(hwnd, 0, rc.left, rc.top, 0, 0, SWP_NOACTIVATE | SWP_NOZORDER | SWP_NOSIZE)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxGetTopLevelWindow
'------------------------------------------------------------------------------
' Retrieves the window's top-level parent or owner window.
' ========================================================================================
Function AfxGetTopLevelWindow (hwnd AS HWND) AS HWND
	Dim As HWND hWndParent,  hWndTmp 
	If IsWindow(hwnd) = NULL Then
		Exit Function
	EndIf
	hWndTmp = hwnd
	Do
		hWndParent = hWndTmp
		If (GetWindowLongPtr(hWndParent, GWL_STYLE) BAND WS_CHILD) Then
			hWndTmp = GetParent(hWndParent)
		Else
			 hWndTmp = GetWindow(hWndParent, GW_OWNER)
		End If	 
		If hWndTmp = NULL Then
			Exit Do
		EndIf
	Loop
	Function = hWndParent
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
'==============================================================================
$IFUSE USE_AfxGetFormHandle
'------------------------------------------------------------------------------
' Finds the handle of the top-level window or MDI child window that is the ancestor of the
' specified window handle. The reference handle is the handle of any control on the form.
' Code borrowed from a function written by Dominic Mitchell for Phoenix.
' ========================================================================================
Function AfxGetFormHandle ( hwnd AS HWND) AS HWND
   While (GetWindowLongPtr(hwnd, GWL_STYLE) BAND WS_CHILD)
      If (GetWindowLongPtr(hwnd, GWL_EXSTYLE) BAND WS_EX_MDICHILD) Then
      	Exit Whilw
      EndIf
      hwnd = GetParent(hwnd)
   Wend
   Function = hwnd
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
'==============================================================================
$IFUSE USE_AfxGetControlHandle
'------------------------------------------------------------------------------
' Returns the handle of the control with the specified identifier. The reference handle
' can be the handle of the form or the handle of any other control on the form.
' Parameters:
' - hwnd = Reference window handle.
' - Control identifier.
' Returns the handle of the control or NULL.
' ========================================================================================

' // Enumerates child controls on the specified window.
' // Callback function for AfxGetControlHandle.
' // Parameters:
' // hwnd = Handle of child window.
' // lParam = Address of variable with child window handle
' // Return value: CTRUE or FALSE

Function AfxGetControlHandle_ChildEnumProc ( hwnd AS HWND, lParam AS LPARAM) AS LONG
	Dim As HWND Ptr pItem 
	pItem = (HWND*)lParam
	If GetDlgCtrlID(hwnd) = LOWORD(*pItem) THEN
		*pItem = hwnd
		Exit Function
	End If
	Function = TRUE
End Function
'------------------------------------------------------------------------------
Function AfxGetControlHandle (hwnd AS HWND, wCtrlID AS WORD) AS HWND
	Dim As HWND hwndChild 
	hwnd = AfxGetFormHandle(hwnd)
	hwndChild = (HWND)(DWORD_PTR) wCtrlID
	EnumChildWindows(hwnd, (WNDENUMPROC)&AfxGetControlHandle_ChildEnumProc, (LPARAM) &hwndChild)
	If hwndChild = (HWND)wCtrlID Then
		Function = NULL
	Else
		Function = hwndChild
	EndIf
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
'==============================================================================
$IFUSE USE_AfxGetTopEnabledWindow
'------------------------------------------------------------------------------
' Retrieves the handle of the enabled and visible window at the top of the z-order in an
' application.
' Return value: Handle of window at top of z-order or NULL.
'------------------------------------------------------------------------------

' // Callback enumeration procedure for finding the window at the top of the z-order.
' // Parameters:
' // hwnd = Handle of top-level window
' // lParam = Address of variable for window handle
'------------------------------------------------------------------------------
Function AfxGetTopEnabledWindow_EnumWindowsProc (hwnd As HWND, lParam As LPARAM) AS LONG
	Dim wszClassName$ * MAX_PATH
	Dim As HWND Ptr phwndTop
	Dim As DWORD dwProcessId
	If IsWindowEnabled(hwnd) Then
		If IsWindowVisible(hwnd) Then	
			GetClassName(hwnd, (LPWSTR)&wszClassName,MAX_PATH) 
			If wszClassName <> "tooltips_class32" Then
				GetWindowThreadProcessId(hwnd, &dwProcessId)
				If dwProcessId = GetCurrentProcessId() Then
					phwndTop = (HWND*)lParam
					*phwndTop = hwnd
					Exit Function
				End If
			End If
		End If
	End If
	Function = TRUE
End Function
'------------------------------------------------------------------------------
Function AfxGetTopEnabledWindow () AS HWND
	Dim As HWND hwndTop
	EnumWindows((WNDENUMPROC)&AfxGetTopEnabledWindow_EnumWindowsProc, (LPARAM) &hwndTop)
	Function = hwndTop
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
'==============================================================================
$IFUSE USE_AfxGethWndFromPID
'------------------------------------------------------------------------------
' Retrieves a window handle given it's process identifier
'------------------------------------------------------------------------------
Function AfxGethWndFromPID ( PID AS DWORD) AS HWND
	Dim As DWORD dwPID , dwThreadID 
	' // Get the first window handle
	Dim As HWND hwnd = FindWindow(NULL, NULL)
	' // Enumerate all the windows
	While hwnd <> NULL
		' // If the parent window is NULL, it's a top level window
		If GetParent(hwnd) = NULL Then
			' // Get it's process id
			dwThreadID = GetWindowThreadProcessId(hwnd, &dwPID)
			If dwPID = PID Then
				' // We have found it
				Function = hwnd
				'EXIT WHILE
			End If
		End If
		' // Get the next window handle
		hwnd = GetWindow(hwnd, GW_HWNDNEXT)
	Wend
	Function = NULL
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
'==============================================================================
$IFUSE USE_AfxGetWindowLocation
'------------------------------------------------------------------------------
' Gets the location of the top left corner of the window, in pixels.
' The location is relative to the upper-left corner of the client area in the parent window.
'------------------------------------------------------------------------------
Sub AfxGetWindowLocation ( hwnd As HWND, nLeft As LONG PTR, nTop As LONG PTR)
	Dim As RECT rc
	' // Get the dimensions of the window
	GetWindowRect(hwnd, &rc)
	' // Convert the coordinates to be relative to the parent
	MapWindowPoints(HWND_DESKTOP, GetParent(hwnd), (POINT PTR) &rc, 2)
	' // Return the left and top values
	*nLeft = rc.left
	*nTop = rc.top
End Sub
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
'==============================================================================
$IFUSE USE_AfxSetDlgMsgResult
'------------------------------------------------------------------------------
' Sets the return value of a message processed in the dialog box procedure.
' Return value: TRUE or FALSE.
'------------------------------------------------------------------------------
Function AfxSetDlgMsgResult( hwnd As HWND, uMsg As UINT, result As LONG) AS BOOL
	IF uMsg = WM_CTLCOLORMSGBOX      OR _
		uMsg = WM_CTLCOLOREDIT        OR _
		uMsg = WM_CTLCOLORLISTBOX     OR _
		uMsg = WM_CTLCOLORBTN         OR _
		uMsg = WM_CTLCOLORDLG         OR _
		uMsg = WM_CTLCOLORSCROLLBAR   OR _
		uMsg = WM_CTLCOLORSTATIC      OR _
		uMsg = WM_COMPAREITEM         OR _
		uMsg = WM_VKEYTOITEM          OR _
		uMsg = WM_CHARTOITEM          OR _
		uMsg = WM_QUERYDRAGICON       OR _
		uMsg = WM_INITDIALOG          Then
		Function = (BOOL) IIF(SetWindowLongPtr(hwnd, DWLP_MSGRESULT, result), TRUE, FALSE)
	End If
	Function = FALSE
End Function

'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
' ########################################################################################
'                              *** DPI RELATED PROCEDURES ***
' ########################################################################################

'==============================================================================
$IFUSE USE_AfxSetProcessDPIAware
$TYPEDEF BOOL (*BC9_AfxSetProcessDPIAware)()
'------------------------------------------------------------------------------
' Sets the current process as dots per inch (dpi) aware.
' Note: SetProcessDPIAware is subject to a possible race condition if a DLL caches dpi
' settings during initialization. For this reason, it is recommended that dpi-aware be set
' through the application (.exe) manifest rather than by calling SetProcessDPIAware.
' Return value: TRUE on success; FALSE on failure.
'------------------------------------------------------------------------------
Function AfxSetProcessDPIAware () As BOOL
	Dim As HMODULE pLib = LoadLibrary("user32.dll")
	Dim As BOOL bRet
	If pLib = 0 Then
		Exit Function
	EndIf
	Dim pProc As BC9_AfxSetProcessDPIAware 
	pProc = (BC9_AfxSetProcessDPIAware)GetProcAddress(pLib, "SetProcessDPIAware")
	If pProc = 0 Then
		Exit Function
	EndIf
	bRet = pProc()
	FreeLibrary(pLib)
	Function = bRet
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxIsProcessDPIAware
$TYPEDEF BOOL (*BC9_AfxIsProcessDPIAware)()
'------------------------------------------------------------------------------
' Determines whether the current process is dots per inch (dpi) aware such that it adjusts
' the sizes of UI elements to compensate for the dpi setting.
' Return value: TRUE or FALSE
'------------------------------------------------------------------------------
Function AfxIsProcessDPIAware () As BOOL
	Dim As HMODULE pLib = LoadLibrary("user32.dll")
	Dim As BOOL bRet
	If pLib = 0 Then
		Exit Function
	EndIf
	Dim pProc As BC9_AfxIsProcessDPIAware 
	pProc = (BC9_AfxIsProcessDPIAware)GetProcAddress(pLib, "IsProcessDPIAware")
	If pProc = 0 Then
		Exit Function
	EndIf
	bRet = pProc()
	FreeLibrary(pLib)
	Function = bRet
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxUseDpiScaling
'------------------------------------------------------------------------------
' Retrieves the value of the UseDpiScaling setting (Vista/Windows 7+).
' Returns TRUE if the OS uses DPI scaling; FALSE otherwise.
'------------------------------------------------------------------------------
Function AfxUseDpiScaling() As BOOL
	Dim As HKEY hkRes
	Dim As DWORD dwType,dwData,cbData
	If RegOpenKeyEx(HKEY_CURRENT_USER, "Software\Microsoft\Windows\DWM", 0, KEY_QUERY_VALUE, &hkRes) = ERROR_SUCCESS Then
		If hkRes Then
			cbData = SIZEOF(cbData)
			Raw AS Long hr = RegQueryValueEx(hkRes, "UseDpiScaling", 0, &dwType,  (BYTE PTR)&dwData, &cbData)
			RegCloseKey(hkRes)
			If hr = ERROR_SUCCESS Then
				Function = (dwData <> 0)
			EndIf
		EndIf
	EndIf
	Function = 0
End Function
$ENDUSE
'==============================================================================
$IFUSE USE_AfxLogPixelsX
'------------------------------------------------------------------------------
' Retrieves the number of pixels per logical inch along the screen width of the desktop
' window. In a system with multiple display monitors, this value is the same for all monitors.
' ========================================================================================
Function AfxLogPixelsX () AS LONG
	Dim As HDC hDC = GetDC(HWND_DESKTOP)
	Dim As Long dpiX  = GetDeviceCaps(hDC, LOGPIXELSX)
	ReleaseDC(HWND_DESKTOP, hDC)
	Function = dpiX
End Function
'------------------------------------------------------------------------------
CONST AfxGetDpiX = AfxLogPixelsX
$ENDUSE
'==============================================================================
$IFUSE USE_AfxLogPixelsY
'------------------------------------------------------------------------------
' Retrieves the number of pixels per logical inch along the screen height of the desktop
' window. In a system with multiple display monitors, this value is the same for all monitors.
' ========================================================================================
Function AfxLogPixelsY () AS LONG
   Dim As HDC hDC  = GetDC(HWND_DESKTOP)
   Dim As Long dpiY = GetDeviceCaps(hDC, LOGPIXELSY)
   ReleaseDC( HWND_DESKTOP, hDC)
   Function = dpiY
End Function
'------------------------------------------------------------------------------
CONST AfxGetDpiY = AfxLogPixelsY
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxScaleRatioX
'------------------------------------------------------------------------------
' Retrieves the desktop horizontal scaling ratio.
'------------------------------------------------------------------------------
Function AfxScaleRatioX () AS SINGLE
	Dim As HDC hDC = GetDC(HWND_DESKTOP)
	Dim As Single rxRatio  = (GetDeviceCaps(hDC, LOGPIXELSX) / 96)
	ReleaseDC(HWND_DESKTOP, hDC)
	Function = rxRatio
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxScaleRatioY
'------------------------------------------------------------------------------
' Retrieves the desktop vertical scaling ratio.
'------------------------------------------------------------------------------
Function AfxScaleRatioY () AS SINGLE
	Dim As HDC hDC = GetDC(HWND_DESKTOP)
	Dim As Single ryRatio  = (GetDeviceCaps(hDC, LOGPIXELSY) / 96)
	ReleaseDC(HWND_DESKTOP, hDC)
	Function = ryRatio
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxScaleX
'------------------------------------------------------------------------------
' Scales an horizontal coordinate according the DPI (dots per pixel) being used by the desktop.
'------------------------------------------------------------------------------
Function AfxScaleX ( cx AS SINGLE) AS SINGLE
	Dim As HDC hDC  = GetDC(HWND_DESKTOP)
	Dim As Single RetVal = cx * (GetDeviceCaps(hDC, LOGPIXELSX) / 96)
	ReleaseDC( HWND_DESKTOP, hDC)
	Function = RetVal
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxScaleY
'------------------------------------------------------------------------------
' Scales a vertical coordinate according the DPI (dots per pixel) being used by the desktop.
' ========================================================================================
Function AfxScaleY ( cy AS SINGLE) AS SINGLE
	Dim As HDC hDC = GetDC(HWND_DESKTOP)
	Dim As Single RetVal = cy * (GetDeviceCaps(hDC, LOGPIXELSY) / 96)
	ReleaseDC(HWND_DESKTOP, hDC)
	Function = RetVal
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxUnscaleX
'------------------------------------------------------------------------------
' Unscales an horizontal coordinate according the DPI (dots per pixel) being used by the desktop.
' ========================================================================================
Function AfxUnscaleX (BYVAL cx AS SINGLE) AS SINGLE
	Dim As HDC hDC = GetDC(HWND_DESKTOP)
	Dim As Single RetVal = cx / (GetDeviceCaps(hDC, LOGPIXELSX) / 96)
	ReleaseDC(HWND_DESKTOP, hDC)
	Function = RetVal
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxUnscaleY
'------------------------------------------------------------------------------
' Unscales a vertical coordinate according the DPI (dots per pixel) being used by the desktop.
' ========================================================================================
Function AfxUnscaleY (cy AS SINGLE) AS SINGLE
	Dim As HDC hDC  = GetDC(HWND_DESKTOP)
	Dim As Single RetVal = cy / (GetDeviceCaps(hDC, LOGPIXELSY) / 96)
	ReleaseDC(HWND_DESKTOP, hDC)
	Function = RetVal
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxIsResolutionAtLeast
'------------------------------------------------------------------------------
' Determines if screen resolution meets minimum requirements.
' Parameters:
' - cxMin = Minimum screen resolution width in pixels.
' - cxMin = Minimum screen resolution height in pixels.
' Return value: TRUE or FALSE.
' ========================================================================================
Function AfxIsResolutionAtLeast (cxMin AS LONG, cyMin AS LONG) AS BOOL
	Dim As Long ScreenWidth = GetSystemMetrics(SM_CXSCREEN)
	Dim As Long ScreenHeight = GetSystemMetrics(SM_CYSCREEN)
	If (cxMin <= ScreenWidth) AND (cyMin <= ScreenHeight) Then
		Function = TRUE
	EndIf
	Function = FALSE
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxIsDPIResolutionAtLeast
'------------------------------------------------------------------------------
' Determines if screen resolution meets minimum requirements in relative pixels,
' e.g. for a screen resolution of 1920x1080 pixels and a DPI of 192 (scaling ratio = 2),
' the maximum relative pixels for a DPI aware application is 960x540.
' - cxMin = Minimum screen resolution width in relative pixels.
' - cxMin = Minimum screen resolution height in relative pixels.
' Return value: TRUE or FALSE.
' ========================================================================================
Function AfxIsDPIResolutionAtLeast (cxMin AS LONG, cyMin AS LONG) AS BOOL
	' // Get de DPI values used by the desktop window
	Dim As HDC hDC = GetDC(HWND_DESKTOP)
	Dim As Long dpiX = GetDeviceCaps(hDC, LOGPIXELSX)
	Dim As Long dpiY = GetDeviceCaps(hDC, LOGPIXELSY)
	ReleaseDC(HWND_DESKTOP, hDC)
	' // Scale the values
	cxMin = cxMin * dpiX / 96
	cyMin = cyMin * dpiX / 96
	' // Calculate the width and height of the primary display monitor, in pixels
	Dim As Long ScreenWidth  = GetSystemMetrics(SM_CXSCREEN)
	Dim As Long ScreenHeight = GetSystemMetrics(SM_CYSCREEN)
	If (cxMin <= ScreenWidth) AND (cyMin <= ScreenHeight) Then
		Function = TRUE
	EndIf
	Function = FALSE
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxLoadIconMetric
'Declare Function LoadIconMetric LIB "Comctl32.dll" Alias "LoadIconMetric"( hinst AS HINSTANCE,  pszName AS PCWSTR, lims AS LONG, phico AS HICON PTR) AS HRESULT 
$TYPEDEF HRESULT (*BC9_AfxLoadIconMetric)(HINSTANCE, PCWSTR, long, HICON*)
'------------------------------------------------------------------------------
' Loads a specified icon resource with a client-specified system metric.
' See: https://msdn.microsoft.com/en-us/library/windows/desktop/bb775701(v=vs.85).aspx
' ========================================================================================
Function AfxLoadIconMetric (hinst AS HINSTANCE, pszName AS PCWSTR, lims AS LONG, phico AS HICON PTR) AS HRESULT
	'DIM AS ANY PTR pLib = DyLibLoad("Comctl32.dll")
	'IF pLib = NULL THEN EXIT FUNCTION
	'DIM pLoadIconMetric AS FUNCTION (BYVAL hinst AS HINSTANCE, BYVAL pszName AS PCWSTR, BYVAL lims AS LONG, BYVAL phico AS HICON PTR) AS HRESULT
	'pLoadIconMetric = DyLibSymbol(pLib, "LoadIconMetric")
	'IF pLoadIconMetric = NULL THEN EXIT FUNCTION
	'FUNCTION = pLoadIconMetric(hinst, pszName, lims, phico)
	'DyLibFree(pLib)
	Dim As HMODULE pLib = LoadLibrary("Comctl32.dll")
	Dim As HRESULT RetVal
	If pLib = 0 Then
		Exit Function
	EndIf
	Dim pProc As BC9_AfxLoadIconMetric
	pProc = (BC9_AfxLoadIconMetric)GetProcAddress(pLib,"LoadIconMetric")  
	If pProc = 0 Then
		Exit Function
	EndIf
	RetVal = pProc(hinst, pszName, lims, phico)
	FreeLibrary(pLib)
	Function = RetVal
End Function
'------------------------------------------------------------------------------
$ENDUSE
' ########################################################################################
'                                *** METRIC CONVERSIONS ***
' ########################################################################################
'==============================================================================
$IFUSE USE_AfxHiMetricToPixelsX
'------------------------------------------------------------------------------
' Converts from HiMetric to Pixels
' Note: HiMetric is a scaling unit similar to twips used in computing. It is one
' thousandth of a centimeter and is independent of the screen resolution.
' HiMetric per inch = 2540   ' 1 inch = 2.54 mm
' ========================================================================================
' Horizontal resolution
Function AfxHiMetricToPixelsX ( hm AS LONG) AS LONG
	Dim As HDC hDC = GetDC(HWND_DESKTOP)
	Dim As Long nPixelsPerLogicalInchX = GetDeviceCaps(hDC, LOGPIXELSX)
	ReleaseDC(HWND_DESKTOP, hDC)
	Function = MulDiv(hm, nPixelsPerLogicalInchX, 2540)
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxHiMetricToPixelsY
'------------------------------------------------------------------------------
' Vertical resolution
Function AfxHiMetricToPixelsY (BYVAL hm AS LONG) AS LONG
   Dim As HDC hDC  = GetDC(HWND_DESKTOP)
   Dim As long nPixelsPerLogicalInchY = GetDeviceCaps(hDC, LOGPIXELSY)
   ReleaseDC(HWND_DESKTOP, hDC)
   Function = MulDiv(hm, nPixelsPerLogicalInchY, 2540)
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxPixelsToHiMetricX
'------------------------------------------------------------------------------
' Converts from Pixels to HiMetric
' Note: HiMetric is a scaling unit similar to twips used in computing. It is one
' thousandth of a centimeter and is independent of the screen resolution.
' HiMetric per inch = 2540   ' 1 inch = 2.54 mm
' ========================================================================================
' Horizontal resolution
Function AfxPixelsToHiMetricX ( cx AS LONG) AS LONG
	Dim As HDC hDC = GetDC(HWND_DESKTOP)
	Dim As long nPixelsPerLogicalInchX = GetDeviceCaps(hDC, LOGPIXELSX)
	ReleaseDC(HWND_DESKTOP, hDC)
	Function = MulDiv(cx, 2540, nPixelsPerLogicalInchX)
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxPixelsToHiMetricY
'------------------------------------------------------------------------------
' Vertical resolution
Function AfxPixelsToHiMetricY (cy AS LONG) AS LONG
	Dim As HDC hDC = GetDC(HWND_DESKTOP)
	Dim As long nPixelsPerLogicalInchY = GetDeviceCaps(hDC, LOGPIXELSY)
	ReleaseDC(HWND_DESKTOP, hDC)
	Function = MulDiv(cy, 2540, nPixelsPerLogicalInchY)
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxPixelsToPointsX
'------------------------------------------------------------------------------
' Converts pixels to point size (1/72 of an inch).
' ========================================================================================
' Horizontal resolution
Function AfxPixelsToPointsX (pix AS LONG) AS LONG
	Dim As HDC hDC = GetDC(HWND_DESKTOP)
	Dim As long LPX = GetDeviceCaps(hDC, LOGPIXELSX)
	ReleaseDC(HWND_DESKTOP, hDC)
	Function = pix * 72 / LPX
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxPixelsToPointsY
'------------------------------------------------------------------------------
' Vertical resolution
Function AfxPixelsToPointsY ( pix AS LONG) AS LONG
	Dim As HDC hDC = GetDC(HWND_DESKTOP)
	Dim As Long LPY = GetDeviceCaps(hDC, LOGPIXELSY)
	ReleaseDC(HWND_DESKTOP, hDC)
	Function = pix * 72 / LPY
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxPointsToPixelsX
'------------------------------------------------------------------------------
' Converts a point size (1/72 of an inch) to pixels. Horizontal resolution.
' ========================================================================================
' Horizontal resolution
Function AfxPointsToPixelsX ( pts AS LONG) AS LONG
	Dim As HDC hDC = GetDC(HWND_DESKTOP)
	Dim As Long LPX = GetDeviceCaps(hDC, LOGPIXELSX)
	ReleaseDC(HWND_DESKTOP, hDC)
	Function = MulDiv(pts, LPX, 72)
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxPointsToPixelsY
'------------------------------------------------------------------------------
' Vertical resolution
Function AfxPointsToPixelsY ( pts AS LONG) AS LONG
	Dim As HDC hDC = GetDC(HWND_DESKTOP)
	Dim As Long LPY = GetDeviceCaps(hDC, LOGPIXELSY)
	ReleaseDC(HWND_DESKTOP, hDC)
	Function = MulDiv(pts, LPY, 72)
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxPixelsToTwipsX
'------------------------------------------------------------------------------
' Converts pixels to twips.
' Twips are screen-independent units to ensure that the proportion of screen elements are
' the same on all display systems. A twip is defined as being 1/1440 of an inch.
'------------------------------------------------------------------------------
' Horizontal resolution
Function AfxPixelsToTwipsX (nPixels AS LONG) AS LONG
	Dim As HDC hDC = GetDC(HWND_DESKTOP)
	Dim As Long LPX = GetDeviceCaps(hDC, LOGPIXELSX)
	ReleaseDC(HWND_DESKTOP, hDC)
	Function = (nPixels * 1440) / LPX
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxPixelsToTwipsY
'------------------------------------------------------------------------------
' Vertical resolution.
Function AfxPixelsToTwipsY (nPixels AS LONG) AS LONG
	Dim As HDC hDC  = GetDC(HWND_DESKTOP)
	Dim As Long LPY = GetDeviceCaps(hDC, LOGPIXELSY)
	ReleaseDC(HWND_DESKTOP, hDC)
	Function = (nPixels * 1440) / LPY
End Function

'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxTwipsToPixelsX
'------------------------------------------------------------------------------
' Converts twips to pixels.
' Twips are screen-independent units to ensure that the proportion of screen elements are
' the same on all display systems. A twip is defined as being 1/1440 of an inch.
' ========================================================================================
' Horizontal resolution
Function AfxTwipsToPixelsX (nTwips AS LONG) AS LONG
   Dim As HDC hDC = GetDC(HWND_DESKTOP)
   Dim As Long LPX = GetDeviceCaps(hDC, LOGPIXELSX)
   ReleaseDC(HWND_DESKTOP, hDC)
   Function = (nTwips / 1440) * LPX
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxTwipsToPixelsY
'------------------------------------------------------------------------------
' Vertical resolution
Function AfxTwipsToPixelsY (nTwips AS LONG) AS LONG
	Dim As HDC hDC = GetDC(HWND_DESKTOP)
	Dim As Long LPY = GetDeviceCaps(hDC, LOGPIXELSY)
	ReleaseDC(HWND_DESKTOP, hDC)
	Function = (nTwips / 1440) * LPY
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxTwipsPerPixelX
'------------------------------------------------------------------------------
' Returns the width of a pixel, in twips.
' Pixel dimensions can vary between systems and may not always be square, so separate
' functions for pixel width and height are required.
' ========================================================================================
' Horizontal resolution
Function AfxTwipsPerPixelX () AS LONG
   Dim As HDC hDC = GetDC(HWND_DESKTOP)
   Dim As Long LPX = GetDeviceCaps(hDC, LOGPIXELSX)
   ReleaseDC(HWND_DESKTOP, hDC)
   Function = 1440 / LPX
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxTwipsPerPixelY
'------------------------------------------------------------------------------
' Vertical resolution
Function AfxTwipsPerPixelY () AS LONG
	Dim As HDC hDC = GetDC(HWND_DESKTOP)
	Dim As Long LPY = GetDeviceCaps(hDC, LOGPIXELSY)
	ReleaseDC(HWND_DESKTOP, hDC)
	Function = 1440 / LPY
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxPointSizeToDip
'------------------------------------------------------------------------------
' Converts point size to DIP (device independent pixel).
' DIP is defined as 1/96 of an inch and a point is 1/72 of an inch.
' ========================================================================================
Function AfxPointSizeToDip (ptsize AS SINGLE) AS SINGLE
   Function = (ptsize / 72) * 96
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
' ########################################################################################
'                                    *** CLIPBOARD ***
' ########################################################################################

$IFUSE USE_AfxClearClipboard
'------------------------------------------------------------------------------
' Clears the contents of the clipboard.
' Return Value
'   If the function succeeds, the return value is nonzero.
'   If the function fails, the return value is zero.
' ========================================================================================
Function AfxClearClipboard () AS LONG
	Dim As Long RetVal
	' // Opens the clipboard
	If OpenClipboard(NULL) <> 0 Then
		' // Empties the clipboard
		RetVal = EmptyClipboard()
		' // Closes the clipboard
		CloseClipboard()
	End If
	Function = RetVal
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxGetClipboardData
'------------------------------------------------------------------------------
' Retrieves data from the clipboard in the specified format.
' Parameter
'   cfFormat = Clipboard format.
' Return Value
'   If the function succeeds, the return value is the handle to the data.
'   If the function fails, the return value is NULL.
' ========================================================================================
Function AfxGetClipboardData (cfFormat AS DWORD) AS HGLOBAL
	Dim As HANDLE hSource
	' // Opens the clipboard
	If OpenClipboard(NULL) <> 0 Then
		' // Retrieves data from the clipboard in the specified format
		hSource = GetClipboardData(cfFormat)
		' // Closes the clipboard
		CloseClipboard()
		' // Exits on failure
		If hSource = NULL Then
			Exit Function
		EndIf
	End If
	' // Gets the size of the specified global memory object, in bytes
	DIM As size_t dwSize = GlobalSize(hSource)
	' // Exits on failure
	If dwSize = 0 Then
		Exit Function
	EndIf
	' // Gets a pointer to the source memory object
	Dim As LPVOID pSource  = GlobalLock(hSource)
	' // Exits on failure
	If pSource = NULL Then
		Exit Function
	EndIf
	' // Allocates the specified number of bytes from the heap
	Dim As HGLOBAL hDest  = GlobalAlloc(GHND, dwSize)
	' // Exits on failure
	If hDest = NULL Then
		' // Unlocks the source memory object
		GlobalUnlock(hSource)
		Exit Function
	End if
	' // Gets a pointer to the destination memory object
	Dim As LPVOID pDest = GlobalLock(hDest)
	' // Exits on failure
	If pDest = NULL Then
		' // Unlocks the source memory object
		GlobalUnlock(hSource)
		' // Frees the allocated memory block
		GlobalFree(hDest)
		Exit Function
	End if
	' // Copies the data from the source to the destination
	!//<---UNICODE AWARE
	memcpy(pDest, pSource, dwSize)
	!//>---UNICODE AWARE
	' // Unlocks the source memory object
	GlobalUnlock(hSource)
	' // Unlocks the destination memory object
	GlobalUnlock(hDest)
	' // Returns the handle to the data
	Function = hDest
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxGetClipboardText
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'This needs work to convert to bc9
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'------------------------------------------------------------------------------
' ========================================================================================
' Returns an unicode text string from the clipboard.
' Usage examples:
' DIM bs AS AFX_BSTR = AfxGetClipboardText
' AfxMsg bs
' SysFreeString bs
' -or-
' DIM cbs AS CBSTR = AfxGetClipboardText
' IF cbs THEN AfxMsg cbs
' Remarks: Returned as an AFX_BSTR instead of CBSTR or CWSTR for speed.
' ========================================================================================
Function AfxGetClipboardText () As String
	' // If the text format is available...
	'Dim s$ * 32 
	'If IsClipboardFormatAvailable(CF_UNICODETEXT) <> 0 Then
	''	' // Opens the clipboard
	'	If OpenClipboard(NULL) <> 0 Then
	''		' // Gets memory object of clipboard text
	'		Dim As HANDLE hMem  = GetClipboardData(CF_UNICODETEXT)
	'		IF hMem <> NULL Then
	''			' // Locks it and get a pointer
	'			Dim As HGLOBAL pMem = GlobalLock(hMem)
	''			' // Assigns the data to our function return value
	'			If pMem <> NULL Then
	''				' // Gets the size of the global lock
	'				Dim As DWORD dwSize = GlobalSize(hMem)
	'				If dwSize > 0 Then
	''					' // Allocates a BSTR and copies the contents of the clipboard to it
	''					DIM pbstr AS AFX_BSTR = SysAllocStringLen(pMem, dwSize)
	'					Redim s$ * dwSize
	''					FUNCTION = pbstr
	'				End If
	'		End If
	''			' // Releases the memory object
	'			GlobalUnlock(hMem)
	'	End If
	''		' // Closes the clipboard
	'		CloseClipboard()
	'	End If
	'End If
	'Dim sRet$ * 32
	'If IsClipboardFormatAvailable(CF_UNICODETEXT) <> 0 Then
    '	If OpenClipboard(NULL) <> 0 Then
	'		Dim As HANDLE hMem  = GetClipboardData(CF_UNICODETEXT)
	'		If hMem <> NULL Then
	'			Dim As HGLOBAL pMem = GlobalLock(hMem)
	'			If pMem <> NULL Then
	'				Dim As DWORD dwSize = GlobalSize(hMem)
	'				If dwSize > 0 Then
	'					Redim sRet$ * dwSize
	'					sRet$ = *pMem
	'				EndIf
	'			EndIf
	'		EndIf
    '	End If	
	'End If
	Dim sRet$ * 32
	If IsClipboardFormatAvailable(CF_UNICODETEXT) = 0 Then
		goto CleanExit
	EndIf
	If OpenClipboard(NULL) = 0 Then
		goto CleanExit
	EndIf
	Dim As HANDLE hMem  = GetClipboardData(CF_UNICODETEXT)
	If hMem = NULL Then
		CloseClipboard()
		goto CleanExit
	EndIf
	Dim As HGLOBAL pMem = GlobalLock(hMem)
	If pMem = NULL Then
		CloseClipboard()
		goto CleanExit
	EndIf
	Dim As DWORD dwSize = GlobalSize(hMem)
	If dwSize > 0 Then
		Redim sRet$ * dwSize
		sRet$ = (TCHAR*)pMem
	EndIf
CleanExit:	
	Function = sRet$
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxSetClipboardText
'------------------------------------------------------------------------------
' Places an unicode text string into the clipboard.
' Parameter
'   wszText = Text to place in the clipboard.
' Return Value
'   If the function succeeds, the return value is the handle to the data.
'   If the function fails, the return value is NULL.
'==============================================================================
'THIS IS STILL NOT CORRECT Clipboard is not closed on success
' ========================================================================================
Function AfxSetClipboardText (szText$ ) AS HANDLE
	DIM AS HANDLE hData
	' // Opens the clipboard
	IF OpenClipboard(NULL) <> 0 THEN
		' // Empties the clipboard
		EmptyClipboard()
		' // Allocates a global memory block
		DIM AS HGLOBAL hMem  = GlobalAlloc(GMEM_MOVEABLE OR GMEM_DDESHARE, (LEN(szText) + 1) * 2)
		IF hMem <> NULL THEN
			' // Locks it and gets a pointer to the memory location
			DIM AS LPVOID pMem = GlobalLock(hMem)
			' // Copies the text into the allocated memory block
			IF pMem <> NULL THEN
				(_TCHAR*)pMem$ = szText & VCHR$(2,0,0)
			EndIf
			' // Unlocks the memory block
			GlobalUnlock(hMem)
			' // Places the text in the clipboard
			 hData = SetClipboardData(CF_UNICODETEXT, hMem)
			GlobalFree(hMem)
		END IF
		' // Closes the clipboard
		CloseClipboard()
	END IF
    Function = hData
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
' ########################################################################################
'                                      *** FONTS ***
' ########################################################################################
'==============================================================================
$IFUSE USE_AfxGetWindowFont
'------------------------------------------------------------------------------
' Gets the font with which the window is currently drawing its text.
' Note: You can also use the GetWindowFont macro (windowsx.bi).
' ========================================================================================
Function AfxGetWindowFont (hwnd AS HWND) AS HFONT
	Function = (HFONT) SendMessage(hwnd, WM_GETFONT, 0, 0)
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxSetWindowFont
'------------------------------------------------------------------------------
' Sets the font with which the window is currently drawing its text.
' hFont
'   Handle to the font. If this parameter is NULL, the control uses the default system
'   font to draw text.
' fRedraw
'   Specifies whether the control should be redrawn immediately upon setting the font. If
'   this parameter is TRUE, the control redraws itself.
' ========================================================================================
Sub AfxSetWindowFont (hwnd AS HWND, hFont AS HFONT, fRedraw AS LONG = TRUE)
   SendMessage(hwnd, WM_SETFONT, (WPARAM) hFont, fRedraw)
End Sub
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxGetWindowsFontInfo
    $USE USE_AfxFontEnum USE_AfxWindowsVersion
'------------------------------------------------------------------------------
' Retrieves information about the fonts used by Windows.
' Parameters:
' - nType = The type of font:
'   AFX_FONT_CAPTION, AFX_FONT_SMALLCAPTION, AFX_FONT_MENU, AFX_FONT_STATUS, AFX_FONT_MESSAGE
' - plfw = Pointer to a LOGFONTW structure that receives the font information.
' Return value: TRUE on succes or FALSE on failure.
' To get extended error information, call GetLastError.
' ========================================================================================
Function AfxGetWindowsFontInfo (nType AS LONG, plfw AS LOGFONTW PTR) AS BOOL
	Dim As NONCLIENTMETRICSW ncm 
	If plfw = NULL Then
		Exit Function
	EndIf
	If AfxWindowsVersion() >= 6 Then
		ncm.cbSize = 504 
	Else
		ncm.cbSize = 500
	EndIf
	If SystemParametersInfo(SPI_GETNONCLIENTMETRICS, SIZEOF(ncm), &ncm, 0) = 0 Then
		Exit Function
	EndIf
	
	Select Case nType
		Case AFX_FONT_CAPTION
			*plfw = ncm.lfCaptionFont
		Case AFX_FONT_SMALLCAPTION
			*plfw = ncm.lfSmCaptionFont
		Case AFX_FONT_MENU
			*plfw = ncm.lfMenuFont
		Case AFX_FONT_STATUS
			*plfw = ncm.lfStatusFont
		Case AFX_FONT_MESSAGE
			*plfw = ncm.lfMessageFont
		Case Else
	 		Function = FALSE
	End Select
	Function = TRUE
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxGetWindowsFontPointSize
	$USE USE_AfxFontEnum USE_AfxWindowsVersion
'------------------------------------------------------------------------------
' Retrieves the point size of the fonts used by Windows.
' Parameters:
' - nType = The type of font:
'   AFX_FONT_CAPTION, AFX_FONT_SMALLCAPTION, AFX_FONT_MENU, AFX_FONT_STATUS, AFX_FONT_MESSAGE
' Return value: The point size.
' ========================================================================================
Function AfxGetWindowsFontPointSize (nType AS LONG) AS LONG
	Dim AS NONCLIENTMETRICSW ncm 
	If AfxWindowsVersion() >= 6 Then
		ncm.cbSize = 504 
	Else
		ncm.cbSize = 500
	EndIf
	If SystemParametersInfo(SPI_GETNONCLIENTMETRICS, SIZEOF(ncm), &ncm, 0) = 0 Then
		Exit Function
	EndIf
	Dim As HDC hDC = CreateDC("DISPLAY", NULL, NULL, NULL)
	If hDC = NULL Then
		Exit Function
	EndIf
	Dim As Long cyPixelsPerInch = GetDeviceCaps(hDC, LOGPIXELSY)
	DeleteDC(hDC)
	Dim As Long nPointSize
	
	Select Case nType
		Case AFX_FONT_CAPTION
			nPointSize = MulDiv(ncm.lfCaptionFont.lfHeight, 72, cyPixelsPerInch)
		Case AFX_FONT_SMALLCAPTION
			nPointSize = MulDiv(ncm.lfSmCaptionFont.lfHeight, 72, cyPixelsPerInch)
		Case AFX_FONT_MENU
			nPointSize = MulDiv(ncm.lfMenuFont.lfHeight, 72, cyPixelsPerInch)
		Case AFX_FONT_STATUS
			nPointSize = MulDiv(ncm.lfStatusFont.lfHeight, 72, cyPixelsPerInch)
		Case AFX_FONT_MESSAGE
			nPointSize = MulDiv(ncm.lfMessageFont.lfHeight, 72, cyPixelsPerInch)
	End Select
	If nPointSize < 0 Then
		nPointSize = -nPointSize
	EndIf
	Function = nPointSize
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
'==============================================================================
$IFUSE USE_AfxModifyFontFaceName
'------------------------------------------------------------------------------
' Modifies the face name of the font of a window or control.
' Parameters:
' - hwnd = Handle of the window or control.
' - pwszNewFaceName = The new face name of the font.
' Return value: The handle of the new font on success, or NULL on failure.
' To get extended error information, call GetLastError.
' Remarks: The returned font must be destroyed with DeleteObject or the macro DeleteFont
' when no longer needed to prevent memory leaks.
' ========================================================================================
Function AfxModifyFontFaceName (hwnd AS HWND, szNewFaceName$) AS HFONT
	Dim  AS LOGFONTW lfw
	If hwnd = NULL OR Len(szNewFaceName) = 0 Then
		Exit Function
	EndIf
	' // Get the handle of the font used by the header
	Dim As HFONT hCurFont = (HFONT) SendMessage(hwnd, WM_GETFONT, 0, 0)
	If hCurFont = 0 Then
		Exit Function
	EndIf
	' // Get the LOGFONTW structure
	If GetObject(hCurFont, SIZEOF(lfw), &lfw) = 0 Then
		Exit Function
	EndIf
	' // Change the face name
	lfw.lfFaceName$ = szNewFaceName$
	' // Create a new font
	Dim As HFONT hNewFont  = CreateFontIndirect(&lfw)
	If hNewFont = 0 Then
		Exit Function
	EndIf
	' // Select the new font and delete the old one
	Dim As HDC hDC = GetDC(hwnd)
	DeleteObject(SelectObject(hDC, (HGDIOBJ) hNewFont))
	ReleaseDC(hwnd, hDC)
	SendMessage(hwnd, WM_SETFONT, (WPARAM) hNewFont, TRUE)
	FUNCTION = hNewFont
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxModifyFontSettings
  $USE USE_AfxGetFontPointSize
  $USE USE_AfxLogPixelsY
'------------------------------------------------------------------------------
' Modifies settings of the font used by a window of control.
' Parameters:
' - hwnd = Handle of the window or control.
' - nSetting : One of the AFX_FONT_xxx constants.
' - nValue: Depends of the nSetting value
'   AFX_FONT_HEIGHT
'      The base is 100. To increase the font a 20% pass 120; to reduce it a 20% pass 80%.
'   AFX_FONT_WEIGHT
'      The weight of the font in the range 0 through 1000. For example, 400 is normal and
'      700 is bold. If this value is zero, a default weight is used.
'      The following values are defined for convenience.
'      FW_DONTCARE (0), FW_THIN (100), FW_EXTRALIGHT (200), FW_ULTRALIGHT (200), FW_LIGHT (300),
'      FW_NORMAL (400), FW_REGULAR (400), FW_MEDIUM (500), FW_SEMIBOLD (600), FW_DEMIBOLD (600),
'      FW_BOLD (700), FW_EXTRABOLD (800), FW_ULTRABOLD (800), FW_HEAVY (900), FW_BLACK (900)
'   AFX_FONT_ITALIC : TRUE or FALSE.
'   AFX_FONT_UNDERLINE : TRUE or FALSE.
'   AFX_FONT_STRIKEOUT : TRUE or FALSE.
'   AFX_FONT_CHARSET
'      The following values are predefined: ANSI_CHARSET, BALTIC_CHARSET, CHINESEBIG5_CHARSET,
'      DEFAULT_CHARSET, EASTEUROPE_CHARSET, GB2312_CHARSET, GREEK_CHARSET, HANGUL_CHARSET,
'      MAC_CHARSET, OEM_CHARSET, RUSSIAN_CHARSET, SHIFTJIS_CHARSET, SYMBOL_CHARSET, TURKISH_CHARSET,
'      VIETNAMESE_CHARSET, JOHAB_CHARSET (Korean language edition of Windows), ARABIC_CHARSET and
'      HEBREW_CHARSET (Middle East language edition of Windows), THAI_CHARSET (Thai language
'      edition of Windows).
'      The OEM_CHARSET value specifies a character set that is operating-system dependent.
'      DEFAULT_CHARSET is set to a value based on the current system locale. For example, when
'      the system locale is English (United States), it is set as ANSI_CHARSET.
'      Fonts with other character sets may exist in the operating system. If an application uses
'      a font with an unknown character set, it should not attempt to translate or interpret
'      strings that are rendered with that font.
'      This parameter is important in the font mapping process. To ensure consistent results,
'      specify a specific character set. If you specify a typeface name in the lfFaceName member,
'      make sure that the lfCharSet value matches the character set of the typeface specified in lfFaceName.
' Return value: The handle of the new font on success, or NULL on failure.
' To get extended error information, call GetLastError.
' Remarks: The returned font must be destroyed with DeleteObject or the macro DeleteFont
' when no longer needed to prevent memory leaks.
' ========================================================================================
Function AfxModifyFontSettings ( hwnd AS HWND, nSetting AS LONG,  nValue AS LONG) AS HFONT
	Dim As LOGFONTW lfw
	If IsWindow(hwnd) = 0 Then
		Exit Function
	EndIf
	' // Get the handle of the font used by the header
	Dim As HFONT hCurFont  = (HFONT) SendMessage(hwnd, WM_GETFONT, 0, 0)
	If hCurFont = NULL Then
		EXIT FUNCTION
	EndIf
	' // Get the LOGFONTW structure
	If GetObject(hCurFont, SIZEOF(lfw), &lfw) = 0 Then
		EXIT FUNCTION
	EndIf
	' // Change the specified setting
	SELECT CASE nSetting
		CASE AFX_FONT_HEIGHT
			' // Change the point size
			Dim AS LONG lPointSize  = AfxGetFontPointSize(lfw.lfHeight)
			lPointSize = lPointSize * (nValue / 100)
			lfw.lfHeight = -MulDiv(lPointSize, AfxLogPixelsY(), 72)
		CASE AFX_FONT_WEIGHT
			' // Change the font weight
			lfw.lfWeight = nValue
		CASE AFX_FONT_ITALIC
			' // Change the italic flag
			lfw.lfItalic = nValue
		CASE AFX_FONT_UNDERLINE
			' // Change the underline flag
			lfw.lfUnderline = nValue
		CASE AFX_FONT_STRIKEOUT
			' // Change the strikeout flag
			lfw.lfStrikeOut = nValue
		CASE AFX_FONT_CHARSET
			' // Change the charset
			lfw.lfCharSet = nValue
		CASE ELSE
			EXIT FUNCTION
	END SELECT
	' // Create a new font
	Dim AS HFONT hNewFont = CreateFontIndirect(&lfw)
	If hNewFont = NULL Then
		EXIT FUNCTION
	EndIf
	' // Select the new font and delete the old one
	Dim As HDC hDC  = GetDC(hwnd)
	DeleteObject(SelectObject(hDC, (HGDIOBJ) hNewFont))
	ReleaseDC(hwnd, hDC)
	SendMessage(hwnd, WM_SETFONT, (WPARAM) hNewFont, TRUE)
	Function = hNewFont
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxModifyFontHeight
'------------------------------------------------------------------------------
' Modifies the height of the font used by a window of control.
' Parameters:
' - hwnd = Handle of the window or control.
' - nValue: The base is 100. To increase the font a 20% pass 120; to reduce it a 20% pass 80%.
' Return value: The handle of the new font on success, or NULL on failure.
' To get extended error information, call GetLastError.
' Remarks: The returned font must be destroyed with DeleteObject or the macro DeleteFont
' when no longer needed to prevent memory leaks.
' ========================================================================================
Function AfxModifyFontHeight ( hwnd AS HWND,  nValue AS LONG) AS HFONT
   Function = AfxModifyFontSettings(hwnd, AFX_FONT_HEIGHT, nValue)
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxCreateFont
'------------------------------------------------------------------------------
' Creates a logical font.
' Parameters:
' - wszFaceName = The typeface name.
' - lPointSize = The point size.
' - DPI = Dots per inch to calculate scaling. Default value = 96 (no scaling). If you pass -1
'   and the application is DPI aware, the DPI value used by the operating system will be used.
' - lWeight = The weight of the font in the range 0 through 1000. For example, 400 is normal
'      and 700 is bold. If this value is zero, a default weight is used.
'      The following values are defined for convenience.
'      FW_DONTCARE (0), FW_THIN (100), FW_EXTRALIGHT (200), FW_ULTRALIGHT (200), FW_LIGHT (300),
'      FW_NORMAL (400), FW_REGULAR (400), FW_MEDIUM (500), FW_SEMIBOLD (600), FW_DEMIBOLD (600),
'      FW_BOLD (700), FW_EXTRABOLD (800), FW_ULTRABOLD (800), FW_HEAVY (900), FW_BLACK (900)
' - bItalic = Italic flag. CTRUE or FALSE
' - bUnderline = Underline flag. CTRUE or FALSE
' - bStrikeOut = StrikeOut flag. CTRUE or FALSE
' - bCharset = Charset.
'      The following values are predefined: ANSI_CHARSET, BALTIC_CHARSET, CHINESEBIG5_CHARSET,
'      DEFAULT_CHARSET, EASTEUROPE_CHARSET, GB2312_CHARSET, GREEK_CHARSET, HANGUL_CHARSET,
'      MAC_CHARSET, OEM_CHARSET, RUSSIAN_CHARSET, SHIFTJIS_CHARSET, SYMBOL_CHARSET, TURKISH_CHARSET,
'      VIETNAMESE_CHARSET, JOHAB_CHARSET (Korean language edition of Windows), ARABIC_CHARSET and
'      HEBREW_CHARSET (Middle East language edition of Windows), THAI_CHARSET (Thai language
'      edition of Windows).
'      The OEM_CHARSET value specifies a character set that is operating-system dependent.
'      DEFAULT_CHARSET is set to a value based on the current system locale. For example, when
'      the system locale is English (United States), it is set as ANSI_CHARSET.
'      Fonts with other character sets may exist in the operating system. If an application uses
'      a font with an unknown character set, it should not attempt to translate or interpret
'      strings that are rendered with that font.
'      This parameter is important in the font mapping process. To ensure consistent results,
'      specify a specific character set. If you specify a typeface name in the lfFaceName member,
'      make sure that the lfCharSet value matches the character set of the typeface specified in lfFaceName.
' Return value: The handle of the font or NULL on failure.
' Remarks: The returned font must be destroyed with DeleteObject or the macro DeleteFont
' when no longer needed to prevent memory leaks.
' Usage examples:
'   hFont = AfxCreateFont("MS Sans Serif", 8, , FW_NORMAL, , , , DEFAULT_CHARSET)
'   hFont = AfxCreateFont("Courier New", 10, 96 , FW_BOLD, , , , DEFAULT_CHARSET)
'   hFont = AfxCreateFont("Marlett", 8, -1, FW_NORMAL, , , , SYMBOL_CHARSET)
' ========================================================================================
Function AfxCreateFont (szFaceName As char Ptr, lPointSize AS LONG, DPI AS LONG = 96, _
	lWeight AS LONG = 0,bItalic As BYTE = FALSE, bUnderline AS BYTE = FALSE, _
    bStrikeOut As BYTE = FALSE, bCharSet AS BYTE = DEFAULT_CHARSET) AS HFONT

	Dim As LOGFONTW tlfw 
	Dim As HDC hDC = GetDC(HWND_DESKTOP)
	
	' // Font scaling
	If DPI = -1 Then
		DPI = GetDeviceCaps(hDC, LOGPIXELSX)
	EndIf
	If DPI > 0 Then
		lPointSize = (lPointSize * DPI) / GetDeviceCaps(hDC, LOGPIXELSY)
	EndIf
	
	tlfw.lfHeight         = -MulDiv(lPointSize, GetDeviceCaps(hDC, LOGPIXELSY), 72)  ' logical font height
	tlfw.lfWidth          =  0                                                        ' average character width
	tlfw.lfEscapement     =  0                                                        ' escapement
	tlfw.lfOrientation    =  0                                                        ' orientation angles
	tlfw.lfWeight         =  lWeight                                                  ' font weight
	tlfw.lfItalic         =  bItalic                                                  ' italic(CTRUE/FALSE)
	tlfw.lfUnderline      =  bUnderline                                               ' underline(CTRUE/FALSE)
	tlfw.lfStrikeOut      =  bStrikeOut                                               ' strikeout(CTRUE/FALSE)
	tlfw.lfCharSet        =  bCharSet                                                 ' character set
	tlfw.lfOutPrecision   =  OUT_TT_PRECIS                                            ' output precision
	tlfw.lfClipPrecision  =  CLIP_DEFAULT_PRECIS                                      ' clipping precision
	tlfw.lfQuality        =  DEFAULT_QUALITY                                          ' output quality
	tlfw.lfPitchAndFamily =  FF_DONTCARE                                              ' pitch and family
	tlfw.lfFaceName$       =  szFaceName                                              ' typeface name
	
	ReleaseDC(HWND_DESKTOP, hDC)
	Function = CreateFontIndirect(&tlfw)
End Function

'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxGetFontPointSize
'------------------------------------------------------------------------------
' Returns the point size of a font given its logical height
' ========================================================================================
Function AfxGetFontPointSize (nHeight AS LONG) AS LONG
	Dim As HDC hDC = CreateDC("DISPLAY", NULL, NULL, NULL)
	If hDC = NULL Then
		Exit Function
	EndIf
	Dim As Long cyPixelsPerInch = GetDeviceCaps(hDC, LOGPIXELSY)
	DeleteDC(hDC)
	Dim As Long nPointSize = MulDiv(nHeight, 72, cyPixelsPerInch)
	If nPointSize < 0 Then
		nPointSize = -nPointSize
	EndIf
	Function = nPointSize
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxGetFontHeight
'------------------------------------------------------------------------------
' Returns the logical height of a font given its point size
' ========================================================================================
Function AfxGetFontHeight (nPointSize AS LONG) AS LONG
	Dim As HDC hDC = CreateDC("DISPLAY", NULL, NULL, NULL)
	If hDC = NULL Then
		Exit Function
	EndIf
	Dim As Long cyPixelsPerInch = GetDeviceCaps(hDC, LOGPIXELSY)
	DeleteDC(hDC)
	Dim As Long nHeight = -MulDiv(nPointSize, cyPixelsPerInch, 72)
	Function = nHeight
End Function
'------------------------------------------------------------------------------
$ENDUSE













'Font Enum
'==============================================================================
$IFUSE USE_AfxFontEnum
'------------------------------------------------------------------------------
Enum
   AFX_FONT_CAPTION = 1    ' // Caption font
   AFX_FONT_SMALLCAPTION   ' // Small caption font
   AFX_FONT_MENU           ' // Font used in menu bars
   AFX_FONT_STATUS         ' // Font used in status bars and tooltips
   AFX_FONT_MESSAGE        ' // Font used in message boxes
   ' // Font settings
   AFX_FONT_HEIGHT         ' // Font height
   AFX_FONT_WEIGHT         ' // Font weight
   AFX_FONT_ITALIC         ' // Font italic
   AFX_FONT_UNDERLINE      ' // Font underline
   AFX_FONT_STRIKEOUT      ' // Font strikeout
   AFX_FONT_CHARSET        ' // Font charset
End Enum
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
' Returns the Windows version
' Platform 1:
'   400 Windows 95
'   410 Windows 98
'   490 Windows ME
' Platform 2:
'   400 Windows NT
'   500 Windows 2000
'   501 Windows XP
'   502 Windows Server 2003
'   600 Windows Vista and Windows Server 2008
'   601 Windows 7
'   602 Windows 8
'   603 Windows 8.1
' Note: As Windows 95 and Windows NT return the same version number, we also need to call
' GetWindowsPlatform to differentiate them.
' ========================================================================================
$IFUSE USE_AfxWindowsVersion
Function AfxWindowsVersion() As Long
	Dim As DWORD dwVersion
	Dim As LONG nMajorVer, nMinorVer
	dwVersion = GetVersion()
	nMajorVer = LOBYTE(LOWORD(dwVersion))
	nMinorVer = HIBYTE(LOWORD(dwVersion))
	Function = (nMajorVer + nMinorVer / 100) * 100
End Function
$ENDUSE
'==============================================================================
' ########################################################################################
'                        *** DIBs (Device Independent Bitmaps) ***
' ########################################################################################

$IFUSE USE_AfxCreateDIBSection
	CONST BITSPIXEL_ = 12
'------------------------------------------------------------------------------
' Creates a DIB that applications can write to directly.
' Parameters:
' - hDC     = A handle to a device context.
' - nWidth  = The width of the bitmap, in pixels.
' - nHeight = The height of the bitmap, in pixels.
' - bpp     = Bits per pixel
' - ppvBits = A pointer to a variable that receives a pointer to the location of the
'             DIB bit values. Can be NULL.
' Return value: If the function succeeds, the return value is a handle to the newly
' created DIB, and *ppvBits points to the bitmap bit values.
' If the function fails, the return value is NULL, and *ppvBits is NULL.
' The function can fail if one or more of the input parameters is invalid.
' Remarks:
'   You must delete the returned bitmap handle with DeleteObject when no longer needed to
'   avoid memory leaks.
'   You cannot paste a DIB section from one application into another application.
'   AfxCreateDIBSection does not use the BITMAPINFOHEADER parameters biXPelsPerMeter or
'   biYPelsPerMeter and will not provide resolution information in the BITMAPINFO structure.
' Usage example:
'   DIM hdcWindow AS HDC, hbmp AS HBITMAP, pvBits AS ANY PTR
'   hdcWindow = GetWindowDC(hwnd)   ' where hwnd is the handle of the wanted window or control
'   hbmp = AfxCreateDIBSection(hdcWindow, 10, 10, @pvBits)
'   ReleaseDC(hwnd, hdcWindow)
' ========================================================================================
Function AfxCreateDIBSection (hDC AS HDC, nWidth AS DWORD, nHeight AS DWORD,  bpp AS LONG = 0,  ppvBits As void PTR PTR = NULL) AS HBITMAP
	Dim AS BITMAPINFO bi 
	bi.bmiHeader.biSize = SIZEOF(bi.bmiHeader)
	bi.bmiHeader.biWidth = nWidth
	bi.bmiHeader.biHeight = nHeight
	bi.bmiHeader.biPlanes = 1
	'bi.bmiHeader.biBitCount = IIF&(bpp <> 0, bpp, GetDeviceCaps(hDC, BITSPIXEL_))
	bi.bmiHeader.biBitCount = (WORD)IIF(bpp <> 0, (WORD)bpp, (WORD)GetDeviceCaps(hDC, BITSPIXEL_))
	bi.bmiHeader.biCompression = BI_RGB
	Function = CreateDIBSection(hDC, &bi, DIB_RGB_COLORS, ppvBits, NULL, 0)
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxDibLoadImage
'------------------------------------------------------------------------------
' Loads a DIB in memory and returns a pointer to it.
' Parameter:
' - pwszFileName = Path of the bitmap file.
' Reutn Value:
'   A pointer to the bitmap file header.
'   Release it with CoTaskMemFree when no longer needed.
' ========================================================================================
Function AfxDibLoadImage (szFileName As char Ptr) AS BITMAPFILEHEADER PTR
	Dim As Long bSuccess 
	Dim As DWORD dwFileSize, dwHighSize, dwBytesRead 
	Dim AS HANDLE hFile
	Dim AS BITMAPFILEHEADER PTR pbmfh 
	hFile = CreateFile(szFileName, GENERIC_READ, FILE_SHARE_READ, NULL, _
	   OPEN_EXISTING, FILE_FLAG_SEQUENTIAL_SCAN, NULL)
	If hFile = INVALID_HANDLE_VALUE Then
		EXIT FUNCTION
	EndIf
	' // Get the size of the file
	dwFileSize = GetFileSize(hFile, &dwHighSize)
	If dwHighSize Then
		CloseHandle(hFile)
		EXIT FUNCTION
	End If
	' // Read the contents of the file. Notice that pmfh has been cast as
	' // BITMAPFILEHEADER PTR to be able to read the header.
	pbmfh = (BITMAPFILEHEADER PTR)CoTaskMemAlloc(dwFileSize)
	bSuccess = ReadFile(hFile, pbmfh, dwFileSize, &dwBytesRead, NULL)
	' // Check for "BM" (&H4D42, i.e. &H42 = "B", &H4D = "M", they are in reverse order)
	If bSuccess = 0 OR dwBytesRead <> dwFileSize OR pbmfh->bfType <> 0x4D42 Then
		CoTaskMemFree(pbmfh)
		CloseHandle(hFile)
		EXIT FUNCTION
	END IF
	' // Close the file handle and return a pointer to the data read
	CloseHandle(hFile)
	FUNCTION = pbmfh
End Function

'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxDibSaveImage
'------------------------------------------------------------------------------
' Saves a DIB to a file.
' - pwszFileName = Path of the file.
' - pbmfh = Pointer to the bitmap file header.
' Return Value
'   TRUE if the DIB has been saved successfully; FALSE otherwise.
' ========================================================================================
Function AfxDibSaveImage (szFileName As char Ptr, pbmfh AS BITMAPFILEHEADER PTR) AS BOOL
	Dim As Long bSuccess
	Dim As DWORD dwBytesWritten
	Dim As HANDLE hFile
	If pbmfh = NULL Then
		EXIT FUNCTION
	EndIf
	hFile = CreateFile(szFileName, GENERIC_WRITE, 0, BYVAL NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL)
	If hFile = INVALID_HANDLE_VALUE Then
		EXIT FUNCTION
	EndIf
	bSuccess = WriteFile(hFile, BYVAL pbmfh, BYVAL pbmfh->bfSize, &dwBytesWritten, NULL)
	CloseHandle(hFile)
	If bSuccess = 0 OR dwBytesWritten <> pbmfh->bfSize Then
		DeleteFile(szFileName)
		EXIT FUNCTION
	End If
	Function = TRUE
End Function
'------------------------------------------------------------------------------
$ENDUSE
' ########################################################################################
'                                   *** BITMAPS ***
' ########################################################################################
'==============================================================================
$IFUSE USE_AfxGetBitmapWidth
' Retrieves the width of a bitmap
'------------------------------------------------------------------------------
Function AfxGetBitmapWidth (hBitmap AS HBITMAP) AS LONG
	Dim AS BITMAP bm 
	If hBitmap = NULL Then
		EXIT FUNCTION
	EndIf
	If GetObject(hBitmap, SIZEOF(bm), &bm) Then
		FUNCTION = bm.bmWidth
	End If
	Function = 0
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxGetBitmapHeight
'------------------------------------------------------------------------------
' Retrieves the height of a bitmap
' ========================================================================================
Function AfxGetBitmapHeight (hBitmap AS HBITMAP) AS LONG
	Dim AS BITMAP bm 
	If hBitmap = NULL Then
		EXIT FUNCTION
	EndIf
	If GetObject(hBitmap, SIZEOF(bm), &bm) Then
		FUNCTION = bm.bmHeight
	EndIf
	Function = 0
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxCaptureDisplay
'------------------------------------------------------------------------------
' Captures the display and returns an handle to a bitmap.
' ========================================================================================
Function AfxCaptureDisplay () AS HBITMAP
	Dim As HDC hScreenDC = CreateDC("DISPLAY", "", "", NULL)
	If hScreenDC = NULL Then
		EXIT FUNCTION
	EndIf
	Dim As Long cx = GetDeviceCaps(hScreenDC, HORZRES)
	Dim As Long cy = GetDeviceCaps(hScreenDC, VERTRES)
	Dim As HDC hMemDC = CreateCompatibleDC(hScreenDC)
	If hMemDC = NULL Then
		EXIT FUNCTION
	EndIf
	Dim As HBITMAP hBitmap = CreateCompatibleBitmap(hScreenDC, cx, cy)
	If hBitmap = NULL Then
		EXIT FUNCTION
	EndIf
	Dim AS HBITMAP hBmpOld  = (HBITMAP)SelectObject(hMemDC, hBitmap)
	' // Note: CAPTUREBLT flag is required to capture layered windows
	BitBlt(hMemDC, 0, 0, cx, cy, hScreenDC, 0, 0, SRCCOPY BOR CAPTUREBLT)
	SelectObject(hMemDC, hBmpOld)
	DeleteDC(hMemDC)
	DeleteDC(hScreenDC)
	Function = hBitmap
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxDrawBitmap
'------------------------------------------------------------------------------
' Draws a bitmap.
' - hDC     : A handle to the destination device context.
' - xStart  : The x-coordinate, in logical units, of the upper-left corner of the destination rectangle.
' - yStart  : The y-coordinate, in logical units, of the upper-left corner of the destination rectangle.
' - hBitmap : Handle of the bitmap to draw.
' Return value: TRUE or FALSE.
' ========================================================================================
Function AfxDrawBitmap (hDC AS HDC, xStart AS LONG, yStart AS LONG, hBitmap AS HBITMAP) AS BOOL
	Dim AS BITMAP bm
	Dim As HDC hMemDC
	If hDC = NULL OR hBitmap = NULL Then
		EXIT FUNCTION
	EndIf
	hMemDC = CreateCompatibleDC(hDC)
	If hMemDC = NULL Then
		EXIT FUNCTION
	EndIf
	SelectObject(hMemDC, hBitmap)
	If GetObject(hBitmap, SIZEOF(BITMAP), &bm) Then
		BitBlt(hDC, xStart, yStart, bm.bmWidth, bm.bmHeight, hMemDC, 0, 0, SRCCOPY)
		DeleteDC(hMemDC)
		Function = TRUE
	End If
	Function = FALSE
End Function
'------------------------------------------------------------------------------
$ENDUSE
' ########################################################################################
'                                     *** FILES ***
' ########################################################################################

'==============================================================================
$IFUSE USE_AfxFileExists
'------------------------------------------------------------------------------
' Searches a directory for a file or subdirectory with a name that matches a specific name
' (or partial name if wildcards are used).
' Parameter:
' - pwszFileSpec: The directory or path, and the file name, which can include wildcard
'   characters, for example, an asterisk (*) or a question mark (?).
'   This parameter should not be NULL, an invalid string (for example, an empty string or a
'   string that is missing the terminating null character), or end in a trailing backslash (\).
'   If the string ends with a wildcard, period (.), or directory name, the user must have
'   access permissions to the root and all subdirectories on the path. To extend the limit
'   of MAX_PATH wide characters to 32,767 wide characters, prepend "\\?\" to the path.
' Return value:
'   Returns TRUE if the specified file exists or FALSE otherwise.
' Remarks:
'   Prepending the string "\\?\" does not allow access to the root directory.
'   On network shares, you can use a pwszFileSpec in the form of the following:
'   "\\server\service\*". However, you cannot use a pwszFileSpec that points to the share
'   itself; for example, "\\server\service" is not valid.
'   To examine a directory that is not a root directory, use the path to that directory,
'   without a trailing backslash. For example, an argument of "C:\Windows" returns information
'   about the directory "C:\Windows", not about a directory or file in "C:\Windows".
'   To examine the files and directories in "C:\Windows", use an pwszFileSpec of "C:\Windows\*".
'   Be aware that some other thread or process could create or delete a file with this name
'   between the time you query for the result and the time you act on the information.
'   If this is a potential concern for your application, one possible solution is to use
'   the CreateFile function with CREATE_NEW (which fails if the file exists) or OPEN_EXISTING
'   (which fails if the file does not exist).
' ========================================================================================
Function AfxFileExists ( szFileSpec As char Ptr) AS BOOL
	Dim As WIN32_FIND_DATAW fd 
	If szFileSpec = NULL Then
		EXIT FUNCTION
	EndIf
	Dim AS HANDLE hFind  = FindFirstFile(szFileSpec, &fd)
	If hFind = INVALID_HANDLE_VALUE Then
		EXIT FUNCTION
	EndIf
	FindClose(hFind)
	' // Make sure that it is not a directory or a temporary file
	If (fd.dwFileAttributes BAND FILE_ATTRIBUTE_DIRECTORY) <> FILE_ATTRIBUTE_DIRECTORY AND _
	(fd.dwFileAttributes BAND FILE_ATTRIBUTE_TEMPORARY) <> FILE_ATTRIBUTE_TEMPORARY Then
		Function = TRUE
	End If
	Function = FALSE
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxFolderExists
'------------------------------------------------------------------------------
' Searches a directory for a file or subdirectory with a name that matches a specific name
' (or partial name if wildcards are used).
' Parameter:
' - pwszFileSpec: The directory or path, and the file name, which can include wildcard
'   characters, for example, an asterisk (*) or a question mark (?).
'   This parameter should not be NULL, an invalid string (for example, an empty string or a
'   string that is missing the terminating null character), or end in a trailing backslash (\).
'   If the string ends with a wildcard, period (.), or directory name, the user must have
'   access permissions to the root and all subdirectories on the path. To extend the limit
'   of MAX_PATH wide characters to 32,767 wide characters, prepend "\\?\" to the path.
' Return value:
'   Returns TRUE if the specified folder exists or FALSE otherwise.
' Remarks
'   Prepending the string "\\?\" does not allow access to the root directory.
'   On network shares, you can use an btrFileName in the form of the following: "\\server\service\*".
'   However, you cannot use an btrFileName that points to the share itself; for example,
'   "\\server\service" is not valid.
'   To examine a directory that is not a root directory, use the path to that directory,
'   without a trailing backslash. For example, an argument of "C:\Windows" returns information
'   about the directory "C:\Windows", not about a directory or file in "C:\Windows".
'   To examine the files and directories in "C:\Windows", use an btrFileName of "C:\Windows\*".
'   Be aware that some other thread or process could create or delete a file with this name
'   between the time you query for the result and the time you act on the information.
'   If this is a potential concern for your application, one possible solution is to use
'   the CreateFile function with CREATE_NEW (which fails if the file exists) or OPEN_EXISTING
'   (which fails if the file does not exist).
' ========================================================================================
Function AfxFolderExists (szFileSpec As char Ptr) As BOOL
	Dim AS WIN32_FIND_DATAW fd 
	If szFileSpec = NULL Then
		EXIT FUNCTION
	EndIf
	Dim As HANDLE hFind = FindFirstFile(szFileSpec, &fd)
	If hFind = INVALID_HANDLE_VALUE Then
		EXIT FUNCTION
	EndIf
	FindClose(hFind)
	' // Make sure that it is a directory
	If (fd.dwFileAttributes BAND FILE_ATTRIBUTE_DIRECTORY) = FILE_ATTRIBUTE_DIRECTORY Then
		FUNCTION = TRUE
	EndIf
	Function = FALSE
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxIsFile
'------------------------------------------------------------------------------
' Returns TRUE if the specified path is a file; FALSE, otherwise.
' To extend the limit from MAX_PATH to 32,767 wide characters, prepend "\\?\" to the path.
' ========================================================================================
Function AfxIsFile (szFileSpec As char Ptr) AS BOOL
	Dim As DWORD dwAttributes = GetFileAttributes(szFileSpec)
	If dwAttributes = INVALID_FILE_ATTRIBUTES Then
		Function = FALSE
	EndIf
	Function =  ((dwAttributes BAND FILE_ATTRIBUTE_DIRECTORY) <>  FILE_ATTRIBUTE_DIRECTORY)
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxIsFolder
'------------------------------------------------------------------------------
' Returns TRUE if the specified path is a directory; FALSE, otherwise.
' To extend the limit from MAX_PATH to 32,767 wide characters, prepend "\\?\" to the path.
' ========================================================================================
Function AfxIsFolder (szFileSpec As char Ptr) AS BOOL
	Dim As DWORD dwAttributes  = GetFileAttributes(szFileSpec)
	If dwAttributes = INVALID_FILE_ATTRIBUTES Then
		Function =  FALSE
	EndIf
	Function =  ((dwAttributes BAND FILE_ATTRIBUTE_DIRECTORY) EqualTo FILE_ATTRIBUTE_DIRECTORY)
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxIsSystemFile
'------------------------------------------------------------------------------
' Returns TRUE if the specified path is a system file; FALSE, otherwise.
' To extend the limit from MAX_PATH to 32,767 wide characters, prepend "\\?\" to the path.
' ========================================================================================
Function AfxIsSystemFile ( szFileSpec As char Ptr) As BOOL
	Dim As DWORD dwAttributes = GetFileAttributes(szFileSpec)
	If dwAttributes = INVALID_FILE_ATTRIBUTES Then
		Function = FALSE
	EndIf
	Function = ((dwAttributes BAND FILE_ATTRIBUTE_SYSTEM) EqualTo FILE_ATTRIBUTE_SYSTEM)
End Function

'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxIsHiddenFile
'------------------------------------------------------------------------------
' Returns TRUE if the specified path is a hidden file; FALSE, otherwise.
' To extend the limit from MAX_PATH to 32,767 wide characters, prepend "\\?\" to the path.
' ========================================================================================
Function AfxIsHiddenFile (szFileSpec As char Ptr) AS BOOL
	Dim As DWORD dwAttributes = GetFileAttributes(szFileSpec)
	If dwAttributes = INVALID_FILE_ATTRIBUTES Then
		Function =  FALSE
	EndIf
	Function = ((dwAttributes BAND FILE_ATTRIBUTE_HIDDEN) EqualTo FILE_ATTRIBUTE_HIDDEN)
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxIsReadOnlyFile
'------------------------------------------------------------------------------
' Returns TRUE if the specified path is a read only file; FALSE, otherwise.
' To extend the limit from MAX_PATH to 32,767 wide characters, prepend "\\?\" to the path.
' ========================================================================================
Function AfxIsReadOnlyFile ( szFileSpec As char Ptr) AS BOOL
	Dim As DWORD dwAttributes = GetFileAttributes(szFileSpec)
	If dwAttributes = INVALID_FILE_ATTRIBUTES Then
		Function = FALSE
	EndIf
	Function =  ((dwAttributes BAND FILE_ATTRIBUTE_READONLY) EqualTo FILE_ATTRIBUTE_READONLY)
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxIsTemporaryFile
'------------------------------------------------------------------------------
' Returns TRUE if the specified path is a temporary file; FALSE, otherwise.
' To extend the limit from MAX_PATH to 32,767 wide characters, prepend "\\?\" to the path.
' ========================================================================================
Function AfxIsTemporaryFile (szFileSpec As char Ptr) AS BOOL
	Dim As DWORD dwAttributes = GetFileAttributes(szFileSpec)
	If dwAttributes = INVALID_FILE_ATTRIBUTES Then
		Function = FALSE
	EndIf
	Function = ((dwAttributes BAND FILE_ATTRIBUTE_TEMPORARY) EqualTo FILE_ATTRIBUTE_TEMPORARY)
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxIsNormalFile
'------------------------------------------------------------------------------
' Returns TRUE if the specified path is a normal file; FALSE, otherwise.
' To extend the limit from MAX_PATH to 32,767 wide characters, prepend "\\?\" to the path.
' ========================================================================================
Function AfxIsNormalFile (szFileSpec As char Ptr) AS BOOL
	Dim As DWORD dwAttributes = GetFileAttributes(szFileSpec)
	If dwAttributes = INVALID_FILE_ATTRIBUTES Then
		Function = FALSE
	EndIf
	Function = ((dwAttributes BAND FILE_ATTRIBUTE_NORMAL) EqualTo FILE_ATTRIBUTE_NORMAL)
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxIsCompressedFile
'------------------------------------------------------------------------------
' Returns TRUE if the specified path is a compressed file or diectory; FALSE, otherwise.
' To extend the limit from MAX_PATH to 32,767 wide characters, prepend "\\?\" to the path.
' ========================================================================================
Function AfxIsCompressedFile (szFileSpec As char Ptr) AS BOOL
	Dim As DWORD dwAttributes = GetFileAttributes(szFileSpec)
	If dwAttributes = INVALID_FILE_ATTRIBUTES Then
		Function = FALSE
	EndIf
	Function = ((dwAttributes BAND FILE_ATTRIBUTE_COMPRESSED) EqualTo FILE_ATTRIBUTE_COMPRESSED)
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxIsEncryptedFile
'------------------------------------------------------------------------------
' Returns TRUE if the specified path is an encrypted file or diectory; FALSE, otherwise.
' To extend the limit from MAX_PATH to 32,767 wide characters, prepend "\\?\" to the path.
' ========================================================================================
Function AfxIsEncryptedFile (szFileSpec As char Ptr) AS BOOL
	Dim As DWORD dwAttributes = GetFileAttributes(szFileSpec)
	If dwAttributes = INVALID_FILE_ATTRIBUTES Then
		Function = FALSE
	EndIf
	Function = ((dwAttributes BAND FILE_ATTRIBUTE_ENCRYPTED) EqualTo FILE_ATTRIBUTE_ENCRYPTED)
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxIsNotContentIndexedFile
'------------------------------------------------------------------------------
' Returns TRUE if the specified file or directory is not to be indexed by the content
' indexing service; FALSE, otherwise.
' To extend the limit from MAX_PATH to 32,767 wide characters, prepend "\\?\" to the path.
' ========================================================================================
Function AfxIsNotContentIndexedFile (szFileSpec As char Ptr) AS BOOL
	Dim AS DWORD dwAttributes = GetFileAttributes(szFileSpec)
	If dwAttributes = INVALID_FILE_ATTRIBUTES Then
		Function = FALSE
	EndIf
	Function =  ((dwAttributes BAND FILE_ATTRIBUTE_NOT_CONTENT_INDEXED) EqualTo FILE_ATTRIBUTE_NOT_CONTENT_INDEXED)
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxIsOffLineFile
'------------------------------------------------------------------------------
' Returns TRUE if the specified file is not available immediately; FALSE, otherwise.
' To extend the limit from MAX_PATH to 32,767 wide characters, prepend "\\?\" to the path.
' ========================================================================================
Function AfxIsOffLineFile (szFileSpec As char Ptr) AS BOOL
	Dim As DWORD dwAttributes  = GetFileAttributes(szFileSpec)
	If dwAttributes = INVALID_FILE_ATTRIBUTES Then
		Function =  FALSE
	EndIf
	Function =  ((dwAttributes BAND FILE_ATTRIBUTE_OFFLINE) EqualTo FILE_ATTRIBUTE_OFFLINE)
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxIsReparsePointFile
'------------------------------------------------------------------------------
' Returns TRUE if the specified path is a file or directory that has an associated reparse
' point, or a file that is a symbolic link; FALSE, otherwise.
' To extend the limit from MAX_PATH to 32,767 wide characters, prepend "\\?\" to the path.
' ========================================================================================
Function AfxIsReparsePointFile (szFileSpec As char Ptr) AS BOOL
	Dim As DWORD dwAttributes = GetFileAttributes(szFileSpec)
	If dwAttributes = INVALID_FILE_ATTRIBUTES Then
		Function = FALSE
	EndIf
	Function = ((dwAttributes BAND FILE_ATTRIBUTE_REPARSE_POINT) EqualTo FILE_ATTRIBUTE_REPARSE_POINT)
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxIsSparseFile
'------------------------------------------------------------------------------
' Returns TRUE if the specified path is a sparse file; FALSE, otherwise.
' To extend the limit from MAX_PATH to 32,767 wide characters, prepend "\\?\" to the path.
' ========================================================================================
Function AfxIsSparseFile (szFileSpec As char Ptr) AS BOOL
	Dim As DWORD dwAttributes = GetFileAttributes(szFileSpec)
	If dwAttributes = INVALID_FILE_ATTRIBUTES Then
		Function = FALSE
	EndIf
	Function =  ((dwAttributes BAND FILE_ATTRIBUTE_SPARSE_FILE) EqualTo FILE_ATTRIBUTE_SPARSE_FILE)
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxGetFileSize
'------------------------------------------------------------------------------
' Returns the size in bytes of the specified file. Don't use it with folders.
' ========================================================================================
Function AfxGetFileSize (szFileSpec As char Ptr) As ULONGLONG
	Dim AS WIN32_FIND_DATAW fd 
	Dim AS HANDLE hFind  = FindFirstFile(szFileSpec, &fd)
	If hFind = INVALID_HANDLE_VALUE Then
		Function = 0
	EndIf
	FindClose(hFind)
	If (fd.dwFileAttributes BAND FILE_ATTRIBUTE_DIRECTORY) NotEqualTo FILE_ATTRIBUTE_DIRECTORY AND _
	   (fd.dwFileAttributes BAND FILE_ATTRIBUTE_TEMPORARY) NotEqualTo FILE_ATTRIBUTE_TEMPORARY Then
		Dim AS ULONGLONG ullSize  = (fd.nFileSizeHigh * (0xFFFFFFFF + 1)) + fd.nFileSizeLow
		Function = ullSize
	End If
	Function = 0
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxGetFileCreationTime
'------------------------------------------------------------------------------
' Returns the time the file was created.
' - wszFileSpec: The directory or path, and the file name, which can include wildcard characters,
'   for example, an asterisk (*) or a question mark (?).
'   This parameter should not be NULL, an invalid string (for example, an empty string or a
'   string that is missing the terminating null character), or end in a trailing backslash (\).
'   If the string ends with a wildcard, period (.), or directory name, the user must have access
'   permissions to the root and all subdirectories on the path.
'   To extend the limit from MAX_PATH to 32,767 wide characters, prepend "\\?\" to the path.
' - bUTC: Pass FALSE if you want to get the time in local time (the NTFS file system stores time
'   values in UTC format, so they are not affected by changes in time zone or daylight saving time).
'   FileTimeToLocalFileTime uses the current settings for the time zone and daylight saving time.
'   Therefore, if it is daylight saving time, it takes daylight saving time into account, even
'   if the file time you are converting is in standard time.
' Usage: AfxFileTimeToDateStr(AfxGetFileCreationTime("C:\Tests\test.bas", FALSE), "dd/MM/yyyy")
' ========================================================================================
Function AfxGetFileCreationTime (wszFileSpec AS char Ptr, bUTC AS BOOL = TRUE) AS FILETIME
	Dim AS WIN32_FIND_DATAW fd 
	Dim As HANDLE hFind = FindFirstFile(wszFileSpec, &fd)
	Dim As FILETIME  FT
	If hFind <> INVALID_HANDLE_VALUE Then
		FindClose(hFind)
		If bUTC = TRUE Then
			Function = fd.ftCreationTime
		Else
			FileTimeToLocalFileTime(&fd.ftCreationTime, &FT)
			Function =  FT
		End If
	End If
	Function = FT
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxGetFileLastAccessTime
'------------------------------------------------------------------------------
' Returns the time the file was last accessed. The NTFS file system delays updates to the
' last access time for a file by up to 1 hour after the last access.
' ========================================================================================
Function AfxGetFileLastAccessTime ( wszFileSpec As char Ptr, bUTC AS BOOL = TRUE) AS FILETIME
	Dim AS WIN32_FIND_DATAW fd 
	Dim AS HANDLE hFind  = FindFirstFile(wszFileSpec, &fd)
	DIM AS FILETIME FT 
	If hFind <> INVALID_HANDLE_VALUE Then
		FindClose(hFind)
		If bUTC = TRUE Then
			Function = fd.ftLastAccessTime
		Else
			FileTimeToLocalFileTime(&fd.ftLastAccessTime, &FT)
		End If
	End If
	Function = FT
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxGetFileLastWriteTime
'------------------------------------------------------------------------------
' Returns the time the file was last written to, truncated, or overwritten.
' When writing to a file, the last write time is not fully updated until all handles that
' are used for writing are closed.
' ========================================================================================
Function AfxGetFileLastWriteTime ( wszFileSpec AS char Ptr, bUTC AS BOOL = TRUE) AS FILETIME
	Dim As WIN32_FIND_DATAW fd
	Dim As HANDLE hFind = FindFirstFile(wszFileSpec, &fd)
	Dim As FILETIME FT 
	If hFind <> INVALID_HANDLE_VALUE Then
		FindClose(hFind)
		If bUTC = TRUE Then
			Function = fd.ftLastWriteTime
		Else 
			FileTimeToLocalFileTime(&fd.ftLastWriteTime, &FT)
		End If
	End If
	Function = FT	
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================










