' ########################################################################################
' Microsoft Windows
' File: CbColor.inc
' Contents: Combobox color list
' Based on the CBCOLOR control originally written by Börje Hagsten in 2001.
' Compiler: Ported to bc9Basic jcfuller 08/23/2016  
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
$IFUSE USE_CCbColor
CONST CBCOL_SETAUTOCOLOR = WM_USER + 100
CONST CBCOL_SETUSERCOLOR = WM_USER + 101
CONST CBCOL_SETCOLORNAME = WM_USER + 102
CONST CBCOL_GETAUTOCOLOR = WM_USER + 200
CONST CBCOL_GETUSERCOLOR = WM_USER + 201
CONST CBCOL_GETSELCOLOR  = WM_USER + 202
Type rgNamesType
	rgNames[18,20] As char
End Type
' ========================================================================================
' CCbColor class
' ========================================================================================
Class CCbColor
	private:
		Dim As HWND m_hCtl
		Dim AS HFONT m_hFont
		Dim As WNDPROC m_oldProc
		Dim As COLORREF m_autoColor
		Dim As COLORREF m_userColor
		Dim As Single m_ratio
		Dim As COLORREF m_rgColors[15]
		!char m_rgbNames[18][20] = {"Auto", "Black", "Blue", "Green", "Cyan", "Red",
        ! "Magenta", "Brown", "Light Gray", "Gray", "Light Blue", "Light Green", "Light Cyan",
        ! "Light Red", "Light Magenta", "Yellow", "Bright White", "User selected..."};
    public:
    	Dim Constructor CCbColor(pWindow As CWindow Ptr, cID As Integer, x As Long = 0, y As Long = 0, _
    	                         nWidth As Long = 0, nHeight As Long = 0, dwAutoColor As COLORREF = 0, _
    	                         dwUserColor As COLORREF = 0, prgNames As char ptr ptr = NULL,numBytes As DWORD = 0)
    	Dim Destructor ~CCbColor()
    	Dim Function hWindow() As HWND
    	Dim Function GetQBColor(hWnd As HWND,c As Long,dlg As Long) As COLORREF
    	Dim Sub AutoColor(nColor As COLORREF)
    	Dim Function AutoColor() As COLORREF
    	Dim Sub UserColor(nColor As COLORREF)
		Dim Function UserColor() As COLORREF
		Dim Function SelColor() As COLORREF
		Dim Function ScalingRatio() As Single
		Dim Sub ScalingRatio(rxRatio As Single)
		Dim Static Function CCbColorProc (hwnd AS HWND, uMsg AS UINT,wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
		'Dim Function CCbColorProc (BYVAL hwnd AS HWND, BYVAL uMsg AS UINT, BYVAL wParam AS WPARAM, BYVAL lParam AS LPARAM) AS friend LRESULT
End Class
'==============================================================================
'Function CCbColorProc (hwnd AS HWND,uMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
'	Dim As CCbColor Ptr pCbColor
'	Select Case uMsg
'		Case WM_CREATE
'			zTrace("WM_CREATE")
'			Exit Function
'		Case WM_DESTROY
'		zTrace("WM_DESTROY")
'			'Remove subclassing
'			SetWindowLongPtr( hwnd, GWLP_WNDPROC, (LONG_PTR) RemoveProp(hwnd, "OLDWNDPROC"))
'			'Remove the property
'			RemoveProp(hwnd,"CBCOLORPTR")
'			Exit Function
'		Case WM_DRAWITEM
'		zTrace("WM_DRAWITEM")
'			'Get a pointer to the class
'			pCbColor = (CCbColor Ptr) GetProp(hwnd,"CBCOLORPTR")
'			If pCbColor = NULL Then
'				Exit Function
'			EndIf
'			BeginBlock
'				Dim As HBRUSH hBrush
'				Dim wszText$
'				Dim As DRAWITEMSTRUCT PTR lpdis
'				Dim As RECT rc
'				lpdis = (DRAWITEMSTRUCT PTR)lParam
'				If lpdis->itemID = 0xFFFFFFFF Then
'					zTrace("lpdis->itemID = 0xFFFFFFFF ")
'					Exit Function
'				EndIf
'				Select Case lpdis->itemAction
'					Case ODA_DRAWENTIRE, ODA_SELECT
'						'Clear background
'						FillRect(lpdis->hDC, &lpdis->rcItem, GetSysColorBrush(COLOR_WINDOW))
'						'Get/draw text
'						SendMessage( hwnd, CB_GETLBTEXT, lpdis->itemID, (LPARAM) &wszText)
'						SetBkColor(lpdis->hDC, GetSysColor(COLOR_WINDOW))
'						SetTextColor( lpdis->hDC, GetSysColor(COLOR_WINDOWTEXT))
'						rc = lpdis->rcItem
'						rc.left = 28 * (pCbColor->m_ratio * 0.72)
'						DrawText(lpdis->hDC, wszText, LEN(wszText), &rc, DT_SINGLELINE BOR DT_LEFT BOR DT_VCENTER)
'						'If selected item...
'						If (lpdis->itemState BAND ODS_SELECTED) Then
'							' // If not ODS_COMBOBOXEDIT...
'							If (lpdis->itemState BAND ODS_COMBOBOXEDIT) = 0 Then
'								' // Set coordinates
'								rc.left = 26 * (pCbColor->m_ratio * 0.72)
'								rc.right = lpdis->rcItem.right
'								rc.top = lpdis->rcItem.top
'								rc.bottom = lpdis->rcItem.bottom
'								' // Invert area around text only
'								InvertRect( lpdis->hDC, &rc)
'							End if
'							' // and draw a focus rectangle around all
'							DrawFocusRect(lpdis->hDC, &lpdis->rcItem)
'						End If
'						'Paint color rectangle using RoundRect for nicer looks
'						' If ODS_COMBOBOXEDIT...
'						If (lpdis->itemState BAND ODS_COMBOBOXEDIT) Then
'							' Set coordinates
'							rc.left = 4 * (pCbColor->m_ratio * 0.72)
'							rc.right = 24 * (pCbColor->m_ratio * 0.72)
'						Else
'							' A tiny bit to the left in list...
'							rc.left = 3 * (pCbColor->m_ratio * 0.72)
'							rc.right = 23 * (pCbColor->m_ratio * 0.72)
'						End If
'						rc.top    = (lpdis->rcItem.top + (2 * pCbColor->m_ratio))
'						rc.bottom = (lpdis->rcItem.bottom - (2 * pCbColor->m_ratio))
'						' Create brush with the appropriate color
'						
'						hBrush = CreateSolidBrush(pCbColor->GetQBColor(hwnd, lpdis->itemID, FALSE))
'						
'						' Select brush into device context
'						hBrush = (HBRUSH)SelectObject(lpdis->hDC, hBrush)
'						' Draw the rectangle
'						DIM AS LONG nCorner = pCbColor->m_ratio * 0.72
'						RoundRect(lpdis->hDC, rc.left, rc.top, rc.right, rc.bottom, nCorner, nCorner)
'						' Select old brush back and delete new one
'						DeleteObject( SelectObject(lpdis->hDC, hBrush))
'				End Select
'			EndBlock
'			Function = TRUE
'		Case CBCOL_SETAUTOCOLOR
'		zTrace("CBCOL_SETAUTOCOLOR")
'			pCbColor = (CCbColor PTR) GetProp(hwnd, "CBCOLORPTR")	
'			If pCbColor = NULL Then
'				Exit Function
'			EndIf
'			pCbColor->m_autoColor = wParam
'			Exit Function
'		Case CBCOL_GETAUTOCOLOR
'		zTrace("CBCOL_GETAUTOCOLOR")
'			pCbColor = (CCbColor PTR) GetProp(hwnd, "CBCOLORPTR")
'			If pCbColor = NULL Then
'				Exit Function
'			EndIf
'			Function = pCbColor->m_autoColor
'		Case CBCOL_SETUSERCOLOR
'			pCbColor = (CCbColor PTR) GetProp(hwnd, "CBCOLORPTR")
'			If pCbColor = NULL Then
'				Exit Function
'			EndIf
'			pCbColor->m_userColor = wParam
'		Case CBCOL_GETUSERCOLOR
'			pCbColor = (CCbColor PTR) GetProp(hwnd, "CBCOLORPTR")
'			If pCbColor = NULL Then
'				Exit Function
'			EndIf
'			Function = pCbColor->m_userColor
'		Case CBCOL_GETSELCOLOR
'			Dim As Long nRes
'			nRes = SendMessage(hwnd, CB_GETCURSEL, 0, 0)
'			pCbColor = (CCbColor PTR) GetProp(hwnd, "CBCOLORPTR")
'			If pCbColor = NULL Then
'				Exit Function
'			EndIf
'			If nRes > CB_ERR Then
'				Function = pCbColor->GetQBColor(hwnd, nRes, TRUE)
'			EndIf
'			Exit Function
'	End Select
'	
'	Function = CallWindowProc(GetProp(hwnd, "OLDWNDPROC"), hwnd, uMsg, wParam, lParam)
'End Function

CLASS_METHODS_START CCbColor
Function CCbColorProc (hwnd AS HWND,uMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
	Dim As CCbColor Ptr pCbColor
	Select Case uMsg
		Case WM_CREATE
			zTrace("WM_CREATE")
			Exit Function
		Case WM_DESTROY
			'Remove subclassing
			SetWindowLongPtr( hwnd, GWLP_WNDPROC, (LONG_PTR) RemoveProp(hwnd, "OLDWNDPROC"))
			'Remove the property
			RemoveProp(hwnd,"CBCOLORPTR")
			Exit Function
		Case WM_DRAWITEM
			zTrace("WM_DRAWITEM")
			'Get a pointer to the class
			pCbColor = (CCbColor Ptr) GetProp(hwnd,"CBCOLORPTR")
			If pCbColor = NULL Then
				Exit Function
			EndIf
			BeginBlock
				Dim As HBRUSH hBrush
				Dim wszText$
				Dim As DRAWITEMSTRUCT PTR lpdis
				Dim As RECT rc
				lpdis = (DRAWITEMSTRUCT PTR)lParam
				If lpdis->itemID = 0xFFFFFFFF Then
					Exit Function
				EndIf
				Select Case lpdis->itemAction
					Case ODA_DRAWENTIRE, ODA_SELECT
						'Clear background
						FillRect(lpdis->hDC, &lpdis->rcItem, GetSysColorBrush(COLOR_WINDOW))
						'Get/draw text
						SendMessage( hwnd, CB_GETLBTEXT, lpdis->itemID, (LPARAM) &wszText)
						SetBkColor(lpdis->hDC, GetSysColor(COLOR_WINDOW))
						SetTextColor( lpdis->hDC, GetSysColor(COLOR_WINDOWTEXT))
						rc = lpdis->rcItem
						rc.left = 28 * (pCbColor->m_ratio * 0.72)
						DrawText(lpdis->hDC, wszText, LEN(wszText), &rc, DT_SINGLELINE BOR DT_LEFT BOR DT_VCENTER)
						'If selected item...
						If (lpdis->itemState BAND ODS_SELECTED) Then
							' // If not ODS_COMBOBOXEDIT...
							If (lpdis->itemState BAND ODS_COMBOBOXEDIT) = 0 Then
								' // Set coordinates
								rc.left = 26 * (pCbColor->m_ratio * 0.72)
								rc.right = lpdis->rcItem.right
								rc.top = lpdis->rcItem.top
								rc.bottom = lpdis->rcItem.bottom
								' // Invert area around text only
								InvertRect( lpdis->hDC, &rc)
							End if
							' // and draw a focus rectangle around all
							DrawFocusRect(lpdis->hDC, &lpdis->rcItem)
						End If
						'Paint color rectangle using RoundRect for nicer looks
						' If ODS_COMBOBOXEDIT...
						If (lpdis->itemState BAND ODS_COMBOBOXEDIT) Then
							' Set coordinates
							rc.left = 4 * (pCbColor->m_ratio * 0.72)
							rc.right = 24 * (pCbColor->m_ratio * 0.72)
						Else
							' A tiny bit to the left in list...
							rc.left = 3 * (pCbColor->m_ratio * 0.72)
							rc.right = 23 * (pCbColor->m_ratio * 0.72)
						End If
						rc.top    = (lpdis->rcItem.top + (2 * pCbColor->m_ratio))
						rc.bottom = (lpdis->rcItem.bottom - (2 * pCbColor->m_ratio))
						' Create brush with the appropriate color
						
						hBrush = CreateSolidBrush(pCbColor->GetQBColor(hwnd, lpdis->itemID, FALSE))
						
						' Select brush into device context
						hBrush = (HBRUSH)SelectObject(lpdis->hDC, hBrush)
						' Draw the rectangle
						DIM AS LONG nCorner = pCbColor->m_ratio * 0.72
						RoundRect(lpdis->hDC, rc.left, rc.top, rc.right, rc.bottom, nCorner, nCorner)
						' Select old brush back and delete new one
						DeleteObject( SelectObject(lpdis->hDC, hBrush))
				End Select
			EndBlock
			Function = TRUE
		Case CBCOL_SETAUTOCOLOR
			pCbColor = (CCbColor PTR) GetProp(hwnd, "CBCOLORPTR")	
			If pCbColor = NULL Then
				Exit Function
			EndIf
			pCbColor->m_autoColor = wParam
			Exit Function
		Case CBCOL_GETAUTOCOLOR
			pCbColor = (CCbColor PTR) GetProp(hwnd, "CBCOLORPTR")
			If pCbColor = NULL Then
				Exit Function
			EndIf
			Function = pCbColor->m_autoColor
		Case CBCOL_SETUSERCOLOR
			pCbColor = (CCbColor PTR) GetProp(hwnd, "CBCOLORPTR")
			If pCbColor = NULL Then
				Exit Function
			EndIf
			pCbColor->m_userColor = wParam
		Case CBCOL_GETUSERCOLOR
			pCbColor = (CCbColor PTR) GetProp(hwnd, "CBCOLORPTR")
			If pCbColor = NULL Then
				Exit Function
			EndIf
			Function = pCbColor->m_userColor
		Case CBCOL_GETSELCOLOR
			Dim As Long nRes
			nRes = SendMessage(hwnd, CB_GETCURSEL, 0, 0)
			pCbColor = (CCbColor PTR) GetProp(hwnd, "CBCOLORPTR")
			If pCbColor = NULL Then
				Exit Function
			EndIf
			If nRes > CB_ERR Then
				Function = pCbColor->GetQBColor(hwnd, nRes, TRUE)
			EndIf
			Exit Function
	End Select
	
	Function = CallWindowProc(GetProp(hwnd, "OLDWNDPROC"), hwnd, uMsg, wParam, lParam)
End Function
'==============================================================================
Constructor CCbColor(pWindow As CWindow Ptr, cID As Integer, x As Long, y As Long , _
    	                         nWidth As Long, nHeight As Long , dwAutoColor As COLORREF , _
    	                         dwUserColor As COLORREF , prgNames As char ptr Ptr,numBytes As DWORD )
	If prgNames <> NULL AND numBytes < (18 * 20 * 2) + 1 Then
		'memcpy(&m_rgbNames[0,0],prgNames,numBytes)
	EndIf
	'Create the control
	If pWindow Then
		
		m_hCtl = pWindow->AddControl("COMBOBOX", pWindow->hWindow(), cID, "", _
                 x, y, nWidth, nHeight, WS_CHILD BOR WS_VISIBLE BOR CBS_OWNERDRAWFIXED BOR CBS_HASSTRINGS BOR _
                 CBS_DROPDOWNLIST BOR WS_TABSTOP BOR CBS_DISABLENOSCROLL BOR WS_VSCROLL, WS_EX_CLIENTEDGE, _
                 NULL, (WNDPROC) CCbColorProc)
    	m_ratio = pWindow->rxRatio()
	EndIf
	If m_hCtl Then
		'Set the same font used by the parent
		Dim As LOGFONTW lfw
		If pWindow->Font() Then
			If GetObject(pWindow->Font(), SIZEOF(lfw), &lfw) Then
				m_hFont = CreateFontIndirectW(&lfw)
			EndIf
		EndIf
		'Store a pointer to the class as a property
		SetProp(m_hCtl, "CBCOLORPTR",  this)
		Dim As Long i
		For i = 0 To UBound(m_rgbNames)
			SendMessage(m_hCtl,CB_ADDSTRING,0,(LPARAM) m_rgbNames[i])
		Next
		'Store default values (usually COLOR_WINDOW or COLOR_WINDOWTEXT)
		m_autoColor = dwAutoColor
		m_userColor = dwUserColor
		'Create initial colormap for the ChooseColor dialog
		Dim As Long cl
		For i = 1 To 16
			cl = i * 16 -1
			m_rgColors[16-i] = RGB(cl,cl,cl)
		Next
	EndIf
End Constructor
'------------------------------------------------------------------------------
Destructor CCbColor()
	If m_hFont Then
		DeleteObject(m_hFont)
	EndIf
End Destructor
'------------------------------------------------------------------------------
Function hWindow() As HWND
	Function = m_hCtl
End Function
'------------------------------------------------------------------------------
Function GetQBColor(hwnd AS HWND, c AS LONG, dlg AS LONG) AS COLORREF
	Select Case c
		CASE  0 : FUNCTION = m_autoColor          ' // Pre-set system color, like COLOR_WINDOW or COLOR_WINDOWTEXT
		CASE  1 : FUNCTION = RGB(0,     0,   0)   ' // Black
		CASE  2 : FUNCTION = RGB(0,     0, 128)   ' // Blue
		CASE  3 : FUNCTION = RGB(0,   128,   0)   ' // Green
		CASE  4 : FUNCTION = RGB(0,   128, 128)   ' // Cyan
		CASE  5 : FUNCTION = RGB(196,   0,   0)   ' // Red
		CASE  6 : FUNCTION = RGB(128,   0, 128)   ' // Magenta
		CASE  7 : FUNCTION = RGB(128,  64,   0)   ' // Brown
		CASE  8 : FUNCTION = RGB(196, 196, 196)   ' // Light Gray
		CASE  9 : FUNCTION = RGB(128, 128, 128)   ' // Gray
		CASE 10 : FUNCTION = RGB(0,     0, 255)   ' // Light Blue
		CASE 11 : FUNCTION = RGB(0,   255,   0)   ' // Light Green
		CASE 12 : FUNCTION = RGB(0,   255, 255)   ' // Light Cyan
		CASE 13 : FUNCTION = RGB(255,   0,   0)   ' // Light Red
		CASE 14 : FUNCTION = RGB(255,   0, 255)   ' // Light Magenta
		CASE 15 : FUNCTION = RGB(255, 255,   0)   ' // Yellow
		CASE 16 : FUNCTION = RGB(255, 255, 255)   ' // White
		CASE 17
			'Display the ChooseColor dialog
			DIM AS CHOOSECOLORW cc
			cc.lStructSize  = SIZEOF(cc)
			cc.lpCustColors = &m_rgColors[0]
			cc.Flags        = CC_RGBINIT BOR CC_FULLOPEN
            '  Allow the dialog to "auto-select" previously selected color
            '  (only works for base colors, but still better than nothing)
			cc.rgbResult    = m_userColor
			If ChooseColor(&cc) Then
				m_userColor = cc.rgbResult
				InvalidateRect(hwnd,NULL,0)
				UpdateWindow(hwnd)
			EndIf
			Function = m_userColor
	End Select
	Function = m_autoColor
End Function
'==============================================================================
Sub AutoColor(nColor AS COLORREF)
   m_autoColor = nColor
END Sub
'------------------------------------------------------------------------------
Function AutoColor() As COLORREF
	Function = m_autoColor 
End Function
'==============================================================================
Sub UserColor(nColor AS COLORREF)
	m_userColor = nColor
End Sub
'------------------------------------------------------------------------------
Function UserColor() As COLORREF
	Function = m_userColor
End Function
'==============================================================================
Function SelColor() As COLORREF
	Dim As LRESULT nSel
	nSel = SendMessage(m_hCtl,CB_GETCURSEL,0,0)
	If nSel > CB_ERR Then
		Function = GetQBColor(m_hCtl,nSel,1)  
	EndIf
End Function
'==============================================================================
Sub ScalingRatio(rxRatio As Single)
	m_ratio = rxRatio
End Sub
'------------------------------------------------------------------------------
Function ScalingRatio() As Single
	Function = m_ratio
End Function
'==============================================================================
CLASS_METHODS_END 'CCbColor
$ENDUSE
