'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
''Ported from FreeBasic version created by Jose Rocca
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*

$USE USE_AfxUseDpiScaling USE_AfxWindowsVersion USE_AfxIsProcessDPIAware USE_AfxSetWindowClientSize
$USE USE_AfxCenterWindow
$Include <Afx/AfxWin.bi> 
$IFUSE USE_CScrollWindow
'==============================================================================
Class CScrollWindow
	private:
		Dim As HWND m_hwnd             ' // Handle of the window
		Dim As RECT m_ClientRect        ' // Coordinates of the window's client area
		Dim As Long m_nHorzInc         ' // Horizontal increment
		Dim As Long m_nVertInc         ' // Vertical increment
		Dim As Long m_HScrollMax       ' // Maximum horizontal scroll value
		Dim As Long m_VScrollMax       ' // Maximum vertical scroll value
		Dim As Long m_HScrollPos       ' // Horizontal scroll position
		Dim As Long m_VScrollPos       ' // Vertical scroll position
		Dim As Long m_HorzUnits        ' // Amount, in device units, of horizontal scrolling
		Dim As Long m_VertUnits        ' // Amount, in device units, of vertical scrolling
	public:
		Dim Constructor CScrollWindow(hWnd As HWND)
		Dim Destructor ~CScrollWindow()
		Dim Sub SetupScrollbars()
		Dim Sub ResetScrollbars()
		Dim Sub SetClientRect(pRect As RECT Ptr)
		Dim Sub SetScrollingUnits(nHorzUnits As Long,nVertUnits As Long)
		Dim Sub OnSize (wParam As WPARAM, lParam As LPARAM)
		Dim Sub OnVScroll (wParam As WPARAM, lParam As LPARAM)
		Dim Sub OnHScroll (wParam As WPARAM, lParam As LPARAM)
		Dim Sub OnMouseWheel(wParam As WPARAM, lParam As LPARAM)
End Class
'==============================================================================
$ENDUSE
'==============================================================================
Class CWindow
	private:
		Dim As HWND m_hwnd
		Dim As HINSTANCE m_hInstance
		Dim As HFONT m_hFont
		Dim As HACCEL m_hAccel
		Raw As Long m_DPI = 96
		Raw As Single m_rx = 1
		Raw As Single m_ry = 1
		Dim As ATOM m_wAtom
		'Raw As wstring m_fsClassName
		Raw As char m_szClassName[260] 
		Dim As Long m_DefaultFontSize
		Raw As char m_szDefaultFontName[260]
		Raw As LONG_PTR m_rgUserData[99]
		'Dim As ACCEL m_rgAccelEntries[1]
		Dim As ACCEL Ptr m_rgAccelEntries 
		!#ifdef USEMDI
			Dim AS HWND m_hwndClient
			Raw As char fspMDIClassName[260]
		!#endif 
		Dim As HMODULE m_hRichEditLib
$IFUSE USE_CScrollWindow		
		Dim As CScrollWindow Ptr m_pScrollWindow
$ENDUSE		
	public:
		Dim Constructor CWindow(szClassName As char Ptr = "")
		Dim	Destructor ~CWindow()
		Dim Function DPI() As Single
		Dim Sub DPI(dpi As Single)
		Dim Function UserData(idx As Long) As LONG_PTR
		Dim Sub UserData(idx As Long,newValue As LONG_PTR)
		Dim Function Do_Events(nCmdShow = 0 As Long) As Long
		Dim Function Create(hParent As HWND = NULL,wsTitle As char Ptr = "" ,lpfnWndProc As WNDPROC = NULL , _
					x As Long = CW_USEDEFAULT ,y As Long = CW_USEDEFAULT ,nWidth As Long = CW_USEDEFAULT ,nHeight As Long = CW_USEDEFAULT , _
					dwStyle As DWORD = WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN | WS_CLIPSIBLINGS , _
					dwExStyle As DWORD = WS_EX_CONTROLPARENT | WS_EX_WINDOWEDGE ) As HWND 
		Dim Sub SetClientSize(nWidth As Long,nHeight As Long)
		Dim Sub Center(hwnd As HWND = NULL ,hwndParent As HWND = NULL )
		Dim Function hWindow() As HWND
		Dim Sub hWindow(hwnd As HWND)	
		Dim Function InstanceHandle() As HINSTANCE
		Dim Sub InstanceHandle(hInst AS HINSTANCE)	
		Dim Function ClassStyle() As ULONG_PTR
		Dim Sub ClassStyle(dwStyle As ULONG_PTR)
		Dim Function WindowStyle() As ULONG_PTR
		Dim Sub WindowStyle(dwStyle AS ULONG_PTR)	
		Dim Function WindowExStyle() AS ULONG_PTR
		Dim Sub WindowExStyle(dwStyle As ULONG_PTR)
		Dim Function DefaultFontName() As char Ptr
		Dim Sub DefaultFontName(fsFontName As char Ptr) 
		Dim Function DefaultFontSize() As Long
		Dim Sub DefaultFontSize(nPointSize As Long)
		Dim Function Font() As HFONT
		Dim Sub Font(hFont As HFONT)
		Dim Function Brush() As HBRUSH
		Dim Sub Brush(hbrBackground AS HBRUSH)
		Dim Sub BigIcon(hIcon As HICON)
		Dim Sub SmallIcon(hIcon As HICON)
		Dim Function rxRatio() As Single
		Dim Sub rxRatio(rx As Single)
		Dim Function ryRatio() As Single
		Dim Sub ryRatio(ry As Single)
		Dim Function ScaleX(cx As Single) As Single
		Dim Function ScaleY(cy As Single) As Single
		Dim Function UnScaleX(cx As Single) As Single
		Dim Function UnScaleY(cy As Single) As Single
		Dim Function Width() As Long
		Dim Function Height() AS Long
		Dim Function ClientWidth() As Long
		Dim Function ClientHeight() As Long
		Dim Function ControlWidth(hwnd As HWND) As Long
		Dim Function ControlHeight(hwnd As HWND) As Long
		Dim Function ControlClientWidth(hwnd As HWND) As Long
		Dim Function ControlClientHeight(hwnd As HWND) As Long
		Dim Sub GetWindowRect(lpRect As LPRECT)
		Dim Function GetWindowRect() As RECT
		Dim Sub GetClientRect(lpRect As LPRECT)
		Dim Function GetClientRect() As RECT
		Dim Sub GetControlWindowRect(hwnd As HWND,lpRect As LPRECT)
		Dim Function GetControlWindowRect(hwnd As HWND) As RECT
		Dim Sub GetControlClientRect(hwnd As HWND,lpRect As LPRECT)
		Dim Function GetControlClientRect(hwnd As HWND) As RECT
		Dim Sub GetWorkArea(lpRect As LPRECT)
		Dim Function GetWorkArea() AS RECT
		Dim Function ControlHandle(cID As Long) As HWND
$IFUSE USE_CScrollWindow		
		Dim Function ScrollWindowPtr() As CScrollWindow Ptr
		Dim Sub ScrollWindowPtr(pScrollWindow As CScrollWindow Ptr)
$ENDUSE		
		Dim Sub Resize()
		Dim Function SetWindowPos(hwnd As HWND,hwndInsertAfter As HWND, x As LONG,y As LONG,cx As LONG,cy As LONG, uFlags AS UINT) As BOOL
		Dim Function MoveWindow(hwnd As HWND, x As LONG, y As LONG, nWidth As LONG, nHeight As LONG, bRepaint AS BOOL) AS BOOL
		Dim Function CreateFont (szFaceName As char Ptr,lPointSize As LONG,lWeight As LONG = 0, _
                                 bItalic As BYTE = FALSE, bUnderline AS BYTE = FALSE, _
                                 bStrikeOut AS BYTE = FALSE,bCharSet AS BYTE = DEFAULT_CHARSET) AS HFONT
		Dim Function SetFont(sFaceName As char Ptr,lPointSize As LONG, lWeight As LONG = 0, _
                             bItalic As BYTE = FALSE, bUnderline As BYTE = FALSE, bStrikeOut As BYTE = FALSE, bCharSet As BYTE = DEFAULT_CHARSET) AS BOOL
		Dim Function AddControl(szClassName As char Ptr,hParent As HWND = 0,cID As Long = 0, _
		                        szTitle As char Ptr = "",x As Long = 0,y As Long = 0,nWidth As Long = 0, _
		                        nHeight As Long = 0,dwStyle As Long = -1,dwExStyle As Long = -1,lpParam AS LONG_PTR = 0, _
		                        pWndProc As WNDPROC = NULL,uIdSubClass As UINT_PTR = 0xffffffff,dwRefData As DWORD_PTR = NULL) AS HWND
		Dim Function AccelHandle() As HACCEL
		Dim Sub AccelHandle(hAccel As HACCEL)
		Dim Sub AddAccelerator(fvirt As BYTE, wKey As WORD, cmd As WORD)
		
End Class
'==============================================================================
$IFUSE USE_CTabPage
'Class CTabPage Inherits CWindow
Class CTabPage Inherits CWindow
	private:
		Dim As HWND m_hTabPage
	Public:
		Dim Destructor ~CTabPage()
		Dim Function hTabPage() As HWND
		Dim Function InsertPage( hTab As HWND,nPage As Long,szTitle As char Ptr = "", _
		          	nImage As Long = -1, lpfnWndProc AS WNDPROC = NULL, _
		          	dwStyle As DWORD = WS_CLIPSIBLINGS|WS_CLIPCHILDREN,dwExStyle As DWORD = 0) As HWND
End Class
$ENDUSE

'==============================================================================
$IFUSE USE_CScrollWindow
' ########################################################################################
'                              *** CSCROLLWINDOW CLASS ***
' ########################################################################################
'------------------------------------------------------------------------------
CLASS_METHODS_START CScrollWindow
'------------------------------------------------------------------------------
Constructor CScrollWindow(hwnd As HWND)
	m_hwnd = hwnd
	m_HorzUnits = 10
	m_VertUnits = 10
	GetClientRect(m_hwnd, &m_ClientRect)
End Constructor
'==============================================================================
Destructor CScrollWindow()
End Destructor
'==============================================================================
' Sets the amount, in device units, of horizontal and vertical scrolling
' ========================================================================================
Sub SetClientRect (pRect As RECT Ptr)
	If pRect = NULL Then
		Exit Sub
	EndIf
   m_ClientRect = *pRect
End Sub
'==============================================================================
' Sets the amount, in device units, of horizontal and vertical scrolling
' ========================================================================================
Sub SetScrollingUnits (nHorzUnits As Long, nVertUnits As Long)
	m_HorzUnits = nHorzUnits
	m_VertUnits = nVertUnits
End Sub
'==============================================================================
' Resets the window scrolling information
' ========================================================================================
SUB ResetScrollbars
	ScrollWindow(m_hwnd, m_HScrollPos * m_HorzUnits, 0, NULL, NULL)
	ScrollWindow(m_hwnd, 0, m_VScrollPos * m_HorzUnits, NULL, NULL)
	m_HScrollPos = 0
	m_VScrollPos = 0
	SetScrollPos(m_hwnd, SB_HORZ, m_HScrollPos, TRUE)
	SetScrollPos(m_hwnd, SB_VERT, m_VScrollPos, TRUE)
End Sub
' ========================================================================================
' Sets the scroll information
' ========================================================================================
Sub SetupScrollbars()
	
	Dim As Long bMaximized
	Dim As RECT tempRect
	Dim As WINDOWPLACEMENT wp
	
	GetClientRect(m_hwnd, &tempRect)
	GetWindowPlacement(m_hwnd, &wp)
	bMaximized = (wp.showCmd = SW_MAXIMIZE)
	
	' // Calculate how many scrolling increments for the client area
	m_nHorzInc = ((m_ClientRect.right - m_ClientRect.left) - (tempRect.right  - tempRect.left) ) / m_HorzUnits
	m_nVertInc = ((m_ClientRect.bottom - m_ClientRect.top) - (tempRect.bottom - tempRect.top ) ) / m_HorzUnits
	
	'// Set the vertical and horizontal scrolling info
	m_HScrollMax = max(0, m_nHorzInc)
	m_HScrollPos = min(m_HScrollPos, m_HScrollMax)
	SetScrollRange(m_hwnd, SB_HORZ, 0, m_HScrollMax, FALSE)
	SetScrollPos(m_hwnd, SB_HORZ, m_HScrollPos, TRUE)
	m_VScrollMax = max(0, m_nVertInc)
	m_VScrollPos = min(m_VScrollPos, m_VScrollMax)
	SetScrollRange(m_hwnd, SB_VERT, 0, m_VScrollMax, FALSE)
	SetScrollPos(m_hwnd, SB_VERT, m_VScrollPos, TRUE)
End Sub
' ========================================================================================
' Handle vertical scrollbar messages
' WM_VSCROLL
' nScrollCode = (int) LOWORD(wParam); // scroll bar value
' nPos = (short int) HIWORD(wParam);  // scroll box position
' hwndScrollBar = (HWND) lParam;      // handle of scroll bar
' ========================================================================================
Sub OnVScroll (wParam As WPARAM,lParam As LPARAM)
	Dim As Long nInc,iMove
	Select Case LOWORD(wParam)
		Case SB_TOP
			nInc = -m_VScrollPos
		Case SB_BOTTOM
			nInc = m_VScrollMax - m_VScrollPos
		Case SB_LINEUP
			nInc = -1
		Case SB_LINEDOWN
			nInc = 1
		Case SB_PAGEUP
			nInc = min(-1, -m_nVertInc)
		Case SB_PAGEDOWN
			nInc = max(1, m_nVertInc)
		Case SB_THUMBTRACK
			nInc = HIWORD(wParam) - m_VScrollPos
		Case Else
			nInc = 0
	End Select
	nInc = max(-m_VScrollPos, min(nInc, m_VScrollMax - m_VScrollPos))
	If nInc Then
		m_VScrollPos += nInc
		iMove = -m_HorzUnits * nInc
		ScrollWindow(m_hwnd, 0, iMove, NULL, NULL)
		SetScrollPos(m_hwnd, SB_VERT, m_VScrollPos, TRUE)
	End If
End Sub
' ========================================================================================
' Handle horizontal scrollbar messages
' WM_HSCROLL
' nScrollCode = (int) LOWORD(wParam);  // scroll bar value
' nPos = (short int) HIWORD(wParam);   // scroll box position
' hwndScrollBar = (HWND) lParam;       // handle of scroll bar
' ========================================================================================
Sub OnHScroll (wParam As WPARAM, lParam As LPARAM)
	Dim As Long nInc,iMove
	Select Case LOWORD(wParam)
		Case SB_TOP
			nInc = -m_HScrollPos
		Case SB_BOTTOM
			nInc = m_HScrollMax - m_HScrollPos
		Case SB_LINEUP
			nInc = -1
		Case SB_LINEDOWN
			nInc = 1
		Case SB_PAGEUP
			nInc = -m_HorzUnits
		Case SB_PAGEDOWN
			nInc = m_HorzUnits
		Case SB_THUMBTRACK
			nInc = HIWORD(wParam) - m_HScrollPos
		Case Else
			nInc = 0
	End Select
	nInc = max(-m_HScrollPos, min(nInc, m_HScrollMax - m_HScrollPos))
	If nInc Then
		m_HScrollPos += nInc
		iMove = -m_HorzUnits * nInc
		ScrollWindow(m_hwnd, iMove, 0, NULL, NULL)
		SetScrollPos(m_hwnd, SB_HORZ, m_HScrollPos, TRUE)
	End If
End Sub
' ========================================================================================
' Handle WM_SIZE messges
' WM_SIZE
' fwSizeType = wParam;      // resizing flag
' nWidth = LOWORD(lParam);  // width of client area
' nHeight = HIWORD(lParam); // height of client area
' ========================================================================================
Sub OnSize (wParam As WPARAM,lParam As LPARAM)
	this->ResetScrollbars()
	this->SetupScrollbars()
END SUB
'==============================================================================

'------------------------------------------------------------------------------
CLASS_METHODS_END 'CScrollWindow
$ENDUSE

'------------------------------------------------------------------------------
'==============================================================================
' Registers the window class.
' Parameter:
' - lpfnWndProc = Pointer to the window procedure.
' Return Value:
'   An atom that uniquely identifies the class.
' Remarks:
'   The values of several of the members of this structure can be retrieved with
'   GetClassLongPtrW and set with SetClassLongPtrW.
' Note: The class uses CS_HREDRAW OR CS_VREDRAW as default window styles. Without them,
' the background is not repainted and the controls leave garbage in it when resized. With
' them, windows with many controls cause heavy flicker. To avoid flicker, you can change
' the windows style using e.g. pWindow.ClassStyle = CS_DBLCLKS and take care yourself of
' repainting.
Function CWindow_RegisterClass( szClassName As char Ptr,hInstance As HINSTANCE,lpfnWndProc As WNDPROC) As ATOM
	Dim As ATOM wAtom
	Dim As WNDCLASSEXW wcexw
	static As Long nCount = 0

	static  As char m_wszClassName[256]
	If Len( szClassName) Then
		m_wszClassName = szClassName
	Else
		m_wszClassName = "bc9WindowClass"
		m_wszClassName = m_wszClassName & ":" + STR$(nCount)
	EndIf
   ' // Default handler
	If lpfnWndProc = NULL Then
		lpfnWndProc = (WNDPROC)&CWindow_WindowProc
	EndIf

	' // Fill the WNDCLASSEXW structure
	With wcexw
		.cbSize        = SIZEOF(wcexw)
		.style         = CS_DBLCLKS BOR CS_HREDRAW BOR CS_VREDRAW
		.lpfnWndProc   = lpfnWndProc
		.cbClsExtra    = 0
		.cbWndExtra    = SIZEOF(HANDLE)
		.hInstance     = hInstance
		.hCursor       = LoadCursor(NULL, (LPCWSTR) IDC_ARROW)
		.hbrBackground = (HBRUSH) (COLOR_3DFACE + 1)
		.lpszMenuName  = NULL
		.lpszClassName = (LPCWSTR)&m_wszClassName
		.hIcon         = 0
		.hIconSm       = 0
		
	End With
	'' // Register the class
	wAtom = RegisterClassEx(&wcexw)
	'' // Increment the class counter
	IF wAtom THEN 
		nCount = nCount + 1
	'Else
	'	zTrace(L"CRAP")
	EndIf
	'' // Return the atom
	
	Function = wAtom
End Function
'------------------------------------------------------------------------------
'==============================================================================
Function CWindow_WindowProc (hwnd AS HWND, uMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
	static As CWindow Ptr pWindow
!#ifdef USEMDI
	static As HWND hwndClient
	Dim As HWND hwndActive
	Dim As HANDLE hMdi
	If hwndClient = NULL AND pWindow != NULL Then
		hwndClient \ pWindow->hwndClient
	EndIf
!#endif	
	Select Case uMsg
		Case WM_CREATE
			' // Retrieve a reference to the CWindow class from the MDI child window handle
			Raw As CREATESTRUCT PTR pCreateStruct = (CREATESTRUCT PTR) lParam
			pWindow = (CWindow PTR) pCreateStruct->lpCreateParams
			Exit Function
		Case WM_SYSCOMMAND
			' // Capture this message and send a WM_CLOSE message
			' // Note: Needed with some OCXs, that otherwise remain in memory
			'If (wParam AND 0xFFF0) = SC_CLOSE Then
			If wParam  = SC_CLOSE Then
				SendMessage(hwnd, WM_CLOSE, 0, 0)
				Exit Function
			End if
		Case WM_COMMAND
			Select Case LOWORD(wParam)
				Case IDCANCEL
					If HIWORD(wParam) = BN_CLICKED Then
						SendMessage(hwnd, WM_CLOSE, 0, 0)
						Exit Function
					EndIf
			End Select
			!#ifdef USEMDI
			If hwndClient Then
				' // Pass unprocessed messages to the active MDI child and then to DefFrameProc()
				hwndActive = (HANDLE) SendMessage(hwndClient, WM_MDIGETACTIVE, 0, 0)
				If IsWindow(hwndActive) Then
					SendMessage(hwndActive, WM_COMMAND, wParam, lParam)
				EndIf
			End If
			!#endif
		Case WM_NOTIFY
			!#ifdef USEMDI
			If hwndClient Then
				' // Pass unprocessed messages to the active MDI child and then to DefFrameProc()
				hwndActive = (HANDLE) SendMessage(hwndClient, WM_MDIGETACTIVE, 0, 0)
				If IsWindow(hwndActive) <> 0 Then
					SendMessage(hwndActive, WM_NOTIFY, wParam, lParam)
				EndIf
			END IF
			!#endif
		!#ifdef USEMDI
		Case WM_CLOSE
			If hwndClient Then
				' // Attempt to close all MDI child windows
				EnumChildWindows(hwndClient, CWindow_CloseEnumProc, 0)
				' // If child windows are still open abort closing the application
				If GetWindow(hwndClient, GW_CHILD) Then
					Exit Function
				EndIf
			End if
		!#endif	
		!#ifdef USEMDI
		Case WM_QUERYENDSESSION
			If hwndClient Then
			' // Attempt to close all MDI child windows
				EnumChildWindows(hwndClient, CWindow_CloseEnumProc, 0)
				' // If child windows are still open abort closing the application
				IF GetWindow(hwndClient, GW_CHILD) Then
					Exit Function
				EndIf
			End If
		!#endif
		
		Case WM_DESTROY
			PostQuitMessage(0)
			Exit Function
	End Select
	
	
!#ifdef USEMDI
	If hwndClient Then
		' // The DefFrameProc function provides default processing for any window
		' // messages that the window procedure of a multiple-document interface (MDI)
		' // frame window does not process. All window messages that are not explicitly
		' // processed by the window procedure must be passed to the DefFrameProc
		' // function, not the DefWindowProc function.
		
		Function = DefFrameProc(hwnd, hwndClient, uMsg, wParam, lParam)
	Else
	' // The DefWindowProc function calls the default window procedure to provide
	' // default processing for any window messages that an application does not process.
	' // This function ensures that every message is processed. DefWindowProc
	' // is called with the same parameters received by the window procedure.
		
		FUNCTION = DefWindowProc(hwnd, uMsg, wParam, lParam)
	End If	
!#else
	Function = DefWindowProc(hwnd, uMsg, wParam, lParam)
!#endif
End Function
'==============================================================================
CLASS_METHODS_START CWindow
Constructor CWindow(szClassName  As char Ptr)
	m_szClassName$ = szClassName
	m_hInstance = ::GetModuleHandle(NULL)
	If AfxUseDpiScaling = 0 Then
		this->DPI(96)
	Else
		this->DPI(-1)
	EndIf
	If Len(m_szDefaultFontName) = 0 Then
		If AfxWindowsVersion() >= 600 AND AfxIsProcessDPIAware() Then
			m_szDefaultFontName$ = "Segoe UI" 
		Else
			m_szDefaultFontName$ = "Tahoma"
		EndIf
	EndIf
	If m_DefaultFontSize = 0 Then
		If AfxWindowsVersion() >= 600 AND AfxIsProcessDPIAware() Then
			m_DefaultFontSize = 9
		Else
			m_DefaultFontSize = 8
		EndIf
	EndIf
	Dim As INITCOMMONCONTROLSEX icc
	icc.dwSize = SIZEOF(icc)
	icc.dwICC  = ICC_NATIVEFNTCTL_CLASS|ICC_COOL_CLASSES|ICC_BAR_CLASSES| _
	            ICC_TAB_CLASSES|ICC_USEREX_CLASSES|ICC_WIN95_CLASSES| _
	            ICC_STANDARD_CLASSES|ICC_ANIMATE_CLASS|ICC_DATE_CLASSES| _
	            ICC_HOTKEY_CLASS|ICC_INTERNET_CLASSES|ICC_LISTVIEW_CLASSES| _
	            ICC_PAGESCROLLER_CLASS|ICC_PROGRESS_CLASS|ICC_TREEVIEW_CLASSES| _
	            ICC_UPDOWN_CLASS
	::InitCommonControlsEx(&icc)

End Constructor

'==============================================================================
Destructor CWindow()
	If m_hFont Then
		::DeleteObject(m_hFont)
	EndIf
	If m_hAccel Then
		::DestroyAcceleratorTable(m_hAccel)
	EndIf
	If Len(m_szClassName) Then
		UnregisterClass(m_szClassName, m_hInstance)
	EndIf
	If m_hRichEditLib Then
		FreeLibrary(m_hRichEditLib)
	EndIf
$IFUSE USE_CScrollWindow	
	If m_pScrollWindow Then
		delete m_pScrollWindow
	EndIf
$ENDUSE	
	'!#ifdef USE_ZTRACE
	'	zTrace(L"DESTRUCTOR")
	'!#endif	
	'? "DESTRUCTOR"
End Destructor
'==============================================================================
'==============================================================================
'------------------------------------------------------------------------------
Function DPI() As Single
	Function = m_DPI
End Function
' ========================================================================================
' Sets the DPI (dots per pixel) to be used by the application.
' Pass -1 to use the value returned by the GetDeviceCaps API function.
' Note: Set this value if you want to make your application High-DPI aware.
' The main window, controls and fonts will be scaled if the user changes the DPI setting.
' Don't change the DPI value once the main window has been created.
' ========================================================================================
Sub DPI(nDPI As Single)
	Dim As HDC hDC
	m_DPI = nDPI
	' // Get the screen device context
	hDC = GetDC(NULL)
	If m_DPI < 0 Then
		m_DPI = GetDeviceCaps(hDC, LOGPIXELSX)
		nDPI = m_DPI
	EndIf
   ' // Resolution ratio = current resolution / 96
	If nDPI < 0 THEN
	  m_rx = (GetDeviceCaps(hDC, LOGPIXELSX) / 96)
	  m_ry = (GetDeviceCaps(hDC, LOGPIXELSY) / 96)
	Else
	  m_rx = nDPI / 96
	  m_ry = nDPI / 96
	End If
	ReleaseDC(NULL, hDC)
End Sub
'------------------------------------------------------------------------------


'==============================================================================
' Retrieves a value from the user data area of a CWindow.
' idx = The index number of the user data value to retrieve, in the range 0 to 99 inclusive.
'------------------------------------------------------------------------------
Function UserData(idx As Long) As LONG_PTR
	If idx < 0 OR idx > 99 Then
		Exit Function
	EndIf
	Function = m_rgUserData[idx]
End Function
'==============================================================================
' Sets a value in the user data area of a CWindow.
' idx = The index number of the user data value to retrieve, in the range 0 to 99 inclusive.
'------------------------------------------------------------------------------
Sub UserData(idx As Long,newValue As LONG_PTR)
	If idx < 0 OR idx > 99 Then
		Exit Sub
	EndIf
	m_rgUserData[idx] = newValue
End Sub
'==============================================================================
' Processes window messages
' // Uses IsDialogMessage in the message pump
' // Note: To process arrow keys, characters, enter, insert, backspace or delete keys, set USEDLGMSG = 0.
' // Or you can leave it as is and process the WM_GETDLGCODE message:
' // CASE WM_GETDLGCODE
' //    FUNCTION = DLGC_WANTALLKEYS
' // If you are only interested in arrow keys and characters...
' // CASE WM_GETDLGCODE
' //    FUNCTION = DLGC_WANTARROWS OR DLGC_WANTCHARS
'#ifndef USEDLGMSG
'#define USEDLGMSG 1
Const USEDLGMSG = 1
'#endif

Function Do_Events(nCmdShow = 0 As Long) As Long
	Dim As MSG uMsg
	If m_hwnd = NULL Then
		Exit Function
	EndIf
	If nCmdShow = 0 Then
		ShowWindow(m_hwnd,SW_SHOW)
	Else
		ShowWindow(m_hwnd,nCmdShow)
	EndIf
	While (GetMessage(&uMsg,NULL,0,0))
!#ifdef USEMDI
      ' // Processes accelerator keystrokes for window menu command
      ' // of the multiple document interface (MDI) child windows
    	IF m_hwndClient = NULL OR TranslateMDISysAccel(m_hwndClient, &uMsg) = 0 THEN
!#endif
        	' // Processes accelerator keys for menu commands
        	IF m_hAccel = NULL OR TranslateAccelerator(m_hwnd, m_hAccel, &uMsg) = 0 THEN
				!#if (USEDLGMSG >= 1)
			            ' // Determines whether a message is intended for the specified
			            ' // dialog box and, if it is, processes the message.
			            If IsDialogMessage(m_hwnd, &uMsg) = 0 THEN
			               ' // Translates virtual-key messages into character messages.
			               TranslateMessage(&uMsg)
			               ' // Dispatches a message to a window procedure.
			               DispatchMessage(&uMsg)
			            END IF
				!#else
			            ' // Translates virtual-key messages into character messages.
			            TranslateMessage(&uMsg)
			            ' // Dispatches a message to a window procedure.
			            DispatchMessage(&uMsg)
				!#endif
        	End If
!#ifdef USEMDI
		End If
!#endif        	
	Wend
	Function = uMsg.wParam
End Function
'==============================================================================
' Window creation
' Parameters:
' - hParent     = Parent window handle
' - wszTitle    = Window caption
' - lpfnWndProc = Address of the callback function
' - x           = Horizontal position
' - y           = Vertical position
' - nWidth      = Window width
' - nHeight     = Window height
' - dwStyle     = Window style
' - dwExStyle   = Extended style
' Remarks: As the last parameter we are passing a pointer to the class to allow its use
' in the WM_CREATE message, e.g.
'    CASE WM_CREATE
'       DIM pCreateStruct AS CREATESTRUCT PTR = CAST(CREATESTRUCT PTR, lParam)
'       DIM pWindow AS CWindow PTR = CAST(CWindow PTR, pCreateStruct->lpCreateParams)
'       IF pWindow THEN pWindow->AddControl("Button", hwnd, IDCANCEL, "&Close", 350, 250, 75, 23)
' -or-
'    CASE WM_CREATE
'       DIM pWindow AS CWindow PTR = AfxCWindowPtr(CAST(CREATESTRUCT PTR, lParam))
'       IF pWindow THEN pWindow->AddControl("Button", hwnd, IDCANCEL, "&Close", 350, 250, 75, 23)
' -or-
'    CASE WM_CREATE
'       DIM pWindow AS CWindow PTR = AfxCWindowPtr(lParam)
'       IF pWindow THEN pWindow->AddControl("Button", hwnd, IDCANCEL, "&Close", 350, 250, 75, 23)
' ========================================================================================
Function Create(hParent = NULL As HWND,sTitle As char Ptr,lpfnWndProc As WNDPROC, _
					x = CW_USEDEFAULT As Long,y = CW_USEDEFAULT As Long,nWidth = CW_USEDEFAULT As Long,nHeight = CW_USEDEFAULT As Long, _
					dwStyle = WS_OVERLAPPEDWINDOW BOR WS_CLIPCHILDREN BOR WS_CLIPSIBLINGS As DWORD, _
					dwExStyle = WS_EX_CONTROLPARENT BOR WS_EX_WINDOWEDGE As DWORD) As HWND
	
	If m_hwnd != NULL Then
		Exit Function
	EndIf
	m_wAtom = CWindow_RegisterClass(m_szClassName, m_hInstance, lpfnWndProc)
	If m_wAtom = 0 Then
		Exit Function
	EndIf
	'create default font
	If m_hFont = NULL Then
		m_hFont = this->CreateFont(m_szDefaultFontName,m_DefaultFontSize,FW_NORMAL,FALSE, FALSE, FALSE, DEFAULT_CHARSET)		
	EndIf
	'Create the windows
	m_hwnd = ::CreateWindowEx(dwExStyle,(LPCWSTR)(ULONG_PTR)(WORD)m_wAtom,sTitle,dwStyle, _
            IIF(x = CW_USEDEFAULT, (int)CW_USEDEFAULT,(int)( x * m_rx)), _
            IIF(y = CW_USEDEFAULT, (int)CW_USEDEFAULT, (int)(y * m_ry)), _
            IIF(nWidth = CW_USEDEFAULT, (int)CW_USEDEFAULT, (int)(nWidth * m_rx)), _
            IIF(nHeight = CW_USEDEFAULT, (int)CW_USEDEFAULT, (int)(nHeight * m_ry)), _
            hParent, NULL, m_hInstance, (HANDLE) this)
 	If m_hwnd = NULL Then
 		Exit Function
 	EndIf
 	::GetClassName(m_hwnd, (LPWSTR)&m_szClassName, SIZEOF(m_szClassName) / 2)
 	'Set the font
 	If m_hFont Then
 		::SendMessage(m_hwnd, WM_SETFONT, (WPARAM) m_hFont, FALSE)
 	EndIf
 	'store the class pointer
 	::SetWindowLongPtr(m_hwnd, 0, (LONG_PTR) this)
	Function = m_hwnd					
End Function
' ========================================================================================
' Adjusts the bounding rectangle of the window based on the desired size of the client area.
' ========================================================================================
Sub SetClientSize(nWidth As LOng,nHeight As Long)
	AfxSetWindowClientSize(m_hwnd, nWidth, nHeight, m_rx, m_ry)
End Sub
'==============================================================================
' Centers a window on the screen or over another window.
' It also ensures that the placement is done within the work area.
' Parameters:
' - hwnd = Handle of the window.
' - hwndParent = [optional] Handle of the parent window.
' =====================================================================================
SUB Center (hwnd As HWND, hwndParent As HWND )
	If hwnd = NULL Then
   		hwnd = m_hwnd
	EndIf
	AfxCenterWindow(hwnd, hwndParent)
END SUB
'==============================================================================
'Returns the window handle
'------------------------------------------------------------------------------
Function hWindow() As HWND
	Function = m_hwnd
End Function
'------------------------------------------------------------------------------
'Sets the window handle
'------------------------------------------------------------------------------
Sub hWindow(hwnd As HWND)
	If m_hwnd = NULL Then
		m_hwnd = hwnd
	EndIf
End Sub

'==============================================================================
'Returns the instance handle
'------------------------------------------------------------------------------
Function InstanceHandle() As HINSTANCE
	Function = m_hInstance
End Function
'------------------------------------------------------------------------------
'Sets the instance handle
'------------------------------------------------------------------------------
Sub InstanceHandle(hInst As HINSTANCE)
	If m_hInstance = NULL Then
		m_hInstance = hInst
	EndIf
End Sub
'==============================================================================
'Returns the class style
'------------------------------------------------------------------------------
Function ClassStyle() AS ULONG_PTR
	If m_hwnd = NULL Then
		Exit Function
	EndIf
	Function = GetClassLongPtr(m_hwnd,GCL_STYLE)
End Function
'------------------------------------------------------------------------------
'Sets the Class style
'------------------------------------------------------------------------------
Sub ClassStyle(dwStyle AS ULONG_PTR)
	If m_hwnd = NULL Then
		Exit Sub
	EndIf
	SetClassLongPtr(m_hwnd, GCL_STYLE, dwStyle)
End Sub
'==============================================================================
'Gets the Window style
'------------------------------------------------------------------------------
Function WindowStyle() As ULONG_PTR
	If m_hwnd = NULL Then
		Exit Function
	EndIf
	Function = GetWindowLongPtr(m_hwnd, GWL_STYLE)
End Function
'------------------------------------------------------------------------------
'Sets the Window Style
'------------------------------------------------------------------------------
Sub WindowStyle(dwStyle As ULONG_PTR)
	If m_hwnd = NULL Then
		Exit Sub
	EndIf
	SetWindowLongPtr(m_hwnd, GWL_STYLE, dwStyle)
End Sub
'==============================================================================
'Gets The Windows extended style
'------------------------------------------------------------------------------
Function WindowExStyle() As ULONG_PTR
	If m_hwnd = NULL Then
		Exit Function
	EndIf
	Function = GetWindowLongPtr(m_hwnd, GWL_EXSTYLE)	
End Function
'------------------------------------------------------------------------------
Sub WindowExStyle(dwExStyle As ULONG_PTR)
	If m_hwnd = NULL Then
		Exit Sub
	EndIf
	SetWindowLongPtr(m_hwnd, GWL_EXSTYLE, dwExStyle)
End Sub
'==============================================================================
'Get/set default font name
'------------------------------------------------------------------------------
Function DefaultFontName() As char Ptr
	Function = m_szDefaultFontName
End Function
'------------------------------------------------------------------------------
Sub DefaultFontName(fsFontName As char Ptr)
	m_szDefaultFontName$ = fsFontName
End Sub
'==============================================================================
'Get/Set default font size
'------------------------------------------------------------------------------
Function DefaultFontSize() As Long
	Function = m_DefaultFontSize
End Function
'------------------------------------------------------------------------------
Sub DefaultFontSize(nPointSize As Long)
	m_DefaultFontSize = nPointSize
End Sub
'==============================================================================
'Get/set default font handle
'------------------------------------------------------------------------------
Function Font() As HFONT
	Function = m_hFont
End Function
'------------------------------------------------------------------------------
Sub Font(hFont AS HFONT)
	If m_hFont Then
		DeleteObject(m_hFont)
	EndIf
	m_hFont = hFont
End Sub
'==============================================================================
'Gets the background brush
'------------------------------------------------------------------------------
Function Brush() As HBRUSH
	If m_hwnd = NULL Then
		Exit Function
	EndIf
	Function = (HBRUSH)GetClassLongPtr(m_hwnd, GCLP_HBRBACKGROUND)
End Function
'------------------------------------------------------------------------------
' Sets the background brush.
' Handle to the class background brush. This member can be a handle to the physical
' brush to be used for painting the background, or it can be a color value. A color
' value must be one of the standard system colors (the value 1 must be added
' to the chosen color), e.g. COLOR_WINDOW + 1
'------------------------------------------------------------------------------
Sub Brush(hbrBackground AS HBRUSH)
	If m_hwnd = NULL Then
		Exit Sub
	EndIf
	SetClassLongPtr(m_hwnd, GCLP_HBRBACKGROUND, (LONG_PTR) hbrBackground)
    InvalidateRect( m_hwnd, NULL, TRUE)
    UpdateWindow(m_hwnd)
End Sub
'==============================================================================
' Associates a new large icon with the main window. The system displays the large icon
' in the ALT+TAB dialog box.
' Parameters:
' - hIcon = Handle to the new large icon.
'   If this parameter is NULL, the icon is removed.
'------------------------------------------------------------------------------
Sub BigIcon(hIcon As HICON)
	SendMessage(m_hwnd,WM_SETICON, (WPARAM) ICON_BIG, (LPARAM) hIcon)
End Sub
'==============================================================================
' Associates a new small icon with the main window. The system displays the small icon
' in the in the window caption.
' Parameters:
' - hIcon = Handle to the new small icon.
'   If this parameter is NULL, the icon is removed.
'------------------------------------------------------------------------------
Sub SmallIcon(hIcon As HICON)
	SendMessage(m_hwnd,WM_SETICON, (WPARAM) ICON_SMALL, (LPARAM) hIcon)
End Sub
'==============================================================================
'Gets the horizontal scaling ratio
'------------------------------------------------------------------------------
Function rxRatio() As Single
	Function = m_rx
End Sub
'==============================================================================
'Sets the horizontal scaling ratio
'------------------------------------------------------------------------------
Sub rxRatio(rx As Single)
	m_rx = rx
End Sub
'==============================================================================
' Gets the vertical scaling ratio
'------------------------------------------------------------------------------
Function ryRatio() AS Single
	Function = m_ry
End Function
'==============================================================================
' Sets the vertical scaligng ratio
'------------------------------------------------------------------------------
Sub ryRatio(ry As Single)
	m_ry = ry
End Sub
'==============================================================================
' Scales a horizontal coordinate according the DPI setting.
'------------------------------------------------------------------------------
Function ScaleX(cx As Single) As Single
	Function = cx * m_rx
End Function
'==============================================================================
'Scales a vertical coordinate according the DPI setting.
'------------------------------------------------------------------------------
Function ScaleY(cy As Single) As Single
	Function = cy * m_ry
End Function
'==============================================================================
' Unscales an horizontal coordinate according the DPI setting.
'------------------------------------------------------------------------------
Function UnScaleX(cx As Single) As Single
	Function = cx / m_rx
End Function
'==============================================================================
' Unscales a vertical coordinate according the DPI setting.
'------------------------------------------------------------------------------
Function UnScaleY(cy As Single) As Single
	Function = cy / m_ry
End Function
'==============================================================================
' Returns the width of the window
'------------------------------------------------------------------------------
Function Width() As Long
	Dim As RECT rc
	::GetWindowRect(m_hwnd, &rc)
   ' // Divide by m_rx to make the result High DPI aware
   Function = (rc.right - rc.left) / m_rx
End Function
'==============================================================================
' Returns the height of the window
'------------------------------------------------------------------------------
Function Height() As Long
	Dim As RECT rc
	::GetWindowRect(m_hwnd, &rc)
   ' // Divide by m_ry to make the result High DPI aware
   	Function = (rc.bottom - rc.top) / m_ry
End Function
'==============================================================================
' Returns the client width of the window
Function ClientWidth() As Long
	Dim As RECT rc
	::GetClientRect(m_hwnd, &rc)
	' // Divide by m_rx to make the result High DPI aware
	Function = (rc.right - rc.left) / m_rx
End Function
'==============================================================================
' Returns the client height of the window
'------------------------------------------------------------------------------
Function ClientHeight() As Long
	Dim As RECT rc
	::GetClientRect(m_hwnd, &rc)
   ' // Divide by m_ry to make the result High DPI aware
   	Function = (rc.bottom - rc.top) / m_ry
End Function
'==============================================================================
' Returns the width of the specified window
'------------------------------------------------------------------------------
Function ControlWidth (hwnd As HWND) As Long
	Dim As RECT rc
	::GetWindowRect(hwnd, &rc)
	' // Divide by m_rx to make the result High DPI aware
	Function = (rc.right - rc.left) / m_rx
End Function
'==============================================================================
' Returns the height of the specified window
'------------------------------------------------------------------------------
Function ControlHeight(hwnd As HWND) As Long
	Dim As RECT rc
	::GetWindowRect(hwnd, &rc)
	' // Divide by m_ry to make the result High DPI aware
	Function = (rc.bottom - rc.top) / m_ry
End Function
'==============================================================================
' Returns the client width of the specified window
'------------------------------------------------------------------------------
Function ControlClientWidth(hwnd As HWND) As Long
	Dim As RECT rc
	::GetClientRect(hwnd, &rc)
	' // Divide by m_rx to make the result High DPI aware
	Function = (rc.right - rc.left) / m_rx
End Function
'==============================================================================
' Returns the client height of the specified window
'------------------------------------------------------------------------------
Function ControlClientHeight(hwnd As HWND) As Long
	Dim As RECT rc
	::GetClientRect(hwnd, &rc)
	' // Divide by m_ry to make the result High DPI aware
	Function = (rc.bottom - rc.top) / m_ry
End Function
'==============================================================================
' Retrieves the dimensions of the bounding rectangle of the main window.
'------------------------------------------------------------------------------
Sub GetWindowRect(lpRect As LPRECT)
	If lpRect = NULL Then
		Exit Sub
	EndIf
	::GetWindowRect(m_hwnd, lpRect)
	' // Divide by m_rx and m_ry to make the result High DPI aware
	lpRect->left   /= m_rx
	lpRect->right  /= m_rx
	lpRect->top    /= m_ry
	lpRect->bottom /= m_ry
End Sub
'==============================================================================
Function GetWindowRect() As RECT
	Dim As RECT rc
	::GetWindowRect(m_hwnd, &rc)
	' // Divide by m_rx and m_ry to make the result High DPI aware
	rc.left   /= m_rx
	rc.right  /= m_rx
	rc.top    /= m_ry
	rc.bottom /= m_ry
	Function = rc
End Function
'==============================================================================
' Retrieves the coordinates of the main window's client area.
'------------------------------------------------------------------------------
Sub GetClientRect(lpRect As LPRECT)
	If lpRect = NULL Then
		Exit Sub
	EndIf
	::GetClientRect(m_hwnd,lpRect)
	' // Divide by m_rx and m_ry to make the result High DPI aware
	lpRect->left   /= m_rx
	lpRect->right  /= m_rx
	lpRect->top    /= m_ry
	lpRect->bottom /= m_ry
End Sub
'==============================================================================
Function GetClientRect() As RECT
	Dim As RECT rc
	::GetClientRect(m_hwnd, &rc)
	' // Divide by m_rx and m_ry to make the result High DPI aware
	rc.left   /= m_rx
	rc.right  /= m_rx
	rc.top    /= m_ry
	rc.bottom /= m_ry
	Function = rc
End Function
'==============================================================================
' Retrieves the dimensions of the bounding rectangle of the specified window.
'------------------------------------------------------------------------------
Sub GetControlWindowRect(hwnd As HWND,lpRect As LPRECT)
	If lpRect = NULL Then
		Exit Sub
	EndIf
	::GetWindowRect(hwnd, lpRect)
	' // Divide by m_rx and m_ry to make the result High DPI aware
	lpRect->left   /= m_rx
	lpRect->right  /= m_rx
	lpRect->top    /= m_ry
	lpRect->bottom /= m_ry
End Sub
'------------------------------------------------------------------------------
Function GetControlWindowRect(hwnd As HWND) As RECT
	Dim As RECT rc
	::GetWindowRect(hwnd, &rc)
	' // Divide by m_rx and m_ry to make the result High DPI aware
	rc.left   /= m_rx
	rc.right  /= m_rx
	rc.top    /= m_ry
	rc.bottom /= m_ry
	Function = rc
End Function
'==============================================================================
' Retrieves the dimensions of a window's client area.
'------------------------------------------------------------------------------
Sub GetControlClientRect(hwnd As HWND,lpRect As LPRECT)
	If lpRect = NULL Then
		Exit Sub
	EndIf
	::GetClientRect(hwnd,lpRect)	
	' // Divide by m_rx and m_ry to make the result High DPI aware
	lpRect->left   /= m_rx
	lpRect->right  /= m_rx
	lpRect->top    /= m_ry
	lpRect->bottom /= m_ry
End Sub
'------------------------------------------------------------------------------
Function GetControlClientRect(hwnd As HWND) As RECT
	Dim As RECT rc
	::GetClientRect(hwnd,&rc)
	rc.left   /= m_rx
	rc.right  /= m_rx
	rc.top    /= m_ry
	rc.bottom /= m_ry
	Function = rc
End Function
'==============================================================================
' Retrieves the size of the work area on the primary display monitor. The work area is the
' portion of the screen not obscured by the system taskbar or by application desktop toolbars.
'------------------------------------------------------------------------------
Sub GetWorkArea(lpRect As LPRECT)
	If lpRect = NULL Then
		Exit Sub
	EndIf
	SystemParametersInfo(SPI_GETWORKAREA, 0, lpRect, 0)
	' // Divide by m_rx and m_ry to make the result High DPI aware
	lpRect->left   /= m_rx
	lpRect->right  /= m_rx
	lpRect->top    /= m_ry
	lpRect->bottom /= m_ry
End Sub
'------------------------------------------------------------------------------
Function GetWorkArea() AS RECT
	Dim As RECT rc
	SystemParametersInfo(SPI_GETWORKAREA, 0, &rc, 0)
	' // Divide by m_rx and m_ry to make the result High DPI aware
	rc.left   /= m_rx
	rc.right  /= m_rx
	rc.top    /= m_ry
	rc.bottom /= m_ry
	Function = rc
End Function
'==============================================================================
' Retrieves a handle to the child control specified by its identifier.
Function ControlHandle(cID As Long) AS HWND
	Function = ::GetDlgItem(m_hwnd,cID)
End Function
'==============================================================================
$IFUSE USE_CScrollWindow
'------------------------------------------------------------------------------
Function ScrollWindowPtr() As CScrollWindow Ptr
	Function = m_pScrollWindow
End Function
''------------------------------------------------------------------------------
Sub ScrollWindowPtr(pScrollWindow As CScrollWindow Ptr)
	If m_pScrollWindow Then
		delete m_pScrollWindow
		m_pScrollWindow = pScrollWindow
	EndIf
End Sub
$ENDUSE
'==============================================================================
' Resizes the window
'------------------------------------------------------------------------------
Sub Resize()
	::SendMessage(m_hwnd, WM_SIZE,(WPARAM) SIZE_RESTORED, MAKELONG(this->ClientWidth(), this->ClientHeight()))
End Sub
'==============================================================================
Function SetWindowPos(hwnd As HWND,hwndInsertAfter As HWND, x As LONG,y As LONG,cx As LONG,cy As LONG, uFlags AS UINT) As BOOL
	Function = ::SetWindowPos(hwnd, hwndInsertAfter, x * m_rx, y * m_ry, cx * m_rx, cy * m_ry, uFlags)
End Function
'==============================================================================
Function MoveWindow(hwnd As HWND, x As LONG, y As LONG, nWidth As LONG, nHeight As LONG, bRepaint AS BOOL) AS BOOL
	Function = ::MoveWindow(hwnd, x * m_rx, y * m_ry, nWidth * m_rx, nHeight * m_ry, bRepaint)
End Function
'==============================================================================
' Creates a High DPI aware logical font.
' - wszFaceName = The typeface name.
' - lPointSize = The point size.
' - lWeight = The weight of the font in the range 0 through 1000. For example, 400 is normal
'      and 700 is bold. If this value is zero, a default weight is used.
'      The following values are defined for convenience.
'      FW_DONTCARE (0), FW_THIN (100), FW_EXTRALIGHT (200), FW_ULTRALIGHT (200), FW_LIGHT (300),
'      FW_NORMAL (400), FW_REGULAR (400), FW_MEDIUM (500), FW_SEMIBOLD (600), FW_DEMIBOLD (600),
'      FW_BOLD (700), FW_EXTRABOLD (800), FW_ULTRABOLD (800), FW_HEAVY (900), FW_BLACK (900)
' - bItalic = Italic flag. CTRUE or FALSE
' - bUnderline = Underline flag. CTRUE or FALSE
' - bStrikeOut = StrikeOut flag. CTRUE or FALSE
' - bCharset = Charset.
'      The following values are predefined: ANSI_CHARSET, BALTIC_CHARSET, CHINESEBIG5_CHARSET,
'      DEFAULT_CHARSET, EASTEUROPE_CHARSET, GB2312_CHARSET, GREEK_CHARSET, HANGUL_CHARSET,
'      MAC_CHARSET, OEM_CHARSET, RUSSIAN_CHARSET, SHIFTJIS_CHARSET, SYMBOL_CHARSET, TURKISH_CHARSET,
'      VIETNAMESE_CHARSET, JOHAB_CHARSET (Korean language edition of Windows), ARABIC_CHARSET and
'      HEBREW_CHARSET (Middle East language edition of Windows), THAI_CHARSET (Thai language
'      edition of Windows).
'      The OEM_CHARSET value specifies a character set that is operating-system dependent.
'      DEFAULT_CHARSET is set to a value based on the current system locale. For example, when
'      the system locale is English (United States), it is set as ANSI_CHARSET.
'      Fonts with other character sets may exist in the operating system. If an application uses
'      a font with an unknown character set, it should not attempt to translate or interpret
'      strings that are rendered with that font.
'      This parameter is important in the font mapping process. To ensure consistent results,
'      specify a specific character set. If you specify a typeface name in the lfFaceName member,
'      make sure that the lfCharSet value matches the character set of the typeface specified in lfFaceName.
' Return value: The handle of the font or NULL on failure.
' Remarks: The returned font must be destroyed with DeleteObject or the macro DeleteFont
' when no longer needed to prevent memory leaks.
' Usage examples:
'   hFont = CWindow.CreateFont("MS Sans Serif", 8, FW_NORMAL, , , , DEFAULT_CHARSET)
'   hFont = CWindow.CreateFont("Courier New", 10, FW_BOLD, , , , DEFAULT_CHARSET)
'   hFont = CWindow.CreateFont("Marlett", 8, FW_NORMAL, , , , SYMBOL_CHARSET)

Function CreateFont( _
		szFaceName As char Ptr, _
		lPointSize As LONG, _
		lWeight As LONG = 0, _
        bItalic As BYTE = FALSE, _
        bUnderline AS BYTE = FALSE, _
        bStrikeOut AS BYTE = FALSE, _
		bCharSet AS BYTE = DEFAULT_CHARSET) AS HFONT
	Dim As LOGFONTW tlfw
	Dim sFaceName$
	If Len(szFaceName) Then
		sFaceName$ = szFaceName
	Else
		sFaceName$ = m_szDefaultFontName
	EndIf
	' // The result must be 1, unless the programmer has set a different DPI with the set DPI property
	Raw As HDC hDC = GetDC(HWND_DESKTOP)
	' fb -> lPointSize = (lPointSize * m_DPI) \ .GetDeviceCaps(hDC, LOGPIXELSY)
	lPointSize = (lPointSize * m_DPI) / ::GetDeviceCaps(hDC, LOGPIXELSY)
	tlfw.lfHeight         = -MulDiv(lPointSize, ::GetDeviceCaps(hDC, LOGPIXELSY), 72)  ' logical font height
	tlfw.lfWidth          =  0                                                        ' average character width
	tlfw.lfEscapement     =  0                                                        ' escapement
	tlfw.lfOrientation    =  0                                                        ' orientation angles
	tlfw.lfWeight         =  lWeight                                                  ' font weight
	tlfw.lfItalic         =  bItalic                                                  ' italic(CTRUE/FALSE)
	tlfw.lfUnderline      =  bUnderline                                               ' underline(CTRUE/FALSE)
	tlfw.lfStrikeOut      =  bStrikeOut                                               ' strikeout(CTRUE/FALSE)
	tlfw.lfCharSet        =  bCharSet                                                 ' character set
	tlfw.lfOutPrecision   =  OUT_TT_PRECIS                                            ' output precision
	tlfw.lfClipPrecision  =  CLIP_DEFAULT_PRECIS                                      ' clipping precision
	tlfw.lfQuality        =  DEFAULT_QUALITY                                          ' output quality
	tlfw.lfPitchAndFamily =  FF_DONTCARE                                              ' pitch and family
	tlfw.lfFaceName$       =  sFaceName$                                    ' typeface name
	::ReleaseDC(HWND_DESKTOP, hDC)
	Function = ::CreateFontIndirect(&tlfw)
End Function
'==============================================================================
Function SetFont( _
	    szFaceName As char Ptr, _
	    lPointSize As LONG, _
	    lWeight As LONG = 0, _
        bItalic As BYTE = FALSE, _
        bUnderline As BYTE = FALSE, _
        bStrikeOut As BYTE = FALSE, _
        bCharSet As BYTE = DEFAULT_CHARSET) AS BOOL

	Dim As HFONT hFont
	Dim strFaceName$
	If Len(szFaceName) Then
		strFaceName$ = szFaceName
	Else
		strFaceName$ = m_szDefaultFontName
	EndIf
	hFont = this->CreateFont(strFaceName, lPointSize, lWeight, bItalic, bUnderline, bStrikeOut, bCharSet)
	If hFont Then
		If m_hFont Then
			::DeleteObject(m_hFont)
		EndIf
		m_hFont = hFont
		m_szDefaultFontName$ = strFaceName$
		m_DefaultFontSize = lPointSize
		Function = TRUE
	Else
		Function = FALSE
	End If			
End Function
'==============================================================================
Function AddControl( _
	szClassName As char Ptr, _
	hParent As HWND = NULL, _
	cID As Long = 0, _
	szTitle As char Ptr = "", _
	x As Long = 0, _
	y As Long = 0, _
	nWidth As Long = 0, _
	nHeight As Long = 0, _
	dwStyle As Long = -1, _
	dwExStyle As Long = -1, _
	lpParam As LONG_PTR = 0, _
	pWndProc As WNDPROC = NULL, _
	uIdSubclass As UINT_PTR = 0xFFFFFFFF, _
	dwRefData As DWORD_PTR = NULL _
	) As HWND
	
	Dim As HWND hCtl
	If Len(szClassName) = 0 Then
		Exit Function
	EndIf
	If hParent = NULL Then
		hParent = m_hwnd
	EndIf
	Raw As Long bSetFont = TRUE
	Dim sClassName$
	sClassName$ = Ucase$(szClassName$)
	
	'Select Case Ucase$(sClassName$)
	Select Case sClassName$
		Case _T("BUTTON")
			IF dwStyle = -1 Then
				dwStyle = WS_VISIBLE|WS_TABSTOP|BS_PUSHBUTTON|BS_CENTER|BS_VCENTER
			EndIf
			If dwStyle = BS_FLAT Then
				dwStyle = WS_VISIBLE|WS_TABSTOP|BS_PUSHBUTTON|BS_CENTER|BS_VCENTER|BS_FLAT
			EndIf
			If dwStyle = BS_DEFPUSHBUTTON Then
				dwStyle = WS_VISIBLE|WS_TABSTOP|BS_CENTER|BS_VCENTER|BS_DEFPUSHBUTTON
			EndIf
			If dwStyle = BS_OWNERDRAW Then
				dwStyle = WS_VISIBLE|WS_TABSTOP|BS_OWNERDRAW
			EndIf
			If dwStyle = BS_SPLITBUTTON Then
				dwStyle = WS_VISIBLE|WS_TABSTOP|BS_CENTER|BS_VCENTER|BS_SPLITBUTTON
			EndIf
			If dwStyle = BS_DEFSPLITBUTTON Then
				dwStyle = WS_VISIBLE|WS_TABSTOP|BS_CENTER|BS_VCENTER|BS_DEFSPLITBUTTON
			EndIf
			dwExStyle = 0
		Case _T("CUSTOMBUTTON"), _T("OWNERDRAWBUTTON")
			' Adds an ownerdraw button to the window.
			sClassName$ = "Button"
			If dwStyle = -1 Then
				dwStyle = WS_VISIBLE|WS_TABSTOP|BS_OWNERDRAW
			EndIf
			dwExStyle = 0
		Case _T("RADIOBUTTON"), _T("OPTION")
			' Adds a radio button to the window.
			sClassName$ = "Button"
			If dwStyle = -1 Then
				dwStyle = WS_VISIBLE|WS_TABSTOP|BS_AUTORADIOBUTTON|BS_LEFT|BS_VCENTER
			EndIf
			If dwStyle = WS_GROUP Then
				dwStyle = WS_VISIBLE|WS_TABSTOP|BS_AUTORADIOBUTTON|BS_LEFT|BS_VCENTER|WS_GROUP
			EndIf
			dwExStyle = 0
		Case _T("CHECKBOX")
			' Adds a checkbox to the window.
			sClassName$ = "Button"
			If dwStyle = -1 Then
				dwStyle = WS_VISIBLE|WS_TABSTOP|BS_AUTOCHECKBOX|BS_LEFT|BS_VCENTER
			EndIf
			dwExStyle = 0
		Case _T("CHECK3STATE")
			' Adds a 3 state checkbox to the window.
			sClassName$ = "Button"
			If dwStyle = -1 Then
				dwStyle = WS_VISIBLE|WS_TABSTOP|BS_AUTO3STATE|BS_LEFT|BS_VCENTER
			EndIf
			dwExStyle = 0
		Case _T("LABEL")
			' Adds a label to the window.
			sClassName$ = "Static"
			If dwStyle = -1 Then
				dwStyle = WS_VISIBLE|SS_LEFT|WS_GROUP|SS_NOTIFY
			EndIf
			dwExStyle = 0
		Case _T("BITMAPLABEL")
			' Adds an image label to the window.
			' You must delete the bitmap before the application ends.
			sClassName$ = "Static"
			If dwStyle = -1 Then
				dwStyle = WS_VISIBLE|WS_GROUP|SS_BITMAP
			EndIf
			If dwExStyle = -1 Then
				dwExStyle = WS_EX_TRANSPARENT
			EndIf
			bSetFont = FALSE
		Case _T("ICONLABEL")
			' Adds an image label to the window.
			' You must delete the icon before the application ends.
			sClassName$ = "Static"
			If dwStyle = -1 Then
				dwStyle = WS_VISIBLE|WS_GROUP|SS_ICON
			EndIf
			If dwExStyle = -1 Then
				dwExStyle = WS_EX_TRANSPARENT
			EndIf
			bSetFont = FALSE
		Case _T("CUSTOMLABEL")
			' Adds an ownerdraw label to the window.
			sClassName$ = "Static"
			If dwStyle = -1 Then
				dwStyle = WS_VISIBLE|WS_GROUP|SS_OWNERDRAW
			EndIf
			dwExStyle = 0
			bSetFont = FALSE
		Case _T("FRAME"), _T("FRAMEWINDOW")
			' Adds a frame to the window.
			' Note: This is not the same that PowerBASIC DDT's Frame control, that in fact is a Group Box.
			sClassName$ = "Static"
			If dwStyle = -1 Then
				dwStyle = WS_VISIBLE|WS_CLIPSIBLINGS|WS_GROUP|SS_BLACKFRAME
			EndIf
			If dwExStyle = -1 Then
				dwExStyle = WS_EX_TRANSPARENT
			EndIf
			bSetFont = FALSE
		Case _T("GROUPBOX")
			' Adds a group box to the window.
			sClassName$ = "Button"
			IF dwStyle = -1 Then
				dwStyle = WS_VISIBLE|WS_CLIPSIBLINGS|WS_GROUP|BS_GROUPBOX
			EndIf
			If dwExStyle = -1 Then
				dwExStyle = WS_EX_TRANSPARENT
			EndIf
		Case _T("LINE")	
			' Adds an horizontal line to the window
			sClassName$ = "Static"
			If dwStyle = -1 Then
				dwStyle = WS_VISIBLE|SS_ETCHEDFRAME
			EndIf
			If dwExStyle = -1 Then
				dwExStyle = WS_EX_TRANSPARENT
			EndIf
			bSetFont = FALSE
		Case _T("EDIT"),_T("TEXTBOX")
			' Adds an edit control to the window.
			sClassName$ = "Edit"
			If dwStyle = -1 Then
				dwStyle = WS_VISIBLE|WS_TABSTOP|ES_LEFT|ES_AUTOHSCROLL
			EndIf
			If dwExStyle = -1 Then
				dwExStyle = WS_EX_CLIENTEDGE
			EndIf
		Case _T("EDITMULTILINE"),_T("MULTILINETEXTBOX"),_T("MEMO")
			' Adds an edit control to the window.
			sClassName$ = "Edit"
			If dwStyle = -1 Then
				'dwStyle = WS_VISIBLE|WS_TABSTOP|ES_LEFT|ES_AUTOHSCROLL|ES_MULTILINE|ES_NOHIDESEL|ES_WANTRETURN
				dwStyle = WS_CHILD | WS_VISIBLE | ES_WANTRETURN | WS_VSCROLL | ES_MULTILINE | ES_AUTOVSCROLL | ES_AUTOHSCROLL
			EndIf
			If dwExStyle = -1 Then
				dwExStyle = WS_EX_CLIENTEDGE
			EndIf
		Case _T("COMBOBOX")
			' Adds a combo box to the window.
			'zTrace(sClassName$)
			If dwStyle = -1 Then
				dwStyle = WS_CHILD|WS_VISIBLE|WS_VSCROLL|WS_BORDER|WS_TABSTOP|CBS_DROPDOWN|CBS_HASSTRINGS|CBS_SORT
			EndIf
			If dwExStyle = -1 Then
				dwExStyle = WS_EX_CLIENTEDGE			
			EndIf
		Case _T("COMBOBOXEX"), _T("COMBOBOXEX32")
			' Adds a combo box ex to the window.
			sClassName$ = "ComboBoxEx32"
			If dwStyle = -1 Then
				dwStyle = WS_VISIBLE|WS_BORDER|WS_TABSTOP|CBS_DROPDOWNLIST
			EndIf
			dwExStyle = 0
		Case _T("LISTBOX")
			' Adds a list box to the window.
			If dwStyle = -1 Then
				dwStyle = WS_VISIBLE|WS_HSCROLL|WS_VSCROLL|WS_BORDER|WS_TABSTOP|LBS_STANDARD|LBS_HASSTRINGS|LBS_SORT|LBS_NOTIFY
			EndIf
			If dwExStyle = -1 Then
				dwExStyle = WS_EX_CLIENTEDGE	
			EndIf
		Case _T("PROGRESSBAR"), _T("MSCTLS_PROGRESS32")
			' Adds a progress bar to the window.
			sClassName$ = "msctls_progress32"
			If dwStyle = -1 Then
				dwStyle = WS_VISIBLE
			EndIf
			dwExStyle = 0
			bSetFont = FALSE
		Case _T("HEADER"), _T("SYSHEADER32")
			' Adds an header control to the window.
			sClassName$ = "SysHeader32"
			If dwStyle = -1 Then
				dwStyle = WS_VISIBLE|CCS_TOP|HDS_HORZ|HDS_BUTTONS
			EndIf
			dwExStyle = 0
		Case _T("TREEVIEW"), _T("SYSTREEVIEW32")
			' Adds a tree view control to the window.
			sClassName$ = "SysTreeView32"
			If dwStyle = -1 Then
				dwStyle = WS_VISIBLE|WS_BORDER|WS_TABSTOP|TVS_HASBUTTONS|TVS_HASLINES|TVS_LINESATROOT|TVS_SHOWSELALWAYS
			EndIf
			If dwExStyle = -1 Then
				dwExStyle = WS_EX_CLIENTEDGE			
			EndIf
		Case _T("LISTVIEW"), _T("SYSLISTVIEW32")
			' Adds a list view control to the window.
			sClassName$ = "SysListView32"
			If dwStyle = -1 Then
				dwStyle = WS_VISIBLE|WS_CLIPCHILDREN|WS_TABSTOP|LVS_REPORT|LVS_SHOWSELALWAYS|LVS_SHAREIMAGELISTS|LVS_AUTOARRANGE|LVS_EDITLABELS|LVS_ALIGNTOP
			EndIf
			If dwExStyle = -1 Then
				dwExStyle = WS_EX_CLIENTEDGE	
			EndIf
		Case _T("TOOLBAR"), _T("TOOLBARWINDOW32")
			' Adds a toolbar control to the window.
			sClassName$ = "ToolbarWindow32"
			If dwStyle = -1 Then
				dwStyle = WS_VISIBLE|WS_CLIPCHILDREN|WS_CLIPSIBLINGS|CCS_TOP|WS_BORDER|TBSTYLE_FLAT|TBSTYLE_TOOLTIPS
			EndIf
			dwExStyle = 0
		Case _T("REBAR"), _T("REBARWINDOW32")
			' Adds a rebar control to the window.
			sClassName$ = "ReBarWindow32"
			If dwStyle = -1 Then
				dwStyle = WS_VISIBLE|WS_BORDER|WS_CLIPCHILDREN|WS_CLIPSIBLINGS|CCS_NODIVIDER|RBS_VARHEIGHT|RBS_BANDBORDERS
			EndIf
			dwExStyle = 0
		Case _T("DATETIMEPICKER"), _T("SYSDATETIMEPICK32")
			' Adds a date time picker control to the window.
			sClassName$ = "SysDateTimePick32"
			If dwStyle = -1 Then
				dwStyle = WS_VISIBLE|WS_TABSTOP|DTS_SHORTDATEFORMAT
			EndIf
			dwExStyle = 0
		Case _T("MONTHCALENDAR"), _T("MONTHCAL"), _T("SYSMONTHCAL32")
			' Adds a month calendar control to the window.
			sClassName$ = "SysMonthCal32"
			If dwStyle = -1 Then
				dwStyle = WS_VISIBLE|WS_TABSTOP
			EndIf
			If dwExStyle = -1 Then
				dwExStyle = WS_EX_CLIENTEDGE	
			EndIf
		Case _T("IPADDRESS"), _T("SYSIPADDRESS32")
			' Adds an IPAddress control to the window.
			sClassName$ = "SysIPAddress32"
			If dwStyle = -1 Then
				dwStyle = WS_VISIBLE|WS_TABSTOP
			EndIf
			If dwExStyle = -1 Then
				dwExStyle = WS_EX_CLIENTEDGE	
			EndIf
		Case _T("HOTKEY"), _T("MSCTLS_HOTKEY32")
			' Adds an hotkey control to the window.
			sClassName$ = "msctls_hotkey32"
			If dwStyle = -1 Then
				dwStyle = WS_VISIBLE|WS_TABSTOP
			EndIf
			If dwExStyle = -1 Then
				dwExStyle = WS_EX_CLIENTEDGE	
			EndIf
		Case _T("ANIMATE"), _T("ANIMATION"), _T("SYSANIMATE32")
			' Adds an animation control to the window.
			sClassName$ = "SysAnimate32"
			If dwStyle = -1 Then
				dwStyle = WS_VISIBLE|ACS_TRANSPARENT
			EndIf
			dwExStyle = 0	
		Case _T("SYSLINK")
			' Adds a SysLink control to the window.
			' Note: The SysLink control is defined in the ComCtl32.dll version 6 and requires a manifest
			' or directive that specifies that version 6 of the DLL should be used if it is available.
			sClassName$ = "WC_LINK"
			If dwStyle = -1 Then
				dwStyle = WS_VISIBLE|WS_TABSTOP
			EndIf
			dwExStyle = 0
			bSetFont = FALSE	
		Case _T("PAGER"), _T("SYSPAGER")
			' Adds a Pager control to the window.
			sClassName$ = "SysPager"
			If dwStyle = -1 Then
				dwStyle = WS_VISIBLE|WS_TABSTOP|PGS_HORZ
			EndIf
			dwExStyle = 0
			bSetFont = FALSE	
		Case _T("TAB"), _T("TABCONTROL"), _T("SYSTABCONTROL32")
			' Adds a Tab control to the window.
			sClassName$ = "SysTabControl32"
			If dwStyle = -1 Then
				dwStyle = WS_VISIBLE|WS_GROUP|WS_TABSTOP|WS_CLIPCHILDREN|WS_CLIPSIBLINGS|TCS_TABS|TCS_SINGLELINE|TCS_RAGGEDRIGHT
			EndIf
			If dwExStyle = -1 Then
				dwExStyle = 0
			EndIf	
			dwExStyle =  dwExStyle|WS_EX_CONTROLPARENT
		Case _T("STATUSBAR"), _T("MSCTLS_STATUSBAR32")
			' Adds a StatusBar control to the window.
			sClassName$ = "msctls_statusbar32"
			If dwStyle = -1 Then
				dwStyle = WS_VISIBLE|WS_CLIPCHILDREN|WS_CLIPSIBLINGS|CCS_BOTTOM|SBARS_SIZEGRIP
			EndIf
			dwExStyle = 0	 
		Case _T("SIZEBAR"), _T("SIZEBOX"),_T("SIZEGRIP")
			' Adds a size box to the window.
			sClassName$ = "Scrollbar"
			If dwStyle = -1 Then
				dwStyle = WS_VISIBLE|SBS_SIZEGRIP|SBS_SIZEBOXBOTTOMRIGHTALIGN
			EndIf
			dwExStyle = 0
			bSetFont = FALSE
			nWidth = GetSystemMetrics(SM_CXVSCROLL)
			nHeight = GetSystemMetrics(SM_CYHSCROLL)
			Raw As RECT rcClient  = this->GetClientRect()
			x = rcClient.right - nWidth
			y = rcClient.bottom - nHeight
		Case _T("HSCROLLBAR")
			' Adds an horizontal scroll bar to the window.
			sClassName$ = "Scrollbar"
			If dwStyle = -1 Then
				dwStyle = WS_VISIBLE|WS_TABSTOP|SBS_HORZ
			EndIf
			dwExStyle = 0
			bSetFont = FALSE		
		Case _T("VSCROLLBAR")
			' Adds a vertical scroll bar to the window.
			sClassName$ = "Scrollbar"
			If dwStyle = -1 Then
				dwStyle = WS_VISIBLE|WS_TABSTOP|SBS_VERT
			EndIf
			dwExStyle = 0
			bSetFont = FALSE
		Case _T("TRACKBAR"), _T("MSCTLS_TRACKBAR32")
			sClassName$ = "msctls_trackbar32"
			If dwStyle = -1 Then
				dwStyle = WS_VISIBLE|WS_TABSTOP|TBS_AUTOTICKS|TBS_HORZ|TBS_BOTTOM|TBS_TOOLTIPS
			EndIf
			dwExStyle = 0
			bSetFont = FALSE
		Case _T("UPDOWN"), _T("MSCTLS_UPDOWN32")
			sClassName$ = "msctls_updown32"
			If dwStyle = -1 Then
				dwStyle = WS_VISIBLE|UDS_WRAP|UDS_ARROWKEYS|UDS_ALIGNRIGHT|UDS_SETBUDDYINT
			EndIf
			dwExStyle = 0
			bSetFont = FALSE			
		Case _T("RICHEDIT"), _T("RichEdit50W")
			!#define ES_SAVESEL  0x00008000
			If dwStyle = -1 Then
				dwStyle = WS_VISIBLE|WS_TABSTOP|ES_LEFT|WS_HSCROLL|WS_VSCROLL|ES_AUTOHSCROLL|ES_AUTOVSCROLL|ES_MULTILINE|ES_WANTRETURN|ES_NOHIDESEL|ES_SAVESEL
			EndIf
			If dwExStyle = -1 Then
				dwExStyle = WS_EX_CLIENTEDGE
			EndIf
			sClassName$ = "RichEdit50W"
			m_hRichEditLib = (HMODULE) LoadLibrary(_T("MSFTEDIT.DLL"))	
	End Select
	
   ' // Don't allow negative values for the styles
	If dwStyle = -1 Then
		dwStyle = 0
	End If	
	If dwExStyle = -1 Then
	    dwExStyle = 0	
	End If    
	
	' // Make sure that the control has the WS_CHILD style
	dwStyle = dwStyle|WS_CHILD
	hCtl = ::CreateWindowEx(dwExStyle, sClassName, szTitle, dwStyle, x * m_rx, y * m_ry, nWidth * m_rx, nHeight * m_ry, _
	      hParent, (HMENU)(LONG_PTR) cID, m_hInstance, (LPVOID) lpParam)
	If hCtl = NULL Then
		Exit Function
	EndIf
	If m_hFont Then
		If bSetFont Then
			::SendMessage(hCtl, WM_SETFONT, (WPARAM) m_hFont, TRUE)
		EndIf
	EndIf
	sClassName$ = Ucase$(szClassName$)
	Select Case sClassName$
		Case _T("COMBOBOX")
			If nHeight < 0 Then
				SendMessage(hCtl,CB_SETMINVISIBLE,_abs64(nHeight),0)
			End If
		Case _T("LISTBOX")
			' // Adjust the height of the control so that the integral height
			' // is based on the new font rather than the default SYSTEM_FONT
			SetWindowPos(hCtl, NULL, x, y, nWidth, nHeight, SWP_NOZORDER)
		Case _T("DATETIMEPICKER"), _T("SYSDATETIMEPICK32")
			' // Sets the font to be used by the date and time picker control's child month calendar control.
			If m_hFont Then
				SendMessage(hCtl, DTM_SETMCFONT, (WPARAM) m_hFont, TRUE)	
			EndIf
		Case _T("PROGRESSBAR"), _T("MSCTLS_PROGRESS32")
			' // Set the default range
			::SendMessage(hCtl, PBM_SETRANGE32, 0, 100)
			' // Set the default initial value
			::SendMessage(hCtl, PBM_SETPOS, 0, 0)
		Case _T("TRACKBAR"), _T("MSCTLS_TRACKBAR32")
			' // Set the default range values
			::SendMessage(hCtl, TBM_SETRANGEMIN, TRUE, 0)
			::SendMessage(hCtl, TBM_SETRANGEMAX, TRUE, 100)
			' // Set the default page size
			::SendMessage(hCtl, TBM_SETPAGESIZE, 0, 10)
		Case _T("UPDOWN"), _T("MSCTLS_UPDOWN32")
			' // Set the default base
			::SendMessage(hCtl, UDM_SETBASE, 10, 0)
			' // Set the default range values
			::SendMessage(hCtl, UDM_SETRANGE32, 100, 0)
			' // Set the default initial value
			::SendMessage(hCtl, UDM_SETPOS32, 0, 0)
			' // Correct for Windows using a default size for the updown control
			this->SetWindowPos(hCtl, NULL, x, y, nWidth, nHeight, SWP_NOZORDER)
		Case _T("HSCROLLBAR"), _T("VSCROLLBAR")
			' // Initialize the scroll bar with default values
			Dim As SCROLLINFO tsi 
			tsi.cbSize = SIZEOF(tsi)
			tsi.fMask  = SIF_PAGE BOR SIF_POS BOR SIF_RANGE
			tsi.nMin   = 0
			tsi.nMax   = 100
			tsi.nPage  = 0
			tsi.nPos   = 0
			::SetScrollInfo(hCtl, SB_CTL, &tsi, TRUE)
		Case _T("TOOLBAR"), _T("TOOLBARWINDOW32")
			' // Set the button size
			Dim As Long nButtonWidth, nButtonHeight
			nButtonWidth = LOWORD(::SendMessage(hCtl, TB_GETBUTTONSIZE, 0, 0)) * m_rx
			nButtonHeight = HIWORD(::SendMessage(hCtl, TB_GETBUTTONSIZE, 0, 0)) * m_ry
			::SendMessage(hCtl, TB_SETBUTTONSIZE, 0, MAKELONG(nButtonWidth, nButtonHeight))
			' // Send this message for backward compatibility
			::SendMessage(hCtl, TB_BUTTONSTRUCTSIZE, SIZEOF(TBBUTTON), 0)
		Case _T("BITMAPLABEL")
			' // Loads the image
			DIM hImage AS HANDLE, wID AS WORD, dwID AS DWORD
			If Left$(szTitle, 1) = _T("#") Then
				'wID = Val(Mid$(szTitle, 2))
				wID = atol(Mid$(szTitle, 2))
				dwID = MAKELONG(wID, 0)
				hImage = ::LoadImage(m_hInstance,(LPCWSTR)(ULONG_PTR) dwID, IMAGE_BITMAP, 0, 0, LR_DEFAULTCOLOR)
			Else
				hImage = ::LoadImage(m_hInstance, szTitle, IMAGE_BITMAP, 0, 0, LR_DEFAULTCOLOR)
			End If
			If hImage Then
				::SendMessage(hCtl, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM) hImage)						
			EndIf
		Case _T("ICONLABEL")
			' // Loads the image
			Dim hImage AS HANDLE, wID As WORD, dwID As DWORD
			If Left$(szTitle, 1) = "#" Then
				wID = atol(Mid$(szTitle, 2))
				dwID = MAKELONG(wID, 0)
				hImage = ::LoadImage(m_hInstance, (LPCWSTR)(ULONG_PTR) dwID, IMAGE_ICON, 0, 0, LR_DEFAULTCOLOR)
			Else
				hImage = ::LoadImage(m_hInstance, szTitle, IMAGE_ICON, 0, 0, LR_DEFAULTCOLOR)
			End if
			If hImage Then
				::SendMessage(hCtl, STM_SETIMAGE, IMAGE_ICON, (LPARAM) hImage)	
			EndIf
		Case _T("BITMAPBUTTON")
			' // Loads the image
			Dim hImage As HANDLE, wID As WORD, dwID As DWORD
			If Left$(szTitle, 1) = "#" Then
				wID = atol(Mid$(szTitle, 2))
				dwID = MAKELONG(wID, 0)
				hImage = ::LoadImage(m_hInstance, (LPCWSTR)(ULONG_PTR) dwID, IMAGE_BITMAP, 0, 0, LR_DEFAULTCOLOR)
			Else
				hImage = ::LoadImage(m_hInstance, szTitle, IMAGE_BITMAP, 0, 0, LR_DEFAULTCOLOR)
			End If
			If hImage Then
				::SendMessage(hCtl, BM_SETIMAGE, IMAGE_BITMAP, (LPARAM) hImage)	
			EndIf
		Case _T("ICONBUTTON")
			' // Loads the image
			Dim hImage As HANDLE, wID As WORD, dwID As DWORD
			If Left$(szTitle, 1) = "#" Then
				wID = atol(Mid$(szTitle, 2))
				dwID = MAKELONG(wID, 0)
				hImage = ::LoadImage(m_hInstance, (LPCWSTR)(ULONG_PTR) dwID, IMAGE_ICON, 0, 0, LR_DEFAULTCOLOR)
			Else
				hImage = ::LoadImage(m_hInstance, szTitle, IMAGE_ICON, 0, 0, LR_DEFAULTCOLOR)
			End If
			If hImage Then
				::SendMessage(hCtl, BM_SETIMAGE, IMAGE_ICON, (LPARAM) hImage)	
			EndIf
	End Select
	' // Subclass the control if pWndProc is not null
	If pWndProc <> NULL THEN
		
		If uIdSubclass = 0xFFFFFFFF Then
			::SetProp(hCtl, _T("OLDWNDPROC"), (HANDLE) ::SetWindowLongPtr(hCtl, GWLP_WNDPROC,(LONG_PTR) pWndProc))
		Else
			::SetWindowSubclass(hCtl, (SUBCLASSPROC) pWndProc, uIdSubclass, dwRefData)
		End If
	End If
	
	Function = hCtl
End Function
'==============================================================================
Function AccelHandle() As HACCEL
	Function = m_hAccel
End Function
'------------------------------------------------------------------------------
Sub AccelHandle(hAccel As HACCEL)
	m_hAccel = hAccel
End Sub
'==============================================================================
Sub AddAccelerator (fvirt As BYTE, wKey As WORD, cmd As WORD)
	'Redim Preserve m_rgAccelEntries[UBOUND(m_rgAccelEntries) + 1] As ACCEL
End Sub
CLASS_METHODS_END 'CWindow

$IFUSE USE_CTabPage
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
' CTABPAGE CLASS
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
CLASS_METHODS_START CTabPage
Destructor CTabPage()
	Dim As Long i,nCount
	Dim As HWND hTab
	Dim As TCITEMW tci
	hTab = ::GetParent(m_hTabPage)
	If hTab Then
		' // Get the number of items
		nCount = ::SendMessage(hTab, TCM_GETITEMCOUNT, 0, 0)
		' // Ask to return the value of the lParam member
		tci.mask = TCIF_PARAM
		For i = 0 To nCount -1 
			If ::SendMessage(hTab, TCM_GETITEMW, i, (LPARAM)&tci) THEN
				If tci.lParam = (LPARAM)this Then
					' // Delete the tab item
					::SendMessage(hTab, TCM_DELETEITEM, i, 0)
					' // Destroy the window of the tab page
					::DestroyWindow(m_hTabPage)
					' // Set the focus in the first tab
					If nCount > 1 Then
						::SendMessage(hTab, TCM_SETCURFOCUS, 0, 0)
					EndIf
					Exit For
				EndIf
			EndIf
		Next
	Else
		' // Destroy the window of the tab page
		::DestroyWindow(m_hTabPage)
		
	EndIf
End Destructor
' ========================================================================================
' Adds a tab page and creates a generic window that will be associated with the page.
' Parameters:
' - hTab        = [in] A handle to the tab control.
' - nPage       = [in] The zero based position of the page to be inserted.
' - wszTitle    = [in, opt] The text to be displayed of the tab area.
' - nImage      = [in, opt] Index in the tab control's image list, or -1 if there is no image for the tab.
' - lpfnWndProc = [in, opt] Address of the window callback procedure.
' Return Value:
' - The handle of the new tab page.
' ========================================================================================
Function InsertPage(hTab As HWND, nPage As Long, szTitle As char Ptr, nImage As Long,lpfnWndProc AS WNDPROC, _
	        dwStyle As DWORD, dwExStyle As DWORD) As HWND
	Dim As Long x, y, nWidth, nHeight, cItems
	Dim As RECT rc
	Dim As TCITEMW tci
	'Function = m_hTabPage	
	If IsWindow(hTab) = NULL Then
		Exit Function
	EndIf
	If lpfnWndProc = NULL Then
		lpfnWndProc = (WNDPROC) GetClassLongPtr(hWindow(), GWLP_WNDPROC)
	EndIf
	 
	dwStyle = dwStyle|WS_CHILD
	dwExStyle = dwExStyle|WS_EX_CONTROLPARENT
	this->ClassStyle(CS_DBLCLKS)
	
	cItems = SendMessage(hTab, TCM_GETITEMCOUNT, 0, 0)
	If nPage < 0 OR nPage > cItems Then
		nPage = cItems	            
	EndIf
	tci.mask    = TCIF_TEXT|TCIF_IMAGE|TCIF_PARAM
	tci.pszText = (LPWSTR)szTitle
	tci.iImage  = nImage
	tci.lParam  = (LPARAM)this
	SendMessage(hTab, TCM_INSERTITEMW, nPage, (LPARAM) &tci)
	::GetWindowRect(hTab, &rc)
	::SendMessage(hTab, TCM_ADJUSTRECT, FALSE, (LPARAM) &rc)
	::MapWindowPoints( NULL, hTab, (LPPOINT) &rc, 2)
	' // Adjust for High DPI because create will resize the values
	rc.left   /= rxRatio()
	rc.right  /= rxRatio()
	rc.top    /= ryRatio()
	rc.bottom /= ryRatio()
	' // Calculate coordinates and size
	x = rc.left
	y = rc.top
	nWidth  = max(1, rc.right - rc.left)
	nHeight = max(1, rc.bottom - rc.top)
	m_hTabPage = Create(hTab, szTitle, lpfnWndProc, x, y, nWidth, nHeight, dwStyle, dwExStyle)
	Function = m_hTabPage
End Function
' ========================================================================================
' Returns the window handle of the tab page
' ========================================================================================
Function hTabPage () AS HWND
   Function = m_hTabPage
End Function
'==============================================================================
CLASS_METHODS_END 'CTabPage
$ENDUSE
' ########################################################################################
'                                *** HELPER FUNCTIONS ***
' ########################################################################################
$IFUSE USE_CTabPage
' =====================================================================================
' Resizes all the tab pages associated with a tab control
' =====================================================================================
Function AfxResizeTabPages (hTab AS HWND) AS BOOL
	If hTab = NULL Then
		Exit Function
	EndIf
	Dim As Long nCount,i
	Dim As TCITEMW tci
	Dim As CTabPage Ptr pTabPage
	' // Get the number of items
	nCount = ::SendMessage(hTab, TCM_GETITEMCOUNT, 0, 0)
	If nCount = 0 Then
		EXIT Function
	EndIf
	' // Ask to return the value of the lParam member
	tci.mask = TCIF_PARAM
	' // Get information of the items
	xFor i = 0 While i < nCount By i++
		If ::SendMessage(hTab, TCM_GETITEMW, i, (LPARAM) &tci) THEN
			If tci.lParam Then
				pTabPage = (CTabPage PTR) tci.lParam
				' // Retrieve the size of the tab control window
				Dim As RECT rcParent 
				::GetWindowRect(hTab, &rcParent)
				' // Calculates the tab control's display area given its window rectangle
				::SendMessage(hTab, TCM_ADJUSTRECT, FALSE, (LPARAM) &rcParent)
				' // Convert to window coordinates
				::MapWindowPoints(NULL, hTab, (LPPOINT) &rcParent, 2)
				' // Move the tab page
				::MoveWindow(pTabPage->hTabPage(), rcParent.left, rcParent.top, _
				   rcParent.right - rcParent.left, rcParent.bottom - rcParent.top, TRUE)
				
			EndIf
		EndIf
	xNext
	Function = TRUE
End Function
'==============================================================================
' Detroys the specified tab page
' Parameters:
' - hTab = Handle to the tab control.
' - idx  = Zero based index of the tab.
' Return value: TRUE or FALSE.
' ========================================================================================
Function AfxDestroyTabPage (hTab AS HWND, idx AS LONG) AS BOOL
	If hTab = NULL Then
		Exit Function
	EndIf
	Dim As TCITEMW tci 
	Dim As CTabPage Ptr pTabPage 
	' // Ask to return the value of the lParam member
	tci.mask = TCIF_PARAM
	If ::SendMessage(hTab, TCM_GETITEMW, idx, (LPARAM) &tci) = 0 Then
		Exit Function
	EndIf
	If tci.lParam Then
		pTabPage = (CTabPage PTR) tci.lParam
		
		If pTabPage Then
			Delete pTabPage
			Function = TRUE
		End if
	End If
	Function = FALSE
End Function
'==============================================================================
' Detroys all the tab pages
' Parameter:
' - hTab = Handle to the tab control.
' Return value: TRUE or FALSE.
' ========================================================================================
Function AfxDestroyAllTabPages (hTab As HWND) AS BOOL
	If hTab = NULL Then
		Exit Function
	EndIf
	Dim As TCITEMW tci 
	Dim As CTabPage PTR pTabPage
	' // Ask to return the value of the lParam member
	tci.mask = TCIF_PARAM
	Do
		If ::SendMessage(hTab, TCM_GETITEMW, 0, (LPARAM) &tci) = 0 Then
			Exit Do
		EndIf
		If tci.lParam Then
			pTabPage = (CTabPage PTR) tci.lParam
			If pTabPage Then
				Delete pTabPage
				Function = TRUE
			End If
		End if
	Loop
	Function = FALSE
End Function
$ENDUSE

'==============================================================================
' Returns a pointer to the CWindow class given the handle of its associated window handle.
' To retrieve it from the handle of any of its child windows or controls, use AfxCWindowOwnerPtr.
' ========================================================================================
Function AfxCWindowPtr (hwnd AS HWND) As CWindow PTR
   Function = (CWindow PTR) ::GetWindowLongPtr(hwnd, 0)
End Function
'==============================================================================
' Returns a pointer to the CWindow class given the a pointer to the CREATESTRUCT structure.
' ========================================================================================
Function AfxCWindowPtr (lParam AS LPARAM) As CWindow PTR
   Raw As CREATESTRUCT PTR pCreateStruct  = (CREATESTRUCT PTR) lParam
   Function = (CWindow PTR) pCreateStruct->lpCreateParams
End Function
'==============================================================================
' Returns a pointer to the CWindow class given the a pointer to the CREATESTRUCT structure.
' ========================================================================================
Function AfxCWindowPtr (pCreateStruct As CREATESTRUCT PTR) As CWindow PTR
   Function = (CWindow PTR) pCreateStruct->lpCreateParams
End Function
'==============================================================================
' Returns a pointer to the CWindow class given the handle of the window created with it
' or the handle of any of it's children.
' ========================================================================================
Function AfxCWindowOwnerPtr (hwnd AS HWND) As CWindow Ptr
	If hwnd = NULL Then
		Exit Function
	EndIf
	Dim AS HWND hRootOwner  = ::GetAncestor(hwnd, GA_ROOTOWNER)
	If hRootOwner = NULL Then
		Exit Function
	EndIf
	Function = (CWindow PTR) ::GetWindowLongPtr(hRootOwner, 0)
End Function
$IFUSE USE_CTabPage
' ========================================================================================
' Returns a pointer to the CTabPage class given the handle of the tab control to which the
' tab page is associated and the zero-based tab index. If nTabIdx is ommited, the function
' will return the pointer of the selected tab, if any.
' ========================================================================================
Function AfxCTabPagePtr (hTab AS HWND, idx AS Long) As CTabPage Ptr
	If hTab = NULL Then
		Exit Function
	EndIf
	If idx = -1 Then
		idx = SendMessage(hTab, TCM_GETCURSEL, 0, 0)
	EndIf
	If idx = -1 Then
		Exit Function   ' No tab selected
	EndIf
	' // Ask to return the value of the lParam member
	Dim As TCITEMW tci
	tci.mask = TCIF_PARAM
	If ::SendMessage(hTab, TCM_GETITEMW, idx, (LPARAM) &tci) Then
		If tci.lParam Then
			Function = (CTabPage PTR) tci.lParam
		End If
	End If
	Function = NULL
END FUNCTION
' ========================================================================================
' Returns a pointer to the CScrollWindow class given the handle of the tab control to which the
' tab page is associated and the zero-based tab index. If nTabIdx is ommited, the function
' will return the pointer associated to the selected tab, if any.
' ========================================================================================

Function AfxScrollTabPagePtr (hTab AS HWND, idx AS LONG) As CScrollWindow PTR
   Function = AfxCTabPagePtr(hTab, idx)->ScrollWindowPtr()
END FUNCTION
$ENDUSE

$IFUSE USE_CScrollWindow		
'==============================================================================
' Returns a pointer to the CScrollWindow class given the handle of the window attached to it.
' ========================================================================================
FUNCTION AfxScrollWindowPtr (BYVAL hwnd AS HWND) AS CScrollWindow PTR
   'FUNCTION = (CWindow PTR) GetWindowLongPtr(hwnd, 0))->ScrollWindowPtr
   Dim As CWindow Ptr pWindow = AfxCWindowPtr(hwnd)
   Function = pWindow->ScrollWindowPtr()
   
END FUNCTION
' ========================================================================================
$ENDUSE



