
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'bc9Basic helper routines wrapped with $IFUSE
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
$IFUSE USE_ALL_BC9LIB
	$USE USE_IMATCH
	$USE USE_HSpaceControls
	$USE USE_JoinLines
	$USE USE_bc9FileSaveDialog
	$USE USE_bc9FileOpenDialog
	$USE USE_InstrAny
	$USE USE_InstrAnyRev
	$USE USE_ISSPACE
	$USE USE_SetColor
	$USE USE_IMATCHNQ
	$USE USE_RECTSIZE
$ENDUSE

$IFUSE USE_RECTSIZE
CONST RECTWIDTH(tRect) = tRect.right-tRect.left
CONST RECTHEIGHT(tRect) = tRect.bottom-tRect.top
$ENDUSE

'==============================================================================
'***********************
'  Bracket Handling
'***********************

CONST c_SglQt = 39
CONST c_DblQt = 34
CONST c_LPar  = 40
CONST c_RPar  = 41
CONST c_Komma = 44
CONST c_LtBkt = 91
CONST c_RtBkt = 93
'==============================================================================
'------------------------------------------------------------------------------
$IFUSE USE_IMATCH
'----------------------------------------------
'Case insensitive comparison - MatchStr$ to Arg$
' mt = 0, 1 or 2 Match left, whole word, right
'----------------------------------------------
CONST iMatchLft(A,B) = iMatch(A,B,0)
CONST iMatchWrd(A,B) = iMatch(A,B,1)
CONST iMatchRgt(A,B) = iMatch(A,B,2)

'FUNCTION iMatch(Arg$, MatchStr$, mt)
FUNCTION iMatch(Arg As const char Ptr, MatchStr As const char Ptr, mt)

  IF mt = 2 THEN
    DIM RAW L1, L2
    L1 = LEN(Arg$) : L2 = LEN(MatchStr$)
    IF L1 < L2 THEN FUNCTION = FALSE
    Arg = (Arg + L1) - L2
  END IF

  WHILE *MatchStr
    'If we run out string to match against then return no match
    IF *Arg = 0 THEN FUNCTION = FALSE
    'bit ORing a character with 0x20 produces the lower case of it
    IF (*Arg BOR 32) <> (*MatchStr BOR 32) THEN FUNCTION = FALSE
    INCR Arg
    INCR MatchStr
  WEND
  IF mt AND *Arg <> 0 THEN FUNCTION = FALSE
  FUNCTION = TRUE
END FUNCTION
$ENDUSE
'==============================================================================
'==============================================================================
$IFUSE USE_IMATCHNQ	
'------------------------------------------------------------------------------
FUNCTION iMatchNQ(Arg As const char Ptr, MatchStr As const char Ptr)
  Dim As Int mi
  DIM AS PCHAR  a = (char Ptr)Arg 


  WHILE MatchStr[mi]
    IF *a = c_DblQt THEN
      mi=0
      WHILE *(++a) <> c_DblQt
        IF *a = 0 THEN FUNCTION = 0
      WEND
    END IF

    IF a[mi] = 0 THEN FUNCTION = 0
    'If we run out string to match against then return no match
    'bit ORing a character with 0x20 produces the lower case of it
    IF (a[mi] BOR 32) <> (MatchStr[mi] BOR 32) THEN
      INCR a : mi= -1
    END IF
    INCR mi
  WEND
  FUNCTION = (a-Arg) + 1  ' We have a match
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE

'==============================================================================
$IFUSE USE_HSpaceControls
'Note: All controls need to be the same size with the same Top coordinate
'------------------------------------------------------------------------------
Sub HSpaceControls (hDlg As HWND,pba[] As Integer,NumOfCtls As Integer)
    Local As Integer InterSpace,Start,x,DlgWidth,CtlWidth,CtlHeight
    Local As RECT r
    GetClientRect(hDlg,&r)
    DlgWidth = r.right - r.left
    GetWindowRect(GetDlgItem(hDlg,pba[0]),&r)
    MapWindowPoints(0,hDlg,(LPPOINT)&r,2)
    CtlWidth = r.right - r.left
    CtlHeight = r.bottom - r.top
    InterSpace = (DlgWidth -(NumOfCtls * CtlWidth)) / (NumOfCtls+1)
    Start=InterSpace
    For x = 0 To NumOfCtls-1
        GetWindowRect(GetDlgItem(hDlg,pba[x]),&r)
        MapWindowPoints(0,hDlg,(LPPOINT)&r,2)
        MoveWindow(GetDlgItem(hDlg,pba[x]),Start,r.top,CtlWidth,CtlHeight,1)
        Start = Start + InterSpace + CtlWidth    
    Next x
End Sub 
$ENDUSE
'==============================================================================
$IFUSE USE_JoinLines
FUNCTION JoinLines(Arg$)
	static CurLine$
  IF iMatchRgt(Arg$, " _") THEN
    Arg[LEN(Arg)-1] = 0
    CurLine$ = CurLine$ & Arg$
    FUNCTION = TRUE
  END IF

  IF *CurLine <> 0 THEN
    Arg$ = CurLine$ & Arg$
    CurLine$ = ""
  END IF

  FUNCTION = FALSE
END FUNCTION
$ENDUSE
'==============================================================================
$IFUSE USE_bc9FileSaveDialog
$USE USE_bc9StrParseCount
'==============================================================================
Function bc9FileSaveDialog(hwndOwner As HWND, _
						   szFileName As char Ptr = "", _
						   szDefExt AS CHAR Ptr = "", _	
	                       szTitle As char Ptr = "File Save Dialog", _	
	                       szFileTypes As char Ptr = "bc9 code files,All Files", _
	                       szFileSpecs As char Ptr = "*.bas;*.inc;*.bi,*.*", _
	                       sigdnName AS SIGDN = SIGDN_FILESYSPATH _
	                       ) As String
	Dim As size_t items1,items2,i
	Dim As HRESULT hr
	Dim As IFileSaveDialog Ptr psfd 
	Dim sFile$
	items1 = bc9StrParseCount(szFileTypes)
	items2 = bc9StrParseCount(szFileSpecs)
	If items1 <> items2 Then
		Function = ""
	EndIf
	
	hr = CoCreateInstance(__uuidof(FileSaveDialog), NULL, CLSCTX_INPROC_SERVER,_uuidof(psfd),reinterpret_cast<void**>(&psfd))	
	If psfd = NULL Then
		Function = ""
	EndIf
	Raw As COMDLG_FILTERSPEC Ptr rgFileTypes  = New COMDLG_FILTERSPEC[items1]  
	Dim Dynamic sTypes$[items1 +1,32] As char
	Dim Dynamic sSpecs$[items1 +1,32] As char 
	xFor i = 0 While i < items1 By i++
		sTypes$[i] = StrToken$(szFileTypes,",",i+1)
		sSpecs$[i] = StrToken$(szFileSpecs,",",i+1)
		rgFileTypes[i].pszName = sTypes$[i]
		rgFileTypes[i].pszSpec = sSpecs$[i]
	xNext
	psfd->lpVtbl->SetFileTypes(psfd, items1, &rgFileTypes[0])
'	' // Set the title of the dialog
	hr = psfd->lpVtbl->SetTitle(psfd, szTitle)
	' // Set the file name
	hr = psfd->lpVtbl->SetFileName(psfd, szFileName)
	' // Set the extension
	hr = psfd->lpVtbl->SetDefaultExtension(psfd, szDefExt)
		' // Display the dialog
	hr = psfd->lpVtbl->Show(psfd, hwndOwner)
	
	' // Get the result
	Dim As IShellItem PTR pItem 
	Dim As char PTR pwszName 
	If SUCCEEDED(hr) Then
		hr = psfd->lpVtbl->GetResult(psfd, &pItem)
		If SUCCEEDED(hr) Then
			hr = pItem->lpVtbl->GetDisplayName(pItem, sigdnName, &pwszName)
			sFile$ = pwszName
			CoTaskMemFree(pwszName)
		EndIf
	EndIf
	delete [] rgFileTypes
	' // Cleanup
	If pItem Then
		pItem->lpVtbl->Release(pItem)
	EndIf
	If psfd Then 
		psfd->lpVtbl->Release(psfd)
	EndIf
	
	'FREE sTypes	
	'FREE sSpecs

	Function = sFile$
	
End Function
$ENDUSE
'==============================================================================
$IFUSE USE_bc9FileOpenDialog
$USE USE_bc9StrParseCount
Function bc9FileOpenDialog(hwndOwner As HWND, _
	                       szTitle As char Ptr = "A Single-Selection Dialog", _	
	                       szFileTypes As char Ptr = "bc9 code files,All Files", _
	                       szFileSpecs As char Ptr = "*.bas;*.inc;*.bi,*.*", _
	                       sigdnName AS SIGDN = SIGDN_FILESYSPATH _
	                       ) As String
	Dim As size_t items1,items2,i
	Dim As HRESULT hr
	Dim As IFileOpenDialog Ptr pofd 
	Dim sFile$',stemp$
	
	items1 = bc9StrParseCount(szFileTypes)
	items2 = bc9StrParseCount(szFileSpecs)
	If items1 <> items2 Then
		Function = ""
	EndIf
	hr = CoCreateInstance(__uuidof(FileOpenDialog), NULL, CLSCTX_INPROC_SERVER,_uuidof(pofd),reinterpret_cast<void**>(&pofd))
	
	If pofd = NULL Then
		Exit Function
	EndIf
	
	Raw As COMDLG_FILTERSPEC Ptr rgFileTypes  = New COMDLG_FILTERSPEC[items1]  
	Dim Dynamic sTypes$[items1 +1,32] As char
	Dim Dynamic sSpecs$[items1 +1,32] As char 
	xFor i = 0 While i < items1 By i++
		sTypes$[i] = StrToken$(szFileTypes,",",i+1)
		sSpecs$[i] = StrToken$(szFileSpecs,",",i+1)
		rgFileTypes[i].pszName = sTypes$[i]
		rgFileTypes[i].pszSpec = sSpecs$[i]
	xNext
	pofd->lpVtbl->SetFileTypes(pofd, items1, &rgFileTypes[0])
'	' // Set the title of the dialog
	hr = pofd->lpVtbl->SetTitle(pofd, szTitle)
		' // Display the dialog
	hr = pofd->lpVtbl->Show(pofd, hwndOwner)

	' // Get the result
	Dim As IShellItem PTR pItem 
	Dim As char PTR pwszName 
	If SUCCEEDED(hr) Then
		hr = pofd->lpVtbl->GetResult(pofd, &pItem)
		If SUCCEEDED(hr) Then
			hr = pItem->lpVtbl->GetDisplayName(pItem, sigdnName, &pwszName)
			sFile$ = pwszName
			CoTaskMemFree(pwszName)
		EndIf
	EndIf
	delete [] rgFileTypes
	' // Cleanup
	If pItem Then
		pItem->lpVtbl->Release(pItem)
	EndIf
	If pofd Then 
		pofd->lpVtbl->Release(pofd)
	EndIf
'	FREE sTypes	
'	FREE sSpecs
	Function = sFile$                       
End Function
$ENDUSE
'==============================================================================
$IFUSE USE_InstrAnyRev
Function InstrAnyRev(mainStr As const char ptr ,matchStr As const char ptr,Start As Long = -1) As Long
	Dim As Long i,j
	Dim As Long L1,L2
	L1 = Len(mainStr)
	L2 = Len(matchStr)
	If (L1 = 0) OR (L2 = 0 ) Then 
		Function = 0
	EndIf
	DECR(L1)
	DECR(L2)
	If Start = -1 Then
		Start = L1
	ElseIf (Start  < 1) OR (Start > Len(mainStr)) Then
		Function = 0
	ElseIf Start = Len(mainStr) Then
		Start = L1
	EndIf
	
	For i = Start To 0 Step -1
		For j = 0 To L2
			If matchStr[j] = mainStr[i] Then
				Function = i + 1
			EndIf
		Next
	Next
	Function = 0
End Function
$ENDUSE
'==============================================================================
$IFUSE USE_InstrAny
'------------------------------------------------------------------------------
Function InstrAny(szMainStr As const char ptr,szMatchStr As const char ptr,Start As Long = 1,SensFlag As int = 0) As int
	Raw As Long MainLen = Len(szMainStr), _
	            MatchLen = Len(szMatchStr)
	Dim nPos,i,j    
	If Start < 1 OR Start > MainLen OR MainLen = 0 OR MatchLen = 0 Then
		Function = 0
	EndIf
	DECR Start
	xFor i = Start While i < MainLen By i++
		xFor j = 0 While j < MatchLen By j++
			If SensFlag Then
				If toupper(szMainStr[i]) = toupper(szMatchStr[j]) Then
					nPos = i+1
					Exit Nest
				End if
			Else	
				If szMainStr[i] = szMatchStr[j] Then
					nPos = i+1
					Exit Nest
				End If		
			EndIf
				
		xNext
	xNext
	Function = nPos
End Function

'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_SetColor
'------------------------------------------------------------------------------
Function SetColor (  TxtColr As COLORREF,  BkColr As COLORREF,  hdc As HDC ) AS HBRUSH
	static As HBRUSH ReUsableBrush
    DeleteObject(ReUsableBrush)
    ReUsableBrush = CreateSolidBrush( BkColr )
    SetTextColor( hdc, TxtColr )
    SetBkColor( hdc, BkColr )
    Function  = ReUsableBrush
End Function
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
'==============================================================================
$IFUSE USE_itoa
'------------------------------------------------------------------------------
$CCODE UDT
/*********************************************************************
*      _ltoa   (NTDLL.@)
*
* Convert a long integer to a string.
*
* RETURNS
*  str.
*
* NOTES
*  - Converts value to a Nul terminated string which is copied to str.
*  - The maximum length of the copied str is 33 bytes. If radix
*  is 10 and value is negative, the value is converted with sign.
*  - Does not check if radix is in the range of 2 to 36.
*  - If str is NULL it crashes, as the native function does.
*/
char * __cdecl _ltoa(
    LONG value, /* [I] Value to be converted */
    char *str,  /* [O] Destination for the converted value */
    int radix)  /* [I] Number base for conversion */
{
    ULONG val;
    int negative;
    char buffer[33];
    char *pos;
    int digit;

    if (value < 0 && radix == 10) {
        negative = 1;
        val = -value;
    } else {
        negative = 0;
        val = value;
    } /* if */

    pos = &buffer[32];
    *pos = '\0';

    do {
        digit = val % radix;
        val = val / radix;
        if (digit < 10) {
            *--pos = '0' + digit;
        } else {
            *--pos = 'a' + digit - 10;
        } /* if */
    } while (val != 0L);

    if (negative) {
        *--pos = '-';
    } /* if */

    memcpy(str, pos, &buffer[32] - pos + 1);
    return str;
}

char * __cdecl _itoa(
    int value, /* [I] Value to be converted */
    char *str, /* [O] Destination for the converted value */
    int radix) /* [I] Number base for conversion */
{
    return _ltoa(value, str, radix);
}
$CCODE

'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================

$IFUSE USE_MEMMOVE
$CCODE UDT
//<---UNICODE AWARE
void *memmove( void *dest, const void *source, size_t len )
{
    register char *dst = (char*)dest;
    register const char *src = (char*)source;

    /* Use memcpy if not overlapping */
    if ((dst + len <= src) || (src + len <= dst))
    {
        memcpy( dst, src, len );
    }
    /* Otherwise do it the hard way (FIXME: could do better than this) */
    else if (dst < src)
    {
        while (len--) *dst++ = *src++;
    }
    else
    {
        dst += len - 1;
        src += len - 1;
        while (len--) *dst-- = *src--;
    }
    return dest;
}
//>---UNICODE AWARE
$CCODE
$ENDUSE

'CONST ZPRINT(x) = zTrace(ANSITOWIDE((char*)(x)))
'GLOBAL _ZTRACE_ As BOOL
'DECLARE FUNCTION zTrace LIB "ztrace64.dll" ALIAS "zTrace"(ws As const WCHAR Ptr) As LONG_PTR

$IFUSE USE_CreateArr
$CCODE UDT

void*   CreateArr (void*, int, int, int, size_t *);
void    DestroyArr (void**, int, int);

void *CreateArr(void *a, int elem_size, int update, int num_dims, size_t *args )
{
    size_t s, s1, s2;
    void **vp;
    size_t *marker;
    marker = args;
    s = *marker++;
   	s2 = s + 2;
    if(num_dims == 1)
    {
        if(update && a)
            a = realloc(a, s2 * elem_size);
        else
            a = calloc(s2, elem_size);
        return a;
    }
    else if(update && a)
    {
        s1 = 0;
        vp = (void**)a;
        while(*vp && s1 <= s)
        {
            vp++;
            s1++;
        }
        if(s1 > s)
        {
            vp--;
            DestroyArr(vp, num_dims, 0);
        }
        a = realloc(a, s2 * sizeof(int *));
        s1 = 0;
        vp = (void**)a;
        while(*vp && s1 <= s)
        {
            vp++;
            s1++;
        }
        while(s1 < s2)
        {
            *(((void **)vp)) = NULL;
            vp++;
            s1++;
        }
    }
    else
        a = calloc(s2 * sizeof(int *), 1);
    vp = (void**)a;
    if(--num_dims > 0)
    {
        for(s1 = 0; s1 < s; s1++)
        {
            vp[s1] = CreateArr(vp[s1], elem_size, update, num_dims, marker);
        }
    }
    return a;
}


void DestroyArr (void** a, int num_dims, int top_free)
{
    int i = 0;
    static int s = 0;
    if(num_dims == 1)
    {
        free(a);
        return;
    }
    s++;
    num_dims--;
    while(a[i])
    {
        DestroyArr((void**)a[i], num_dims, top_free);
        if(num_dims > 1)
            free(a[i]);
        a[i++] = NULL;
    }
    s--;
    if(s == 0 && top_free)
        free(a);
}

$CCODE
$ENDUSE
'==============================================================================
$IFUSE USE_bc9StrParseCount 
Function bc9StrParseCount(szMainStr As char Ptr,szDelim As char Ptr = ",") As Long
	Raw As Long nCount=1,nPos=1
	Do
		nPos = Instr(szMainStr,szDelim,nPos)
		If nPos = 0 Then
			Exit Do
		EndIf
		nCount += 1
		nPos += Len(szDelim)
	Loop
	Function = nCount
End Function
$ENDUSE
'$IFUSE USE_IIF
'	Template <class T>
'		Function _iif(cond As BOOL, trueCase As T,falseCase As T) As T
'			If cond Then
'				Function = trueCase
'			EndIf
'			Function = falseCase
'		End Function
'	End Template
'$ENDUSE

$IFUSE USE_FLOOR
'$CCODE UDT
'float floor(float x)
'{
'    int i = (int)x;
'    return (float)((x<0.0f) ? i-1 : i);
'}	 
'double floor(double x)
'{
'	if(x>0)return (int)x;
'	return (int)(x-0.9999999999999999);
'}
'$CCODE
$CCODE UDT
template<typename T>
	T floor(T x)
	{
		int i = (int)x;
		return (T) ((x<0.0) ? i-1 : i);	
	}
$CCODE
$ENDUSE
'added to TCLib.Lib with isspace.cpp
'==============================================================================
'$IFUSE USE_ISSPACE
'Function isspace(c As const char) As BOOL
'	'If c = 0x20 OR c = 0x09 OR c = 0x0a OR c = 0x0b OR c = 0x0c OR c = 0x0d Then
'	'	Function = TRUE
'	'Else
'	'	Function = FALSE
'	'EndIf
'	$CCODE
'		return (c == 0x20 || c == 0x09 || c == 0x0a || c == 0x0b || c == 0x0c || c == 0x0d ) ? TRUE : FALSE; 
'	$CCODE
'End Function
'$ENDUSE
$IFUSE USE_BcxDict
'------------------------------------------------------------------------------
$USE USE_CVariant
!class CVariant;
'------------------------------------------------------------------------------
'MS Scripting runtime IDictionary from (scrrun.dll)
GLOBAL As const CLSID CLSID_Dictionary = {0xEE09B103,0x97E0,0x11CF,{0x97,0x8F,0x00,0xA0,0x24,0x63,0xE0,0x6F}}
GLOBAL As const IID IID_IDictionary = {0x42C642C1,0x97E1,0x11CF,{0x97,0x8F,0x00,0xA0,0x24,0x63,0xE0,0x6F}} 

ENUM As CompareMethod
	BinaryCompare
	TextCompare
	DatabaseCompare 
End Enum
Interface IDictionary Inherits IDispatch
	public:
		Dim Function putref_Item(Key As VARIANT* ,pRetItem As VARIANT*) = 0 As virtual HRESULT
		Dim Function put_Item(Key As VARIANT* ,pRetItem As VARIANT*) = 0 As virtual HRESULT
		Dim Function get_Item(Key As VARIANT* ,pRetItem As VARIANT*) = 0 As virtual HRESULT
		Dim Function Add(Key As VARIANT* ,Item As VARIANT*) = 0 As virtual HRESULT
		Dim Function get_Count(pCount As long*) = 0 As virtual HRESULT
		Dim Function Exists(Key As VARIANT*, pExists As VARIANT_BOOL*) = 0 As virtual HRESULT
		Dim Function Items(pItemsArray As VARIANT*) = 0 As virtual HRESULT
		Dim Function put_Key(Key As VARIANT*,rhs As VARIANT*) = 0 As virtual HRESULT
		Dim Function Keys(pKeysArray AS VARIANT*) = 0 As virtual HRESULT
		Dim Function _Remove(Key As VARIANT*) = 0 As virtual HRESULT
		Dim Function RemoveAll() = 0 As virtual HRESULT
		Dim Function put_CompareMode(pcomp As CompareMethod) = 0 As virtual HRESULT
		Dim Function get_CompareMode(pcomp As CompareMethod*) = 0 As virtual HRESULT
		Dim Function _NewEnum(ppunk As IUnknown**) = 0 As virtual HRESULT
		Dim Function get_HashVal(Key As VARIANT*, HashVal As VARIANT*) = 0 As virtual HRESULT 
End Interface
'==============================================================================
'wrapper class to make it easier to use IDictionary
Class cBcxDic
	public:
		Dim Constructor cBcxDic()
		Dim Destructor ~cBcxDic()
		Dim Function Add(skey As char*,sitem As char*) As BOOL
		Dim Function Add(ikey As int,sitem As char*) As BOOL
		Dim Function Add(vkey As VARIANT*,vitem As VARIANT*) As BOOL
		Dim Function put_item(skey As char*,spretitem As char*) As BOOL
		Dim Function put_item(key As long,spretitem As char*) As BOOL
		Dim Function get_item(skey As char*) As char*
		Dim Function get_item(key As long) As char*
		Dim Function get_count() As long
		Dim Function Exists(skey As char*) As BOOL
		Dim Function Exists(key As long) As BOOL
		Dim Function put_key(skey As char*,rhs As char*) As BOOL
		Dim Function put_key(key As long,rhs As char*) As BOOL
		Dim Function _Remove(skey As char*) AS BOOL
		Dim Function _Remove(key As long) AS BOOL
		Dim Function RemoveAll() As BOOL
		Dim Function put_CompareMode(pcomp As CompareMethod) AS BOOL
		Dim Function get_CompareMode() As CompareMethod

	protected:
		Raw As IDictionary Ptr m_oDict	
End Class
'------------------------------------------------------------------------------
Constructor cBcxDic::cBcxDic()
	Raw As HRESULT hr
	hr = CoCreateInstance(CLSID_Dictionary,NULL,CLSCTX_INPROC_SERVER,IID_IDictionary,(void**)&m_oDict)
	
End Constructor
'------------------------------------------------------------------------------
Destructor cBcxDic::~cBcxDic()
	m_oDict->Release()
End Destructor
'------------------------------------------------------------------------------
Function cBcxDic::Add(skey As char*, sitem As char*) AS BOOL
	Raw As CVariant v1,v2
	v1.Set(skey)
	v2.Set(sitem)
	m_oDict->Add(&v1,&v2)
	Function = 0
End Function
'------------------------------------------------------------------------------
Function cBcxDic::Add(ikey As int,sitem As char*) As BOOL
	Raw As CVariant v1,v2
	v1.Set(ikey)
	v2.Set(sitem)
	m_oDict->Add(&v1,&v2)
	Function = 0
End Function
'------------------------------------------------------------------------------
Function cBcxDic::get_count() As long
	Raw As long count
	m_oDict->get_Count(&count)
	Function = count
End Function
'------------------------------------------------------------------------------
Function cBcxDic::Exists(skey As char*) As BOOL
	Raw As CVariant v1
	Raw As VARIANT_BOOL vb
	v1.Set(skey)
	m_oDict->Exists(&v1,&vb)
	If vb Then
		Function = TRUE
	Else
		Function = FALSE	
	End If
End Function
'------------------------------------------------------------------------------
Function cBcxDic::put_item(skey As char*, spretitem As char*) As BOOL
	Raw As CVariant v1,v2
	v1.Set(skey)
	v2.Set(spretitem)
	m_oDict->put_Item(&v1,&v2)
	Function = 0
End Function
'------------------------------------------------------------------------------
Function cBcxDic::put_key(skey As char*,rhs As char*) As BOOL
	Raw As CVariant v1,v2
	v1.Set(skey)
	v2.Set(rhs)
	m_oDict->put_Key(&v1,&v2)
	Function = 0
End Function
'------------------------------------------------------------------------------
Function cBcxDic::get_item(skey As char*) AS char*
	Raw As CVariant v1,v2
	v1.Set(skey)
	m_oDict->get_Item(&v1,&v2)
	Function = v2.ToString()
End Function
'------------------------------------------------------------------------------
Function cBcxDic::get_item(skey As Long) AS char*
	Raw As CVariant v1,v2
	v1.Set(skey)
	m_oDict->get_Item(&v1,&v2)
	Function = v2.ToString()
End Function
'------------------------------------------------------------------------------
Function cBcxDic::_Remove(skey As char*) As BOOL
	Raw As CVariant v
	Raw As HRESULT hr
	v.Set(skey)
	hr = m_oDict->_Remove(&v)
	If SUCCEEDED(hr) Then
		Function = TRUE
	EndIf
	Function = FALSE
End Function
'==============================================================================
$ENDUSE
'==============================================================================
$IFUSE USE_CVariant
'------------------------------------------------------------------------------
Class CVariant Inherits VARIANT
	public:
		Dim Constructor CVariant()
		Dim Constructor CVariant(bValue As VARIANT_BOOL)
		Dim Constructor CVariant(iValue As Integer)
		Dim Constructor CVariant(nValue As long)
		Dim Constructor CVariant(dValue As double)
		'Dim Constructor CVariant(zValue As LPCSTR)
		Dim Constructor CVariant(zValue As char Ptr)
		Dim Constructor CVariant(pV As VARIANT Ptr)
		Dim ConStructor CVariant(L_Bound As Integer, iElement As Integer)
		Dim Destructor ~CVariant()
		Dim Function IsArray(iElement As Integer = 0) As BOOL
		Dim Function IsString(iElement As Integer = 0) As BOOL
		Dim Function IsInt(iElement As Integer = 0) AS BOOL
		Dim Function IsBool(iElement As Integer = 0) AS BOOL
		Dim Function operator&() As VARIANT*
		Dim Function ElementAt(iElement As Integer = 0) As VARIANT*
		Dim Function ToString(iElement As Integer = 0) As char*
		Dim Function ToInt(iElement As Integer = 0) As Integer
		Dim Function ToBool(iElement As Integer = 0) As BOOL
		Dim Sub Set(szString As char ptr,iElement As Integer = 0)
		Dim Sub Set(iValue As Integer,iElement As Integer = 0)
		Dim Sub Set(bValue As VARIANT_BOOL,iElement As Integer = 0)
End Class
Function CVariant::operator&() As VARIANT*
	Function = this
End Function
Constructor CVariant::CVariant()
	vt = VT_EMPTY
End Constructor

'------------------------------------------------------------------------------
Constructor CVariant::CVariant(bValue As VARIANT_BOOL)
	vt = VT_BOOL
	bVal = bValue
End Constructor
'------------------------------------------------------------------------------
Constructor CVariant::CVariant(iValue As Integer)
	vt = VT_I4
	intVal = iValue
End Constructor
'------------------------------------------------------------------------------
Constructor CVariant::CVariant(nValue As long)
	vt = VT_I4
	lVal = nValue
End Constructor
'------------------------------------------------------------------------------
Constructor CVariant::CVariant(dValue As double)
	vt = VT_R8
	dblVal = dValue
End Constructor
'------------------------------------------------------------------------------
Constructor CVariant::CVariant(szValue As char ptr)
	'If lstrlenA(szValue) > 0 Then
	If Len(szValue) Then
		vt = VT_BSTR
		'bstrVal = A2W(szValue)
		bstrVal = SysAllocString(szValue)
	End If
End Constructor
'------------------------------------------------------------------------------
Constructor CVariant::CVariant(pV As VARIANT Ptr)
	'assert(pV)
	vt = VT_VARIANT
	pvarVal = pV
End Constructor
'------------------------------------------------------------------------------
Constructor CVariant::CVariant(L_Bound As Integer,iElementCount As Integer)
	'	Set the type to an array of variants...
	vt = VT_ARRAY | VT_VARIANT
	parray = new SAFEARRAY

	'	We only support 1 dimensional arrays..
	parray->cDims = 1
	parray->fFeatures = FADF_VARIANT | FADF_HAVEVARTYPE | FADF_FIXEDSIZE | FADF_STATIC
	parray->cbElements = sizeof(VARIANT)
	parray->cLocks = 0

	'	Allocate the array of variants we point to...
	parray->pvData = new VARIANT[iElementCount]
	!//<---UNICODE AWARE
	memset(parray->pvData, 0, sizeof(VARIANT) * iElementCount)
	!//>---UNICODE AWARE
	parray->rgsabound[0].lLbound = L_Bound
	parray->rgsabound[0].cElements = iElementCount	
End Constructor
'------------------------------------------------------------------------------
Destructor CVariant::~CVariant()
	Raw i As UINT
	Select Case vt
		Case VT_BSTR
			SysFreeString(bstrVal)
		Case VT_ARRAY , VT_VARIANT
			For i = 0 To parray->rgsabound[0].cElements -1
				If (((VARIANT *) parray->pvData)[i].vt = VT_BSTR) Then
					SysFreeString(((VARIANT *) parray->pvData)[i].bstrVal)
				'Else
				'	delete parray->pvData		
				End If
			Next
			
			delete parray
		'Case VT_VARIANT
		'	We do nothing in this case because it's a
		'	wrapped VARIANT pointer we know little about.
		'	We certainly don't have enough information to
		'	safely delete it so we let it's originator 
		'	worry about it
			
	End Select
End Destructor
'------------------------------------------------------------------------------
'Attributes
Function CVariant::IsArray(iElement As Integer) As BOOL
	Raw As VARIANT* pV = ElementAt(iElement)
	Raw As VARTYPE v
	If (pV <> (VARIANT *) NULL) Then
		if (pV->vt = VT_VARIANT && pV->pvarVal <> (VARIANT *) NULL) Then
			v = pV->pvarVal->vt
		else
			v = pV->vt
        End If
		Function =  v & VT_ARRAY
		
	End If
	Function = FALSE
End Function
'------------------------------------------------------------------------------
Function CVariant::IsString(iElement As Integer) AS BOOL
	Raw As VARIANT* pV = ElementAt(iElement)
	Raw As VARTYPE v
	If (pV <> (VARIANT *) NULL) Then
		if (pV->vt = VT_VARIANT && pV->pvarVal <> (VARIANT *) NULL) Then
			v = pV->pvarVal->vt
		else
			v = pV->vt
        End If
        
		Function = v == VT_BSTR  
		
	End If
	Function = FALSE
	
End Function
'------------------------------------------------------------------------------
Function CVariant::IsInt(iElement As Integer) As BOOL
	Raw As VARIANT* pV = ElementAt(iElement)
	Raw As VARTYPE v
	If (pV <> (VARIANT *) NULL) Then
		if (pV->vt = VT_VARIANT && pV->pvarVal <> (VARIANT *) NULL) Then
			v = pV->pvarVal->vt
		else
			v = pV->vt
        End If
        Select Case v
        	Case VT_I1, VT_I2, VT_I4
        		Function = TRUE
        	Case Else
        		Function = FALSE	
        End Select
	End If
	Function = FALSE
End Function
'------------------------------------------------------------------------------
Function CVariant::IsBool(iElement As Integer) As BOOL
	Raw As VARIANT* pV = ElementAt(iElement)
	Raw As VARTYPE v
	If (pV <> (VARIANT *) NULL) Then
		if (pV->vt = VT_VARIANT && pV->pvarVal <> (VARIANT *) NULL) Then
			v = pV->pvarVal->vt
		else
			v = pV->vt
        End If
        Function = v == VT_BOOL
    End if	
    Function = FALSE
End Function
'------------------------------------------------------------------------------
'Array operations
Function CVariant::ElementAt(iElement As Integer) As VARIANT Ptr
	If (vt = VT_VARIANT) Then
		'	It's a pointer to an external VARIANT
		'	so return that variant
		Function = pvarVal
	End If
		
	If (NOT (vt & VT_ARRAY)) Then
		'	It's not an array so return ourselves
		Function = this
	End If
	'	Calculate our element offset
	Raw As Integer	offset = iElement - parray->rgsabound[0].lLbound
	'	Offset must be zero or greater and less than the bounds
	'if (offset >= 0 && offset <= int(parray->rgsabound[0].cElements)) Then
	'	Function = &((VARIANT *) parray->pvData)[offset]
	'else
	'	Function = (VARIANT *) NULL
	'End If
$CCODE
	//	Offset must be zero or greater and less than the bounds
	if (offset >= 0 && offset <= int(parray->rgsabound[0].cElements))
		return &((VARIANT *) parray->pvData)[offset];
	else
		return (VARIANT *) NULL;
$CCODE		
End Function
'------------------------------------------------------------------------------
Function CVariant::ToString(iElement As Integer) As char *
	'	Get the VARIANT at the iElement offset
	Raw As VARIANT Ptr v = ElementAt(iElement)
	
    If (v <> (VARIANT *) NULL && v->vt = VT_BSTR) Then
    	'Function = W2A(v->bstrVal)
    	Function = (char ptr)v->bstrVal
    End If
    Function = ""
End Function
'------------------------------------------------------------------------------
Function CVariant::ToInt(iElement As Integer) As Integer
	'	Get the VARIANT at the iElement offset
	Raw As VARIANT Ptr v = ElementAt(iElement)
	If (v <> (VARIANT *) NULL) Then
		Select Case v->vt
			Case VT_I1
				Function = (int) v->bVal
			Case VT_I2
				Function = (int) v->iVal
			Case VT_I4
				Function = (int) v->lVal		
		End Select
	End If
	Function = 0	
End Function
'------------------------------------------------------------------------------
Function CVariant::ToBool(iElement As Integer) As BOOL
	Raw As VARIANT Ptr v = ElementAt(iElement)
	If (v <> (VARIANT *) NULL) Then
		If (v->vt = VT_BOOL) Then
			Function = v->boolVal
		Else
			Function = FALSE	
		End If
	End If
	Function = FALSE	
End Function
'------------------------------------------------------------------------------
Sub CVariant::Set(szString As char ptr,iElement As Integer)
	'assert(szString)
	'	Get the VARIANT at the iElement offset
	Raw As VARIANT Ptr v = ElementAt(iElement)
	If (v <> (VARIANT *) NULL) Then
		v->vt = VT_BSTR
		v->bstrVal = SysAllocString(szString)
	End If
	
End Sub
'------------------------------------------------------------------------------
Sub CVariant::Set(iValue As Integer,iElement As Integer)
	Raw As VARIANT Ptr v = ElementAt(iElement)
	If (v <> (VARIANT *) NULL) Then
		v->vt = VT_I4
		v->lVal = iValue
	End If	
End Sub
'------------------------------------------------------------------------------
Sub CVariant::Set(bValue As VARIANT_BOOL, iElement As Integer)
	Raw As VARIANT Ptr v = ElementAt(iElement)
	If (v <> (VARIANT *) NULL) Then
		v->vt = VT_BOOL
		v->lVal = bValue
	End If	
End Sub
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ISDIGIT
'------------------------------------------------------------------------------
$CCODE UDT
int isdigit(int c){
	return (c >= '0' && c <= '9' ? 1 : 0);
}
$CCODE
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
'==============================================================================
$IFUSE USE_VCenterCtrl
'------------------------------------------------------------------------------
Sub VCenterCtrl(hCtrl As HWND,hParent As HWND)
	Dim As RECT rc,rp
	GetClientRect(hParent,&rp)
	GetWindowRect(hCtrl,&rc)
	MapWindowPoints(0,hParent,(LPPOINT)&rc,2)
	MoveWindow(hCtrl,(RECTWIDTH(rp) - RECTWIDTH(rc))/2,rc.top,RECTWIDTH(rc),RECTHEIGHT(rc),1)
End Sub
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_HCenterCtrl
Sub HCenterCtrl(hCtrl AS HWND,hParent As HWND)
	Dim As RECT rc,rp
	GetClientRect(hParent,&rp)
	GetWindowRect(hCtrl,&rc)
	MapWindowPoints(0,hParent,(LPPOINT)&rc,2)
	MoveWindow(hCtrl,rc.left,(RECTHEIGHT(rp) - RECTHEIGHT(rc))/2,RECTWIDTH(rc),RECTHEIGHT(rc),1)	
End Sub
$ENDUSE

