' ########################################################################################
' Microsoft Windows
' File: CW_COMMCTRL_ButtonOwnerdraw.bas
' Contents: Demonstrates the use of an ownerdraw button.
' Compiler: Ported to bc9Basic jcfuller 08/16/2016  
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"		'135,680 bytes
$ONEXIT "TCLIB.BAT $FILE$"					' 20,992 bytes
$HEADER
	#include <commctrl.h>					/*'For CWindow*/ 
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
$HEADER

$Include <Afx/CWindow.bi>
'==============================================================================
CONST IDC_BUTTON = 1001
'==============================================================================
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin,hButton

	Raw As CWindow pWindow
	hWin = pWindow.Create(NULL, "CWindow with ownerdraw button", &WndProc)
	pWindow.Center()

	' // Add and ownerdraw button
	hButton = pWindow.AddControl("CUSTOMBUTTON",hWin, IDC_BUTTON, "&Ownerdraw button", 100, 50, 150, 23)
	'  Alternate way:
	'    hButton  = pWindow.AddControl("Button", hWin, IDC_BUTTON, "&Ownerdraw button", 100, 50, 150, 23, BS_OWNERDRAW)
	SetFocus(hButton)
	
	' // Dispatch messages
	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
	
End Function
'==============================================================================
CallBack Function WndProc()
	Select Case Msg
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
			End Select
		Case WM_DRAWITEM
			Raw As DRAWITEMSTRUCT PTR pDis = (DRAWITEMSTRUCT*) lParam 
			If pDis->CtlID <> IDC_BUTTON Then
				Exit Function
			EndIf
			' // Get the rectangle that defines the boundaries of the button to be drawn.
			Raw As RECT rc = pDis->rcItem
			
			' // Create a new font
			Raw As CWindow Ptr pWindow = AfxCWindowPtr(CBHNDL)
			Raw As HGDIOBJ hNewFont = pWindow->CreateFont("Segoe UI",9,FW_NORMAL,FALSE, FALSE, FALSE, DEFAULT_CHARSET)
			Raw As HGDIOBJ hOldFont = SelectObject(pDis->hDC, hNewFont)
			
			' // Draw the button
			If (pDis->itemState BAND ODS_FOCUS) Then
				Raw As HPEN hPen = (HPEN)SelectObject(pDis->hDC, CreatePen(PS_SOLID, 3, RGB(0,0,255)))
				Raw As HBRUSH hBrush = (HBRUSH)SelectObject(pDis->hDC, GetSysColorBrush(COLOR_BTNFACE))
				Rectangle(pDis->hDC, rc.left, rc.top, rc.right, rc.bottom)
				SelectObject(pDis->hDC, hBrush)
				DeleteObject(SelectObject(pDis->hDC, hPen))
			Else
				FillRect(pDis->hDC, &rc, GetSysColorBrush(COLOR_BTNFACE))
			EndIf
			
			' // Draw the button's edge
			rc.left += 3: rc.top += 3 : rc.bottom -= 3: rc.right -= 3
			If (pDis->itemState BAND ODS_SELECTED) Then
				DrawEdge(pDis->hDC, &rc, BDR_SUNKEN, BF_RECT BOR BF_MIDDLE BOR BF_SOFT)
				rc.left += 2 : rc.top += 2
			Else
				DrawEdge(pDis->hDC, &rc, BDR_RAISED, BF_RECT BOR BF_MIDDLE BOR BF_SOFT)
			END IF
			
			' // Draw the button's caption
			SetBkMode(pDis->hDC, TRANSPARENT)
			SetTextColor(pDis->hDC, iif((pDis->itemState BAND ODS_DISABLED), GetSysColor(COLOR_GRAYTEXT), GetSysColor(COLOR_BTNTEXT)))
			Raw As char ptr szText = new char[260]
			
			GetWindowText(pDis->hwndItem, szText, 260)
			DrawText(pDis->hDC, szText, -1, &rc, DT_CENTER BOR DT_VCENTER) ' or DT_SINGLELINE
			If szText Then
				delete[] szText
			EndIf
			SelectObject(pDis->hDC, hOldFont)
			DeleteObject(hNewFont)
			Function = TRUE
		Case WM_DESTROY
			' // Quit the application
         	PostQuitMessage(0)
			Exit Function
	End Select
End Function
