' ########################################################################################
' Microsoft Windows
' File: CW_COMMCTRL_ButtonOwnerdraw3.bas - Template
' Contents: Ownerdraw button with "normal" and "hot" images.
' When the mouse enters the button, the image changes to "hot",
' and when it leaves the normal image is restored.
' Compiler: Ported to bc9Basic jcfuller 08/16/2016  
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"		'135,680 bytes
$ONEXIT "TCLIB.BAT $FILE$"					' 20,992 bytes
$HEADER
	#include <commctrl.h>					/*'For CWindow*/ 
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
$HEADER

$Include <Afx/CWindow.bi>
'==============================================================================
CONST IDC_BUTTON = 1001
'==============================================================================
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin,hButton

	Raw As CWindow pWindow
	hWin = pWindow.Create(NULL, "CWindow with ownerdraw button", &WndProc)
	pWindow.Center()

	' // Add a subclassed ownerdraw button
	hButton = pWindow.AddControl("CustomButton",hWin, IDC_BUTTON, "", 100, 50, 50, 50,-1,-1,0,(WNDPROC)&Button_SubclassProc)
	'  Alternate way:
	'    hButton  = pWindow.AddControl("Button", hWin, IDC_BUTTON, "&Ownerdraw button", 100, 50, 150, 23, BS_OWNERDRAW)
	SetFocus(hButton)
	
	' // Dispatch messages
	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
	
End Function
'==============================================================================
CallBack Function WndProc()
	Select Case Msg
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
				Case IDC_BUTTON
					If CBCTLMSG = BN_CLICKED Then
						MessageBox(CBHNDL,"Button Clicked","",MB_OK)
						Exit Function
					EndIf
			End Select
		Case WM_DRAWITEM
			Raw As CWindow Ptr pWindow = AfxCWindowPtr(CBHNDL)
			Raw As DRAWITEMSTRUCT PTR pDis = (DRAWITEMSTRUCT*) lParam 
			If pDis->CtlID <> IDC_BUTTON Then
				Exit Function
			EndIf
			' Icon identifiers in User32.dll. Hacked with ResourceHacker.
			' IDI_APPLICATION = 100, IDI_WARNING = 101, IDI_QUESTION = 102, IDI_ERROR = 103
			' IDI_INFORMATION = 104, IDI_WINLOGO = 105, IDI_SHIELD = 106
			' Used here to make the example simpler.
			' Normally, you will load an icon or bitmap from a file or resource.
			Raw As HICON hIcon
			If GetProp(CTLHNDL(IDC_BUTTON),"HOT") = 0 Then
				hIcon = (HICON)LoadImage(GetModuleHandle("User32"), MAKEINTRESOURCEW(102), IMAGE_ICON, _
               pWindow->ScaleX(50), pWindow->ScaleY(50), LR_DEFAULTCOLOR)
			Else
	            hIcon = (HICON)LoadImage(GetModuleHandle("User32"), MAKEINTRESOURCEW(103), IMAGE_ICON, _
    	           pWindow->ScaleX(50), pWindow->ScaleY(50), LR_DEFAULTCOLOR)
			EndIf
			If hIcon Then
	            DrawState(pDis->hDC, NULL, NULL, (LPARAM) hIcon, 0, 0, 0, 0, 0, DST_ICON)
	            DestroyIcon(hIcon)
				
			EndIf
			Function = TRUE
		Case WM_DESTROY
			PostQuitMessage(0)
			Exit Function
	End Select
End Function
'==============================================================================
CallBack Function Button_SubclassProc()
	Select Case Msg
		Case WM_GETDLGCODE
			Function = DLGC_WANTALLKEYS
		Case WM_LBUTTONDOWN
			MessageBox(GetParent(CBHNDL),"Click","bc9Basic",MB_OK)
			Exit Function
		Case WM_KEYDOWN
			Select Case LOWORD(wParam)
				Case VK_ESCAPE
					SendMessage(GetParent(CBHNDL),WM_CLOSE,0,0)
					Exit Function
			End Select
		Case WM_MOUSEMOVE	
			' // Tracks the mouse movement and stores the hot state
			Dim As TRACKMOUSEEVENT trackMouse
			If GetProp(CBHNDL,"HOT") = 0 Then
				trackMouse.cbSize = SIZEOF(trackMouse)
				trackMouse.dwFlags = TME_LEAVE
				trackMouse.hwndTrack = CBHNDL
				trackMouse.dwHoverTime = 1
				TrackMouseEvent(&trackMouse)
				SetProp(CBHNDL, "HOT", (HANDLE) TRUE)
				InvalidateRect(CBHNDL, NULL, 0)
				UpdateWindow(CBHNDL)
			EndIf
			Exit Function
		Case WM_MOUSELEAVE
			' // Removes the hot state and redraws the button
			RemoveProp(CBHNDL, "HOT")
			InvalidateRect(CBHNDL, NULL, 0)
			UpdateWindow(CBHNDL)
			Exit Function
		Case WM_DESTROY
			SetWindowLongPtr(CBHNDL,GWLP_WNDPROC,(LONG_PTR)RemoveProp(CBHNDL,"OLDWNDPROC"))
			
	End Select
	Function = CallWindowProc(GetProp(CBHNDL,"OLDWNDPROC"),CBHNDL,CBMSG,CBWPARAM,CBLPARAM)
End Function
