' ########################################################################################
' Microsoft Windows
' File: CW_COMMCTRL_ButtonSubclass.bas
' Contents: CWindow with a subclassed button
' Compiler: Ported to bc9Basic jcfuller 08/17/2016  
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"		
$ONEXIT "TCLIB.BAT $FILE$"					
$HEADER
	#include <commctrl.h>					/*'For CWindow*/ 
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
$HEADER

$Include <Afx/CWindow.bi>
'==============================================================================
CONST IDC_BUTTON = 1001
'==============================================================================
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin,hButton

	Raw As CWindow pWindow
	hWin = pWindow.Create(NULL, "CWindow with a subclassed button", &WndProc)
	pWindow.SetClientSize(500,320)
	pWindow.Center()

   ' // Add a button without position or size (it will be resized in the WM_SIZE message).
   pWindow.AddControl("Button",hWin , IDC_BUTTON, "Click me",-1 -1,-1 ,-1 ,-1 ,-1 ,-1 ,-1 , (WNDPROC) &Button_SubclassProc)

	
	' // Dispatch messages
	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
	
End Function
'==============================================================================
CallBack Function WndProc()
	Select Case CBMSG
		Case WM_COMMAND
			Select Case CBCTL
				' // If ESC key pressed, close the application sending an WM_CLOSE message
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
			End Select
		Case WM_SIZE
			'Resize the button
			Raw As CWindow Ptr pWindow = AfxCWindowPtr(CBHNDL)
			If pWindow Then
				pWindow->MoveWindow(CTLHNDL(IDC_BUTTON),pWindow->ClientWidth() - 120,pWindow->ClientHeight() - 50, 75, 23,TRUE)
			EndIf
		Case WM_DESTROY
			PostQuitMessage(0)
			Exit Function
	End Select
End Function
'==============================================================================
CallBack Function Button_SubclassProc()
	Select Case CBMSG
		Case WM_GETDLGCODE
			'All keyboard input
			Function = DLGC_WANTALLKEYS
		Case WM_LBUTTONDOWN
			MessageBox(GetParent(CBHNDL),"Click","bc9Basic",MB_OK)
			Exit Function
		Case WM_KEYDOWN
			Select Case LOWORD(wParam)
				Case VK_ESCAPE
					SendMessage(GetParent(CBHNDL),WM_CLOSE,0,0)
					Exit Function
			End Select
		Case WM_DESTROY
			SetWindowLongPtr(CBHNDL,GWLP_WNDPROC,(LONG_PTR)RemoveProp(CBHNDL,"OLDWNDPROC"))
			
	End Select
	Function = CallWindowProc(GetProp(CBHNDL,"OLDWNDPROC"),CBHNDL,CBMSG,CBWPARAM,CBLPARAM)
End Function
