' ########################################################################################
' Microsoft Windows
' File: CW_COMMCTRL_ComboBox.bas
' Contents: Demonstrates the use of the ComboBox control.
' Comments: Commonly used to allow a user to select an item from a predefined list.
' Compiler: Ported to bc9Basic jcfuller 08/23/2016  
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"		
$ONEXIT "TCLIB.BAT $FILE$"	
'==============================================================================
$HEADER
	#include <windowsx.h>					/*'For COMMCTRL macros*/
	#include <commctrl.h>					/*'For CWindow*/ 
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
$HEADER
'==============================================================================
$Include <Afx/CWindow.bi>
'$Include <bc9Lib.bi>
'$Include <Afx/AfxMenu.bi>
'$Include <Afx/AfxTime.bi>
'$Include <Afx/AfxPath.bi>
'$Include <Afx/AfxCtl.bi>
'==============================================================================
CONST IDC_COMBOBOX = 1001
'==============================================================================
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin
	Raw As CWindow pWindow
	
	hWin = pWindow.Create(NULL, "ComboBox control", &WndProc)
	pWindow.Center()
	' // Add a combobox control
	Raw AS HWND hComboBox = pWindow.AddControl("ComboBox",hWin , IDC_COMBOBOX, "", 80, 30, 190, 100)
	Dim As Long i
	Dim wszText$
	For i = 1 To 9
		wszText$ = "Item " & Right$("00" & Str$(i),2)
		ComboBox_AddString(hComboBox,wszText)
	Next
	' // Select the first item in the combo box
	ComboBox_SetCurSel(hComboBox, 0)

	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal

End Function
'==============================================================================
CallBack Function WndProc()
	
	Select Case CBMSG
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
				Case IDC_COMBOBOX
					' // The selection has changed
					If CBCTLMSG = LBN_SELCHANGE Then
						'Handle of the combobox
						Raw As HWND hComboBox = CTLHNDL(IDC_COMBOBOX)
						'Retrieve the Item selected 
						Raw As Long curSel = ComboBox_GetCurSel(hComboBox)
						'Retrieve the length of the text of the selected item
						Raw As Long nLen = ComboBox_GetLBTextLen(hComboBox, curSel)
						Raw As char ptr pwszText = new char[(nLen+1)*sizeof(char)] 
						ComboBox_GetLBText(hComboBox, curSel, pwszText)
						MessageBox(CBHNDL,"You have selected " & pwszText$,"ComboBox Test",MB_OK)
						delete [] pwszText
					EndIf
			End Select
		Case WM_DESTROY
			PostQuitMessage(0)
			Exit Function
	End Select

End Function
