' ########################################################################################
' Microsoft Windows
' File: CW_COMMCTRL_ContextMenu.bas
' Contents: CWindow with a context menu
' Compiler: Ported to bc9Basic jcfuller 08/23/2016  
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"		
$ONEXIT "TCLIB.BAT $FILE$"	
'==============================================================================
$HEADER
	#include <commctrl.h>					/*'For CWindow*/ 
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
$HEADER
'==============================================================================
$USE USE_CreatePopUpMenu USE_AfxStrParse
'==============================================================================
$Include <Afx/CWindow.bi>
$Include <bc9Lib.bi>
$Include <Afx/AfxMenu.bi>
'$Include <Afx/AfxTime.bi>
'$Include <Afx/AfxPath.bi>
'$Include <Afx/AfxCtl.bi>
$Include <Afx/AfxStr.bi>
'==============================================================================
CONST IDC_LABEL = 1001
' // Menu identifiers
ENUM
   IDM_NEW = 1001   ' New file
   IDM_OPEN         ' Open file...
   IDM_SAVE         ' Save file
   IDM_SAVEAS       ' Save file as...
   IDM_EXIT         ' Exit
END ENUM
Dim gMenuList$ 
'==============================================================================
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin
	Raw As CWindow pWindow
	gMenuList$ = "New File,Open File,Save File,Save File As,Exit"
	hWin = pWindow.Create(NULL, "CWindow with a context menu", &WndProc)
	pWindow.SetClientSize(400, 230)
	pWindow.Center()

	' // Add a label
	pWindow.AddControl("Label",hWin, IDC_LABEL, " Click the mouse right button", 110, 20, 175, 23)
	' // Add a button
	pWindow.AddControl("Button",hWin , IDCANCEL, "&Close", 280,180, 75, 23)
	
	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
End Function	
'==============================================================================
CallBack Function WndProc()
	Select Case CBMSG
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
				Case IDM_NEW To IDM_EXIT
					MessageBox(CBHNDL, AfxStrParse$(gMenuList$,CBCTL-1000) & " option clicked", "Menu", MB_OK)
					'If CBCTL = IDM_EXIT Then
					'	PostMessage(CBHNDL,WM_CLOSE,0,0)
					'EndIf
					Exit Function
			End Select
		Case WM_CONTEXTMENU
			' // Build the context menu
			Raw AS HMENU hPopUpMenu = CreatePopupMenu()
			AppendMenu( hPopUpMenu, MF_ENABLED, IDM_NEW, "&New" & CHR$(9) & "Ctrl+N")
			AppendMenu( hPopUpMenu, MF_ENABLED, IDM_OPEN, "&Open..." & CHR$(9) & "Ctrl+O")
			AppendMenu( hPopUpMenu, MF_SEPARATOR, 0, "")
			AppendMenu( hPopUpMenu, MF_ENABLED, IDM_SAVE, "&Save" & CHR$(9) & "Ctrl+S")
			AppendMenu( hPopUpMenu, MF_ENABLED, IDM_SAVEAS, "Save &As...")
			AppendMenu( hPopUpMenu, MF_SEPARATOR, 0, "")
			AppendMenu( hPopUpMenu, MF_ENABLED, IDM_EXIT, "E&xit" & CHR$(9) & "Alt+F4")
			Dim As POINT pt
			GetCursorPos(&pt)
			TrackPopupMenu(hPopUpMenu, 0, pt.x, pt.y, 0, CBHNDL, NULL)
			DestroyMenu(hPopUpMenu)
			Exit Function
		Case WM_DESTROY
			PostQuitMessage(0)
			Exit Function
	End Select
End Function
