' ########################################################################################
' Microsoft Windows
' File: CW_COMMCTRL_DTPicker.bas
' Contents: Demonstrates the use of the Date Time Picker control.
' Compiler: Ported to bc9Basic jcfuller 08/23/2016  
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"		
$ONEXIT "TCLIB.BAT $FILE$"	
'==============================================================================
$HEADER
	#include <commctrl.h>					/*'For CWindow*/ 
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
$HEADER
'==============================================================================

'==============================================================================
$Include <Afx/CWindow.bi>
'$Include <bc9Lib.bi>
'$Include <Afx/AfxMenu.bi>
'$Include <Afx/AfxTime.bi>
'$Include <Afx/AfxPath.bi>
'$Include <Afx/AfxCtl.bi>
'==============================================================================
CONST IDC_LABEL = 1001
CONST IDC_DTPICKER = 1002
'==============================================================================
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin,htDTP
	Raw As CWindow pWindow
	
	hWin = pWindow.Create(NULL, "Date time picker", &WndProc)
	pWindow.Center()

	' // Add the controls
	pWindow.AddControl("Label",hWin , IDC_LABEL, "", 50, 20, 300, 23)
	htDTP = pWindow.AddControl("SysDateTimePick32",hWin , IDC_DTPICKER, "", 100, 50, 150, 23)	
	
	' // Set the date
	DIM AS SYSTEMTIME st
	st.wDay = 15
	st.wMonth = 8
	st.wYear = 2016
	DateTime_SetSystemtime(htDTP, GDT_VALID, &st)
	
	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
End Function	
'==============================================================================
CallBack Function WndProc()
	Select Case CBMSG
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
			End Select
		Case WM_NOTIFY
			' // Notification messages
			DIM AS NMHDR PTR ptNMHDR
			DIM AS NMDATETIMECHANGE PTR ptNMDTC
			ptNMHDR = (NMHDR PTR) CBLPARAM
			SELECT CASE ptNMHDR->idFrom
				CASE IDC_DTPICKER
					SELECT CASE ptNMHDR->code
						CASE DTN_DATETIMECHANGE
							' // Get the selected date
							ptNMDTC = (NMDATETIMECHANGE PTR) CBLPARAM
							Raw As char ptr wszDate = new char[260]
							GetDateFormat(LOCALE_USER_DEFAULT, DATE_LONGDATE, &ptNMDTC->st, NULL, wszDate, 260)
							SetWindowText( CTLHNDL(IDC_LABEL) , "Selected date: " & wszDate$)
							delete [] wszDate
					END SELECT
			END SELECT
			EXIT FUNCTION
			
		Case WM_DESTROY
			PostQuitMessage(0)
			Exit Function
	End Select

End Function
