' ########################################################################################
' Microsoft Windows
' File: CW_COMMCTRL_GroupBox.bas
' Contents: Demonstrates the use of the GroupBox control.
' Comments: Drawn around several controls to indicate a visual association between them.
' Often used around related radio buttons.
' Remarks: In PowerBASIC it is mistakenly called "Frame" instead of "Group Box".
' Compiler: Ported to bc9Basic jcfuller 08/25/2016  
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"		
$ONEXIT "TCLIB.BAT $FILE$"	
'==============================================================================
$HEADER
	#include <commctrl.h>					/*'For CWindow*/ 
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
$HEADER
'==============================================================================
$Include <Afx/CWindow.bi>
'$Include <bc9Lib.bi>
'$Include <Afx/AfxMenu.bi>
'$Include <Afx/AfxTime.bi>
'$Include <Afx/AfxPath.bi>
'$Include <Afx/AfxCtl.bi>
'==============================================================================
ENUM
   IDC_GROUPBOX = 1001
   IDC_LABEL
   IDC_CHECK3STATE
   IDC_EDIT
   IDC_BUTTON
END ENUM
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin
	Raw As CWindow pWindow
	
		
	hWin = pWindow.Create(NULL, "GroupBox example", &WndProc)
	pWindow.Brush((HBRUSH)GetStockObject(WHITE_BRUSH))
	pWindow.Center()

	' // Add the controls
	pWindow.AddControl("GroupBox",hWin , IDC_GROUPBOX, "GroupBox", 20, 20, 305, 100)
	pWindow.AddControl("Label",hWin , IDC_LABEL, "Label", 60, 50, 75, 23)
	pWindow.AddControl("Check3State",hWin , IDC_CHECK3STATE, "Click me", 60, 80, 75, 23)
	pWindow.AddControl("Edit",hWin , IDC_EDIT, "", 210, 50, 75, 23)
	pWindow.AddControl("Button",hWin , IDC_BUTTON, "&Close", 210, 80, 75, 23)

	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
End Function	
'==============================================================================
CallBack Function WndProc()
	Select Case CBMSG
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
				Case IDC_BUTTON
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
			End Select
		Case WM_CTLCOLORSTATIC
			' Draw the GroupBox using the main window background color
			If GetDlgCtrlID((HWND)CBLPARAM) = IDC_GROUPBOX  OR _
			   GetDlgCtrlID((HWND)CBLPARAM) = IDC_LABEL OR _
			   GetDlgCtrlID((HWND)CBLPARAM) = IDC_CHECK3STATE Then
				' Return handle of brush used to paint background
				Function = (LRESULT)GetClassLongPtr(CBHNDL, GCLP_HBRBACKGROUND)
			EndIf
		Case WM_DESTROY
			PostQuitMessage(0)
			Exit Function
	End Select
End Function
