' ########################################################################################
' Microsoft Windows
' File: CW_COMMCTRL_HeaderCtrl.bas
' Contents: Demonstrates the use of the Header control.
' Compiler: Ported to bc9Basic jcfuller 08/25/2016  
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"		
$ONEXIT "TCLIB.BAT $FILE$"	
'==============================================================================
$HEADER
	#include <commctrl.h>					/*'For CWindow*/ 
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
$HEADER
'==============================================================================
$Include <Afx/CWindow.bi>
'$Include <bc9Lib.bi>
'$Include <Afx/AfxMenu.bi>
'$Include <Afx/AfxTime.bi>
'$Include <Afx/AfxPath.bi>
'$Include <Afx/AfxCtl.bi>
'==============================================================================
CONST IDC_HEADER = 1001
'==============================================================================
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin,hHeader
	Raw As CWindow pWindow
	
	hWin = pWindow.Create(NULL, "Header Control", &WndProc)
	pWindow.Center()

	' Add the header control.
	hHeader = pWindow.AddControl("Header",hWin , IDC_HEADER, "", 0, 0, pWindow.ClientWidth(), 23)
	
	' Insert items
	Dim As HDITEM thdi
	Dim wszItem$
	wszItem       = "Item 1"
	thdi.mask     = HDI_WIDTH BOR HDI_FORMAT BOR HDI_TEXT
	thdi.fmt      = HDF_LEFT BOR HDF_STRING
	thdi.cxy      = pWindow.ScaleX(80)
	thdi.pszText  = (LPWSTR)wszItem
	Header_InsertItem(hHeader, 1, &thdi)
	wszItem       = "Item 2"
	Header_InsertItem(hHeader, 2, &thdi)
	wszItem       = "Item 3"
	Header_InsertItem(hHeader, 3, &thdi)
	wszItem       = "Item 4"
	Header_InsertItem(hHeader, 4, &thdi)
	
	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
End Function	
'==============================================================================
CallBack Function WndProc()
	Select Case CBMSG
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
			End Select
		Case WM_NOTIFY
			' Retrieve the header item clicked
			Raw As NMHDR Ptr ptnmhdr = (NMHDR Ptr)CBLPARAM
			Select case ptnmhdr->code
				Case HDN_ITEMCLICKW
					Raw As NMHEADER PTR ptnmh = (NMHEADER PTR)CBLPARAM
					MessageBox(CBHNDL,"You Have Clicked Item " & Str$(ptnmh->iItem +1),"",MB_OK)  
			End Select
		Case WM_DESTROY
			PostQuitMessage(0)
			Exit Function
	End Select
End Function
'==============================================================================