' ########################################################################################
' Microsoft Windows
' File: CW_COMMCTRL_ListView.bas
' Contents: CWindow with a ListView
' Compiler: Ported to bc9Basic jcfuller 08/25/2016  
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"		
$ONEXIT "TCLIB.BAT $FILE$"	
'==============================================================================
$HEADER
	#include <windowsx.h>					/*'For ListView macros*/
	#include <commctrl.h>					/*'For CWindow*/ 
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
$HEADER
'==============================================================================
$Include <Afx/CWindow.bi>
'$Include <bc9Lib.bi>
'$Include <Afx/AfxMenu.bi>
'$Include <Afx/AfxTime.bi>
'$Include <Afx/AfxPath.bi>
'$Include <Afx/AfxCtl.bi>
'==============================================================================
CONST IDC_LISTVIEW = 1001
'==============================================================================
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin,hListView
	Raw As CWindow pWindow
	
	hWin = pWindow.Create(NULL, "CWindow with a ListView", &WndProc)
	pWindow.ClassStyle(CS_DBLCLKS)   ' // Change the window style to avoid flicker
	pWindow.SetClientSize(565, 320)
	
	pWindow.Center()

	' Add a listview
	hListView = pWindow.AddControl("ListView",hWin , IDC_LISTVIEW, "")
	
	' // Add some extended styles
	Raw AS DWORD dwExStyle = ListView_GetExtendedListViewStyle(hListView)
	dwExStyle = dwExStyle BOR LVS_EX_FULLROWSELECT BOR LVS_EX_GRIDLINES
	ListView_SetExtendedListViewStyle(hListView, dwExStyle)
	
	' Add the header's column names
	Dim As Long i
	Dim As LVCOLUMNW lvc
	Dim As char ptr wszText = new char[260]
	lvc.mask = LVCF_FMT BOR LVCF_WIDTH BOR LVCF_TEXT BOR LVCF_SUBITEM
	For i = 0 To 4
		wszText$ = "Column " & Str$(i)
		lvc.pszText = (LPWSTR)wszText
		lvc.cx = pWindow.ScaleX(110)
		lvc.iSubItem = i
		ListView_InsertColumn(hListView, i, &lvc)
	Next
	
	'Populate the ListView with some data
	Dim As Long x
	Dim As LVITEMW lvi
	lvi.mask = LVIF_TEXT
	For i = 0 To 29
		lvi.iItem = i
		lvi.iSubItem = 0
		wszText$ = "Column 0 Row" & STR$(i)
		lvi.pszText = (LPSTR)wszText
		ListView_InsertItem(hListView, &lvi)
		For x = 1 To 4
			wszText$ = "Column " & STR$(x) & " Row" & STR$(i)
			ListView_SetItemText(hListView, i, x, (LPWSTR)wszText)
		Next
	Next
	delete [] wszText
	' // Select the fist item
	ListView_SetItemState(hListView, 0, LVIS_FOCUSED OR LVIS_SELECTED, 0x000F)
	' // Set the focus in the ListView
	SetFocus(hListView)
	
	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
End Function	
'==============================================================================
CallBack Function WndProc()
	DIM AS NMHDR PTR pNmh            ' // Pointer to a NMHDR structure
	DIM AS NMLISTVIEW PTR pLvNm       ' // Pointer to a NMLISTVIEW structure
	DIM AS NMLVCUSTOMDRAW PTR pLvCd   ' // Pointer to a NMLVCUSTOMDRAW structure

	Select Case CBMSG
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
			End Select
		Case WM_SIZE
			'  Resize the ListView control and its header
			If CBWPARAM <> SIZE_MINIMIZED Then
				Dim As HWND hListView
				Raw As CWindow Ptr pWindow
				pWindow = AfxCWindowPtr(CBHNDL)
				hListView = CTLHNDL(IDC_LISTVIEW)
				If pWindow Then
					pWindow->MoveWindow( hListView, 5, 5, pWindow->ClientWidth() - 10, pWindow->ClientHeight() - 10, TRUE)
				EndIf
			EndIf
		Case WM_DESTROY
			PostQuitMessage(0)
			Exit Function
	End Select
End Function
