' ########################################################################################
' Microsoft Windows
' File: CW_COMMCTRL_Menu.bas
' Contents: CWindow with a menu
' Compiler: Ported to bc9Basic jcfuller 08/26/2016 with added msgbox display 
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
 
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"		
$ONEXIT "TCLIB.BAT $FILE$"	
'==============================================================================
$HEADER
	#include <commctrl.h>					/*'For CWindow*/ 
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
$HEADER
'==============================================================================
'Include the AfxStrParse Function
$USE USE_AfxStrParse
'==============================================================================
$Include <Afx/CWindow.bi>
'$Include <bc9Lib.bi>
'$Include <Afx/AfxMenu.bi>
'$Include <Afx/AfxTime.bi>
'$Include <Afx/AfxPath.bi>
'$Include <Afx/AfxCtl.bi>
$Include <Afx/AfxStr.bi>
'==============================================================================
' // Menu identifiers
ENUM
   IDM_NEW = 1001     ' New file
   IDM_OPEN           ' Open file...
   IDM_SAVE           ' Save file
   IDM_SAVEAS         ' Save file as...
   IDM_EXIT           ' Exit

   IDM_UNDO = 2001    ' Undo
   IDM_CUT            ' Cut
   IDM_COPY           ' Copy
   IDM_PASTE          ' Paste

   IDM_TILEH = 3001   ' Tile hosizontal
   IDM_TILEV          ' Tile vertical
   IDM_CASCADE        ' Cascade
   IDM_ARRANGE        ' Arrange icons
   IDM_CLOSE          ' Close
   IDM_CLOSEALL       ' Close all
END ENUM
'------------------------------------------------------------------------------
'MessageBox item name list
Dim gMenuList$ 
'==============================================================================
Function BuildMenu() As HMENU
	Dim As HMENU hMenu,hPopUpMenu

	hMenu = CreateMenu()
	hPopUpMenu = CreatePopupMenu()
		AppendMenu( hMenu, MF_POPUP OR MF_ENABLED, (UINT_PTR) hPopUpMenu, "&File")
		AppendMenu( hPopUpMenu, MF_ENABLED, IDM_NEW, "&New" & TAB$ & "Ctrl+N")
		AppendMenu( hPopUpMenu, MF_ENABLED, IDM_OPEN, "&Open..." & TAB$ & "Ctrl+O")
		AppendMenu( hPopUpMenu, MF_SEPARATOR, 0, "")
		AppendMenu( hPopUpMenu, MF_ENABLED, IDM_SAVE, "&Save" & CHR$(9) & "Ctrl+S")
		AppendMenu( hPopUpMenu, MF_ENABLED, IDM_SAVEAS, "Save &As...")
		AppendMenu( hPopUpMenu, MF_SEPARATOR, 0, "")
		AppendMenu( hPopUpMenu, MF_ENABLED, IDM_EXIT, "E&xit" & CHR$(9) & "Alt+F4")
	hPopUpMenu = CreatePopupMenu()
		AppendMenu( hMenu, MF_POPUP OR MF_ENABLED, (UINT_PTR) hPopUpMenu, "&Edit")
		AppendMenu( hPopUpMenu, MF_ENABLED, IDM_UNDO, "&Undo" & CHR$(9) & "Ctrl+Z")
		AppendMenu( hPopUpMenu, MF_SEPARATOR, 0, "")
		AppendMenu( hPopUpMenu, MF_ENABLED, IDM_CUT, "Cu&t" & CHR$(9) & "Ctrl+X")
		AppendMenu( hPopUpMenu, MF_ENABLED, IDM_COPY, "&Copy" & CHR$(9) & "Ctrl+C")
		AppendMenu( hPopUpMenu, MF_ENABLED, IDM_PASTE, "&Paste" & CHR$(9) & "Ctrl+V")
	hPopUpMenu = CreatePopupMenu()
		AppendMenu( hMenu, MF_POPUP OR MF_ENABLED, (UINT_PTR) hPopUpMenu, "&Window")
		AppendMenu( hPopUpMenu, MF_ENABLED, IDM_TILEH, "&Tile Horizontal")
		AppendMenu( hPopUpMenu, MF_ENABLED, IDM_TILEV, "Tile &Vertical")
		AppendMenu( hPopUpMenu, MF_ENABLED, IDM_CASCADE, "Ca&scade")
		AppendMenu( hPopUpMenu, MF_ENABLED, IDM_ARRANGE, "&Arrange &Icons")
		AppendMenu( hPopUpMenu, MF_SEPARATOR, 0, "")
		AppendMenu( hPopUpMenu, MF_ENABLED, IDM_CLOSE, "&Close" & CHR$(9) & "Ctrl+F4")
		AppendMenu( hPopUpMenu, MF_ENABLED, IDM_CLOSEALL, "Close &All")	
	Function = hMenu
End Function
'==============================================================================
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin,hListView
	Raw As CWindow pWindow
	gMenuList$ = "New,Open,Save,Save As,Exit,Undo,Cut,Copy,Paste,Tile Horizontal,Tile Vertical,Cascade,Arrange Icons,Close,Close All"
	hWin = pWindow.Create(NULL, "CWindow with a menu", &WndProc)
	pWindow.SetClientSize(400, 250)
	pWindow.Center()
	' Add a Button
	pWindow.AddControl("Button",hWin , IDCANCEL, "&Close", 280, 180, 75, 23)
	'Create the menu
	Raw As HMENU hMenu = BuildMenu()
	SetMenu(pWindow.hWindow(),hMenu)
	
	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
End Function
'==============================================================================	
CallBack Function WndProc()
	Dim As Integer item
	Select Case CBMSG
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
				Case >= IDM_NEW AND < IDM_UNDO
					item = CBCTL - 1000
					MessageBox(CBHNDL,"File -> " & AfxStrParse$(gMenuList$,item),"Menu",MB_OK)
					If CBCTL = IDM_EXIT Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
					EndIf
					Exit Function
				Case >= IDM_UNDO AND < IDM_TILEH
					item = (CBCTL - 2000)+5
					MessageBox(CBHNDL,"Edit -> " & AfxStrParse$(gMenuList$,item),"Menu",MB_OK)
					Exit Function
				Case Else
					item = (CBCTL - 3000)+9
					MessageBox(CBHNDL,"Window -> " & AfxStrParse$(gMenuList$,item),"Menu",MB_OK)
					Exit Function
			End Select
			
			Exit Function
			
		Case WM_DESTROY
			PostQuitMessage(0)
			Exit Function
	End Select
End Function
