' ########################################################################################
' Microsoft Windows
' File: CW_COMMCTRL_MonthCal.bas
' Contents: Demonstrates the use of the Month Calendar control.
' Compiler: Ported to bc9Basic jcfuller 08/25/2016  
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"		
$ONEXIT "TCLIB.BAT $FILE$"	
'==============================================================================
$HEADER
	#include <windowsx.h>
	#include <commctrl.h>					/*'For CWindow*/ 
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
$HEADER
'==============================================================================
$Include <Afx/CWindow.bi>
'$Include <bc9Lib.bi>
'$Include <Afx/AfxMenu.bi>
'$Include <Afx/AfxTime.bi>
'$Include <Afx/AfxPath.bi>
'$Include <Afx/AfxCtl.bi>
'==============================================================================
CONST IDC_MONTHCAL = 1001
'==============================================================================
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin
	Raw As CWindow pWindow
	
	hWin = pWindow.Create(NULL, "CWindow with a month calendar", &WndProc)
	pWindow.SetClientSize(400, 220)
	pWindow.Center()

	' // Add the control
	pWindow.AddControl("SysMonthCal32",hWin , IDC_MONTHCAL, "",10, 10, _
	                   pWindow.ClientWidth() - 20, pWindow.ClientHeight() - 20)

	
	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
End Function	
'==============================================================================
CallBack Function WndProc()
	Select Case CBMSG
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
			End Select
		Case WM_NOTIFY
			Raw As NMSELCHANGE PTR ptnmsc = (NMSELCHANGE PTR) CBLPARAM
			'Get selected date
			If ptnmsc->nmhdr.code = MCN_SELCHANGE Then
				Raw As char ptr wszDate = new char[260]
				wszDate$ = "Day: " & Str$(ptnmsc->stSelStart.wDay) & " " & _
				           "Month: " & Str$(ptnmsc->stSelStart.wMonth) & " " & _
				           "Year: " & Str$(ptnmsc->stSelStart.wYear)
				SendMessage(CBHNDL,WM_SETTEXT,0,(LPARAM) wszDate)
				delete [] wszDate           
				Exit Function
			EndIf
		Case WM_SIZE
			If CBWPARAM <> SIZE_MINIMIZED Then
				'Resize the control
				Raw As CWindow Ptr pWindow = AfxCWindowPtr(CBHNDL)
				If pWindow Then
					pWindow->MoveWindow(CTLHNDL(IDC_MONTHCAL), 10, 10, pWindow->ClientWidth() - 20, pWindow->ClientHeight() - 20, TRUE)
				EndIf
			EndIf
		Case WM_DESTROY
			PostQuitMessage(0)
			Exit Function
	End Select
End Function
