' ########################################################################################
' Microsoft Windows
' File: CW_COMMCTRL_Rebar.bas
' Contents: CWindow with a rebar control
' Compiler: Ported to bc9Basic jcfuller 08/26/2016  
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"		
$ONEXIT "TCLIB.BAT $FILE$"	
'==============================================================================
$HEADER
	#include<windowsx.h>
	#include <commctrl.h>					/*'For CWindow*/ 
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
$HEADER
'==============================================================================
'Include these functions
'------------------------------------------------------------------------------
$USE USE_Toolbar_SetExtendedStyle USE_Toolbar_AddBitmap USE_Toolbar_AddButton
$USE USE_Toolbar_AddSeparator USE_Toolbar_AutoSize USE_AfxComCtlVersion 
$USE USE_Toolbar_GetButtonHeight USE_Rebar_InsertBand USE_Toolbar_GetTooltips
'==============================================================================
$Include <Afx/CWindow.bi>
'$Include <bc9Lib.bi>
'$Include <Afx/AfxMenu.bi>
'$Include <Afx/AfxTime.bi>
'$Include <Afx/AfxPath.bi>
$Include <Afx/AfxCtl.bi>
'==============================================================================
CONST IDC_TOOLBAR = 1001
CONST IDC_CBBOX = 1002
CONST IDC_REBAR = 1003

Enum
	IDM_CUT=28000
	IDM_COPY
	IDM_PASTE
	IDM_UNDO
	IDM_REDOW
	IDM_DELETE
	IDM_FILENEW
	IDM_FILEOPEN
	IDM_FILESAVE
	IDM_PRINTPRE
	IDM_PROPERTIES
	IDM_HELP
	IDM_FIND
	IDM_REPLACE
	IDM_PRINT
End Enum   
'==============================================================================
Function CreateToolBar(pWindow As CWindow Ptr) As HWND
	Raw As HWND hToolBar = pWindow->AddControl("Toolbar",pWindow->hWindow() , IDC_TOOLBAR, "",0 ,0 ,0 ,0 , _
                           WS_CHILD BOR WS_VISIBLE BOR TBSTYLE_TOOLTIPS BOR TBSTYLE_FLAT BOR CCS_NODIVIDER BOR CCS_NORESIZE BOR CCS_NOPARENTALIGN)
    ' Allow drop down arrows
	Toolbar_SetExtendedStyle(hToolBar, TBSTYLE_EX_DRAWDDARROWS)
	'Add a bitmap with the button images  
    Dim As TBADDBITMAP ttbab
    ttbab.hInst = HINST_COMMCTRL
	If AfxIsProcessDPIAware() Then
		ttbab.nID = IDB_STD_LARGE_COLOR
	Else
		ttbab.nID = IDB_STD_SMALL_COLOR
	End if
    Toolbar_AddBitmap(hToolBar, 0, &ttbab)
	' // Add buttons to the toolbar
	Toolbar_AddButton( hToolBar, STD_CUT, IDM_CUT)
	Toolbar_AddButton( hToolBar, STD_COPY, IDM_COPY)
	Toolbar_AddButton( hToolBar, STD_PASTE, IDM_PASTE)
	Toolbar_AddButton( hToolBar, STD_DELETE, IDM_DELETE)
	Toolbar_AddSeparator( hToolBar)
	Toolbar_AddButton( hToolBar, STD_UNDO, IDM_UNDO)
	Toolbar_AddButton( hToolBar, STD_REDOW, IDM_REDOW)
	Toolbar_AddSeparator( hToolBar)
	Toolbar_AddButton( hToolBar, STD_FILENEW, IDM_FILENEW, 0, BTNS_DROPDOWN)
	Toolbar_AddButton( hToolBar, STD_FILEOPEN, IDM_FILEOPEN)
	Toolbar_AddButton( hToolBar, STD_FILESAVE, IDM_FILESAVE)
	Toolbar_AddButton( hToolBar, STD_PRINTPRE, IDM_PRINTPRE)
	Toolbar_AddSeparator( hToolBar)
	Toolbar_AddButton( hToolBar, STD_FIND, IDM_FIND)
	Toolbar_AddButton( hToolBar, STD_REPLACE, IDM_REPLACE)
	Toolbar_AddSeparator( hToolBar)
	Toolbar_AddButton( hToolBar, STD_PROPERTIES, IDM_PROPERTIES)
	Toolbar_AddButton( hToolBar, STD_PRINT, IDM_PRINT)
	Toolbar_AddSeparator( hToolBar)
	Toolbar_AddButton( hToolBar, STD_HELP, IDM_HELP)
    'Size the toolbar
    Toolbar_AutoSize(hToolBar)
    Function = hToolBar
End Function
'==============================================================================
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin,hButton,hRebar,hToolBar,hCbBox
	Raw As CWindow pWindow
	
	hWin = pWindow.Create(NULL, "CWindow with a rebar", &WndProc)
	' Disable background erasing
	pWindow.ClassStyle(CS_DBLCLKS)
	' // Set the client size
	pWindow.SetClientSize(850, 250)
	pWindow.Center()
	'add a button
	hButton = pWindow.AddControl("Button",hWin , IDCANCEL, "&Close")
	' Create a rebar control
	hRebar = pWindow.AddControl("Rebar",hWin , IDC_REBAR)
	'Create the toolbar
	hToolBar = CreateToolBar(&pWindow)
   ' // Add the band containing the toolbar control to the rebar
   ' // The size of the REBARBANDINFOW is different in Vista/Windows 7
	Dim As RECT rc
	Dim wszText$
	Dim As REBARBANDINFOW rbbi
	rbbi.cbSize  = REBARBANDINFO_V6_SIZE
	' Insert the toolbar in the rebar control
	rbbi.fMask      = RBBIM_STYLE BOR RBBIM_CHILD BOR RBBIM_CHILDSIZE BOR _
	                 RBBIM_SIZE BOR RBBIM_ID BOR RBBIM_IDEALSIZE BOR RBBIM_TEXT
	rbbi.fStyle     = RBBS_CHILDEDGE
	rbbi.hwndChild  = hToolBar
	rbbi.cxMinChild = 270 * pWindow.rxRatio()
	rbbi.cyMinChild = Toolbar_GetButtonHeight(hToolBar)
	rbbi.cx         = 270 * pWindow.rxRatio()
	rbbi.cxIdeal    = 270 * pWindow.rxRatio()
	wszText = "Toolbar"
	rbbi.lpText = (LPWSTR)&wszText
	'// Insert band into rebar
	Rebar_InsertBand(hRebar, -1, &rbbi)
	
   ' Insert a combobox in the rebar control
   	hCbBox = pWindow.AddControl("ComboBox",hWin , IDC_CBBOX, "", 0, 0, 0, 50 * pWindow.rxRatio())
   	GetWindowRect(hCbBox, &rc)
	rbbi.fMask      = RBBIM_STYLE BOR RBBIM_CHILD BOR RBBIM_CHILDSIZE BOR _
	                 RBBIM_SIZE BOR RBBIM_ID BOR RBBIM_IDEALSIZE BOR RBBIM_TEXT
	rbbi.fStyle     = RBBS_FIXEDSIZE BOR RBBS_CHILDEDGE
	rbbi.hwndChild  = hCbBox
	rbbi.cxMinChild = 200 * pWindow.rxRatio()
	rbbi.cyMinChild = rc.bottom - rc.top
	rbbi.cx         = 200 * pWindow.rxRatio()
	rbbi.cxIdeal    = 200 * pWindow.rxRatio()
	wszText = "Combobox"
	rbbi.lpText = (LPWSTR)&wszText
	'// Insert band into rebar
	Rebar_InsertBand(hRebar, -1, &rbbi)
   	
	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
End Function	
'==============================================================================
CallBack Function WndProc()
	Select Case CBMSG
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
			End Select
		Case WM_NOTIFY
			DIM AS NMHDR PTR ptnmhdr              	' // Information about a notification message
			DIM AS NMTTDISPINFOW PTR  ptttdi      	' // Tooltip notification message information
			DIM wszTooltipText$						' // Tooltip text
			ptnmhdr = (NMHDR PTR)CBLPARAM
			Select Case ptnmhdr->code
				'The height of the rebar has changed
				Case RBN_HEIGHTCHANGE
					'Get the coordinates of the client area
					Dim As RECT rc
					GetClientRect(CBHNDL,&rc)
					'Send a WM_SIZE message to resize the controls
					SendMessage(CBHNDL, WM_SIZE, SIZE_RESTORED, MAKELONG(rc.right - rc.left, rc.bottom - rc.top))
				 ' Toolbar tooltips
				Case TTN_GETDISPINFOW
					ptttdi = (NMTTDISPINFOW PTR)CBLPARAM
					ptttdi->hinst = NULL
					wszTooltipText$ = ""
					Select Case ptttdi->hdr.hwndFrom
						Case Toolbar_GetTooltips(GetDlgItem(GetDlgItem(CBHNDL, IDC_REBAR), IDC_TOOLBAR))
							Select Case ptttdi->hdr.idFrom
								CASE IDM_CUT        : wszTooltipText = "Cut"
								CASE IDM_COPY       : wszTooltipText = "Copy"
								CASE IDM_PASTE      : wszTooltipText = "Paste"
								CASE IDM_UNDO       : wszTooltipText = "Undo"
								CASE IDM_REDOW      : wszTooltipText = "Redo"
								CASE IDM_DELETE     : wszTooltipText = "Delete"
								CASE IDM_FILENEW    : wszTooltipText = "File New"
								CASE IDM_FILEOPEN   : wszTooltipText = "File Open"
								CASE IDM_FILESAVE   : wszTooltipText = "File Save"
								CASE IDM_PRINTPRE   : wszTooltipText = "Print Preview"
								CASE IDM_PROPERTIES : wszTooltipText = "Properties"
								CASE IDM_HELP       : wszTooltipText = "Help"
								CASE IDM_FIND       : wszTooltipText = "Find"
								CASE IDM_REPLACE    : wszTooltipText = "Replace"
								CASE IDM_PRINT      : wszTooltipText = "Print"
							End Select
							If Len(wszTooltipText) Then
								ptttdi->lpszText = (LPWSTR)&wszTooltipText
							EndIf
					End Select
			End Select
		Case WM_SIZE
			If CBWPARAM <> SIZE_MINIMIZED Then
	            ' // Update the size and position of the Rebar control
    	        SendMessage(CTLHNDL(IDC_REBAR), WM_SIZE, CBWPARAM, CBLPARAM)
				Raw As CWindow Ptr pWindow = AfxCWindowPtr(CBHNDL)
				If pWindow Then
					pWindow->MoveWindow( CTLHNDL(IDCANCEL), pWindow->ClientWidth() - 95, pWindow->ClientHeight() - 35, 75, 23, TRUE)
				EndIf
				Exit Function
			EndIf
		Case WM_DESTROY
			PostQuitMessage(0)
			Exit Function
	End Select
End Function
