' ########################################################################################
' Microsoft Windows
' File: CW_COMMCTRL_SBMouseClick.bas
' Contents: Demonstrates how to determine which part of Statusbar was clicked.
' Compiler: Ported to bc9Basic jcfuller 08/26/2016  
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP"' TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"		
$ONEXIT "TCLIB.BAT $FILE$"	
'==============================================================================
$HEADER
	#include <commctrl.h>					/*'For CWindow*/ 
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
$HEADER
'==============================================================================
$USE USE_StatusBar_SetParts USE_StatusBar_Simple
'==============================================================================
$Include <Afx/CWindow.bi>
'$Include <bc9Lib.bi>
'$Include <Afx/AfxMenu.bi>
'$Include <Afx/AfxTime.bi>
'$Include <Afx/AfxPath.bi>
$Include <Afx/AfxCtl.bi>
'==============================================================================
CONST IDC_STATUSBAR = 1001
'==============================================================================
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin,hStatusBar
	Raw As CWindow pWindow
	
	hWin = pWindow.Create(NULL, "Status bar: Detect mouse click", &WndProc)
	pWindow.Center()

	
   ' Add a label
   pWindow.AddControl("LABEL",hWin , -1, "Click one of the sections of the status bar with the mouse", _
      20, 40, 350, 23)
	' Add a status bar
	hStatusBar = pWindow.AddControl("Statusbar",hWin , IDC_STATUSBAR)
	'Set the parts
	Dim As Long rgParts[3] = {(LONG)pWindow.ScaleX(100),(LONG)pWindow.ScaleX(220),-1}
	If StatusBar_SetParts(hStatusBar,3,&rgParts[0]) Then
		StatusBar_Simple(hStatusBar,FALSE)
	EndIf
	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
End Function	
'==============================================================================
CallBack Function WndProc()
	Select Case CBMSG
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
			End Select
		Case WM_NOTIFY
			'Detect if the user has clicked the mouse in one of the status bar parts
			Dim As NMHDR PTR ptnmhdr
			ptnmhdr = (NMHDR PTR) CBLPARAM
			Select Case ptnmhdr->idFrom
				Case IDC_STATUSBAR
					Dim As NMMOUSE Ptr lpnm
					If ptnmhdr->code = NM_CLICK Then
						lpnm = (NMMOUSE Ptr) CBLPARAM
						'Display the zero-based index of the section that was clicked.
						MessageBox(CBHNDL, "You have clicked section " & STR$(lpnm->dwItemSpec), "", MB_OK)
					EndIf
			End Select
		Case WM_SIZE
			'Resizes the status bar and redraws it
			Raw As HWND hStatusBar = CTLHNDL(IDC_STATUSBAR)
			SendMessage(hStatusBar, WM_SIZE, CBWPARAM,CBLPARAM)
			InvalidateRect(hStatusBar, NULL, TRUE)
			Exit Function
		Case WM_DESTROY
			PostQuitMessage(0)
			Exit Function
	End Select
End Function
