' ########################################################################################
' Microsoft Windows
' File: CW_COMMCTRL_SBwithPB.bas - Template
' Contents: Demonstrates the use of the Statusbar and ProgressBar controls.
' Comments: In this example, the progress bar has been made child of the status bar.
' Compiler: Ported to bc9Basic jcfuller 08/27/2016  
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"		
$ONEXIT "TCLIB.BAT $FILE$"	
'==============================================================================
$HEADER
	#include <commctrl.h>					/*'For CWindow*/ 
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
$HEADER
'==============================================================================
'Include these functions
$USE USE_StatusBar_SetParts USE_StatusBar_Simple USE_ProgressBar_SetRange32
$USE USE_ProgressBar_SetPos USE_ProgressBar_SetStep USE_ProgressBar_StepIt
'==============================================================================
'------------------------------------------------------------------------------
$Include <Afx/CWindow.bi>
'$Include <bc9Lib.bi>
'$Include <Afx/AfxMenu.bi>
'$Include <Afx/AfxTime.bi>
'$Include <Afx/AfxPath.bi>
$Include <Afx/AfxCtl.bi>
'==============================================================================
CONST IDC_START = 1001
CONST IDC_STATUSBAR = 1002
CONST IDC_PROGRESSBAR = 1003
'==============================================================================
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin,hStatusBar,hProgressBar
	Raw As CWindow pWindow
	
	hWin = pWindow.Create(NULL, "Status bar with progress bar", &WndProc)
	pWindow.Center()

	' Add a button
	pWindow.AddControl("Button",hWin , IDC_START, "&Start", 20, 20, 75, 23)
   	
   	' Add a status bar
	hStatusBar = pWindow.AddControl("Statusbar",hWin , IDC_STATUSBAR)
	' Set the parts
	Raw As LONG rgParts[2]  = {(LONG)pWindow.ScaleX(160), -1}
	If StatusBar_SetParts(hStatusBar, 2, &rgParts[0]) Then
		StatusBar_Simple(hStatusBar, FALSE)
	End If

	' Add a progress bar to the status bar
	hProgressBar = pWindow.AddControl("ProgressBar", hStatusBar, IDC_PROGRESSBAR, "", 0, 2, 160, 18)
	' // Set the range
	ProgressBar_SetRange32(hProgressBar, 0, 100)
	' // Set the initial position
	ProgressBar_SetPos(hProgressBar, 0)
	
	
	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
End Function	
'==============================================================================
CallBack Function WndProc()
	Select Case CBMSG
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
				Case IDC_START
					'Retrieve the handle to the progress bar
					Raw As HWND hProgressBar = GetDlgItem(GetDlgItem(CBHNDL, IDC_STATUSBAR), IDC_PROGRESSBAR)
					' *** Test code ***
					' // Sets the step increment
					ProgressBar_SetStep(hProgressBar, 1)
					' // Draws the bar
					DIM i AS LONG
					FOR i = 1 TO 100
						' // Advances the current position for a progress bar by the step
						' // increment and redraws the bar to reflect the new position
						ProgressBar_StepIt(hProgressBar)
						SLEEP(10)
					NEXT
					' // Clears the bar by reseting its position to 0
					ProgressBar_SetPos(hProgressBar, 0)
					
			End Select
		Case WM_SIZE
			'Resizes the status bar and redraws it
			Raw As HWND hStatusBar = CTLHNDL(IDC_STATUSBAR)
			SendMessage(hStatusBar, WM_SIZE, CBWPARAM,CBLPARAM)
			InvalidateRect(hStatusBar, NULL, TRUE)
			Exit Function
			
		Case WM_DESTROY
			PostQuitMessage(0)
			Exit Function
	End Select
End Function
