' ########################################################################################
' Microsoft Windows
' File: CW_COMMCTRL_TabControlDemo.bas - Template
' Contents: CWindow Tab Control template
' Remarks: Demonstrates the use of the CTabPage class
' Compiler: Ported to bc9Basic jcfuller 08/27/2016  
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
CONST IDC_TAB       = 1001
CONST IDC_EDIT1     = 1002
CONST IDC_EDIT2     = 1003
CONST IDC_BTNSUBMIT = 1004
CONST IDC_COMBO     = 1005
CONST IDC_LISTBOX   = 1006
'==============================================================================
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"		
$ONEXIT "TCLIB.BAT $FILE$"	
'==============================================================================
$HEADER
	#include <windowsx.h>
	#include <commctrl.h>					/*'For CWindow*/ 
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
$HEADER
'==============================================================================
$USE USE_CScrollWindow USE_CTabPage
'==============================================================================
$Include <Afx/CWindow.bi>
'$Include <bc9Lib.bi>
'$Include <Afx/AfxMenu.bi>
'$Include <Afx/AfxTime.bi>
'$Include <Afx/AfxPath.bi>
'$Include <Afx/AfxCtl.bi>
'==============================================================================
CONST IDC_CHECK3STATE = 1001
'==============================================================================
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin,hTab,hPg1,hPg2,hPg3
	Raw As CWindow pWindow
	
	hWin = pWindow.Create(NULL, "CWindow with a Tab Control", &WndProc)
	pWindow.SetClientSize(500, 320)
	pWindow.Center()

	hTab = pWindow.AddControl("Tab",hWin , IDC_TAB, "", 10, 10, pWindow.ClientWidth() - 20, pWindow.ClientHeight() - 42)
	
	'Create the first tab page
	Raw As CTabPage Ptr pTabPage1 = new CTabPage
	hPg1 = pTabPage1->InsertPage(hTab, 0, "Tab 1", -1, &TabPage1_WndProc)
	'Create the second tab page
	Raw As CTabPage Ptr pTabPage2 = new CTabPage
	hPg2 = pTabPage2->InsertPage(hTab, 1, "Tab 2", -1, &TabPage2_WndProc)
	'Create the third tab page
	Dim As CTabPage Ptr pTabPage3 = new CTabPage
	pTabPage3->InsertPage(hTab, 2, "Tab 3", -1, &TabPage3_WndProc)

	' Add a button
	pWindow.AddControl("Button",hWin , IDCANCEL, "&Close", 415, 292, 75, 23)

	' // Display the first tab page
	ShowWindow(pTabPage1->hTabPage(), SW_SHOW)
	' // Set the focus to the first tab
	SendMessage( hTab, TCM_SETCURFOCUS, 0, 0)

	
	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
End Function	
'==============================================================================
CallBack Function WndProc()
	Select Case CBMSG
		Case WM_CREATE
			Exit Function
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
			End Select
		Case WM_GETMINMAXINFO
			'Set the pointer to the address of the MINMAXINFO structure
			Dim As MINMAXINFO PTR ptmmi = (MINMAXINFO PTR) CBLPARAM
			'Set the minimum and maximum sizes that can be produced by dragging the borders of the window
			Raw As CWindow Ptr pWindow = AfxCWindowPtr(CBHNDL)
			If pWindow Then
	            ptmmi->ptMinTrackSize.x = 460 * pWindow->rxRatio()
	            ptmmi->ptMinTrackSize.y = 320 * pWindow->ryRatio()
			EndIf
			Exit Function
		Case WM_SIZE
			Dim As CWindow Ptr pWindow = AfxCWindowPtr(CBHNDL)
			Dim As HWND hTab = CTLHNDL(IDC_TAB)
			
			If pWindow Then
				'Move the close button	
				pWindow->MoveWindow(CTLHNDL(IDCANCEL), pWindow->ClientWidth() - 85, pWindow->ClientHeight() - 28, 75, 23, TRUE)
				'Resize the tab control
				pWindow->MoveWindow(hTab, 10, 10, pWindow->ClientWidth() - 20, pWindow->ClientHeight() - 42, TRUE)
			EndIf
			AfxResizeTabPages(hTab)
			Exit Function
		Case WM_NOTIFY
			Dim As DWORD nPage
			Dim As CTabPage Ptr pTabPage
			Dim As TCITEMW	tci
			Raw As NMHDR Ptr ptnmhdr = (NMHDR Ptr) CBLPARAM
			Select Case ptnmhdr->idFrom
				Case IDC_TAB
					Select Case ptnmhdr->code
						Case TCN_SELCHANGE
							'Show the selected page
							pTabPage = AfxCTabPagePtr(ptnmhdr->hwndFrom, -1)
							If pTabPage Then
								ShowWindow(pTabPage->hTabPage(), SW_SHOW)
							EndIf
						Case TCN_SELCHANGING
							'Hide the current page
							pTabPage = AfxCTabPagePtr(ptnmhdr->hwndFrom, -1)
							If pTabPage Then
								ShowWindow(pTabPage->hTabPage(), SW_HIDE)
							EndIf
					End Select
			End Select
			
		Case WM_DESTROY
			' Destroy the tab pages
        	AfxDestroyAllTabPages(CTLHNDL(IDC_TAB))
			PostQuitMessage(0)
			Exit Function
	End Select
End Function
'==============================================================================
CallBack Function TabPage1_WndProc()
	Select Case CBMSG
		Case WM_CREATE
			'Get a pointer to the TabPage class
			Dim As CTabPage Ptr pTabPage = AfxCTabPagePtr(GetParent(CBHNDL), 0)
			'Add controls to the first page
			pTabPage->AddControl("Label", CBHNDL, -1, "First name", 15, 15, 121, 21)
			pTabPage->AddControl("Label", CBHNDL, -1, "Last name", 15, 50, 121, 21)
			pTabPage->AddControl("Edit", CBHNDL, IDC_EDIT1, "", 165, 15, 186, 21)
			pTabPage->AddControl("Edit", CBHNDL, IDC_EDIT2, "", 165, 50, 186, 21)
			pTabPage->AddControl("Button", CBHNDL, IDC_BTNSUBMIT, "Submit", 340, 185, 76, 26, BS_DEFPUSHBUTTON)
			Exit Function
		Case WM_COMMAND
			Select Case CBCTL
				Case IDC_BTNSUBMIT
					If CBCTLMSG = BN_CLICKED Then
						MessageBox(CBHNDL,"Submit","Tab 1",MB_OK)
						Exit Function
					EndIf
			End Select
	End Select
End Function
'==============================================================================
CallBack Function TabPage2_WndProc()
	Dim As HBRUSH hBrush
	Dim As RECT rc
	Dim As LOGBRUSH tlb
	
	Select Case CBMSG
		Case WM_CREATE
			
			'Get a pointer to the TabPage class
			Dim As CTabPage Ptr pTabPage = AfxCTabPagePtr(GetParent(CBHNDL), 1)

			'Add a combobox to the second page
			Dim As HWND hComboBox = pTabPage->AddControl("ComboBox", CBHNDL, IDC_COMBO, "", 20, 20, 191, 105)
			'Fill the combobox with some data
			Dim wszText$
			Dim As Long i
			For i = 1 To 9
				wszText$ = "Item " & Right$("00"&Str$(i),2)
				ComboBox_AddString(hComboBox,wszText$)
			Next
			'Select the first item in the combo box
			ComboBox_SetCurSel(hComboBox, 0)
			Exit Function
		Case WM_ERASEBKGND
			GetClientRect(CBHNDL,&rc)
			'Create custom brush
			tlb.lbStyle = BS_SOLID
			tlb.lbColor = 0x00CB8734
			tlb.lbHatch = 0
			hBrush = CreateBrushIndirect(&tlb)
			' Erase background
			FillRect((HDC) CBWPARAM, &rc, hBrush)
			DeleteObject(hBrush)
			FUNCTION = TRUE
			
	End Select
End Function
'==============================================================================
CallBack Function TabPage3_WndProc()
	Dim As HBRUSH hBrush
	Dim As RECT rc
	Dim As LOGBRUSH tlb
	
	Select Case CBMSG
		Case WM_CREATE
			'Get a pointer to the TabPage class
			Dim As CTabPage Ptr pTabPage = AfxCTabPagePtr(GetParent(CBHNDL), 2)
			
			'Add a list box to the third page
			'Dim As HWND hListBox = pTabPage->AddControl("ListBox", CBHNDL, IDC_LISTBOX,"",15, 20, 161, 120)
			Dim As HWND hListBox = pTabPage->AddControl("ListBox", CBHNDL, IDC_LISTBOX)
			pTabPage->SetWindowPos(hListBox,NULL,15, 20, 161, 120, SWP_NOZORDER)
			'Fill the ListBox with some data
			Dim wszText$
			Dim As Long i
			For i = 1 To 9
				wszText$ = "Item " & Right$("00"&Str$(i),2)
				ListBox_AddString(hListBox,wszText$)
			Next
			ListBox_SetCurSel(hListBox, 0)
			Exit Function	
		Case WM_ERASEBKGND
			GetClientRect(CBHNDL,&rc)
			'Create custom brush
			tlb.lbStyle = BS_SOLID
			tlb.lbColor = 0x0000FF00
			tlb.lbHatch = 0
			hBrush = CreateBrushIndirect(&tlb)
			' Erase background
			FillRect((HDC) CBWPARAM, &rc, hBrush)
			DeleteObject(hBrush)
			FUNCTION = TRUE
			
	End Select
End Function

