' ########################################################################################
' Microsoft Windows
' File: CW_COMMCTRL_TaskDialogIndirect.bas
' Contents: Task dialog indirect example.
' Remarks: Requires the use of a manifest.
' Compiler: Ported to bc9Basic jcfuller 08/23/2016
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"		
$ONEXIT "TCLIB.BAT $FILE$"	
'==============================================================================
$HEADER
	#include <commctrl.h>					/*'For CWindow*/ 
	#include <shellapi.h>
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
	#pragma comment(lib,"shell32.lib")
$HEADER
'==============================================================================
$Include <Afx/CWindow.bi>
'==============================================================================
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin
	Raw As CWindow pWindow
	
	hWin = pWindow.Create(NULL, "Task Dialog", &WndProc)
	pWindow.SetClientSize(500, 320)
	pWindow.Center()

	' // Add the buttons
	pWindow.AddControl("Button",hWin , IDOK, "&Click me", 280, 270, 75, 23)
	pWindow.AddControl("Button",hWin , IDCANCEL, "&Exit", 380, 270, 75, 23)
	
	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
End Function	
'==============================================================================
CallBack Function WndProc()
	
	Select Case CBMSG
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
				Case IDOK
					If CBCTLMSG = BN_CLICKED Then
						Dim As TASKDIALOGCONFIG TaskConfig
						Dim t$
						t$ = "Hyperlink: <A HREF=" & DQ$ & "http://www.planetsquires.com/protect/forum/index.php?board=39.0" & DQ$ & ">Download link</A>"
						With TaskConfig
							.cbSize = SIZEOF(TASKDIALOGCONFIG)
							.hwndParent = CBHNDL
							.dwFlags = TDF_ENABLE_HYPERLINKS
							.pszWindowTitle = "CWindow"
							.pszMainIcon = TD_INFORMATION_ICON
							.dwCommonButtons = TDCBF_OK_BUTTON BOR TDCBF_CANCEL_BUTTON
							.pszMainInstruction = "CWindow"
							.pszContent = "An update for the CWindow framework has just been released. Click the hyperlink if you want to download it."
							.pszFooter = t$ 
							.pszFooterIcon = TD_WARNING_ICON
							.nDefaultButton = IDOK
							.pfCallback = &TaskDialogIndirectCallbackProc
						End With
						Dim As int nClickedButton
						Dim As HRESULT hr = TaskDialogIndirect(&TaskConfig, &nClickedButton, NULL, NULL)
					EndIf
			End Select
		Case WM_DESTROY
			PostQuitMessage(0)
			Exit Function
	End Select
End Function
'==============================================================================
FUNCTION TaskDialogIndirectCallbackProc(hwnd AS HWND, uNotification AS UINT, wParam AS WPARAM, _
                                        lParam AS LPARAM, dwRefData AS LONG_PTR) AS HRESULT

	Select Case uNotification
		Case TDN_HYPERLINK_CLICKED
			' // The lParam parameter of this message contains the url
			DIM AS HINSTANCE hInstance = ShellExecute(NULL, "open", (LPCWSTR)lParam, NULL, NULL, SW_SHOW)
			
			If hInstance <= (HINSTANCE) 32 Then
				FUNCTION = (HRESULT)(LONG_PTR) hInstance
			ELSE 
			 	FUNCTION = S_OK
			End If
	End Select
	Function = S_OK
End Function
 