' ########################################################################################
' Microsoft Windows
' File: CW_COMMCTRL_ToolbarDropDown.bas
' Contents: CWindow - Toolbar with a dropdown arrow
' Compiler: Ported to bc9Basic jcfuller 08/29/2016  
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"		
$ONEXIT "TCLIB.BAT $FILE$"	
'==============================================================================
$HEADER
	#include <commctrl.h>					/*'For CWindow*/ 
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
$HEADER
'==============================================================================
$USE USE_Toolbar_AddButton USE_Toolbar_AddSeparator USE_AfxStrParse USE_Toolbar_AutoSize
$USE USE_Toolbar_SetExtendedStyle
'==============================================================================
$Include <Afx/CWindow.bi>
$Include <Afx/AfxCtl.bi>
$Include <Afx/AfxStr.bi>
'==============================================================================
CONST IDC_TOOLBAR = 1001
ENUM 
	IDM_CUT = 28000
	IDM_COPY
	IDM_PASTE
	IDM_DELETE
	IDM_UNDO
	IDM_REDOW
	IDM_FILENEW
	IDM_FILEOPEN  
	IDM_FILESAVE
	IDM_PRINTPRE
	IDM_FIND
	IDM_REPLACE
	IDM_PROPERTIES
	IDM_PRINT
	IDM_HELP 
END ENUM
'------------------------------------------------------------------------------
Dim gTbList$
'==============================================================================
Sub AddToolbarButtons(hToolBar As HWND)
	' // Add a bitmap with the button images
	DIM AS TBADDBITMAP ttbab
	ttbab.hInst = HINST_COMMCTRL
	IF AfxIsProcessDPIAware() THEN
		ttbab.nID = IDB_STD_LARGE_COLOR
	ELSE
		ttbab.nID = IDB_STD_SMALL_COLOR
	END IF
	SendMessage(hToolBar, TB_ADDBITMAP, 0, (LPARAM) &ttbab)
	' // Add buttons to the toolbar
	Toolbar_AddButton( hToolBar, STD_CUT, IDM_CUT)
	Toolbar_AddButton( hToolBar, STD_COPY, IDM_COPY)
	Toolbar_AddButton( hToolBar, STD_PASTE, IDM_PASTE)
	Toolbar_AddButton( hToolBar, STD_DELETE, IDM_DELETE)
	Toolbar_AddSeparator( hToolBar)
	Toolbar_AddButton( hToolBar, STD_UNDO, IDM_UNDO)
	Toolbar_AddButton( hToolBar, STD_REDOW, IDM_REDOW)
	Toolbar_AddSeparator( hToolBar)
	Toolbar_AddButton( hToolBar, STD_FILENEW, IDM_FILENEW,0,BTNS_DROPDOWN)
	Toolbar_AddButton( hToolBar, STD_FILEOPEN, IDM_FILEOPEN)
	Toolbar_AddButton( hToolBar, STD_FILESAVE, IDM_FILESAVE)
	Toolbar_AddButton( hToolBar, STD_PRINTPRE, IDM_PRINTPRE)
	Toolbar_AddSeparator( hToolBar)
	Toolbar_AddButton( hToolBar, STD_FIND, IDM_FIND)
	Toolbar_AddButton( hToolBar, STD_REPLACE, IDM_REPLACE)
	Toolbar_AddSeparator( hToolBar)
	Toolbar_AddButton( hToolBar, STD_PROPERTIES, IDM_PROPERTIES)
	Toolbar_AddButton( hToolBar, STD_PRINT, IDM_PRINT)
	Toolbar_AddSeparator( hToolBar)
	Toolbar_AddButton( hToolBar, STD_HELP, IDM_HELP)
	
End Sub
'==============================================================================
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin,hToolBar
	Raw As CWindow pWindow
	gTbList$ = "Cut,Copy,Paste,Delete,Undo,Redo,FileNew,FileOpen,FileSave,PrintPre,Find,Replace,Properties,Print,Help"
	hWin = pWindow.Create(NULL, "CWindow with a toolbar", &WndProc)
	'Disable background erasing
	pWindow.ClassStyle(CS_DBLCLKS)
	'Set the client size
	pWindow.SetClientSize(520, 150)
	'Center the window
	pWindow.Center()

	'Add a button
	pWindow.AddControl("Button",hWin , IDCANCEL, "&Close")
	
	' // Add a tooolbar
	hToolBar = pWindow.AddControl("Toolbar",hWin , IDC_TOOLBAR)
	Toolbar_SetExtendedStyle(hToolBar, TBSTYLE_EX_DRAWDDARROWS)
	' // Add the toolbar buttons
	AddToolbarButtons( hToolBar)
	' // Size the toolbar
	SendMessage( hToolBar, TB_AUTOSIZE, 0, 0)
	
	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
End Function	
'==============================================================================
CallBack Function WndProc()
	Dim As Integer item
	Select Case CBMSG
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
				Case IDM_CUT To IDM_HELP
					item = CBCTL - 27999
					MessageBox(CBHNDL,"You have clicked " & AfxStrParse$(gTbList$,item),"ToolBar",MB_OK)
			End Select
		Case WM_NOTIFY
			' -------------------------------------------------------
			' Notification messages are handled here.
			' The TTN_GETDISPINFO message is sent by a ToolTip control
			' to retrieve information needed to display a ToolTip window.
			' ------------------------------------------------------
			DIM AS NMHDR PTR ptnmhdr            ' // Information about a notification message
			DIM AS NMTTDISPINFOW PTR ptttdi     ' // Tooltip notification message information
			DIM wszTooltipText$					' // Tooltip text
			ptnmhdr = (NMHDR PTR) CBLPARAM
			Select Case ptnmhdr->code
				Case TTN_GETDISPINFOW
					ptttdi = (NMTTDISPINFOW PTR) CBLPARAM
					ptttdi->hinst = NULL
					wszTooltipText$ = ""
					Select Case ptttdi->hdr.hwndFrom
						Case (HWND)SendMessage(CTLHNDL(IDC_TOOLBAR), TB_GETTOOLTIPS, 0, 0) 
							Select Case ptttdi->hdr.idFrom
								Case IDM_CUT        : wszTooltipText = "Cut"
								Case IDM_COPY       : wszTooltipText = "Copy"
								Case IDM_PASTE      : wszTooltipText = "Paste"
								Case IDM_UNDO       : wszTooltipText = "Undo"
								Case IDM_REDOW      : wszTooltipText = "Redo"
								Case IDM_DELETE     : wszTooltipText = "Delete"
								Case IDM_FILENEW    : wszTooltipText = "File New"
								Case IDM_FILEOPEN   : wszTooltipText = "File Open"
								Case IDM_FILESAVE   : wszTooltipText = "File Save"
								Case IDM_PRINTPRE   : wszTooltipText = "Print Preview"
								Case IDM_PROPERTIES : wszTooltipText = "Properties"
								Case IDM_HELP       : wszTooltipText = "Help"
								Case IDM_FIND       : wszTooltipText = "Find"
								Case IDM_REPLACE    : wszTooltipText = "Replace"
								Case IDM_PRINT      : wszTooltipText = "Print"
							End Select
							If Len(wszTooltipText) Then
								ptttdi->lpszText = wszTooltipText
							EndIf
					End Select
				Case TBN_DROPDOWN
					DIM AS TBNOTIFY PTR ptbn = (TBNOTIFY PTR)CBLPARAM
					Select Case ptbn->iItem
						Case IDM_FILENEW
							DIM AS RECT rc
							Dim As int iSelection
							SendMessage(ptbn->hdr.hwndFrom, TB_GETRECT, ptbn->iItem, (LPARAM) &rc)
							MapWindowPoints(ptbn->hdr.hwndFrom, HWND_DESKTOP, (LPPOINT) &rc, 2)
							DIM AS HMENU hPopupMenu = CreatePopupMenu()
							AppendMenu( hPopupMenu, MF_ENABLED, 10001, "Option 1")
							AppendMenu( hPopupMenu, MF_ENABLED, 10002, "Option 2")
							AppendMenu( hPopupMenu, MF_ENABLED, 10003, "Option 3")
							AppendMenu( hPopupMenu, MF_ENABLED, 10004, "Option 4")
							AppendMenu( hPopupMenu, MF_ENABLED, 10005, "Option 5")
							iSelection = TrackPopupMenu(hPopupMenu, TPM_RETURNCMD, rc.left, rc.bottom, 0, CBHNDL, NULL)
							If iSelection Then
								MessageBox(CBHNDL,"You have clicked Option " & Str$(iSelection - 10000),"ToolBar",MB_OK)
							EndIf
							DestroyMenu( hPopupMenu)
							
					End Select
			End Select
		Case WM_SIZE
			' // Update the size and position of the Toolbar control
			Toolbar_AutoSize(GetDlgItem(hWnd, IDC_TOOLBAR))
			' // Resize the buttons
			DIM AS CWindow PTR pWindow = AfxCWindowPtr(CBHNDL)
			IF pWindow THEN 
				pWindow->MoveWindow( CTLHNDL(IDCANCEL), pWindow->ClientWidth() - 95, pWindow->ClientHeight() - 35, 75, 23, TRUE)
			EndIf
			
		Case WM_DESTROY
			PostQuitMessage(0)
			Exit Function
	End Select
End Function
