' ########################################################################################
' Microsoft Windows
' File: CW_COMMCTRL_Toolbar.bas
' Contents: CWindow with a toolbar
' Compiler: Ported to bc9Basic jcfuller 08/29/2016  
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"		
$ONEXIT "TCLIB.BAT $FILE$"	
'==============================================================================
$HEADER
	#include <commctrl.h>					/*'For CWindow*/ 
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
$HEADER
'==============================================================================
$USE USE_Toolbar_AddButton USE_Toolbar_AddSeparator USE_AfxStrParse
'==============================================================================
$Include <Afx/CWindow.bi>
$Include <Afx/AfxCtl.bi>
$Include <Afx/AfxStr.bi>
'==============================================================================
CONST IDC_TOOLBAR = 1001
ENUM 
IDM_CUT = 28000
   IDM_COPY, IDM_PASTE, IDM_DELETE, IDM_UNDO, IDM_REDOW, IDM_FILENEW, IDM_FILEOPEN  
   IDM_FILESAVE, IDM_PRINTPRE, IDM_FIND, IDM_REPLACE,IDM_PROPERTIES,  IDM_PRINT, IDM_HELP 
END ENUM
'------------------------------------------------------------------------------
Dim gTbList$
'==============================================================================
Sub AddToolbarButtons(hToolBar As HWND)
	' // Add a bitmap with the button images
	DIM AS TBADDBITMAP ttbab
	ttbab.hInst = HINST_COMMCTRL
	IF AfxIsProcessDPIAware() THEN
		ttbab.nID = IDB_STD_LARGE_COLOR
	ELSE
		ttbab.nID = IDB_STD_SMALL_COLOR
	END IF
	SendMessage(hToolBar, TB_ADDBITMAP, 0, (LPARAM) &ttbab)
	' // Add buttons to the toolbar
	Toolbar_AddButton( hToolBar, STD_CUT, IDM_CUT)
	Toolbar_AddButton( hToolBar, STD_COPY, IDM_COPY)
	Toolbar_AddButton( hToolBar, STD_PASTE, IDM_PASTE)
	Toolbar_AddButton( hToolBar, STD_DELETE, IDM_DELETE)
	Toolbar_AddSeparator( hToolBar)
	Toolbar_AddButton( hToolBar, STD_UNDO, IDM_UNDO)
	Toolbar_AddButton( hToolBar, STD_REDOW, IDM_REDOW)
	Toolbar_AddSeparator( hToolBar)
	Toolbar_AddButton( hToolBar, STD_FILENEW, IDM_FILENEW)
	Toolbar_AddButton( hToolBar, STD_FILEOPEN, IDM_FILEOPEN)
	Toolbar_AddButton( hToolBar, STD_FILESAVE, IDM_FILESAVE)
	Toolbar_AddButton( hToolBar, STD_PRINTPRE, IDM_PRINTPRE)
	Toolbar_AddSeparator( hToolBar)
	Toolbar_AddButton( hToolBar, STD_FIND, IDM_FIND)
	Toolbar_AddButton( hToolBar, STD_REPLACE, IDM_REPLACE)
	Toolbar_AddSeparator( hToolBar)
	Toolbar_AddButton( hToolBar, STD_PROPERTIES, IDM_PROPERTIES)
	Toolbar_AddButton( hToolBar, STD_PRINT, IDM_PRINT)
	Toolbar_AddSeparator( hToolBar)
	Toolbar_AddButton( hToolBar, STD_HELP, IDM_HELP)
	
End Sub
'==============================================================================
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin,hToolBar
	Raw As CWindow pWindow
	gTbList$ = "Cut,Copy,Paste,Delete,Undo,Redo,FileNew,FileOpen,FileSave,PrintPre,Find,Replace,Properties,Print,Help"
	hWin = pWindow.Create(NULL, "CWindow with a toolbar", &WndProc)
	'Disable background erasing
	pWindow.ClassStyle(CS_DBLCLKS)
	'Set the client size
	pWindow.SetClientSize(510, 150)
	'Center the window
	pWindow.Center()

	'Add a button
	pWindow.AddControl("Button",hWin , IDCANCEL, "&Close")
	
	' // Add a tooolbar
	hToolBar = pWindow.AddControl("Toolbar",hWin , IDC_TOOLBAR)
	' // Add the toolbar buttons
	AddToolbarButtons( hToolBar)
	' // Size the toolbar
	SendMessage( hToolBar, TB_AUTOSIZE, 0, 0)
	
	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
End Function	
'==============================================================================
CallBack Function WndProc()
	Dim As Integer item
	Select Case CBMSG
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
				Case IDM_CUT To IDM_HELP
					item = CBCTL - 27999
					MessageBox(CBHNDL,"You have clicked " & AfxStrParse$(gTbList$,item),"ToolBar",MB_OK)
			End Select
		Case WM_DESTROY
			PostQuitMessage(0)
			Exit Function
	End Select
End Function
