' ########################################################################################
' Microsoft Windows
' File: CW_COMMCTRL_Trackbar.bas - Template
' Contents: Demonstrates the use of the Trackbar control.
' Compiler: Ported to bc9Basic jcfuller 08/29/2016  
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"		
$ONEXIT "TCLIB.BAT $FILE$"	
'==============================================================================
$HEADER
	#include <commctrl.h>					/*'For CWindow*/ 
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
$HEADER
'==============================================================================
$USE USE_Trackbar_SetRangeMin USE_Trackbar_SetRangeMax USE_Trackbar_SetPageSize
'==============================================================================
$Include <Afx/CWindow.bi>
$Include <Afx/AfxCtl.bi>
'==============================================================================
CONST IDC_TRACKBAR = 1001
'==============================================================================
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin,hTrackBar
	Raw As CWindow pWindow
	
	hWin = pWindow.Create(NULL, "Trackbar control", &WndProc)
	pWindow.Center()

	' // Add an Trackbar control
	hTrackBar = pWindow.AddControl("Trackbar",hWin , IDC_TRACKBAR, "", 75, 60, 200, 32)
	' // Set the range values
	Trackbar_SetRangeMin(hTrackBar, 0, TRUE)
	Trackbar_SetRangeMax(hTrackBar, 20, TRUE)
	' // Set the page size
	Trackbar_SetPageSize(hTrackBar, 1)
	
	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
End Function	
'==============================================================================
CallBack Function WndProc()
	Select Case CBMSG
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
			End Select
		Case WM_HSCROLL
			If GetDlgCtrlID((HWND)CBLPARAM) = IDC_TRACKBAR Then
				' Put your code here
				' The LOWORD of wParam specifies a scroll bar value that indicates the user's scrolling request.
				' The HIWORD specifies the current position of the scroll box if the LOWORD is SB_THUMBPOSITION
				' or SB_THUMBTRACK; otherwise, this word is not used.
			EndIf
			Exit Function
		Case WM_DESTROY
			PostQuitMessage(0)
			Exit Function
	End Select
End Function
