' ########################################################################################
' Microsoft Windows
' File: CW_COMMCTRL_TreeView.bas
' Contents: Template - CWindow with a TreeView
' Compiler: Ported to bc9Basic jcfuller 08/29/2016  
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"		
$ONEXIT "TCLIB.BAT $FILE$"	
'==============================================================================
$USE USE_TreeView_AddRootItem USE_TreeView_AddItem USE_TreeView_AppendItem
$USE USE_TreeView_GetItemText
'==============================================================================
$HEADER
	#include <commctrl.h>					/*'For CWindow*/ 
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
$HEADER
'==============================================================================
$Include <Afx/CWindow.bi>
$Include <Afx/AfxCtl.bi>
'==============================================================================
CONST IDC_TREEVIEW = 1001
'==============================================================================
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin,hTreeView
	Raw As CWindow pWindow
	
	hWin = pWindow.Create(NULL, "CWindow with a TreeView", &WndProc)
	pWindow.ClassStyle(CS_DBLCLKS)   ' // Change the window style to avoid flicker
	pWindow.SetClientSize(320, 370)
	pWindow.Center()

	' // Add a TreeView
	hTreeView = pWindow.AddControl("TreeView",hWin , IDC_TREEVIEW, "")
	pWindow.SetWindowPos( hTreeView, NULL, 8, 8, 300, 320, SWP_NOZORDER)
	
	' // Add items to the TreeView
	DIM AS HTREEITEM hRoot, hNode, hItem
	' // Create the root node
	hRoot = TreeView_AddRootItem(hTreeView, "Root")
	' // Create a node
	hNode = TreeView_AppendItem(hTreeView, hRoot, "Node 1")
	' // Insert items in the node
	hItem = TreeView_AppendItem(hTreeView, hNode, "Node 1 Item 1")
	hItem = TreeView_AppendItem(hTreeView, hNode, "Node 1 Item 2")
	hItem = TreeView_AppendItem(hTreeView, hNode, "Node 1 Item 3")
	hItem = TreeView_AppendItem(hTreeView, hNode, "Node 1 Item 4")
	hItem = TreeView_AppendItem(hTreeView, hNode, "Node 1 Item 5")
	hItem = TreeView_AppendItem(hTreeView, hNode, "Node 1 Item 6")
	' // Expand the node
	TreeView_Expand(hTreeView, hNode, TVM_EXPAND)

	' // Create another node
	hNode = TreeView_AppendItem(hTreeView, hRoot, "Node 2")
	' // Insert items in the node
	hItem = TreeView_AppendItem(hTreeView, hNode, "Node 2 Item 1")
	hItem = TreeView_AppendItem(hTreeView, hNode, "Node 2 Item 2")
	hItem = TreeView_AppendItem(hTreeView, hNode, "Node 2 Item 3")
	hItem = TreeView_AppendItem(hTreeView, hNode, "Node 2 Item 4")
	hItem = TreeView_AppendItem(hTreeView, hNode, "Node 2 Item 5")
	hItem = TreeView_AppendItem(hTreeView, hNode, "Node 2 Item 6")
	' // Expand the node
	TreeView_Expand(hTreeView, hNode, TVM_EXPAND)
	
	' // Create another node
	hNode = TreeView_AppendItem(hTreeView, hRoot, "Node 3")
	' // Insert items in the node
	hItem = TreeView_AppendItem(hTreeView, hNode, "Node 3 Item 1")
	hItem = TreeView_AppendItem(hTreeView, hNode, "Node 3 Item 2")
	hItem = TreeView_AppendItem(hTreeView, hNode, "Node 3 Item 3")
	hItem = TreeView_AppendItem(hTreeView, hNode, "Node 3 Item 4")
	hItem = TreeView_AppendItem(hTreeView, hNode, "Node 3 Item 5")
	hItem = TreeView_AppendItem(hTreeView, hNode, "Node 3 Item 6")
	' // Expand the node
	TreeView_Expand(hTreeView, hNode, TVM_EXPAND)
	
	' // Create another node
	hNode = TreeView_AppendItem(hTreeView, hRoot, "Node 4")
	' // Insert items in the node
	hItem = TreeView_AppendItem(hTreeView, hNode, "Node 4 Item 1")
	hItem = TreeView_AppendItem(hTreeView, hNode, "Node 4 Item 2")
	hItem = TreeView_AppendItem(hTreeView, hNode, "Node 4 Item 3")
	hItem = TreeView_AppendItem(hTreeView, hNode, "Node 4 Item 4")
	hItem = TreeView_AppendItem(hTreeView, hNode, "Node 4 Item 5")
	hItem = TreeView_AppendItem(hTreeView, hNode, "Node 4 Item 6")
	' // Expand the node
	TreeView_Expand(hTreeView, hNode, TVM_EXPAND)
	
	' // Expand the root node
	TreeView_Expand(hTreeView, hRoot, TVE_EXPAND)

	' // Add a cancel button
	pWindow.AddControl("Button",hWin , IDCANCEL, "Dismiss", 233, 338, 75, 23)

	
	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
End Function	
'==============================================================================
CallBack Function WndProc()
	Select Case CBMSG
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
			End Select
		Case WM_NOTIFY
			DIM AS NMHDR PTR ptnmhdr = (NMHDR PTR)CBLPARAM
			Select Case ptnmhdr->idFrom
				Case IDC_TREEVIEW
					IF ptnmhdr->code = NM_DBLCLK THEN
						' // Retrieve the handle of the TreeView
						DIM AS HWND hTreeView = CTLHNDL(IDC_TREEVIEW)
						' // Retrieve the selected item
						DIM AS HTREEITEM hItem = TreeView_GetSelection(hTreeView)
						' // Retrieve the text of the selected item
						Raw As char wszText[260] 
						TreeView_GetItemText(hTreeView, hItem, wszText,260 )
						MessageBox(CBHNDL, wszText, "", MB_OK)
						Exit Function
					END IF
			End Select
		Case WM_DESTROY
			PostQuitMessage(0)
			Exit Function
	End Select
End Function
