' ########################################################################################
' Microsoft Windows
' File: CW_COMMCTRL_UpDown.bas
' Contents: Demonstrates the use of the UpDown control.
' Compiler: Ported to bc9Basic jcfuller 08/29/2016  
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"		
$ONEXIT "TCLIB.BAT $FILE$"	
'==============================================================================
$HEADER
	#include <commctrl.h>					/*'For CWindow*/ 
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
$HEADER
'==============================================================================
$USE USE_UpDown_SetBuddy USE_UpDown_SetBase USE_UpDown_SetRange32 USE_UpDown_SetPos32
'==============================================================================
$Include <Afx/CWindow.bi>
'$Include <bc9Lib.bi>
'$Include <Afx/AfxMenu.bi>
'$Include <Afx/AfxTime.bi>
'$Include <Afx/AfxPath.bi>
$Include <Afx/AfxCtl.bi>
'==============================================================================
CONST IDC_UPDOWN = 1001
CONST IDC_EDIT = 1002
'==============================================================================
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin,hEdit,hUpDown
	Raw As CWindow pWindow
	
	hWin = pWindow.Create(NULL, "UpDown control", &WndProc)
	pWindow.Center()
	' // Add a label control
	pWindow.AddControl("Label",hWin , -1, "How many lines?", 80, 55, 100, 23)
	' // Add an edit control
	hEdit = pWindow.AddControl("Edit",hWin , IDC_EDIT, "", 200, 55, 50, 23)
	' // Add an UpDown control (the size and position will be automatically adjusted to the buddy control)
	hUpDown = pWindow.AddControl("UpDown",hWin , IDC_UPDOWN)
	' // Set the edit control as budy of the updown control
	UpDown_SetBuddy(hUpDown, hEdit)
	' // Set the base
	UpDown_SetBase(hUpDown, 10)
	' // Set the range
	UpDown_SetRange32(hUpDown, 0, 100)
	' // Set the default initial value
	UpDown_SetPos32(hUpDown, 1)
	' // Set the focus
	SetFocus( hEdit)

	
	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
End Function	
'==============================================================================
CallBack Function WndProc()
	Select Case CBMSG
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
			End Select
		Case WM_NOTIFY
			DIM AS NMHDR PTR ptnmhdr = (NMHDR PTR)CBLPARAM
			Select Case ptnmhdr->idFrom
				Case IDC_UPDOWN
					IF ptnmhdr->code = UDN_DELTAPOS THEN
					  ' Put your code here, e.g.
					  ' DIM AS NMUPDOWN PTR ptnmud = (NMUPDOWN PTR)CBLPARAM
					  ' ptnmud->iPos : Up-down control's current position.
					  ' ptnmud->iDelta : proposed change in the up-down control's position.
					  ' Return nonzero to prevent the change in the control's position, or zero to allow the change.
					END IF
               EXIT FUNCTION
			End Select
		Case WM_DESTROY
			PostQuitMessage(0)
			Exit Function
	End Select
End Function
