' ########################################################################################
' Microsoft Windows
' File: CW_GDI_AltWind.bas
' This program is a translation/adaptation of the ALTWIND.C-Alternate and Winding Fill
' Modes Program  Charles Petzold, 1998, described and analysed in Chapter 5 of the book
' Programming Windows, 5th Edition.
' Displays the figure twice, once using the ALTERNATE filling mode and then using WINDING.
' Compiler: Ported to bc9Basic jcfuller 08/23/2016  
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"		
$ONEXIT "TCLIB.BAT $FILE$"	
'==============================================================================
$HEADER
	#include <commctrl.h>					/*'For CWindow*/ 
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
$HEADER
'==============================================================================
$Include <Afx/CWindow.bi>
'==============================================================================
Function WinMain()

	Dim As HWND hWin
	Raw As CWindow pWindow
	
	hWin = pWindow.Create(NULL, "Alternate and Winding Fill Modes", &WndProc)
	pWindow.Center()

	' // Display the window
	ShowWindow(hWin, CmdShow)
	UpdateWindow(hWin)

	' // Dispatch Windows messages
	DIM AS MSG uMsg
	WHILE (GetMessage(&uMsg, NULL, 0, 0) <> FALSE)
		TranslateMessage(&uMsg)
		DispatchMessage(&uMsg)
	WEND
	FUNCTION = uMsg.wParam
End Function	
'==============================================================================
CallBack Function WndProc()
	Static As Long cxClient,cyClient
	Static As POINT aptFigure[10] = {10, 70, 50, 70, 50, 10, 90, 10, 90, 50, 30, 50, 30, 90, 70, 90, 70, 30, 10, 30}
	
	Select Case CBMSG
		Case WM_SIZE
			cxClient = LOWORD(CBLPARAM)
			cyClient = HIWORD(CBLPARAM)
			Exit Function
		Case WM_PAINT
			' // Do the painting
			DIM AS PAINTSTRUCT ps
			DIM AS HDC hdc = BeginPaint(CBHNDL, &ps)
			SelectObject(hdc, GetStockObject(GRAY_BRUSH))
			DIM  AS LONG i
			Dim As POINT apt[10]
			FOR i = 0 TO 9
				apt[i].x = cxClient * aptFigure[i].x / 200
				apt[i].y = cyClient * aptFigure[i].y / 100
			NEXT
			SetPolyFillMode( hdc, ALTERNATE)
			Polygon( hdc, &apt[0], 10)
			FOR i = 0 TO 9
				apt[i].x = apt[i].x + cxClient / 2
			NEXT
			SetPolyFillMode( hdc, WINDING)
			Polygon( hdc, &apt[0], 10)
			EndPaint(CBHNDL, &ps)
			EXIT FUNCTION
		Case WM_KEYDOWN
			' // If ESC key pressed, close the application sending an WM_CLOSE message
			SELECT CASE LOWORD(wParam)
				CASE VK_ESCAPE
				SendMessage(CBHNDL, WM_CLOSE, 0, 0)
				EXIT FUNCTION
			END SELECT
			
		Case WM_DESTROY
			PostQuitMessage(0)
			Exit Function
	End Select
End Function
