' ########################################################################################
' Microsoft Windows
' File: CW_GDI_EMF1.bas
' Contents: Creates and displays an enhanced metafile with a fairly minimal amount of distraction.
' This program is a translation/adaptation of EMF1.C -- Enhanced Metafile Demo #1
'  Charles Petzold, 1998, described and analysed in Chapter 18 of the book Programming
' Windows, 5th Edition.
' Compiler: Ported to bc9Basic jcfuller 09/02/2016
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"		
$ONEXIT "TCLIB.BAT $FILE$"	
'==============================================================================
$HEADER
	#include <commctrl.h>					/*'For CWindow*/ 
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
$HEADER
'==============================================================================
$Include <Afx/CWindow.bi>
'==============================================================================
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin
	Raw As CWindow pWindow
	
	hWin = pWindow.Create(NULL, "Enhanced Metafile Demo #1", &WndProc)
	pWindow.Brush( (HBRUSH)GetStockObject(WHITE_BRUSH))
	pWindow.SetClientSize(400, 250)
	pWindow.Center()

	
	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
End Function	
'==============================================================================
CallBack Function WndProc()
	Static As HENHMETAFILE hemf				' // Handle to the enhanced metafile
	Dim As HDC hdc							' // Handle to the device context of the window
	Dim As HDC hdcEMF						' // Handle to the device context for the enhanced metafile
	Dim As PAINTSTRUCT ps
	Dim As RECT rc
	Select Case CBMSG
		Case WM_CREATE
			' // Creates a device context for a memory-based enhanced-format metafile
			hdcEMF = CreateEnhMetaFile(NULL, NULL, NULL, NULL)
			' // Draws a rectangle and two lines using GDI
			Rectangle(hdcEMF, 100, 100, 200, 200)
			MoveToEx(hdcEMF, 100, 100, NULL)
			LineTo(hdcEMF, 200, 200)
			MoveToEx(hdcEMF, 200, 100, NULL)
			LineTo(hdcEMF, 100, 200)
			' // Closes an enhanced-metafile device context and returns
			' // a handle that identifies an enhanced-format metafile.
			hemf = CloseEnhMetaFile(hdcEMF)
			EXIT FUNCTION
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
			End Select
		Case WM_PAINT
			' // Displays the picture stored in the specified enhanced-format metafile
			hdc = BeginPaint(CBHNDL, &ps)
			GetClientRect(CBHNDL, &rc)
			rc.left   =     rc.right  / 4
			rc.right  = 3 * rc.right  / 4
			rc.top    =     rc.bottom / 4
			rc.bottom = 3 * rc.bottom / 4
			PlayEnhMetaFile(hdc, hemf, &rc)
			EndPaint(CBHNDL, &ps)
			EXIT FUNCTION
		Case WM_DESTROY
			' // Delete the enhanced metafile
			DeleteEnhMetaFile(hemf)
			PostQuitMessage(0)
			Exit Function
	End Select
End Function
