' ########################################################################################
' Microsoft Windows
' File: CW_GDI_HelloWorldGradientFill.bas
' Contents: CWindow Hello Word with gradient example (GradientFill)
' Compiler: Ported to bc9Basic jcfuller
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"		
$ONEXIT "TCLIB.BAT $FILE$"	
'==============================================================================
$HEADER
	#include <commctrl.h>					/*'For CWindow*/ 
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
	#pragma comment(lib,"Msimg32.lib")		/*'For GradientFill */
$HEADER
'==============================================================================
$Include <Afx/CWindow.bi>
'==============================================================================
Sub DrawGradient(hwnd As HWND,hDC As HDC)
	DIM As RECT rc
	Dim As TRIVERTEX vertex[2]
	GetClientRect(hwnd,&rc)
	vertex[0].x      = 0
	vertex[0].y      = 0
	vertex[0].Red    = 0xFF00
	vertex[0].Green  = 0xFF00
	vertex[0].Blue   = 0x0000
	vertex[0].Alpha  = 0x0000
	
	vertex[1].x      = rc.right - rc.left
	vertex[1].y      = rc.bottom - rc.top
	vertex[1].Red    = 0x8000
	vertex[1].Green  = 0x0000
	vertex[1].Blue   = 0x0000
	vertex[1].Alpha  = 0x0000
	
	DIM AS GRADIENT_RECT gRect
	gRect.UpperLeft  = 0
	gRect.LowerRight = 1
	
	GradientFill( hDC, &vertex[0], 2, &gRect, 1, GRADIENT_FILL_RECT_H)
	
End Sub
'==============================================================================
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin
	Raw As CWindow pWindow
	
	hWin = pWindow.Create(NULL, "CWindow Hello World with gradient", &WndProc)
	pWindow.Brush((HBRUSH) GetStockObject(WHITE_BRUSH))
	pWindow.SetClientSize(500, 320)
	pWindow.Center()

	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
End Function	
'==============================================================================
CallBack Function WndProc()
	Static As HFONT hNewFont
	Select Case CBMSG
		Case WM_CREATE
			' // Get a pointer to the CWindow class from the CREATESTRUCT structure
			DIM AS CWindow PTR pWindow = AfxCWindowPtr(CBLPARAM)
			' // Create a new font scaled according the DPI ratio
			If pWindow->DPI() <> 96 Then
				hNewFont = pWindow->CreateFont("Tahoma", 9)
			EndIf
			EXIT FUNCTION
			
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
			End Select
		Case WM_PAINT
			' // Draw the text
			DIM AS PAINTSTRUCT ps
			Dim As HFONT hOldFont
			DIM AS HDC  hDC = BeginPaint(CBHNDL, &ps)
			If hNewFont Then
				hOldFont = (HFONT) SelectObject(hDC, hNewFont)
			EndIf
			DIM AS RECT rc
			GetClientRect(CBHNDL, &rc)
			SetBkMode( hDC, TRANSPARENT)
			SetTextColor(hDC, 0xFFFFFF)
			DrawText( hDC, "Hello, World!", -1, &rc, DT_SINGLELINE BOR DT_CENTER BOR DT_VCENTER)
			If hNewFont Then
				SelectObject(hDC, (HFONT) hOldFont)
			EndIf
			EndPaint(CBHNDL, &ps)
			FUNCTION = TRUE
		Case WM_ERASEBKGND
			' // Draw the gradient
			DIM AS HDC hDC =(HDC)CBWPARAM
			DrawGradient(cbhndl, hDC)
			FUNCTION = TRUE
			
		Case WM_DESTROY
			PostQuitMessage(0)
			Exit Function
	End Select
End Function
