' ########################################################################################
' Microsoft Windows
' File: CW_GDI_HelloWord.bas
' Contents: CWindow Hello Word example
' Compiler: Ported to bc9Basic jcfuller 09/02/2016
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"		
$ONEXIT "TCLIB.BAT $FILE$"	
'==============================================================================
$HEADER
	#include <commctrl.h>					/*'For CWindow*/ 
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
$HEADER
'==============================================================================
$Include <Afx/CWindow.bi>
'==============================================================================
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin
	Raw As CWindow pWindow
	
	hWin = pWindow.Create(NULL, "CWindow Hello World", &WndProc)
	pWindow.Brush((HBRUSH) GetStockObject(WHITE_BRUSH))
	pWindow.SetClientSize(500, 320)	
	pWindow.Center()
	
	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
End Function	
'==============================================================================
CallBack Function WndProc()
	Static As HFONT hNewFont
	
	Select Case CBMSG
		Case WM_CREATE
			' // Get a pointer to the CWindow class from the CREATESTRUCT structure
			DIM AS CWindow PTR pWindow = AfxCWindowPtr(lParam)
			' // Create a new font scaled according the DPI ratio
			IF pWindow->DPI() <> 96 Then
				hNewFont = pWindow->CreateFont("Tahoma", 9)
			EndIf
			EXIT FUNCTION
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
			End Select
		Case WM_PAINT
			DIM AS RECT rc
			Dim AS PAINTSTRUCT ps
			Dim AS HDC hDC
			Dim AS HFONT hOldFont
			hDC = BeginPaint(CBHNDL, &ps)
			IF hNewFont THEN
				hOldFont = (HFONT) SelectObject(hDC, hNewFont)
			EndIf
			GetClientRect(CBHNDL, &rc)
			DrawText(hDC, "Hello, World!", -1, &rc, DT_SINGLELINE BOR DT_CENTER BOR DT_VCENTER)
			If hNewFont Then 
				SelectObject(hDC, (HFONT) hOldFont)
			EndIf
			EndPaint(CBHNDL, &ps)
			EXIT FUNCTION
		Case WM_DESTROY
			' // Destroy the new font
			If hNewFont Then
				DeleteObject((HGDIOBJ) hNewFont)
			EndIf
			PostQuitMessage(0)
			Exit Function
	End Select
End Function
