' ########################################################################################
' Microsoft Windows
' File: CW_GDI_HelloWordGradient_HDPI.bas
' Contents: CWindow Hello Word with gradient example (High DPI)
' Compiler: Ported to bc9Basic jcfuller
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"		
$ONEXIT "TCLIB.BAT $FILE$"	
'==============================================================================
$HEADER
	#include <commctrl.h>					/*'For CWindow*/ 
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
$HEADER
'==============================================================================
$Include <Afx/CWindow.bi>

'==============================================================================
SUB DrawGradient ( hDC AS HDC)

	DIM AS RECT rcFill
	DIM AS RECT rcClient
	Raw AS Single fStep
	DIM AS HBRUSH hBrush
	DIM AS LONG lOnBand

	GetClientRect(WindowFromDC(hDC), &rcClient)
	fStep = (rcClient.bottom / 200.0)
	FOR lOnBand = 0 TO 199
		SetRect(&rcFill, 0, lOnBand * fStep, rcClient.right + 1, (lOnBand + 1) * fStep)
		hBrush = CreateSolidBrush(RGB(0, 0, (255 - lOnBand)))
		FillRect(hDC, &rcFill, hBrush)
		DeleteObject( hBrush)
	NEXT lOnBand

END SUB

'==============================================================================
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin
	Raw As CWindow pWindow
	
	hWin = pWindow.Create(NULL, "CWindow Hello World with gradient", &WndProc)
	pWindow.Brush((HBRUSH) GetStockObject(WHITE_BRUSH))
	pWindow.SetClientSize(500, 320)
	pWindow.Center()

	' // Add two buttons without position or size (they will be resized in the WM_SIZE message).
	pWindow.AddControl("Button", hWin, IDOK,     "&Ok")
	pWindow.AddControl("Button", hWin, IDCANCEL, "&Quit")

	
	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
End Function	
'==============================================================================
CallBack Function WndProc()
	Static As HFONT hNewFont
	Select Case CBMSG
		Case WM_CREATE 
			' // Get a pointer to the CWindow class from the CREATESTRUCT structure
			DIM AS CWindow PTR pWindow = AfxCWindowPtr(CBLPARAM)
			' // Create a new font scaled according the DPI ratio
			If pWindow->DPI() <> 96 Then
				hNewFont = pWindow->CreateFont("Tahoma", 9)
			EndIf
			EXIT FUNCTION
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
			End Select
		Case WM_PAINT
			' // Draw the text
			DIM AS PAINTSTRUCT ps
			Dim As HFONT hOldFont
			DIM AS HDC  hDC = BeginPaint(CBHNDL, &ps)
			If hNewFont Then
				hOldFont = (HFONT) SelectObject(hDC, hNewFont)
			EndIf
			DIM AS RECT rc
			GetClientRect(CBHNDL, &rc)
			SetBkMode( hDC, TRANSPARENT)
			SetTextColor(hDC, 0xFFFFFF)
			DrawText( hDC, "Hello, World!", -1, &rc, DT_SINGLELINE BOR DT_CENTER BOR DT_VCENTER)
			If hNewFont Then
				SelectObject(hDC, (HFONT) hOldFont)
			EndIf
			EndPaint(CBHNDL, &ps)
			FUNCTION = TRUE
		Case WM_ERASEBKGND
			' // Draw the gradient
			DIM AS HDC hDC =(HDC)CBWPARAM
			DrawGradient( hDC)
			FUNCTION = TRUE
		Case WM_SIZE
			IF CBWPARAM <> SIZE_MINIMIZED Then
				' // Resize the buttons
				DIM AS CWindow PTR pWindow = AfxCWindowPtr(CBHNDL)
				pWindow->MoveWindow(CTLHNDL(IDOK), pWindow->ClientWidth() - 185, pWindow->ClientHeight() - 35, 75, 23, TRUE)
				pWindow->MoveWindow(CTLHNDL(IDCANCEL), pWindow->ClientWidth() - 95, pWindow->ClientHeight() - 35, 75, 23, TRUE)
			END IF
			
		Case WM_DESTROY
			' // Destroy the new font
			If hNewFont Then
				DeleteObject((HGDIOBJ) hNewFont)
			EndIf
			
			PostQuitMessage(0)
			Exit Function
	End Select
End Function
