' ########################################################################################
' Microsoft Windows
' File: CW_GDI_PaintDesktop.bas
' Contents: PaintDesktop demo
' This example uses the PaintDesktop function to fill the clipping region in the
' specified device context with the desktop pattern or wallpaper.
' Compiler: Ported to bc9Basic jcfuller 09/02/2016
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"		
$ONEXIT "TCLIB.BAT $FILE$"	
'==============================================================================
$HEADER
	#include <commctrl.h>					/*'For CWindow*/ 
	#pragma comment(lib,"comctl32.lib")		/*'For CWindow*/
	#pragma comment(lib,"gdi32.lib")		/*'For CWindow*/
	#pragma comment(lib,"advapi32.lib")		/*'For DPI aware check*/
$HEADER
'==============================================================================
$Include <Afx/CWindow.bi>
'==============================================================================
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin
	Raw As CWindow pWindow
	
	hWin = pWindow.Create(NULL, "PaintDesktop demo", &WndProc)
	pWindow.SetClientSize(500, 320)
	pWindow.Center()

	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
End Function	
'==============================================================================
CallBack Function WndProc()
	Select Case CBMSG
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
			End Select
		Case WM_PAINT
			DIM AS PAINTSTRUCT ps
			DIM AS HDC hdc = BeginPaint(CBHNDL, &ps)
			PaintDesktop(hdc)
			EndPaint(CBHNDL, &ps)
			EXIT FUNCTION
		Case WM_ERASEBKGND
			DIM AS HDC hdc = (HDC)CBWPARAM
			PaintDesktop(hdc)
			FUNCTION = TRUE
			
		Case WM_DESTROY
			PostQuitMessage(0)
			Exit Function
	End Select
End Function
