' ########################################################################################
' Microsoft Windows
' File: CW_Layout.bas
' Contents: Demonstrates the use of the Layout manager
' Compiler: Ported to bc9Basic jcfuller 09/02/2016
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'Display the Anchor.gif file In the Help Folder for Anchor Constants
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"					'140,288 bytes
$ONEXIT "TCLIB.BAT $FILE$"								' 23,552 bytes
'==============================================================================
$HEADER
	#include <commctrl.h>					// ' For CWindow  
	#pragma comment(lib,"comctl32.lib")		// ' For CWindow
	#pragma comment(lib,"gdi32.lib")		// ' For CWindow
	#pragma comment(lib,"advapi32.lib")		// ' For DPI aware check
$HEADER
'==============================================================================
$USE USE_AfxAddWindowExStyle USE_CreateArr
'==============================================================================
$Include <Afx/CWindow.bi>
$Include <bc9Lib.bi>
$Include <Afx/CLayout.bi>
'==============================================================================
ENUM As AFX_USERDATA
   AFX_LAYOUTPTRIDX = 0
END ENUM
'------------------------------------------------------------------------------
ENUM
   IDC_EDIT1 = 1001
   IDC_EDIT2
   IDC_GROUPBOX
   IDC_COMBOBOX
END ENUM
'------------------------------------------------------------------------------
CONST WINWIDTH = 646
CONST WINHEIGHT = 310
'==============================================================================
Function WinMain()
	Dim As int iRetVal
	Dim As HWND hWin
	Raw As CWindow pWindow
	
	pWindow.SetFont("Tahoma", 12)
	hWin = pWindow.Create(NULL, "Layout Sizing Example", &WndProc,0,0,WINWIDTH,WINHEIGHT)
	
	'This reduces flickering when resizing (especially the group box)
	AfxAddWindowExStyle(hWin,WS_EX_COMPOSITED) 
	pWindow.Center()
	'  Add an Edit control
	DIM AS HWND hEdit = pWindow.AddControl("Edit",hWin , IDC_EDIT1, "", 16, 16, 399,24)
	'  Add a multiline Edit control
	pWindow.AddControl("EditMultiline",hWin , IDC_EDIT2, "", 16, 54, 397, 146)
	SetFocus( hEdit)
	'  Add more controls
	pWindow.AddControl("GroupBox",hWin , IDC_GROUPBOX, "GroupBox", 452, 6, 144, 210)
	pWindow.AddControl("Button",hWin , IDCANCEL, "Dismiss", 322, 216, 91, 40)
	' Add a combobox control
	DIM AS HWND hComboBox = pWindow.AddControl("ComboBox",hWin , IDC_COMBOBOX, "", 473, 30, 105, 160)
	' Fill the control with some data
	DIM AS LONG i 
	Dim wszText$
	FOR i = 1 TO 9
		wszText$ = "Item " & RIGHT$("00" & STR$(i), 2)
		SendMessage(hComboBox, CB_ADDSTRING, 0, wszText$)
	NEXT

	' // Anchor the controls
	Raw As CLayout pLayout(hWin)
	pWindow.UserData(AFX_LAYOUTPTRIDX,(LONG_PTR) &pLayout)
	With pLayout 
		.AnchorControl(IDC_EDIT1, AFX_ANCHOR_WIDTH)
		.AnchorControl(IDC_EDIT2, AFX_ANCHOR_HEIGHT_WIDTH)
		.AnchorControl(IDCANCEL, AFX_ANCHOR_BOTTOM_RIGHT)
		.AnchorControl(IDC_GROUPBOX, AFX_ANCHOR_HEIGHT_RIGHT)
		.AnchorControl(IDC_COMBOBOX, AFX_ANCHOR_RIGHT)
	End With
	iRetVal = pWindow.Do_Events(CmdShow)
	Function = iRetVal
End Function	
'==============================================================================
CallBack Function WndProc()
	Select Case CBMSG
		Case WM_COMMAND
			Select Case CBCTL
				Case IDCANCEL
					If CBCTLMSG = BN_CLICKED Then
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					EndIf
			End Select
		Case WM_GETMINMAXINFO
			' Set the pointer to the address of the MINMAXINFO structure
			' retrieved from in the lParam of Callback
			Dim As MINMAXINFO Ptr ptmmi = (MINMAXINFO PTR)CBLPARAM
			' Set the minimum and maximum sizes that can be produced by dragging the borders of the window
			Dim As CWindow Ptr pWindow = AfxCWindowPtr(CBHNDL)
			If pWindow Then
				ptmmi->ptMinTrackSize.x = WINWIDTH * pWindow->rxRatio()
				ptmmi->ptMinTrackSize.y = WINHEIGHT * pWindow->ryRatio()
			End If
			Exit Function
		Case WM_SIZE
			' Adjusts the controls
			' Get CWindow class obj from the Window Handle
			Dim As CWindow Ptr pWindow = AfxCWindowPtr(CBHNDL)
			If pWindow Then
				'Get Layout ptr from CWindow user data
				Dim As CLayout Ptr pLayout = (CLayout Ptr) pWindow->UserData(AFX_LAYOUTPTRIDX)
				IF pLayout Then 
					pLayout->AdjustControls()
				EndIf
			End If
			Exit Function
		Case WM_DESTROY
			PostQuitMessage(0)
			Exit Function
	End Select
End Function
