'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'Create binary address file from tab delimited csv file. 
'this demo uses FIO I created for TCLib:
' OpenFile
' LineInput
' FPut/FGet/FSeek
' these use the Win Api instead of the crt.
' Also showcases Fred's String Class (fstring for use with bc9Basic)
'------------------------------------------------------------------------------
'I found the original address csv file on the internet but it was comma delimited
'with embedded quotes and commas. I changed it to TAB delimited.
'------------------------------------------------------------------------------
'This app when run creates a binary file to be used with the CW_AddBook project
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
$ONEXIT "TCLIB.BAT $FILE$"
$NOMAIN
'==============================================================================
CONST MAX_RECORDS = 500
'Change this to reduce the number of binary records in  "Addressxxx.bin"
CONST MAX_RECORDS_OUT = 50
CONST TAB = 9
'==============================================================================
TYPE AddressType
    DIM FirstName 	AS STRING * 32
    DIM LastName  	AS STRING * 32
    DIM Company   	AS STRING * 64
    DIM Address   	AS STRING * 64
    DIM City		AS STRING * 32
    Dim County		As String * 32
    DIM State		AS STRING * 4
    DIM Zip   		AS STRING * 12
    DIM Phone1     	AS STRING * 24
    DIM Phone2     	AS STRING * 24
    DIM Email     	AS STRING * 64
    DIM Url       	AS STRING * 64
END TYPE

Function main()
	Dim As HANDLE hFileIn,hFileOut
	Raw As fstring sFileIn("Myus-500tab.csv")
	Raw As fstring sLine
    Dim As fstring Ptr pStrs	
	Dim As int RetVal,Count
	Dim As DWORD BytesRead
	Raw As AddressType Ptr sAddress = new AddressType
    Dim As int iParseCount,Where
    Raw As fstring sFileOut("Address")
    sFileOut+= fstring(MAX_RECORDS_OUT)
    sFileOut+= ".bin"
    'I know there are 12 items per row so I do not have to calculate:
    'iParseCount = sLine.ParseCount(9)
	iParseCount = 12
	pStrs = new fstring[iParseCount]

	OpenFile sFileIn For Input As hFileIn
	If Not hFileIn Then
		? "No Address csv File"
		Pause
		Function = EXIT_FAILURE
	Else
		OpenFile sFileOut For Output As hFileOut
		Do
			RetVal = LineInput(hFileIn,&sLine)
			Count++
			If Count > MAX_RECORDS OR Count > MAX_RECORDS_OUT Then
				Exit Loop
			EndIf
			If RetVal < 0 Then
				Exit Loop
			EndIf
			sLine.Parse(pStrs,TAB,iParseCount)
			With sAddress->
				FirstName$	= pStrs[0].lpStr()
				LastName$	= pStrs[1].lpStr()
				Company$ 	= pStrs[2].lpStr()
				Address$	= pStrs[3].lpStr()
				City$		= pStrs[4].lpStr()
				County$		= pStrs[5].lpStr()
				State$		= pStrs[6].lpStr()
				Zip$		= pStrs[7].lpStr()
				Phone1$		= pStrs[8].lpStr()
				Phone2$		= pStrs[9].lpStr()
				Email$		= pStrs[10].lpStr()
				Url$		= pStrs[11].lpStr()
			End With
			FPut(hFileOut,sAddress,sizeof(AddressType))
		Loop
	EndIf
	?"AllDone"
	'Close the files using the winapi CloseHandle
	CloseHandle(hFileIn)
	CloseHandle(hFileOut)
	'free the memory for the pStrs[] array
	delete [] pStrs
'------------------------------------------------------------------------------	
	? "Now lets read the first record from the binary file"
	Pause
	
	OpenFile sFileOut For Input As hFileOut
	BytesRead = FGet(hFileOut,sAddress,sizeof(AddressType))
	? "First Name -> "; sAddress->FirstName$
	? "Last  Name -> "; sAddress->LastName$
	? "State       -> "; sAddress->State$
	? ""

	? "Now lets read the last record"
	Pause
	
	Where = (MAX_RECORDS_OUT - 1) * sizeof(AddressType)
	FSeek(hFileOut,Where)
	BytesRead = FGet(hFileOut,sAddress,sizeof(AddressType))
	? "First Name -> "; sAddress->FirstName$
	? "Last  Name -> "; sAddress->LastName$
	? "State       -> "; sAddress->State$
	Pause
	CloseHandle(hFileOut)
	delete sAddress
	Function = EXIT_SUCCESS
End Function
