'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'Updated 10/05/2016
'Note: bc9 auto adds (WPARAM) and (LPARAM) to SendMessage if missing.
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
' ########################################################################################
' Microsoft Windows
' File: AfxCtl.inc
' Contents: Common controls wrapper functions
' Remarks: The files windowsx.bi and commctrl.bi include many macros for the common controls.
' This file contains additional procedures not implemented as macros.
' Compiler: Ported to bc9Basic jcfuller 08/18/2016  
' Copyright (c) 2016 Jos Roca. Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'                                    BUTTON
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'==============================================================================
$IFUSE USE_Button_Click
'------------------------------------------------------------------------------
' Simulates the user clicking a button. This message causes the button to receive the
' WM_LBUTTONDOWN and WM_LBUTTONUP messages, and the button's parent window to receive a
' BN_CLICKED notification code.
' ========================================================================================
SUB Button_Click (hButton AS HWND)
	SendMessage(hButton, BM_CLICK, 0, 0)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Button_GetImage
'------------------------------------------------------------------------------
' Retrieves a handle to the image (icon or bitmap) associated with the button.
' The return value is a handle to the image, if any; otherwise, it is NULL.
' ========================================================================================
FUNCTION Button_GetImage (hButton AS HWND) AS HANDLE
   FUNCTION = (HANDLE) SendMessage(hButton, BM_GETIMAGE, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Button_SetDontClick
'------------------------------------------------------------------------------
' Sets a flag on a radio button that controls the generation of BN_CLICKED messages when
' the button receives focus.
' - bState = A BOOL that specifies the state. CTRUE to set the flag, otherwise FALSE.
' ========================================================================================
SUB Button_SetDontClick (hButton AS HWND, bState AS LONG)
	SendMessage(hButton, BM_SETDONTCLICK, (WPARAM) bState, 0)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Button_SetBitmap
'------------------------------------------------------------------------------
' Associates a new bitmap with a button. The return value is a handle to the image previously
' associated with the button, if any; otherwise, it is NULL.
' ========================================================================================
FUNCTION Button_SetBitmap (hButton AS HWND, hbmp AS HBITMAP) AS HBITMAP
	FUNCTION = (HBITMAP) SendMessage(hButton, BM_SETIMAGE, (WPARAM) IMAGE_BITMAP, (LPARAM) hbmp)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Button_SetIcon
'------------------------------------------------------------------------------
' Associates a new icon with the button. The return value is a handle to the image previously
' associated with the button, if any; otherwise, it is NULL.
' ========================================================================================
FUNCTION Button_SetIcon (hButton AS HWND,hIcon AS HICON) AS HICON
	FUNCTION = (HICON) SendMessage(hButton, BM_SETIMAGE, (WPARAM) IMAGE_ICON, (LPARAM) hIcon)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Button_SetImage
'------------------------------------------------------------------------------
' Associates a new image (icon or bitmap) with the button. The return value is a handle to
' the image previously associated with the button, if any; otherwise, it is NULL.
' ========================================================================================
FUNCTION Button_SetImage (hButton AS HWND, ImageType AS DWORD, hImage AS HANDLE) AS HANDLE
	FUNCTION = (HANDLE) SendMessage(hButton, BM_SETIMAGE, (WPARAM) ImageType, (LPARAM) hImage)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Button_SetImageListXY
'------------------------------------------------------------------------------
' Assigns an image list to a button control. Requires Windows XP or superior.
' Parameters:
' - hButon     = The handle of the button.
' - hImageList =
' - nLeft      = The x-coordinate of the upper-left corner of the rectangle for the image.
' - nTop       = The y-coordinate of the upper-left corner of the rectangle for the image.
' - nRight     = The x-coordinate of the lower-right corner of the rectangle for the image.
' - nBottom    = The y-coordinate of the lower-right corner of the rectangle for the image.
' - uAlign     = The alignment to use. This parameter can be one of the following values:
'                BUTTON_IMAGELIST_ALIGN_LEFT   Align the image with the left margin.
'                BUTTON_IMAGELIST_ALIGN_RIGHT  Align the image with the right margin
'                BUTTON_IMAGELIST_ALIGN_TOP    Align the image with the top margin
'                BUTTON_IMAGELIST_ALIGN_BOTTOM Align the image with the bottom margin
'                BUTTON_IMAGELIST_ALIGN_CENTER Center the image.
'                The default value is BUTTON_IMAGELIST_ALIGN_LEFT.
' Return value:  If the function succeeds, it returns TRUE. Otherwise it returns FALSE.
' Note:  To use this application programming interface (API), you must provide a manifest
' specifying Comclt32.dll version 6.0.
' ========================================================================================
FUNCTION Button_SetImageListXY (hButton AS HWND, himl AS HIMAGELIST,nLeft AS LONG, nTop AS LONG, nRight AS LONG, nBottom AS LONG, uAlign AS DWORD = 0) AS BOOL
	DIM AS BUTTON_IMAGELIST bi  = {himl, nLeft, nTop, nRight, nBottom, uAlign}
	FUNCTION = SendMessage(hButton, BCM_SETIMAGELIST, 0, (LPARAM) &bi)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Button_DeleteBitmap
'------------------------------------------------------------------------------
' Deletes a bitmap associated with a button.
' Returns TRUE or FALSE.
' ========================================================================================
FUNCTION Button_DeleteBitmap (hButton AS HWND) AS BOOL
	FUNCTION = DeleteObject((HGDIOBJ) SendMessage(hButton, BM_SETIMAGE, (WPARAM) IMAGE_BITMAP, (LPARAM) NULL))
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Button_DeleteIcon
'------------------------------------------------------------------------------
' Deletes an icon associated with a button.
' Returns TRUE or FALSE.
' ========================================================================================
FUNCTION Button_DeleteIcon (hButton AS HWND) AS BOOL
	FUNCTION = DeleteObject((HGDIOBJ) SendMessage(hButton, BM_SETIMAGE, (WPARAM) IMAGE_ICON, (LPARAM) NULL))
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Button_DeleteImage
'------------------------------------------------------------------------------
' Deletes an image (icon or bitmap) associated a button.
' Returns TRUE or FALSE.
' ========================================================================================
FUNCTION Button_DeleteImage (hButton AS HWND, ImageType AS DWORD) AS BOOL
	FUNCTION = DeleteObject((HGDIOBJ) SendMessage(hButton, BM_SETIMAGE, (WPARAM) ImageType, (LPARAM) NULL))
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
'not implemented
'$IFUSE USE_Button_SetUtf8Text
''------------------------------------------------------------------------------
'' Sets the text of a button using a UTF8 encode string. The return value is TRUE if the
'' text is set. It is FALSE (for an edit control), LB_ERRSPACE (for a list box), or
'' CB_ERRSPACE (for a combo box) if insufficient space is available to set the text in the
'' edit control. It is CB_ERR if this message is sent to a combo box without an edit control.
'' ========================================================================================
'FUNCTION Button_SetUtf8Text (hButton AS HWND, strUtf8Text AS const char ptr) AS LONG
'	FUNCTION = AfxSetWindowUtf8Text(hButton, strUtf8Text)
'END FUNCTION
''------------------------------------------------------------------------------
'$ENDUSE
'==============================================================================
' ########################################################################################
'                                    *** COMBOBOX ***
' ########################################################################################

$IFUSE USE_ComboBox_GetComboBoxInfo
'------------------------------------------------------------------------------
' Retrieves information about the specified combo box. If the function succeeds, the return
' value is nonzero. If the function fails, the return value is zero. To get extended error
' information, call GetLastError.
' ========================================================================================
FUNCTION ComboBox_GetComboBoxInfo (hComboBox AS HWND, pcbi AS COMBOBOXINFO PTR) AS BOOL
	FUNCTION = SendMessage(hComboBox, CB_GETCOMBOBOXINFO, 0, (LPARAM)(COMBOBOXINFO*) pcbi)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Combobox_CalcHorizontalExtent
'------------------------------------------------------------------------------
' Calculates the size, in logical units, of the widest string item.
' ========================================================================================
FUNCTION Combobox_CalcHorizontalExtent (hComboBox AS HWND) AS LONG
	If IsWindow(hComboBox) = 0 Then
		Exit Function
	EndIf
	'Get handle to the device context of the control
	Raw AS HDC hDC = GetDC(hComboBox)
	'Get the number of items
	Dim As Long i,cxScrollWidth
	'Get the number of items
	Raw As LRESULT cItems = SendMessage(hComboBox, CB_GETCOUNT, 0, 0)
	Dim As SIZE tsize
	xFor i = 0 While i < cItems By i++
		'Get the text of the item
		Raw As Long cbLen = SendMessage(hComboBox, CB_GETLBTEXTLEN, i, 0)
		If cbLen = 0 Then
			Iterate
		EndIf
		Raw As char ptr pbuffer = new char[cbLen*2]
		SendMessage(hComboBox, CB_GETLBTEXT, i, (LPARAM) pbuffer)
		'Computes the width and height of the text
		GetTextExtentPoint32(hDC, pbuffer, cbLen, &tsize)
      	cxScrollWidth = max(cxScrollWidth, tsize.cx)
		delete [] pbuffer
	xNext
	' // Release the device context
	ReleaseDC(hComboBox, hDC)
	' // Return the width of the text
	FUNCTION = cxScrollWidth
	
End Function

'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ComboBox_GetEditBoxHandle
'------------------------------------------------------------------------------
' Retrieves the handle to the edit box of the combobox
' ========================================================================================
FUNCTION ComboBox_GetEditBoxHandle ( hComboBox AS HWND) AS HWND
	DIM AS COMBOBOXINFO tci 
	tci.cbSize = sizeof(COMBOBOXINFO)
	If SendMessage(hComboBox, CB_GETCOMBOBOXINFO, 0, (LPARAM)(COMBOBOXINFO PTR) &tci) = 0 Then
		EXIT FUNCTION
	EndIf
	FUNCTION = tci.hwndItem
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ComboBox_GetListBoxHandle
'------------------------------------------------------------------------------
' Retrieves the handle to the drop down of the combobox
' ========================================================================================
FUNCTION ComboBox_GetListBoxHandle ( hComboBox AS HWND) AS HWND
	DIM AS COMBOBOXINFO tci
	tci.cbSize = sizeof(COMBOBOXINFO)
	If SendMessage(hComboBox, CB_GETCOMBOBOXINFO, 0, (LPARAM)(COMBOBOXINFO PTR) &tci) = 0 Then
		EXIT FUNCTION
	EndIf
	FUNCTION = tci.hwndList
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ComboBox_GetDroppedWidth
'------------------------------------------------------------------------------
' Retrieves the minimum allowable width, in pixels, of the list box of a combo box with
' the CBS_DROPDOWN or CBS_DROPDOWNLIST style. If the message succeeds, the return value
' is the width, in pixels. If the message fails, the return value is CB_ERR.
' ========================================================================================
FUNCTION ComboBox_GetDroppedWidth ( hComboBox AS HWND) AS LONG
	FUNCTION = SendMessage(hComboBox, CB_GETDROPPEDWIDTH, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ComboBox_GetHorizontalExtent
'------------------------------------------------------------------------------
' Retrieves from a combo box the width, in pixels, by which the list box can be scrolled
' horizontally (the scrollable width). This is applicable only if the list box has a
' horizontal scroll bar. The return value is the scrollable width, in pixels.
' ========================================================================================
FUNCTION ComboBox_GetHorizontalExtent ( hComboBox AS HWND) AS LONG
	FUNCTION = SendMessage(hComboBox, CB_GETHORIZONTALEXTENT, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ComboBox_GetLocale
'------------------------------------------------------------------------------
' Retrieves the current locale of the combo box. The locale is used to determine the
' correct sorting order of displayed text for combo boxes with the CBS_SORT style and text
' added by using the CB_ADDSTRING message. The return value specifies the current locale
' of the combo box. The HIWORD contains the country/region code and the LOWORD contains
' the language identifier.
' ========================================================================================
FUNCTION ComboBox_GetLocale ( hComboBox AS HWND) AS LONG
	FUNCTION = SendMessage(hComboBox, CB_GETLOCALE, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ComboBox_GetTopIndex
'------------------------------------------------------------------------------
' Retrieves the zero-based index of the first visible item in the list box portion of a
' combo box. Initially, the item with index 0 is at the top of the list box, but if the
' list box contents have been scrolled, another item may be at the top.
' If the message is successful, the return value is the index of the first visible item in
' the list box of the combo box. If the message fails, the return value is CB_ERR.
' ========================================================================================
FUNCTION ComboBox_GetTopIndex (hComboBox AS HWND) AS LONG
	FUNCTION = SendMessage(hComboBox, CB_GETTOPINDEX, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ComboBox_InitStorage
'------------------------------------------------------------------------------
' Allocates memory for storing list box items. An application sends the CB_INITSTORAGE
' message before adding a large number of items to the list box portion of a combo box.
' If the message is successful, the return value is the total number of items for which
' memory has been pre-allocated, that is, the total number of items added by all successful
' CB_INITSTORAGE messages. If the message fails, the return value is CB_ERRSPACE.
' ========================================================================================
FUNCTION ComboBox_InitStorage (hComboBox AS HWND, items AS LONG, cb AS LONG) AS LONG
	FUNCTION = SendMessage(hComboBox, CB_INITSTORAGE, (WPARAM) items, (LPARAM) cb)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ComboBox_SetDroppedWidth
'------------------------------------------------------------------------------
' Sets the maximum allowable width, in pixels, of the list box of a combo box with the
' CBS_DROPDOWN or CBS_DROPDOWNLIST style. If the message is successful, The return value
' is the new width of the list box. If the message fails, the return value is CB_ERR.
' ========================================================================================
FUNCTION ComboBox_SetDroppedWidth (hComboBox AS HWND, nWidth AS LONG) AS LONG
	FUNCTION = SendMessage(hComboBox, CB_SETDROPPEDWIDTH, (WPARAM) nWidth, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ComboBox_SetHorizontalExtent
'------------------------------------------------------------------------------
' Sets the width, in pixels, by which a list box can be scrolled horizontally (the
' scrollable width). If the width of the list box is smaller than this value, the
' horizontal scroll bar horizontally scrolls items in the list box. If the width of the
' list box is equal to or greater than this value, the horizontal scroll bar is hidden or,
' if the combo box has the CBS_DISABLENOSCROLL style, disabled.
' ========================================================================================
SUB ComboBox_SetHorizontalExtent ( hComboBox AS HWND,  nWidth AS LONG)
	SendMessageW(hComboBox, CB_SETHORIZONTALEXTENT, (WPARAM) nWidth, 0)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ComboBox_SetLocale
'------------------------------------------------------------------------------
' Sets the current locale of the combo box. If the combo box has the CBS_SORT style and
' strings are added using CB_ADDSTRING, the locale of a combo box affects how list items
' are sorted.  The return value is the previous locale identifier. If lcid specifies a
' locale not installed on the system, the return value is CB_ERR and the current combo box
' locale is not changed.
' ========================================================================================
FUNCTION ComboBox_SetLocale (hComboBox AS HWND, lcid AS LONG) AS LONG
	FUNCTION = SendMessage(hComboBox, CB_SETLOCALE, (WPARAM) lcid, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ComboBox_SetTopIndex
'------------------------------------------------------------------------------
' Ensures that a particular item is visible in the list box of a combo box. The system
' scrolls the list box contents so that either the specified it. If the message is successful,
' the return value is zero. If the message fails, the return value is CB_ERR.
' ========================================================================================
FUNCTION ComboBox_SetTopIndex ( hComboBox AS HWND,  index AS DWORD) AS LONG
	FUNCTION = SendMessage(hComboBox, CB_SETTOPINDEX, (WPARAM) index, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
' ########################################################################################
'                                   *** COMBOBOXEX ***
' ########################################################################################
'==============================================================================
$IFUSE USE_ComboBoxEx_DeleteItem
'------------------------------------------------------------------------------
' Removes an item from a ComboBoxEx control. Returns an INT value that represents the number
' of items remaining in the control. If iIndex is invalid, the message returns CB_ERR.
' ========================================================================================
FUNCTION ComboBoxEx_DeleteItem (hComboboxEx AS HWND, nIndex AS DWORD) AS INT
	FUNCTION = SendMessage(hComboboxEx, CBEM_DELETEITEM, (WPARAM) nIndex, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ComboBoxEx_GetComboControl
'------------------------------------------------------------------------------
' Returns the handle to the combo box control within the ComboBoxEx control.
' ========================================================================================
FUNCTION ComboBoxEx_GetComboControl ( hComboBoxEx AS HWND) AS HWND
	FUNCTION = (HWND) SendMessage(hComboBoxEx, CBEM_GETCOMBOCONTROL, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ComboBoxEx_GetEditControl
'------------------------------------------------------------------------------
' Returns the handle to the edit control within the ComboBoxEx control if it uses the
' CBS_DROPDOWN style. Otherwise, the message returns NULL.
' ========================================================================================
FUNCTION ComboBoxEx_GetEditControl (hComboBoxEx AS HWND) AS HWND
	FUNCTION = (HWND) SendMessage(hComboBoxEx, CBEM_GETEDITCONTROL, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ComboBoxEx_GetExtendedStyle
'------------------------------------------------------------------------------
' Returns a DWORD value that contains the ComboBoxEx control extended styles in use for the control.
' ========================================================================================
FUNCTION ComboBoxEx_GetExtendedStyle ( hComboBoxEx AS HWND) AS DWORD
	FUNCTION = SendMessage(hComboBoxEx, CBEM_GETEXTENDEDSTYLE, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ComboBoxEx_GetImageList
'------------------------------------------------------------------------------
' Retrieves the handle to an image list assigned to a ComboBoxEx control.
' ========================================================================================
FUNCTION ComboBoxEx_GetImageList ( hComboBoxEx AS HWND) AS HIMAGELIST
	FUNCTION = (HIMAGELIST) SendMessage(hComboBoxEx, CBEM_GETIMAGELIST, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ComboBoxEx_GetItem
'------------------------------------------------------------------------------
' Retrieves item information for a given ComboBoxEx item. Returns TRUE or FALSE.
' ========================================================================================
FUNCTION ComboBoxEx_GetItem (hComboBoxEx AS HWND, pCBItem AS COMBOBOXEXITEM PTR) AS BOOL
	FUNCTION = SendMessage(hComboBoxEx, CBEM_GETITEM, 0, (LPARAM) pCBItem)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ComboBoxEx_GetUnicodeFormat
'------------------------------------------------------------------------------
' Returns the Unicode format flag for the control. If this value is nonzero, the control
' is using Unicode characters. If this value is zero, the control is using ANSI characters.
' ========================================================================================
FUNCTION ComboBoxEx_GetUnicodeFormat ( hComboBoxEx AS HWND) AS DWORD
	FUNCTION = SendMessage(hComboBoxEx, CBEM_GETUNICODEFORMAT, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ComboBoxEx_HasEditChanged
'------------------------------------------------------------------------------
' Determines whether or not the user has changed the text of a ComboBoxEx edit control.
' Returns TRUE or FALSE.
' ========================================================================================
FUNCTION ComboBoxEx_HasEditChanged (hComboBoxEx AS HWND) AS BOOL
	FUNCTION = SendMessage(hComboBoxEx, CBEM_HASEDITCHANGED, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ComboBoxEx_InsertItem
'------------------------------------------------------------------------------
' Returns the index at which the new item was inserted if successful, or -1 otherwise.
' ========================================================================================
FUNCTION ComboBoxEx_InsertItem (hComboBoxEx AS HWND, lpCBItem AS COMBOBOXEXITEM PTR) AS LONG
	FUNCTION = SendMessage(hComboBoxEx, CBEM_INSERTITEM, 0, (LPARAM) &lpCBItem)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ComboBoxEx_SetExtendedStyle
'------------------------------------------------------------------------------
' Returns a DWORD value that contains the extended styles previously used for the control.
' ========================================================================================
FUNCTION ComboBoxEx_SetExtendedStyle (hComboBoxEx AS HWND, dwExMask AS DWORD, dwExStyle AS DWORD) AS DWORD
	FUNCTION = SendMessage(hComboBoxEx, CBEM_SETEXTENDEDSTYLE, (WPARAM) dwExMask, (LPARAM) dwExStyle)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ComboBoxEx_SetImageList
'------------------------------------------------------------------------------
' Returns the handle to the image list previously associated with the control, or returns
' NULL if no image list was previously set.
' ========================================================================================
FUNCTION ComboBoxEx_SetImageList (hComboBoxEx AS HWND, himl AS HIMAGELIST) AS HIMAGELIST
	FUNCTION = (HIMAGELIST) SendMessage(hComboBoxEx, CBEM_SETIMAGELIST, 0, (LPARAM) himl)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ComboBoxEx_SetItem
'------------------------------------------------------------------------------
' Sets the attributes for an item in a ComboBoxEx control.
' Returns nonzero if successful, or zero otherwise.
' ========================================================================================
FUNCTION ComboBoxEx_SetItem (hComboBoxEx AS HWND, lpCBItem AS COMBOBOXEXITEM PTR) AS BOOL
	FUNCTION = SendMessage(hComboBoxEx, CBEM_SETITEM, 0, (LPARAM) lpCBItem)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ComboBoxEx_SetUnicodeFormat
'------------------------------------------------------------------------------
' Sets the UNICODE character format flag for the control. This message enables you to
' change the character set used by the control at run time rather than having to re-create
' the control. Returns the previous Unicode format flag for the control.
' ========================================================================================
FUNCTION ComboBoxEx_SetUnicodeFormat (hComboBoxEx AS HWND, fUnicode AS DWORD) AS DWORD
	FUNCTION = SendMessage(hComboBoxEx, CBEM_SETUNICODEFORMAT, (WPARAM) fUnicode, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ComboBoxEx_SetWindowTheme
'------------------------------------------------------------------------------
' Sets the visual style of a ComboboxEx control.
' ========================================================================================
SUB ComboBoxEx_SetWindowTheme (hComboBoxEx AS HWND, szStyle As const char ptr)
	SendMessage(hComboBoxEx, CBEM_SETWINDOWTHEME, 0, (LPARAM) szStyle)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
' ########################################################################################
'                                      *** EDIT ***
' ########################################################################################
'==============================================================================
$IFUSE USE_Edit_CharFromPos
'------------------------------------------------------------------------------
' ========================================================================================
' Gets information about the character closest to a specified point in the client area of
' an edit control. You can send this message to either an edit control or a rich edit control.
' Return value: The LOWORD specifies the zero-based index of the character nearest the
' specified point. This index is relative to the beginning of the control, not the beginning
' of the line. If the specified point is beyond the last character in the edit control, the
' return value indicates the last character in the control. The HIWORD specifies the
' zero-based index of the line that contains the character. For single-line edit controls,
' this value is zero. The index indicates the line delimiter if the specified point is
' beyond the last visible character in a line.
' ========================================================================================
FUNCTION Edit_CharFromPos (hEdit AS HWND, x AS SHORT,  y AS SHORT) AS LONG
	FUNCTION = SendMessage(hEdit, EM_CHARFROMPOS, 0, (LPARAM) MAKELONG(x, y))
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Edit_Clear
'------------------------------------------------------------------------------
' Deletes (clears) the current selection, if any, from the edit control.
' ========================================================================================
SUB Edit_Clear ( hEdit AS HWND)
	SendMessage(hEdit, WM_CLEAR, 0, 0)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Edit_Copy
'------------------------------------------------------------------------------
' Copies the current selection to the clipboard in CF_TEXT format.
' ========================================================================================
SUB Edit_Copy (hEdit AS HWND)
	SendMessage(hEdit, WM_COPY, 0, 0)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Edit_Cut
'------------------------------------------------------------------------------
' Deletes (cuts) the current selection, if any, in the edit control and copy the deleted
' text to the clipboard in CF_TEXT format.
' ========================================================================================
SUB Edit_Cut ( hEdit AS HWND)
	SendMessage(hEdit, WM_CUT, 0, 0)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Edit_GetIMEStatus
'------------------------------------------------------------------------------
' Retrieves a set of status flags that indicate how the edit control interacts with the
' Input Method Editor (IME).
' ========================================================================================
FUNCTION Edit_GetIMEStatus (hEdit AS HWND, nStatusType AS LONG) AS LONG
	FUNCTION = SendMessage(hEdit, EM_GETIMESTATUS, (WPARAM) nStatusType, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
'==============================================================================
$IFUSE USE_Edit_GetLimitText
'------------------------------------------------------------------------------
' Gets the current text limit for an edit control. The return value is the text limit.
' ========================================================================================
FUNCTION Edit_GetLimitText (hEdit AS HWND) AS LONG
	FUNCTION = SendMessage(hEdit, EM_GETLIMITTEXT, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Edit_GetMargins
'------------------------------------------------------------------------------
' Returns the width of the left margin in the LOWORD, and the width of the right margin in the HIWORD.
' ========================================================================================
FUNCTION Edit_GetMargins ( hEdit AS HWND) AS DWORD
	FUNCTION = SendMessageW(hEdit, EM_GETMARGINS, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Edit_GetLeftMargin
'------------------------------------------------------------------------------
' Returns the width of the left margin for an edit control.
' ========================================================================================
FUNCTION Edit_GetLeftMargin ( hEdit AS HWND) AS WORD
	FUNCTION = LOWORD(SendMessage(hEdit, EM_GETMARGINS, 0, 0))
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Edit_GetRightMargin
'------------------------------------------------------------------------------
' Gets the width of the right margin for an edit control.
' ========================================================================================
FUNCTION Edit_GetRightMargin (hEdit AS HWND) AS WORD
	FUNCTION = HIWORD(SendMessage(hEdit, EM_GETMARGINS, 0, 0))
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Edit_GetSelStart
'------------------------------------------------------------------------------
' Gets the starting character position of the current selection in an edit control.
' ========================================================================================
FUNCTION Edit_GetSelStart ( hEdit AS HWND) AS WORD
	FUNCTION = LOWORD(SendMessage(hEdit, EM_GETSEL, 0, 0))
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Edit_GetSelEnd
'------------------------------------------------------------------------------
' Gets the ending character position of the current selection in an edit control.
' ========================================================================================
FUNCTION Edit_GetSelEnd (hEdit AS HWND) AS WORD
	FUNCTION = HIWORD(SendMessage(hEdit, EM_GETSEL, 0, 0))
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Edit_GetThumb
'------------------------------------------------------------------------------
' Gets the position of the scroll box (thumb) in the vertical scroll bar of a multiline
' edit control.
' ========================================================================================
FUNCTION Edit_GetThumb ( hEdit AS HWND) AS LONG
	FUNCTION = SendMessage(hEdit, EM_GETTHUMB, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Edit_LineScroll
'------------------------------------------------------------------------------
' Scrolls the text in a multiline edit control.
' If the message is sent to a multiline edit control, the return value is TRUE.
' If the message is sent to a single-line edit control, the return value is FALSE.
' ========================================================================================
FUNCTION Edit_LineScroll (hEdit AS HWND,  x AS LONG, y AS LONG) AS BOOL
	FUNCTION = SendMessage(hEdit, EM_LINESCROLL, (WPARAM) x, (LPARAM) y)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Edit_Paste
'------------------------------------------------------------------------------
' Copies the current content of the clipboard to the edit control at the current caret
' position. Data is inserted only if the clipboard contains data in CF_TEXT format.
' ========================================================================================
SUB Edit_Paste ( hEdit AS HWND)
	SendMessage(hEdit, WM_PASTE, 0, 0)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Edit_PosFromChar
'------------------------------------------------------------------------------
' Retrieves the client area coordinates of a specified character in an edit control.
' The return value contains the client area coordinates of the character. The LOWORD
' contains the horizontal coordinate and the HIWORD contains the vertical coordinate.
' ========================================================================================
FUNCTION Edit_PosFromChar (hEdit AS HWND, index AS DWORD) AS LONG
	FUNCTION = SendMessage(hEdit, EM_POSFROMCHAR, (WPARAM) index, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
'$IFUSE USE_Edit_SetCueBannerTextFocused
'Note -> Is in commcctrl.h
'------------------------------------------------------------------------------
' Sets the text that is displayed as the textual cue, or tip, for an edit control.
' - pwszText: A pointer to a Unicode string that contains the text to display as the textual cue.
' - fDrawFocused: TRUE if the cue banner should show even when the edit control has focus;
'   otherwise, FALSE. FALSE is the default behaviorthe cue banner disappears when the user
'   clicks in the control.
' If the message succeeds, it returns TRUE. Otherwise it returns FALSE.
' ========================================================================================
'I had to rename from  Edit_SetCueBannerTextFocused To Edit_SetCueBannerFocusedText ???
'FUNCTION Edit_SetCueBannerFocusedText ( hEdit AS HWND, pszText AS const char ptr, fDrawFocused AS LONG) AS BOOL
'	FUNCTION = SendMessage(hEdit, EM_SETCUEBANNER, (WPARAM) fDrawFocused, (LPARAM) pszText)
'END FUNCTION
'''------------------------------------------------------------------------------
'$ENDUSE
'==============================================================================
$IFUSE USE_Edit_SetIMEStatus
'------------------------------------------------------------------------------
' Sets the status flags that determine how an edit control interacts with the Input Method
' Editor (IME).
' - nStatusType: The type of status to set. This parameter can be EMSIS_COMPOSITIONSTRING.
' - flags: Data specific to the status type. If wParam is EMSIS_COMPOSITIONSTRING, this
'   parameter can be one or more of the following values: EIMES_GETCOMPSTRATONCE,
'   EIMES_CANCELCOMPSTRINFOCUS, EIMES_COMPLETECOMPSTRKILLFOCUS.
' Returns the previous value of the flags parameter.
' ========================================================================================
FUNCTION Edit_SetIMEStatus ( hEdit AS HWND,  nStatusType AS LONG,  flags AS DWORD) AS DWORD
	FUNCTION = SendMessage(hEdit, EM_SETIMESTATUS, (WPARAM) nStatusType, (LPARAM) flags)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Edit_SetMargins
'------------------------------------------------------------------------------
' Sets the widths of the left and right margins for an edit control. The message redraws
' the control to reflect the new margins.
' ========================================================================================
SUB Edit_SetMargins (hEdit AS HWND, nMargins AS LONG, nWidth AS LONG)
	SendMessage(hEdit, EM_SETMARGINS, (WPARAM) nMargins, (LPARAM) nWidth)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Edit_SetLeftMargin
'------------------------------------------------------------------------------
' Sets the width of the left margin for an edit control. The message redraws the control
' to reflect the new margin.
' ========================================================================================
SUB Edit_SetLeftMargin ( hEdit AS HWND, nWidth AS WORD)
	SendMessage(hEdit, EM_SETMARGINS,  EC_LEFTMARGIN,  MAKELONG(nWidth, 0))
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Edit_SetRightMargin
'------------------------------------------------------------------------------
' Sets the width of the right margin for an edit control. The message redraws the control
' to reflect the new margin.
' ========================================================================================
SUB Edit_SetRightMargin ( hEdit AS HWND, nWidth AS WORD)
	SendMessage(hEdit, EM_SETMARGINS, EC_RIGHTMARGIN, MAKELONG(0, nWidth))
END SUB
'------------------------------------------------------------------------------
$ENDUSE
' ########################################################################################
'                                      *** HEADER ***
' ########################################################################################
'==============================================================================
$IFUSE USE_Header_HitTest
'------------------------------------------------------------------------------
' Tests a point to determine which header item, if any, is at the specified point.
' ========================================================================================
FUNCTION Header_HitTest (hwndHD AS HWND, phdhti AS HDHITTESTINFO PTR) AS LONG
	FUNCTION = SendMessage(hwndHD, HDM_HITTEST, 0,  phdhti)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Header_GetItemWidth
'------------------------------------------------------------------------------
' Gets the width of the specified item of a header control.
' Returns the index of the item at the specified position, if any, or  1 otherwise.
' ========================================================================================
FUNCTION Header_GetItemWidth (hwndHD AS HWND, nItem AS LONG) AS LONG
	DIM AS HDITEMW hdi
	hdi.mask = HDI_WIDTH
	If SendMessage(hwndHD, HDM_GETITEMW, nItem, &hdi) Then
		FUNCTION = hdi.cxy
	EndIf
	Function = -1
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Header_SetItemWidth
'------------------------------------------------------------------------------
' Sets the width of the specified item of a header control.
' Returns nonzero upon success, or zero otherwise.
' ========================================================================================
FUNCTION Header_SetItemWidth (hwndHD AS HWND, nItem AS LONG, nWidth AS LONG) AS BOOL
	DIM AS HDITEMW hdi
	hdi.mask = HDI_WIDTH
	hdi.cxy = nWidth
	FUNCTION = SendMessage(hwndHD, HDM_SETITEMW, nItem, &hdi)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Header_GetItemOrder
'------------------------------------------------------------------------------
' Gets the order of the specified item of a header control.
' ========================================================================================
FUNCTION Header_GetItemOrder (hwndHD AS HWND, nItem AS LONG) AS LONG
	DIM AS HDITEMW hdi
	hdi.mask = HDI_ORDER
	IF SendMessage(hwndHD, HDM_GETITEMW, nItem,&hdi) Then
		FUNCTION = hdi.iOrder
	EndIf
	Function = 0
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Header_SetItemOrder
'------------------------------------------------------------------------------
' Sets the order of the specified item of a header control.
' ========================================================================================
FUNCTION Header_SetItemOrder ( hwndHD AS HWND, nItem AS LONG, iOrder AS LONG) AS LONG
	DIM AS HDITEMW hdi
	hdi.mask = HDI_ORDER
	hdi.iOrder = iOrder
	FUNCTION = SendMessage(hwndHD, HDM_SETITEMW, nItem, &hdi)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Header_GetItemText
'------------------------------------------------------------------------------
' Gets the text of the specified column.
' - hwndHD: Handle to the header control.
' - nItem: The index of the item for which information is to be retrieved.
' - pwszText: A pointer to an item string. If the text is being retrieved from the control,
'   this member must be initialized to point to a character buffer. If this member is set
'   to LPSTR_TEXTCALLBACK, the control will request text information for this item by sending
'   an HDN_GETDISPINFO notification code. Note that although the header control allows a
'   string of any length to be stored as item text, only the first 260 characters are displayed.
' - cchTextMax : Maximum number of characters to return. Both this value and the size of the
'   buffer pointed by pwszText must be one character bigger that the wanted length of the text
'   to return to make room for the null character terminator.
' Return value: Returns TRUE or FALSE.
' Usage example:
' DIM wszText AS WSTRING * 260
' Header_GetItemText(hTreeView, hItem, @wszText, 260)
' AfxMsg(wszText)
' ========================================================================================
FUNCTION Header_GetItemText (hwndHD AS HWND, nItem AS LONG,  pwszText AS  char ptr, cchTextMax AS LONG) AS BOOL
	If pwszText = NULL Then
		EXIT FUNCTION
	EndIf
	DIM AS HDITEMW hdi
	hdi.mask = HDI_TEXT
	hdi.pszText = pwszText
	hdi.cchTextMax = cchTextMax
	FUNCTION = SendMessage(hwndHD, HDM_GETITEMW, 0, &hdi)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Header_SetItemText
'------------------------------------------------------------------------------
' Sets the text of the specified item. Returns TRUE or FALSE.
' ========================================================================================
FUNCTION Header_SetItemText (hwndHD AS HWND, nItem AS LONG, pwszText AS const char ptr) AS BOOL
	IF pwszText = NULL Then
		EXIT FUNCTION
	EndIf
	DIM AS HDITEMW hdi
	hdi.mask = HDI_TEXT
	hdi.cchTextMax = LEN(pwszText)
	hdi.pszText = (LPWSTR)pwszText
	FUNCTION = SendMessage(hwndHD, HDM_SETITEMW, nItem, &hdi)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE

' ########################################################################################
'                                    *** HOTKEY ***
' ########################################################################################

'==============================================================================
$IFUSE USE_HotKey_GetHotKey
'------------------------------------------------------------------------------
' Gets the virtual key code and modifier flags of a hot key from a hot key control.
' Returns the virtual key code and modifier flags. The LOBYTE of the LOWORD is the virtual
' key code of the hot key. The HIBYTE of the LOWORD is the key modifier that specifies the
' keys that define a hot key combination. The modifier flags can be a combination of the
' following values:
'   HOTKEYF_ALT      ALT key
'   HOTKEYF_CONTROL  CONTROL key
'   HOTKEYF_EXT      Extended key
'   HOTKEYF_SHIFT    SHIFT key
' ========================================================================================
FUNCTION HotKey_GetHotKey ( hHotKey AS HWND) AS DWORD
	FUNCTION = SendMessage(hHotKey, HKM_GETHOTKEY, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_HotKey_SetHotKey
'------------------------------------------------------------------------------
' Sets the hot key combination for a hot key control.
' - vkCode: The virtual key code of the hot key.
' - fMods: The key modifier that indicates the keys that define a hot key combination.
' For a list of modifier flag values, see the description of the HotKey_GetHotKey function.
' ========================================================================================
SUB HotKey_SetHotKey ( hHotKey AS HWND, vkCode AS SHORT, fMods AS SHORT)
	SendMessage(hHotKey, HKM_SETHOTKEY, MAKELONG(vkCode, fMods), 0)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_HotKey_SetRules
'------------------------------------------------------------------------------
' Defines the invalid combinations and the default modifier combination for a hot key control.
' - fwCombInv: An array of flags that specify invalid key combinations. This parameter can be a combination
'   of the following values:
' Value Meaning
'   HKCOMB_A ALT
'   HKCOMB_C CTRL
'   HKCOMB_CA CTRL+ALT
'   HKCOMB_NONE Unmodified keys
'   HKCOMB_S SHIFT
'   HKCOMB_SA SHIFT+ALT
'   HKCOMB_SC SHIFT+CTRL
'   HKCOMB_SCA SHIFT+CTRL+ALT
' - fwModInv: An array of flags that specify the key combination to use when the user enters
'   an invalid combination. For a list of modifier flag values, see the description of the
'   HotKey_GetHotKey message.
' ========================================================================================
SUB HotKey_SetRules (hHotKey AS HWND, fwCombInv AS WORD, fwModInv AS WORD)
	SendMessage(hHotKey, HKM_SETRULES, fwCombInv, MAKELONG(fwModInv, 0))
END SUB
'------------------------------------------------------------------------------
$ENDUSE

' ########################################################################################
'                                    *** SCROLLBAR ***
' ########################################################################################


'==============================================================================
$IFUSE USE_ScrollBar_SetRangeRedraw
'------------------------------------------------------------------------------
' Sets the minimum and maximum position values and redraws the control.
' Return value:
' ComCtl32.dll version 5.0: If the position of the scroll box changed, the return value is
' the previous position of the scroll box; otherwise, it is zero.
' ComCtl32.dll version 6.0: The current position of the scroll box, regardless of whether
' it has changed.
' ========================================================================================
FUNCTION ScrollBar_SetRangeRedraw (hScrollBar AS HWND, posMin AS LONG, posMax AS LONG) AS LONG
	FUNCTION = SendMessage(hScrollBar, SBM_SETRANGEREDRAW, posMin,  posMax)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE

' ########################################################################################
'                                    *** SYSLINK ***
' ########################################################################################

'==============================================================================
$IFUSE USE_SysLink_GetIdealHeight
'------------------------------------------------------------------------------
' Retrieves the preferred height of a link for the control's current width.
' ========================================================================================
FUNCTION SysLink_GetIdealHeight ( hLM AS HWND) AS LONG
	FUNCTION = SendMessage(hLM, LM_GETIDEALHEIGHT, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Syslink_GetItem
'------------------------------------------------------------------------------
' Retrieves the states and attributes of an item.
' Returns TRUE if the message succeeds in getting the values and attributes specified.
' ========================================================================================
FUNCTION Syslink_GetItem (hLM AS HWND, lpItem AS LITEM PTR) AS BOOL
	FUNCTION = SendMessage(hLM, LM_GETITEM, 0, &lpItem)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_SysLink_HitTest
'------------------------------------------------------------------------------
' Determines if the user clicked the specified link.
' Returns TRUE if user clicked on a link, otherwise returns FALSE.
' ========================================================================================
FUNCTION SysLink_HitTest (hLM AS HWND, lphti AS LHITTESTINFO PTR) AS BOOL
	FUNCTION = SendMessage(hLM, LM_HITTEST, 0, &lphti)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_SysLink_SetItem
'------------------------------------------------------------------------------
' Sets the states and attributes of an item.
' Returns TRUE if the message succeeds in setting the values and attributes specified.
' ========================================================================================
FUNCTION SysLink_SetItem ( hLM AS HWND, lpItem AS LITEM PTR) AS BOOL
	FUNCTION = SendMessage(hLM, LM_SETITEM, 0, &lpItem)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE

' ########################################################################################
'                                    *** LISTBOX ***
' ########################################################################################

'==============================================================================
$IFUSE USE_ListBox_AddFile
'------------------------------------------------------------------------------
' Adds the specified filename to a list box that contains a directory listing.
' The return value is the zero-based index of the file that was added, or LB_ERR if an error occurs.
' ========================================================================================
FUNCTION ListBox_AddFile (hListBox AS HWND, pwszFileName AS const char ptr) AS LONG
	FUNCTION = SendMessage(hListBox, LB_ADDFILE, 0, pwszFileName)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ListBox_GetAnchorIndex
'------------------------------------------------------------------------------
' Gets the index of the anchor item--that is, the item from which a multiple selection
' starts. A multiple selection spans all items from the anchor item to the caret item.
' The return value is the index of the anchor item.
' ========================================================================================
FUNCTION ListBox_GetAnchorIndex ( hListBox AS HWND) AS LONG
	FUNCTION = SendMessage(hListBox, LB_GETANCHORINDEX, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Listbox_GetListboxInfo
'------------------------------------------------------------------------------
' Gets the number of items per column in a specified list box.
' ========================================================================================
FUNCTION Listbox_GetListboxInfo ( hListBox AS HWND) AS LONG
	FUNCTION = SendMessage(hListBox, LB_GETLISTBOXINFO, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ListBox_GetLocale
'------------------------------------------------------------------------------
' Gets the current locale of the list box. You can use the locale to determine the correct
' sorting order of displayed text (for list boxes with the LBS_SORT style) and of text
' added by the LB_ADDSTRING message.
' ========================================================================================
FUNCTION ListBox_GetLocale ( hListBox AS HWND) AS LONG
	FUNCTION = SendMessage(hListBox, LB_GETLOCALE, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Listbox_InitStorage
'------------------------------------------------------------------------------
' Allocates memory for storing list box items. This message is used before an application
' adds a large number of items to a list box. If the message is successful, the return
' value is the total number of items for which memory has been pre-allocated, that is, the
' total number of items added by all successful LB_INITSTORAGE messages. If the message
' fails, the return value is LB_ERRSPACE.
' ========================================================================================
FUNCTION Listbox_InitStorage (hListBox AS HWND, nItems AS DWORD, nBytes AS DWORD) AS LONG
	FUNCTION = SendMessage(hListBox, LB_INITSTORAGE, nItems,  nBytes)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Listbox_ItemFromPoint
'------------------------------------------------------------------------------
' Gets the zero-based index of the item nearest the specified point in a list box.
' The return value contains the index of the nearest item in the LOWORD. The HIWORD is zero
' if the specified point is in the client area of the list box, or one if it is outside
' the client area.
' ========================================================================================
FUNCTION Listbox_ItemFromPoint (hListBox AS HWND, x AS SHORT, y AS SHORT) AS LONG
	FUNCTION = SendMessage(hListBox, LB_ITEMFROMPOINT, 0,  MAKELONG(x, y))
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Listbox_SelItemRangeEx
'------------------------------------------------------------------------------
' Selects one or more consecutive items in a multiple-selection list box.
' If an error occurs, the return value is LB_ERR.
' ========================================================================================
FUNCTION Listbox_SelItemRangeEx (hListBox AS HWND, startIndex AS LONG, endIndex AS LONG) AS LONG
	FUNCTION = SendMessage(hListBox, LB_SELITEMRANGEEX, startIndex, endIndex)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ListBox_SetAnchorIndex
'------------------------------------------------------------------------------
' Sets the anchor item--that is, the item from which a multiple selection starts.
' A multiple selection spans all items from the anchor item to the caret item.
' If the message succeeds, the return value is zero.
' If the message fails, the return value is LB_ERR.
' ========================================================================================
FUNCTION ListBox_SetAnchorIndex (hListBox AS HWND, index AS LONG) AS LONG
	FUNCTION = SendMessage(hListBox, LB_SETANCHORINDEX, index, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Listbox_SetCount
'------------------------------------------------------------------------------
' Sets the count of items in a list box created with the LBS_NODATA style and not created
' with the LBS_HASSTRINGS style.
' ========================================================================================
FUNCTION Listbox_SetCount ( hListBox AS HWND,  nCount AS DWORD) AS LONG
	FUNCTION = SendMessage(hListBox, LB_SETCOUNT,  nCount, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ListBox_SetLocale
'------------------------------------------------------------------------------
' Sets the current locale of the list box. You can use the locale to determine the correct
' sorting order of displayed text (for list boxes with the LBS_SORT style) and of text
' added by the LB_ADDSTRING message. If an error occurs, the return value is LB_ERR.
' If there is insufficient memory to store the items, the return value is LB_ERRSPACE.
' ========================================================================================
FUNCTION ListBox_SetLocale ( hListBox AS HWND,  wLocaleID AS DWORD) AS LONG
	FUNCTION = SendMessage(hListBox, LB_SETLOCALE, wLocaleID, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ListBox_ReplaceString
'------------------------------------------------------------------------------
' Replaces a string, and his associated data, into a list box.
' The return value is the index of the position at which the string was inserted.
' If an error occurs, the return value is LB_ERR. If there is insufficient space to store
' the new string, the return value is LB_ERRSPACE.
' ========================================================================================
FUNCTION ListBox_ReplaceString ( hListBox AS HWND,  index AS LONG, pwszNewText AS const char ptr, pNewData AS LONG_PTR = 0) AS LONG
	' // Delete the string
	Raw  AS LRESULT lRes = SendMessage(hListBox, LB_DELETESTRING, index, 0)
	If lRes = LB_ERR THEN 
		Function = lRes
	EndIf
	' // Insert the new string
	index = SendMessage(hListBox, LB_INSERTSTRING, index,  pwszNewText)
	If index = LB_ERR OR index = LB_ERRSPACE THEN 
		Function =  index
	EndIf
	lRes = SendMessage(hListBox, LB_SETITEMDATA, index,  pNewData)
	IF lRes = LB_ERR THEN 
		Function = lRes
	EndIf
	FUNCTION = SendMessage(hListBox, iif((GetWindowLongPtr(hListBox, GWL_STYLE) BAND LBS_MULTIPLESEL), LB_SETSEL, LB_SETCURSEL), index, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Listbox_CalcHorizontalExtent
'------------------------------------------------------------------------------
' Calculates the size, in logical units, of the widest string item.
' ========================================================================================
FUNCTION Listbox_CalcHorizontalExtent (BYVAL hListBox AS HWND) AS LONG
	IF IsWindow(hListBox) = 0 THEN 
		EXIT FUNCTION
	EndIf
	' // Get an handle to the device context of the control
	Raw AS HDC hDC = GetDC(hListBox)
	' // Get the number of items
	DIM AS LONG i,cxScrollWidth
	Raw As LRESULT cItems = SendMessage(hListBox, LB_GETCOUNT, 0, 0)
	FOR i = 0 TO cItems - 1
		' // Get the text of the item
		Raw AS LONG cbLen = SendMessage(hListBox, LB_GETTEXTLEN, i, 0)
		If cbLen = 0 THEN 
			Iterate
		EndIf
		Raw As _char Ptr pbuffer = new _char[cbLen*2] 
		SendMessage(hListBox, LB_GETTEXT, i, pbuffer)
		' // Computes the width and height of the text
		DIM AS SIZE tsize 
		GetTextExtentPoint32( hDC,(LPCWSTR) pbuffer, cbLen, &tsize)
		cxScrollWidth = max(cxScrollWidth, tsize.cx)
		delete [] pbuffer
	NEXT
	' // Release the device context
	ReleaseDC(hListBox, hDC)
	' // Return the width of the text
	FUNCTION = cxScrollWidth
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE

' ########################################################################################
'                                    *** LISTVIEW ***
' ########################################################################################

'==============================================================================
$IFUSE USE_ListView_FindString
'------------------------------------------------------------------------------
' Searches the listview for the specified string.
' Returns the index of the item if successful, or -1 otherwise.
' ========================================================================================
FUNCTION ListView_FindString (hwndLV AS HWND, pwszText AS const char ptr) AS LONG
	DIM lvf AS LVFINDINFOW
	lvf.flags = LVFI_STRING
	lvf.psz = pwszText
	FUNCTION = SendMessage(hwndLV, LVM_FINDITEMW, -1, &lvf)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ListView_GetFocusedItem
'------------------------------------------------------------------------------
' Gets the item that has the focus, which may or may not be selected.
' Returns the index of the next item if successful, or -1 otherwise.
' ========================================================================================
FUNCTION ListView_GetFocusedItem (hwndLV AS HWND) AS LONG
	FUNCTION = SendMessage(hwndLV, LVM_GETNEXTITEM, -1, LVNI_ALL BOR LVNI_FOCUSED)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ListView_GetISearchStringLen
'------------------------------------------------------------------------------
' Returns the number of characters in the incremental search string, not including the
' terminating NULL character, or zero if the list-view control is not in incremental search mode.
' ========================================================================================
FUNCTION ListView_GetISearchStringLen ( hwndLV AS HWND) AS LONG
	FUNCTION = SendMessage(hwndLV, LVM_GETISEARCHSTRINGW, 0, NULL)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
'In commctrl.h
'$IFUSE USE_ListView_HitTestEx
''------------------------------------------------------------------------------
'' Determines which list-view item, if any, is at a specified position.
'' ========================================================================================
'FUNCTION ListView_HitTestEx (hwndLV AS HWND,  pinfo AS LVHITTESTINFO PTR) AS LONG
'	FUNCTION = SendMessage(hwndLV, LVM_HITTEST, -1,  pinfo)
'END FUNCTION
''------------------------------------------------------------------------------
'$ENDUSE
'==============================================================================
$IFUSE USE_ListView_GetSelection
'------------------------------------------------------------------------------
' Returns the zero-based index of the currently selected item.
' See the following Microsoft article: How To Select a Listview Item Programmatically
' http://support.microsoft.com/kb/131284
' ========================================================================================
FUNCTION ListView_GetSelection ( hwndLV AS HWND) AS LONG
	FUNCTION = SendMessage(hwndLV, LVM_GETNEXTITEM, -1, LVNI_SELECTED)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ListView_SelectItem
'------------------------------------------------------------------------------
' Selects a ListView item.
' Windows does not provide a separate message or function to set the current selection in
' a listview. Instead, it defines item states or LVIS_* values that determine the listview
' item's appearance and functionality. LVIS_FOCUSED and LVIS_SELECTED in particular are
' the states that determine a listview item's selection state.
' Note that the last parameter passed to this macro is a mask specifying which bits are
' about to change. LVIS_FOCUSED and LVIS_SELECTED are defined in commctrl.inc as &H0001
' and &H0002 respectively, so you need to set the last four bits of the mask.
' See the following Microsoft article: How To Select a Listview Item Programmatically
' http://support.microsoft.com/kb/131284
' ========================================================================================
SUB ListView_SelectItem ( hwndLV AS HWND,  nIndex AS LONG)
	ListView_SetItemState(hwndLV, nIndex, LVIS_FOCUSED BOR LVIS_SELECTED, 0x000F)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ListView_SelectAllItems 
'------------------------------------------------------------------------------
' Selects all the items.
' ========================================================================================
SUB ListView_SelectAllItems (hwndLV AS HWND)
	DIM lvi AS LVITEMW
	lvi.mask = LVIF_STATE
	lvi.state = -1
	lvi.stateMask = LVIS_SELECTED
	SendMessage(hwndLV, LVM_SETITEMSTATE, -1,&lvi)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ListView_UnselectItem
'------------------------------------------------------------------------------
' Unselects an item in a ListView.
' ========================================================================================
SUB ListView_UnselectItem ( hwndLV AS HWND, nIndex AS LONG)
	ListView_SetItemState(hwndLV, nIndex, 0, LVIS_SELECTED)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ListView_UnselectAllItems
'------------------------------------------------------------------------------
' Unselects all items.
' ========================================================================================
SUB ListView_UnselectAllItems ( hwndLV AS HWND)
	ListView_SetItemState(hwndLV, -1, 0, LVIS_SELECTED BOR LVIS_FOCUSED)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ListView_MakeHeaderFlat
'------------------------------------------------------------------------------
' Removes the HDS_BUTTONS style from the header control to give it a flat appearance.
' ========================================================================================
SUB ListView_MakeHeaderFlat ( hwndLV AS HWND)
	Raw AS HWND hLvHeader = (HWND) SendMessage(hwndLV, LVM_GETHEADER, 0, 0)
	IF hLvHeader = NULL THEN
		EXIT SUB
	EndIf
	SetWindowLongPtrW( hLvHeader, GWL_STYLE, GetWindowLongPtrW(hLvHeader, GWL_STYLE) XOR HDS_BUTTONS)
	SetWindowPos(GetParent(hwndLV), NULL, 0, 0, 0, 0, SWP_NOZORDER BOR SWP_NOMOVE BOR SWP_NOSIZE BOR SWP_DRAWFRAME)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ListView_FitContent
'------------------------------------------------------------------------------
' Automatically sizes the specified column. Returns TRUE or FALSE.
' ========================================================================================
FUNCTION ListView_FitContent (hwndLV AS HWND, nCol AS LONG) AS BOOL
	FUNCTION = SendMessage(hwndLV, LVM_SETCOLUMNWIDTH, nCol, LVSCW_AUTOSIZE)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ListView_AutoSizeColumns
'------------------------------------------------------------------------------
' Automatically sizes all the columns of a listview. Returns TRUE or FALSE.
' ========================================================================================
FUNCTION ListView_AutoSizeColumns ( hwndLV AS HWND) AS BOOL
	DIM AS LONG i, nCount 
	Dim As HWND hLvHeader
	Dim As BOOL bRet
	hLvHeader = (HWND) SendMessage(hwndLV, LVM_GETHEADER, 0, 0)
	IF hLvHeader = NULL THEN
		EXIT FUNCTION
	EndIf
	nCount = SendMessage(hLvHeader, HDM_GETITEMCOUNT, 0, 0)
	FOR i = 0 TO nCount - 1
		bRet = SendMessage(hwndLV, LVM_SETCOLUMNWIDTH,  i, LVSCW_AUTOSIZE)
	NEXT
	Function = bRet
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ListView_FitHeader
'------------------------------------------------------------------------------
' Automatically sizes the column to fit the header text. If you use this value with the
' last column, its width is set to fill the remaining width of the list-view control.
' Returns TRUE or FALSE.
' ========================================================================================
FUNCTION ListView_FitHeader (hwndLV AS HWND, nCol AS LONG) AS BOOL
	FUNCTION = SendMessage(hwndLV, LVM_SETCOLUMNWIDTH, nCol, LVSCW_AUTOSIZE_USEHEADER)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ListView_AutoSizeHeader
'------------------------------------------------------------------------------
' Automatically sizes all the columns of the header of a listview
' ========================================================================================
FUNCTION ListView_AutoSizeHeader (hwndLV AS HWND) AS BOOL
	DIM AS LONG i, nCount 
	Dim As HWND hLvHeader
	Dim As BOOL bRet
	hLvHeader = (HWND) SendMessage(hwndLV, LVM_GETHEADER, 0, 0)
	IF hLvHeader = NULL THEN 
		EXIT FUNCTION
	EndIf
	nCount = SendMessage(hLvHeader, HDM_GETITEMCOUNT, 0, 0)
	FOR i = 0 TO nCount - 1
		bRet = SendMessage(hwndLV, LVM_SETCOLUMNWIDTH, i, LVSCW_AUTOSIZE_USEHEADER)
	NEXT
	Function = bRet
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ListView_GetColumnCount
'------------------------------------------------------------------------------
' Gets the number of columns of a listview.
' ========================================================================================
FUNCTION ListView_GetColumnCount ( hwndLV AS HWND) AS LONG
	Raw As HWND hLvHeader = (HWND) SendMessage(hwndLV, LVM_GETHEADER, 0, 0)
	IF hLvHeader = NULL THEN 
		EXIT FUNCTION
	EndIf
	FUNCTION = SendMessage(hLvHeader, HDM_GETITEMCOUNT, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ListView_GetColumnOrder
'------------------------------------------------------------------------------
' Gets the order of the specified column of the listview's header control.
' ========================================================================================
FUNCTION ListView_GetColumnOrder (hwndLV AS HWND, nCol AS LONG) AS LONG
	Raw As HWND hLvHeader = (HWND) SendMessage(hwndLV, LVM_GETHEADER, 0, 0)
	IF hLvHeader = NULL THEN 
		EXIT FUNCTION
	EndIf
	DIM AS HDITEMW hdi
	hdi.mask = HDI_ORDER
	IF SendMessage(hLvHeader, HDM_GETITEM, nCol, &hdi) THEN
		FUNCTION = hdi.iOrder
	EndIf
	Function = 0
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ListView_GetOrderArray
'------------------------------------------------------------------------------
' Gets the current left-to-right order of items in the header of a listview control.
' ========================================================================================
FUNCTION ListView_GetOrderArray (hwndLV AS HWND, nSize AS DWORD, lpiArray AS LONG PTR) AS LONG
	Raw As HWND hLvHeader = (HWND) SendMessage(hwndLV, LVM_GETHEADER, 0, 0)
	IF hLvHeader = NULL THEN 
		EXIT FUNCTION
	EndIf
	FUNCTION = SendMessage(hLvHeader, HDM_GETORDERARRAY, nSize, lpiArray)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_LietView_GetTooltipsFont
'------------------------------------------------------------------------------
' Retrieves the font used by the ToolTip control that the list-view control uses to display ToolTips.
' The return value is a handle to the font used by the control, or NULL if the control is
' using the system font.
' ========================================================================================
FUNCTION LietView_GetTooltipsFont ( hwndLV AS HWND) AS HFONT
	Raw As HWND hwndTooltips = (HWND) SendMessage(hwndLV, LVM_GETTOOLTIPS, 0, 0)
	FUNCTION = (HFONT) SendMessage(hwndTooltips, WM_GETFONT, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ListView_SetTooltipsFont
'------------------------------------------------------------------------------
' Sets the font used by the ToolTip control that the list-view control uses to display ToolTips.
' Parameters:
' - hwndLV  = Handle to the ListView control.
' - hFont   = Handle to the font. If this parameter is NULL, the control uses the default system font to draw text.
' - fRedraw = Specifies whether the control should be redrawn immediately upon setting the font.
'             If this parameter is TRUE, the control redraws itself.
' ========================================================================================
SUB ListView_SetTooltipsFont ( hwndLV AS HWND, hFont AS HFONT = NULL, fRedraw AS BOOL = FALSE)
	Raw As HWND hwndTooltips  = (HWND) SendMessage(hwndLV, LVM_GETTOOLTIPS, 0, 0)
	IF hwndTooltips = NULL THEN 
		EXIT SUB
	EndIf
	SendMessage(hwndTooltips, WM_SETFONT, hFont, fRedraw)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ListView_GetColumnText
'------------------------------------------------------------------------------
' Retrieves the text of the specified column. Returns TRUE or FALSE.
' - hwndLV: Handle to the listview control.
' - nCol: Zero-based index of the column
' - pwszText: A pointer to a buffer to receive the retrieved text.
' - cchTextMax : Maximum number of characters to return. Both this value and the size of the
'   buffer pointed by pwszText must be one character bigger that the wanted length of the text
'   to return to make room for the null character terminator.
' Return value: TRUE or FALSE.
' ========================================================================================
FUNCTION ListView_GetColumnText (hwndLV AS HWND, nCol AS LONG,  pwszText AS const char ptr PTR, cchTextMax AS LONG) AS BOOL
	IF pwszText = NULL THEN 
		EXIT FUNCTION
	EndIf
	DIM lvc AS LVCOLUMNW
	lvc.mask = LVCF_TEXT
	lvc.cchTextMax = cchTextMax
	lvc.pszText = (LPWSTR)pwszText
	FUNCTION = SendMessage(hwndLV, LVM_GETCOLUMNW, nCol, &lvc)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ListView_GetHeaderText
'------------------------------------------------------------------------------
' Retrieves the text of a list-view item or subitem.
' - hwndLV: Handle to the ListView control.
' - nCol: Zero-based index of the column
' - pwszText: A pointer to a buffer that receives the item or subitem text.
' - cchTextMax : Maximum number of characters to return. Both this value and the size of the
'   buffer pointed by pwszText must be one character bigger that the wanted length of the text
'   to return to make room for the null character terminator.
' Returns the number of characters in the pszText member of the LVITEM structure.
' ========================================================================================
FUNCTION ListView_GetHeaderText (hwndLV AS HWND, nCol AS LONG, pwszText AS const char PTR, cchTextMax AS LONG) AS LONG
	Raw As HWND hLvHeader = (HWND) SendMessage(hwndLV, LVM_GETHEADER, 0, 0)
	IF hLvHeader = NULL THEN 
		EXIT FUNCTION
	EndIf
	DIM hdi AS HDITEMW
	hdi.mask = HDI_TEXT
	hdi.cchTextMax = cchTextMax
	hdi.pszText = (LPWSTR)pwszText
	FUNCTION = SendMessage(hLvHeader, HDM_GETITEMW, nCol, &hdi)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ListView_AddColumn
'------------------------------------------------------------------------------
' Inserts a new column in a list-view control.
' - hwndLV: Handle to the ListView control.
' - nCol: Index of the new column.
' - pwszText: The column header text.
' - nWidth: The width of the column, in pixels.
' - nFormat: Alignment of the column header and the subitem text in the column.
'   The alignment of the leftmost column is always left-justified; it cannot be changed.
'   This member can be one of the following values:
'   see https://msdn.microsoft.com/en-us/library/windows/desktop/bb774743%28v=vs.85%29.aspx
' Returns the index of the new column if successful, or -1 otherwise.
' ========================================================================================
FUNCTION ListView_AddColumn (hwndLV AS HWND, nCol AS LONG, pwszText AS const char ptr, nWidth AS LONG, nFormat AS LONG = 0) AS LONG
	DIM AS LVCOLUMNW lvc
	lvc.mask = LVCF_FMT BOR LVCF_WIDTH BOR LVCF_TEXT BOR LVCF_SUBITEM
	lvc.fmt = nFormat
	lvc.pszText = (LPWSTR)pwszText
	lvc.cx = nWidth
	lvc.iSubItem = nCol
	FUNCTION = SendMessage(hwndLV, LVM_INSERTCOLUMNW, nCol, &lvc)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ListView_AddItem
'------------------------------------------------------------------------------
' Inserts a new item in a list-view control.
' - hwndLV: Handle to the ListView control.
' - nItem: Zero-based index at which the new item should be inserted. If this value is
'   greater than the number of items currently contained by the listview control, the new
'   item will be appended to the end of the list and assigned the correct index. Examine the
'   return value to determine the actual index assigned to the item.
' - nImage: Zero-based index of the item's icon in the control's image list.
' - pwszText: The item text.
' Returns the index of the new item if successful, or -1 otherwise.
' ========================================================================================
FUNCTION ListView_AddItem (hwndLV AS HWND, nItem AS LONG, nImage AS LONG, pwszText AS const char PTR) AS LONG
	DIM lvi AS LVITEMW
	lvi.mask = LVIF_TEXT
	lvi.pszText = (LPWSTR)pwszText
	lvi.iItem = nItem
	lvi.iImage = nImage
	FUNCTION = SendMessage(hwndLV, LVM_INSERTITEMW, nItem, &lvi)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ListView_AppendItem
'------------------------------------------------------------------------------
' Appends a new item in a list-view control.
' - hwndLV: Handle to the ListView control.
' - nImage: Zero-based index of the item's icon in the control's image list.
' - pwszText: The item text.
' Returns the index of the new item if successful, or -1 otherwise.
' ========================================================================================
FUNCTION ListView_AppendItem (hwndLV AS HWND, nImage AS LONG, pwszText AS const char PTR) AS LONG
	DIM AS LVITEMW lvi
	Raw As LONG nItem = SendMessage(hwndLV, LVM_GETITEMCOUNT, 0, 0)
	lvi.mask = LVIF_TEXT
	lvi.pszText = (LPWSTR)pwszText
	lvi.iItem = nItem
	lvi.iImage = nImage
	FUNCTION = SendMessage(hwndLV, LVM_INSERTITEMW, nItem, &lvi)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE

' ########################################################################################
'                                      *** REBAR ***
' ########################################################################################

'==============================================================================
$IFUSE USE_Rebar_BeginDrag
'------------------------------------------------------------------------------
' Puts the rebar control in drag-and-drop mode.
' ========================================================================================
SUB Rebar_BeginDrag (hRebar AS HWND, uBand AS DWORD, dwPos AS DWORD)
	SendMessage(hRebar, RB_BEGINDRAG, uBand, dwPos)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_DeleteBand
'------------------------------------------------------------------------------
' Deletes a band from a rebar control. Returns TRUE or FALSE.
' ========================================================================================
FUNCTION Rebar_DeleteBand (hRebar AS HWND, uBand AS DWORD) AS BOOL
	FUNCTION = SendMessage(hRebar, RB_DELETEBAND, uBand, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_DragMove
'------------------------------------------------------------------------------
' Updates the drag position in the rebar control after a previous RB_BEGINDRAG message.
' ========================================================================================
SUB Rebar_DragMove ( hRebar AS HWND, dwPos AS DWORD)
	SendMessage(hRebar, RB_DRAGMOVE, 0, dwPos)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_EndDrag
'------------------------------------------------------------------------------
' Terminates the rebar control's drag-and-drop operation. This message does not cause an
' RBN_ENDDRAG notification to be sent.
' ========================================================================================
SUB Rebar_EndDrag ( hRebar AS HWND)
	SendMessage(hRebar, RB_ENDDRAG, 0, 0)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_GetBandBorders
'------------------------------------------------------------------------------
' Retrieves the borders of a band. The result of this message can be used to calculate the
' usable area in a band.
' ========================================================================================
SUB Rebar_GetBandBorders ( hRebar AS HWND, uBand AS DWORD, lprc AS RECT PTR)
	IF lprc = NULL THEN
		EXIT SUB
	EndIf
	SendMessage(hRebar, RB_GETBANDBORDERS, uBand, lprc)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_GetBandCount
'------------------------------------------------------------------------------
' Retrieves the count of bands currently in the rebar control.
' ========================================================================================
FUNCTION Rebar_GetBandCount ( hRebar AS HWND) AS DWORD
	FUNCTION = SendMessage(hRebar, RB_GETBANDCOUNT, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_GetBandInfo
'------------------------------------------------------------------------------
' Retrieves information about a specified band in a rebar control.
' Returns TRUE or FALSE.
' ========================================================================================
FUNCTION Rebar_GetBandInfo (hRebar AS HWND, uBand AS DWORD, lprbbi AS REBARBANDINFOW PTR) AS BOOL
	FUNCTION = SendMessage(hRebar, RB_GETBANDINFO, uBand, lprbbi)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_GetBandMargins
'------------------------------------------------------------------------------
' Retrieves the margins of a band.
' ========================================================================================
SUB Rebar_GetBandMargins ( hRebar AS HWND, pMargins AS MARGINS PTR)
	IF pMargins = NULL THEN 
		EXIT SUB
	EndIf
	SendMessage(hRebar, RB_GETBANDMARGINS, 0, pMargins)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_GetBarHeight
'------------------------------------------------------------------------------
' Retrieves the height of the rebar control.
' ========================================================================================
FUNCTION Rebar_GetBarHeight (hRebar AS HWND) AS DWORD
	FUNCTION = SendMessage(hRebar, RB_GETBARHEIGHT, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_GetBarInfo
'------------------------------------------------------------------------------
' Retrieves information about the rebar control and the image list it uses.
' Return value: Returns TRUE or FALSE.
' ========================================================================================
FUNCTION Rebar_GetBarInfo (hRebar AS HWND, lprbi AS REBARINFO PTR) AS BOOL
	IF lprbi = NULL THEN 
		EXIT FUNCTION
	EndIf
	FUNCTION = SendMessage(hRebar, RB_GETBARINFO, 0, lprbi)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_GetBkColor
'------------------------------------------------------------------------------
' Retrieves a rebar control's default background color.
' ========================================================================================
FUNCTION Rebar_GetBkColor ( hRebar AS HWND) AS COLORREF
	FUNCTION = SendMessage(hRebar, RB_GETBKCOLOR, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_GetColorScheme
'------------------------------------------------------------------------------
' Retrieves the color scheme information from the rebar control.
' Return value: Returns TRUE or FALSE.
' ========================================================================================
FUNCTION Rebar_GetColorScheme (hRebar AS HWND, lpcs AS COLORSCHEME PTR) AS BOOL
	IF lpcs = NULL THEN 
		EXIT FUNCTION
	EndIf
	FUNCTION = SendMessage(hRebar, RB_GETCOLORSCHEME, 0, lpcs)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_GetDropTarget
'------------------------------------------------------------------------------
' Retrieves a rebar control's IDropTarget interface pointer.
' ========================================================================================
FUNCTION Rebar_GetDropTarget (hRebar AS HWND) AS IDropTarget PTR
	DIM AS IDropTarget PTR ppIDropTarget 
	SendMessage(hRebar, RB_GETDROPTARGET, 0, &ppIDropTarget)
	FUNCTION = ppIDropTarget
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_GetExtendedStyle
'------------------------------------------------------------------------------
' Gets the extended style.
' ========================================================================================
FUNCTION Rebar_GetExtendedStyle ( hRebar AS HWND) AS DWORD
	FUNCTION = SendMessage(hRebar, RB_GETEXTENDEDSTYLE, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_GetPalette
'------------------------------------------------------------------------------
' Retrieves the rebar control's current palette.
' ========================================================================================
FUNCTION Rebar_GetPalette ( hRebar AS HWND) AS DWORD
	FUNCTION = SendMessage(hRebar, RB_GETPALETTE, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_GetRect
'------------------------------------------------------------------------------
' Retrieves the bounding rectangle for a given band in a rebar control.
' Return value: Returns TRUE or FALSE.
' ========================================================================================
FUNCTION Rebar_GetRect (hRebar AS HWND, uBand AS DWORD, lprc AS RECT PTR) AS BOOL
	IF lprc = NULL THEN 
		EXIT FUNCTION
	EndIf
	FUNCTION = SendMessage(hRebar, RB_GETRECT, uBand, lprc)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_GetRowCount
'------------------------------------------------------------------------------
' Retrieves the number of rows of bands in a rebar control.
' ========================================================================================
FUNCTION Rebar_GetRowCount (hRebar AS HWND) AS DWORD
	FUNCTION = SendMessage(hRebar, RB_GETROWCOUNT, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_GetRowHeight
'------------------------------------------------------------------------------
' Retrieves the height of a specified row in a rebar control.
' ========================================================================================
FUNCTION Rebar_GetRowHeight (hRebar AS HWND, uRow AS DWORD) AS DWORD
	FUNCTION = SendMessage(hRebar, RB_GETROWHEIGHT, uRow, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_GetTextColor
'------------------------------------------------------------------------------
' Retrieves a rebar control's default text color.
' ========================================================================================
FUNCTION Rebar_GetTextColor ( hRebar AS HWND) AS COLORREF
	FUNCTION = SendMessage(hRebar, RB_GETTEXTCOLOR, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_GetTooltips
'------------------------------------------------------------------------------
' Retrieves the handle to any ToolTip control associated with the rebar control.
' ========================================================================================
FUNCTION Rebar_GetTooltips ( hRebar AS HWND) AS HWND
	FUNCTION = (HWND) SendMessage(hRebar, RB_GETTOOLTIPS, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_GetUnicodeFormat
'------------------------------------------------------------------------------
' Retrieves the Unicode character format flag for the control.
' ========================================================================================
FUNCTION Rebar_GetUnicodeFormat ( hRebar AS HWND) AS LONG
	FUNCTION = SendMessage(hRebar, RB_GETUNICODEFORMAT, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_HitTest
'------------------------------------------------------------------------------
' Determines which portion of a rebar band is at a given point on the screen, if a rebar
' band exists at that point.
' - hRebar: Pointer to the rebar control.
' - lprhbt: Pointer to an RBHITTESTINFO structure. Before sending the message, the pt member
'   of this structure must be initialized to the point that will be hit tested, in client coordinates.
' Returns the zero-based index of the band at the given point, or -1 if no rebar band was at the point.
' ========================================================================================
FUNCTION Rebar_HitTest ( hRebar AS HWND, lprhbt AS RBHITTESTINFO PTR) AS LONG
	IF lprhbt = NULL THEN 
		EXIT FUNCTION
	EndIf
	FUNCTION = SendMessage(hRebar, RB_HITTEST, 0, lprhbt)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_IdToIndex
'------------------------------------------------------------------------------
' Converts a band identifier to a band index in a rebar control.
' Returns the zero-based band index if successful, or -1 otherwise. If duplicate band
' identifiers exist, the first one is returned.
' ========================================================================================
FUNCTION Rebar_IdToIndex (hRebar AS HWND, uBandID AS DWORD) AS LONG
	FUNCTION = SendMessage(hRebar, RB_IDTOINDEX, uBandID, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_InsertBand
'------------------------------------------------------------------------------
' Inserts a new band in a rebar control.
' ========================================================================================
FUNCTION Rebar_InsertBand ( hRebar AS HWND, nIndex AS LONG, lprbbi AS REBARBANDINFOW PTR) AS BOOL
	IF lprbbi = NULL THEN 
		EXIT FUNCTION
	EndIf
	FUNCTION = SendMessage(hRebar, RB_INSERTBAND, nIndex, lprbbi)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_MaximizeBand
'------------------------------------------------------------------------------
' Resizes a band in a rebar control to either its ideal or largest size.
' ========================================================================================
SUB Rebar_MaximizeBand ( hRebar AS HWND, uBand AS DWORD, fIdeal AS DWORD)
	SendMessage(hRebar, RB_MAXIMIZEBAND, uBand, fIdeal)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_MinimizeBand
'------------------------------------------------------------------------------
' Resizes a band in a rebar control to its smallest size.
' ========================================================================================
SUB Rebar_MinimizeBand ( hRebar AS HWND, uBand AS DWORD)
	SendMessage(hRebar, RB_MINIMIZEBAND, uBand, 0)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_MoveBand
'------------------------------------------------------------------------------
' Moves a band from one index to another. Returns TRUE or FALSE.
' ========================================================================================
FUNCTION Rebar_MoveBand (hRebar AS HWND, nFrom AS DWORD, nTo AS DWORD) AS BOOL
	FUNCTION = SendMessage(hRebar, RB_MOVEBAND, nFrom, nTo)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_PushChevron
'------------------------------------------------------------------------------
' Sent to a rebar control to programmatically push a chevron.
' ========================================================================================
SUB Rebar_PushChevron ( hRebar AS HWND, uBand AS DWORD, iAppValue AS DWORD)
	SendMessage(hRebar, RB_PUSHCHEVRON, uBand, iAppValue)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_SetBandInfo
'------------------------------------------------------------------------------
' Sets characteristics of an existing band in a rebar control. Returns TRUE or FALSE.
' ========================================================================================
FUNCTION Rebar_SetBandInfo (hRebar AS HWND, uBand AS DWORD, lprbbi AS REBARBANDINFOW PTR) AS BOOL
	IF lprbbi = NULL THEN 
		EXIT FUNCTION
	EndIf
	FUNCTION = SendMessage(hRebar, RB_SETBANDINFO, uBand, lprbbi)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_SetBandWidth
'------------------------------------------------------------------------------
' Sets the characteristics of a rebar control. Returns TRUE or FALSE.
' ========================================================================================
FUNCTION Rebar_SetBandWidth (hRebar AS HWND, uBand AS DWORD, nWidth AS DWORD) AS BOOL
	FUNCTION = SendMessage(hRebar, RB_SETBANDWIDTH, uBand, nWidth)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_SetBarInfo
'------------------------------------------------------------------------------
' Sets the characteristics of a rebar control. Returns TRUE or FALSE.
' ========================================================================================
FUNCTION Rebar_SetBarInfo (hRebar AS HWND, lprbi AS REBARINFO PTR) AS BOOL
	IF lprbi = NULL THEN 
		EXIT FUNCTION
	EndIf
	FUNCTION = SendMessage(hRebar, RB_SETBARINFO, 0, lprbi)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_SetBkColor
'------------------------------------------------------------------------------
' Sets a rebar control's default background color.
' Returns a COLORREF value that represents the previous default background color.
' ========================================================================================
FUNCTION Rebar_SetBkColor (hRebar AS HWND, clrBk AS DWORD) AS DWORD
	FUNCTION = SendMessage(hRebar, RB_SETBKCOLOR, 0, clrBk)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_SetColorScheme
'------------------------------------------------------------------------------
' Sets the color scheme information for the rebar control.
' ========================================================================================
SUB Rebar_SetColorScheme ( hRebar AS HWND, lpcs AS COLORSCHEME PTR)
	IF lpcs = NULL THEN 
		EXIT SUB
	EndIf
	SendMessage(hRebar, RB_SETCOLORSCHEME, 0, lpcs)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_SetPalette
'------------------------------------------------------------------------------
' Sets the rebar control's current palette.
' Returns an HPALETTE that specifies the rebar control's previous palette.
' ========================================================================================
FUNCTION Rebar_SetPalette (hRebar AS HWND, hpal AS HPALETTE) AS HPALETTE
	FUNCTION = (HPALETTE) SendMessage(hRebar, RB_SETPALETTE, 0, hpal)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_SetParent
'------------------------------------------------------------------------------
' Sets a rebar control's parent window.
' Returns the handle to the previous parent window, or NULL if there is no previous parent.
' ========================================================================================
FUNCTION Rebar_SetParent (hRebar AS HWND, hwndParent AS hWND) AS HWND
	FUNCTION = (HWND) SendMessage(hRebar, RB_SETPARENT, hwndParent, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_SetTextColor
'------------------------------------------------------------------------------
' Sets a rebar control's default text color.
' Returns a COLORREF value that represents the previous default text color.
' ========================================================================================
FUNCTION Rebar_SetTextColor (hRebar AS HWND, clrText AS COLORREF) AS COLORREF
	FUNCTION = SendMessage(hRebar, RB_SETTEXTCOLOR, 0, clrText)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_SetTooltips
'------------------------------------------------------------------------------
' Associates a tooltip control with the rebar control.
' ========================================================================================
SUB Rebar_SetTooltips ( hRebar AS HWND, hwndToolTip AS HWND)
	SendMessage(hRebar, RB_SETTOOLTIPS, hwndToolTip, 0)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_SetUnicodeFormat
'------------------------------------------------------------------------------
' Sets the Unicode character format flag for the control. This message allows you to
' change the character set used by the control at run time rather than having to re-create
' the control. Returns the previous Unicode format flag for the control.
' ========================================================================================
FUNCTION Rebar_SetUnicodeFormat ( hRebar AS HWND,  fUnicode AS DWORD) AS DWORD
	FUNCTION = SendMessage(hRebar, RB_SETUNICODEFORMAT, fUnicode, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_SetWindowTheme
'------------------------------------------------------------------------------
' Sets the visual style of a rebar control.
' ========================================================================================
SUB Rebar_SetWindowTheme (hRebar AS HWND,  pwszTheme AS const char ptr)
	SendMessage(hRebar, RB_SETWINDOWTHEME, 0, pwszTheme)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_ShowBand
'------------------------------------------------------------------------------
' Shows or hides a given band in a rebar control. Returns TRUE or FALSE.
' ========================================================================================
FUNCTION Rebar_ShowBand (hRebar AS HWND, uBand AS DWORD, fShow AS DWORD) AS BOOL
	FUNCTION = SendMessage(hRebar, RB_SHOWBAND, uBand, fShow)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Rebar_SizeToRect
'------------------------------------------------------------------------------
' Attempts to find the best layout of the bands for the given rectangle. Returns TRUE or FALSE.
' ========================================================================================
FUNCTION Rebar_SizeToRect (hRebar AS HWND,  prc AS RECT PTR) AS BOOL
	IF prc = NULL THEN 
		EXIT FUNCTION
	EndIf
	FUNCTION = SendMessage(hRebar, RB_SIZETORECT, 0, prc)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE

' ########################################################################################
'                                     *** STATIC ***
' ########################################################################################

'==============================================================================
$IFUSE USE_Static_SetImage
'------------------------------------------------------------------------------
' Associates a new image with a static control.
' The return value is a handle to the image previously associated with the static control,
' if any; otherwise, it is NULL.
' To associate an image with a static control, the control must have the proper style. The
' following table shows the style needed for each image type.
' Image type          Static control style
'   IMAGE_BITMAP      SS_BITMAP
'   IMAGE_CURSOR      SS_ICON
'   IMAGE_ENHMETAFILE SS_ENHMETAFILE
'   IMAGE_ICON        SS_ICON
' ========================================================================================
FUNCTION Static_SetImage (hStatic AS HWND, nType AS LONG, hImage AS HANDLE) AS HANDLE
	FUNCTION = (HANDLE) SendMessage(hStatic, STM_SETIMAGE, nType, hImage)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Static_DeleteImage
'------------------------------------------------------------------------------
' Deletes an image associated with an static control. Returns TRUE or FALSE.
' ========================================================================================
FUNCTION Static_DeleteImage (hStatic AS HWND, nType AS LONG) AS BOOL
	FUNCTION = DeleteObject((HGDIOBJ) SendMessage(hStatic, STM_SETIMAGE, nType, 0))
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Static_GetImage
'------------------------------------------------------------------------------
' Retrieves a handle to the image (icon or bitmap) associated with a static control.
' The return value is a handle to the image, if any; otherwise, it is NULL.
' ========================================================================================
FUNCTION Static_GetImage (hStatic AS HWND, nType AS LONG) AS HANDLE
	FUNCTION = (HANDLE) SendMessage(hStatic, STM_GETIMAGE, nType, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Static_SetBitmap
'------------------------------------------------------------------------------
' Associates a bitmap with an static control.
' The return value is a handle to the image previously associated with the static control,
' if any; otherwise, it is NULL.
' ========================================================================================
FUNCTION Static_SetBitmap (hStatic AS HWND, hBitmap AS HBITMAP) AS HBITMAP
	FUNCTION = (HBITMAP) SendMessage(hStatic, STM_SETIMAGE, IMAGE_BITMAP, hBitmap)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Static_DeleteIcon
'------------------------------------------------------------------------------
' Deletes an icon associated with an static control. Returns TRUE o FALSE.
' ========================================================================================
FUNCTION Static_DeleteIcon ( hStatic AS HWND) AS BOOL
	FUNCTION = DeleteObject((HGDIOBJ) SendMessage(hStatic, STM_SETICON, 0, 0))
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Static_DeleteBitmap
'------------------------------------------------------------------------------
' Deletes a bitmap associated with an static control. Returns TRUE o FALSE.
' ========================================================================================
FUNCTION Static_DeleteBitmap ( hStatic AS HWND) AS BOOL
	FUNCTION = DeleteObject((HGDIOBJ) SendMessage(hStatic, STM_SETIMAGE, IMAGE_BITMAP, 0))
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Static_SetCursor
'------------------------------------------------------------------------------
' Associates a cursor with an static control.
' The return value is a handle to the cursor previously associated with the static control,
' ========================================================================================
FUNCTION Static_SetCursor (hStatic AS HWND, hCursor AS HCURSOR) AS HCURSOR
	FUNCTION = (HCURSOR) SendMessage(hStatic, STM_SETIMAGE, IMAGE_CURSOR, hCursor)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Static_DeleteCursor
'------------------------------------------------------------------------------
' Deletes a cursor associated with an static control. Returns TRUE or FALSE.
' ========================================================================================
FUNCTION Static_DeleteCursor ( hStatic AS HWND) AS BOOL
	FUNCTION = DeleteObject((HGDIOBJ) SendMessage(hStatic, STM_SETIMAGE, IMAGE_CURSOR, 0))
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Static_SetEnhancedMetafile
'------------------------------------------------------------------------------
' Associates an enhanced metafile with an static control.
' The return value is a handle to the image previously associated with the static control,
' if any; otherwise, it is NULL.
' ========================================================================================
FUNCTION Static_SetEnhancedMetafile (hStatic AS HWND, hEnhMetafile AS HENHMETAFILE) AS HENHMETAFILE
	FUNCTION = (HENHMETAFILE) SendMessage(hStatic, STM_SETIMAGE, IMAGE_ENHMETAFILE, hEnhMetafile)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Static_DeleteEnhancedMetafile
'------------------------------------------------------------------------------
' Deletes an enhanced metafile associated with an static control. Returns TRUE or FALSE.
' ========================================================================================
FUNCTION Static_DeleteEnhancedMetafile (hStatic AS HWND) AS BOOL
	FUNCTION = DeleteObject((HGDIOBJ) SendMessage(hStatic, STM_SETIMAGE, IMAGE_ENHMETAFILE, 0))
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================

' ########################################################################################
'                                    *** TOOLBAR ***
' ########################################################################################

'==============================================================================
$IFUSE USE_Toolbar_AddBitmap
'------------------------------------------------------------------------------
' Adds one or more images to the list of button images available for a toolbar.
' Returns the index of the first new image if successful, or -1 otherwise.
' ========================================================================================
FUNCTION Toolbar_AddBitmap (hToolBar AS HWND, nButtons AS DWORD, tabm AS TBADDBITMAP PTR) AS LONG
	FUNCTION = SendMessage(hToolBar, TB_ADDBITMAP, nButtons, tabm)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_AddButtons
'------------------------------------------------------------------------------
' Adds one or more buttons to a toolbar.
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION Toolbar_AddButtons ( hToolBar AS HWND, nButtons AS DWORD, lpButtons AS TBBUTTON PTR) AS BOOL
	FUNCTION = SendMessage(hToolBar, TB_ADDBUTTONSW, nButtons, lpButtons)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_AddButton
'------------------------------------------------------------------------------
' Adds a button to a toolbar.
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION Toolbar_AddButton (hToolBar AS HWND, idxBitmap AS LONG, idCommand AS LONG, _
                            fsState AS BYTE = 0, fsStyle AS BYTE = 0, _
                            dwData AS DWORD_PTR = 0, pwszText As const char PTR = NULL) AS BOOL
	IF fsState = 0 THEN 
		fsState = TBSTATE_ENABLED
	EndIf
	DIM AS INT_PTR idxString 
	IF pwszText <> NULL THEN 
		idxString = iif(LEN(pwszText) = 0, (INT_PTR)-1, (INT_PTR) pwszText)
	EndIf
	Raw AS TBBUTTON tbb  = {idxBitmap, idCommand, fsState, fsStyle, {0, 0, 0, 0, 0, 0}, dwData, idxString}
	FUNCTION = SendMessage(hToolBar, TB_ADDBUTTONSW, 1,  &tbb)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_AddSeparator
'------------------------------------------------------------------------------
' Adds a separator to a toolbar.
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION Toolbar_AddSeparator ( hToolBar AS HWND, nWidth AS LONG = 0) AS BOOL
	Raw AS TBBUTTON tbb = {nWidth, 0, TBSTATE_ENABLED, TBSTYLE_SEP, {0, 0, 0, 0, 0, 0}, 0, -1}
	FUNCTION = SendMessage(hToolBar, TB_ADDBUTTONSW, 1, &tbb)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_InsertButton
'------------------------------------------------------------------------------
' Inserts a button in a toolbar.
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION Toolbar_InsertButton ( hToolBar AS HWND, idxButton AS LONG, lpButton AS TBBUTTON PTR) AS BOOL
	FUNCTION = SendMessage(hToolBar, TB_INSERTBUTTONW, idxButton, lpButton)
END FUNCTION
'------------------------------------------------------------------------------
FUNCTION Toolbar_InsertButton ( hToolBar AS HWND, idxButton AS LONG, idxBitmap AS LONG, idCommand AS LONG, _
                                fsState AS BYTE = 0, fsStyle AS BYTE = 0, dwData AS DWORD_PTR = 0, _
                                pwszText AS const char PTR = NULL) AS BOOL
	IF fsState = 0 THEN 
		fsState = TBSTATE_ENABLED
	EndIf
	DIM AS INT_PTR idxString 
	IF pwszText <> NULL THEN 
		'idxString = IIF(LEN(*pwszText) = 0, -1, CAST(INT_PTR, pwszText))
		idxString = iif(LEN(pwszText) = 0, (INT_PTR)-1, (INT_PTR) pwszText)
	EndIf
	Raw AS TBBUTTON tbb = {idxBitmap, idCommand, fsState, fsStyle, {0, 0, 0, 0, 0, 0}, dwData, idxString}
	FUNCTION = SendMessage(hToolBar, TB_INSERTBUTTONW, idxButton, &tbb)
END FUNCTION
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_InsertSeparator
'------------------------------------------------------------------------------
' Inserts a separator in a toolbar.
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION Toolbar_InsertSeparator ( hToolBar AS HWND, idxButton AS LONG, nWidth AS LONG = 0) AS BOOL
	DIM AS TBBUTTON tbb = {nWidth, 0, TBSTATE_ENABLED, TBSTYLE_SEP, {0, 0, 0, 0, 0, 0}, 0, -1}
	FUNCTION = SendMessage(hToolBar, TB_INSERTBUTTONW, idxButton, &tbb)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_AddString
'------------------------------------------------------------------------------
' Adds a new string to the toolbar's string pool.
' Returns the index of the first new string if successful, or -1 otherwise.
' ========================================================================================
FUNCTION Toolbar_AddString ( hToolBar AS HWND, hInst AS HINSTANCE, idString AS INT_PTR) AS LONG
	FUNCTION = SendMessage(hToolBar, TB_ADDSTRINGW, hInst, iif(hInst EQU NULL, (INT_PTR)idString, (INT_PTR)MAKELONG(idString, 0)))
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_AutoSize
'------------------------------------------------------------------------------
' Causes a toolbar to be resized.
' ========================================================================================
SUB Toolbar_AutoSize ( hToolBar AS HWND)
	SendMessage(hToolBar, TB_AUTOSIZE, 0, 0)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_ButtonCount
'------------------------------------------------------------------------------
' Retrieves a count of the buttons currently in the toolbar.
' ========================================================================================
FUNCTION Toolbar_ButtonCount ( hToolBar AS HWND) AS DWORD
	FUNCTION = SendMessage(hToolBar, TB_BUTTONCOUNT, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_ButtonStructSize
'------------------------------------------------------------------------------
' Specifies the size of the TBBUTTON structure.
' ========================================================================================
SUB Toolbar_ButtonStructSize ( hToolBar AS HWND, cb AS LONG)
	SendMessage(hToolBar, TB_BUTTONSTRUCTSIZE, cb, 0)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_ChangeBitmap
'------------------------------------------------------------------------------
' Changes the bitmap for a button in a toolbar.
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION Toolbar_ChangeBitmap ( hToolBar AS HWND, idButton AS LONG, iBitmap AS WORD) AS BOOL
	FUNCTION = SendMessage(hToolBar, TB_CHANGEBITMAP, idButton, MAKELONG(iBitmap, 0))
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_CheckButton
'------------------------------------------------------------------------------
' Checks or unchecks a given button in a toolbar.
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION Toolbar_CheckButton ( hToolBar AS HWND, idButton AS LONG, fCheck AS SHORT) AS BOOL
	FUNCTION = SendMessage(hToolBar, TB_CHECKBUTTON, idButton, MAKELONG(fCheck, 0))
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_CommandToIndex
'------------------------------------------------------------------------------
' Retrieves the zero-based index for the button associated with the specified command
' identifier. Returns the zero-based index for the button or -1 if the specified command
' identifier is invalid.
' ========================================================================================
FUNCTION Toolbar_CommandToIndex (hToolBar AS HWND, idButton AS LONG) AS LONG
	FUNCTION = SendMessage(hToolBar, TB_COMMANDTOINDEX, idButton, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_Customize
'------------------------------------------------------------------------------
' Displays the Customize Toolbar dialog box.
' ========================================================================================
SUB Toolbar_Customize ( hToolBar AS HWND)
	SendMessage(hToolBar, TB_CUSTOMIZE, 0, 0)
END SUB
'------------------------------------------------------------------------------
'==============================================================================
$IFUSE USE_Toolbar_DeleteButton
'------------------------------------------------------------------------------
' Deletes a button from the toolbar.
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION Toolbar_DeleteButton (hToolBar AS HWND,  nButton AS LONG) AS BOOL
	FUNCTION = SendMessage(hToolBar, TB_DELETEBUTTON, nButton, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_EnableButton
'------------------------------------------------------------------------------
' Enables the specified button in a toolbar.
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION Toolbar_EnableButton ( hToolBar AS HWND, idButton AS LONG) AS BOOL
	FUNCTION = SendMessage(hToolBar, TB_ENABLEBUTTON, idButton, MAKELONG(TRUE, 0))
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_DisableButton
'------------------------------------------------------------------------------
' Disables the specified button in a toolbar.
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION Toolbar_DisableButton ( hToolBar AS HWND, idButton AS LONG) AS BOOL
	FUNCTION = SendMessage(hToolBar, TB_ENABLEBUTTON, idButton, MAKELONG(FALSE, 0))
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_GetAnchorHighlight
'------------------------------------------------------------------------------
' Retrieves the anchor highlight setting for a toolbar.
' Returns a Boolean value that indicates if anchor highlighting is set. If this value is
' nonzero, anchor highlighting is enabled. If this value is zero, it is disabled.
' ========================================================================================
FUNCTION Toolbar_GetAnchorHighlight ( hToolBar AS HWND) AS BOOL
	FUNCTION = SendMessage(hToolBar, TB_GETANCHORHIGHLIGHT, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_GetBitmap
'------------------------------------------------------------------------------
' Retrieves the index of the bitmap associated with a button in a toolbar.
' Returns the index of the bitmap if successful, or zero otherwise.
' ========================================================================================
FUNCTION Toolbar_GetBitmap ( hToolBar AS HWND,  idButton AS LONG) AS LONG
	FUNCTION = SendMessage(hToolBar, TB_GETBITMAP, idButton, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_GetBitmapFlags
'------------------------------------------------------------------------------
' Retrieves the flags that describe the type of bitmap to be used.
' Returns a DWORD value that describes the type of bitmap that should be used. If this
' return value has the TBBF_LARGE flag set, applications should use large bitmaps (24 x 24);
' otherwise, applications should use small bitmaps (16 x 16). All other bits are reserved.
' ========================================================================================
FUNCTION Toolbar_GetBitmapFlags ( hToolBar AS HWND) AS DWORD
	FUNCTION = SendMessage(hToolBar, TB_GETBITMAPFLAGS, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_GetButton
'------------------------------------------------------------------------------
' Retrieves information about the specified button in a toolbar.
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION Toolbar_GetButton ( hToolBar AS HWND, nButton AS LONG, ptbb AS TBBUTTON PTR) AS BOOL
	FUNCTION = SendMessage(hToolBar, TB_GETBUTTON, nButton,  ptbb)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_GetButtonSize
'------------------------------------------------------------------------------
' Retrieves the current width and height of toolbar buttons, in pixels.
' Returns a DWORD value that contains the width and height values in the low word and high
' word, respectively.
' ========================================================================================
FUNCTION Toolbar_GetButtonSize ( hToolBar AS HWND) AS DWORD
	FUNCTION = SendMessage(hToolBar, TB_GETBUTTONSIZE, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_GetButtonHeight
'------------------------------------------------------------------------------
' Retrieves the current height of toolbar buttons, in pixels.
' ========================================================================================
FUNCTION Toolbar_GetButtonHeight ( hToolBar AS HWND) AS DWORD
	FUNCTION = HIWORD(SendMessage(hToolBar, TB_GETBUTTONSIZE, 0, 0))
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_GetButtonWidth
'------------------------------------------------------------------------------
' Retrieves the current width of toolbar buttons, in pixels.
' ========================================================================================
FUNCTION Toolbar_GetButtonWidth ( hToolBar AS HWND) AS DWORD
	FUNCTION = LOWORD(SendMessage(hToolBar, TB_GETBUTTONSIZE, 0, 0))
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_GetButtonInfo
'------------------------------------------------------------------------------
' Retrieves extended information for a button in a toolbar.
' Returns the zero-based index of the button, or -1 if an error occurs.
' ========================================================================================
FUNCTION Toolbar_GetButtonInfo ( hToolBar AS HWND, iID AS LONG, lptbbi AS TBBUTTONINFOW PTR) AS LONG
	FUNCTION = SendMessage(hToolBar, TB_GETBUTTONINFOW, iID, lptbbi)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_GetColorScheme
'------------------------------------------------------------------------------
' Retrieves the color scheme information from the toolbar control.
' - lpcs: Pointer to a COLORSCHEME structure that will receive the color scheme information.
'   You must set the cbSize member of this structure to sizeof(COLORSCHEME) before sending
'   this message.
' Returns nonzero if successful, or zero otherwise.
' ========================================================================================
FUNCTION Toolbar_GetColorScheme ( hToolBar AS HWND, lpcs AS COLORSCHEME PTR) AS BOOL
	FUNCTION = SendMessage(hToolBar, TB_GETCOLORSCHEME, 0,  lpcs)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_GetImageList
'------------------------------------------------------------------------------
' Retrieves the image list that a toolbar control uses to display buttons in their default
' state. A toolbar control uses this image list to display buttons when they are not hot
' or disabled.
' ========================================================================================
FUNCTION Toolbar_GetImageList ( hToolBar AS HWND) AS HIMAGELIST
	FUNCTION = (HIMAGELIST) SendMessage(hToolBar, TB_GETIMAGELIST, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_GetDisabledImageList
'------------------------------------------------------------------------------
' Retrieves the image list that a toolbar control uses to display inactive buttons.
' A toolbar control uses this image list to display buttons when they are disabled.
' ========================================================================================
FUNCTION Toolbar_GetDisabledImageList ( hToolBar AS HWND) AS HIMAGELIST
	FUNCTION = (HIMAGELIST) SendMessage(hToolBar, TB_GETDISABLEDIMAGELIST, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_GetHotImageList
'------------------------------------------------------------------------------
' Retrieves the image list that a toolbar control uses to display hot buttons.
' ========================================================================================
FUNCTION Toolbar_GetHotImageList ( hToolBar AS HWND) AS HIMAGELIST
	FUNCTION = (HIMAGELIST) SendMessage(hToolBar, TB_GETHOTIMAGELIST, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_GetExtendedStyle
'------------------------------------------------------------------------------
' Retrieves the extended styles for a toolbar control.
' Returns a DWORD that represents the styles currently in use for the toolbar control.
' This value can be a combination of extended styles.
' ========================================================================================
FUNCTION Toolbar_GetExtendedStyle ( hToolBar AS HWND) AS DWORD
	FUNCTION = SendMessage(hToolBar, TB_GETEXTENDEDSTYLE, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_GetHorizontalPadding
'------------------------------------------------------------------------------
' Retrieves the horizontal padding for a toolbar control.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION Toolbar_GetHorizontalPadding ( hToolBar AS HWND) AS DWORD
	FUNCTION = LOWORD(SendMessage(hToolBar, TB_GETPADDING, 0, 0))
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_GetVerticalPadding
'------------------------------------------------------------------------------
' Retrieves the vertical padding for a toolbar control.
' ========================================================================================
FUNCTION Toolbar_GetVerticalPadding (BYVAL hToolBar AS HWND) AS DWORD
	FUNCTION = HIWORD(SendMessage(hToolBar, TB_GETPADDING, 0, 0))
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_GetHotItem
'------------------------------------------------------------------------------
' Retrieves the index of the hot item in a toolbar.
' ========================================================================================
FUNCTION Toolbar_GetHotItem ( hToolBar AS HWND) AS DWORD
	FUNCTION = SendMessage(hToolBar, TB_GETHOTITEM, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_GetInsertMark
'------------------------------------------------------------------------------
' Retrieves the current insertion mark for the toolbar.
' Always returns TRUE.
' ========================================================================================
FUNCTION Toolbar_GetInsertMark ( hToolBar AS HWND, ptbim AS TBINSERTMARK PTR) AS LONG
	FUNCTION = SendMessage(hToolBar, TB_GETINSERTMARK, 0, ptbim)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_GetInsertMarkColor
'------------------------------------------------------------------------------
' Retrieves the color used to draw the insertion mark for the toolbar.
' Returns a COLORREF value that contains the current insertion mark color.
' ========================================================================================
FUNCTION Toolbar_GetInsertMarkColor ( hToolBar AS HWND) AS COLORREF
	FUNCTION = SendMessage(hToolBar, TB_GETINSERTMARKCOLOR, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_GetItemRect
'------------------------------------------------------------------------------
' Retrieves the bounding rectangle of a button in a toolbar.
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION Toolbar_GetItemRect ( hToolBar AS HWND, nButton AS LONG, lprc AS RECT PTR) AS BOOL
	FUNCTION = SendMessage(hToolBar, TB_GETITEMRECT, nButton, lprc)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_GetMaxSize
'------------------------------------------------------------------------------
' Retrieves the total size of all of the visible buttons and separators in the toolbar.
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION Toolbar_GetMaxSize ( hToolBar AS HWND, psize AS SIZE PTR) AS BOOL
	FUNCTION = SendMessage(hToolBar, TB_GETMAXSIZE, 0, psize)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_GetMetrics
'------------------------------------------------------------------------------
' Retrieves the metrics of a toolbar control.
' Note: To use this API, you must provide a manifest specifying Comclt32.dll version 6.0.
' ========================================================================================
SUB Toolbar_GetMetrics ( hToolBar AS HWND, ptbMetrics AS TBMETRICS PTR)
	SendMessage(hToolBar, TB_GETMETRICS, 0, ptbMetrics)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_GetPadding
'------------------------------------------------------------------------------
' Retrieves the padding for a toolbar control.
' Returns a DWORD value that contains the horizontal padding in the low word and the
' vertical padding in the high word, in pixels.
' ========================================================================================
FUNCTION Toolbar_GetPadding ( hToolBar AS HWND) AS DWORD
	FUNCTION = SendMessage(hToolBar, TB_GETPADDING, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_GetRect
'------------------------------------------------------------------------------
' Retrieves the bounding rectangle for a specified toolbar button.
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION Toolbar_GetRect ( hToolBar AS HWND, iID AS LONG, lprc AS RECT PTR) AS BOOL
	FUNCTION = SendMessage(hToolBar, TB_GETRECT, iID, lprc)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_GetRows
'------------------------------------------------------------------------------
' Retrieves the number of rows of buttons in a toolbar with the TBSTYLE_WRAPABLE style.
' ========================================================================================
FUNCTION Toolbar_GetRows ( hToolBar AS HWND) AS DWORD
	FUNCTION = SendMessage(hToolBar, TB_GETROWS, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_GetState
'------------------------------------------------------------------------------
' Retrieves information about the state of the specified button in a toolbar, such as
' whether it is enabled, pressed, or checked.
' ========================================================================================
FUNCTION Toolbar_GetState ( hToolBar AS HWND, idButton AS LONG) AS DWORD
	FUNCTION = SendMessage(hToolBar, TB_GETSTATE, idButton, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_GetString
'------------------------------------------------------------------------------
' Retrieves a string from a toolbar's string pool.
' - iString: Index of the string
' - pBuffer: Pointer to a buffer used to return the string.
' - cchMax: Length of the buffer in bytes.
' Returns the string length if successful, or -1 otherwise.
' ========================================================================================
FUNCTION Toolbar_GetString (hToolBar AS HWND, iString AS SHORT, pBuffer AS char PTR,  cchMax AS SHORT) AS LONG
	FUNCTION = SendMessage(hToolBar, TB_GETSTRINGW, MAKELONG(cchMax, iString), pBuffer)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_GetStyle
'------------------------------------------------------------------------------
' Retrieves the styles currently in use for a toolbar control.
' Returns a DWORD value that is a combination of toolbar control styles.
' ========================================================================================
FUNCTION Toolbar_GetStyle ( hToolBar AS HWND) AS DWORD
	FUNCTION = SendMessage(hToolBar, TB_GETSTYLE, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_GetTextRows
'------------------------------------------------------------------------------
' Retrieves the number of rows of buttons in a toolbar with the TBSTYLE_WRAPABLE style.
' ========================================================================================
FUNCTION Toolbar_GetTextRows ( hToolBar AS HWND) AS DWORD
	FUNCTION = SendMessage(hToolBar, TB_GETTEXTROWS, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_GetTooltips
'------------------------------------------------------------------------------
' Retrieves the handle to the ToolTip control, if any, associated with the toolbar.
' ========================================================================================
FUNCTION Toolbar_GetTooltips ( hToolBar AS HWND) AS HWND
	FUNCTION = (HWND) SendMessage(hToolBar, TB_GETTOOLTIPS, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_GetUnicodeFormat
'------------------------------------------------------------------------------
' Retrieves the Unicode character format flag for the control.
' ========================================================================================
FUNCTION Toolbar_GetUnicodeFormat ( hToolBar AS HWND) AS DWORD
	FUNCTION = SendMessage(hToolBar, TB_GETUNICODEFORMAT, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_HideButton
'------------------------------------------------------------------------------
' Hides or shows the specified button in a toolbar.
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION Toolbar_HideButton (hToolBar AS HWND, idButton AS LONG, fShow AS SHORT) AS BOOL
	FUNCTION = SendMessage(hToolBar, TB_HIDEBUTTON, idButton, MAKELONG(fShow, 0))
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_HitTest
'------------------------------------------------------------------------------
' Determines where a point lies in a toolbar control.
' Returns an integer value. If the return value is zero or a positive value, it is the
' zero-based index of the nonseparator item in which the point lies. If the return value
' is negative, the point does not lie within a button. The absolute value of the return
' value is the index of a separator item or the nearest nonseparator item.
' ========================================================================================
FUNCTION Toolbar_HitTest ( hToolBar AS HWND, pptHitTest AS POINT PTR) AS LONG
	FUNCTION = SendMessage(hToolBar, TB_HITTEST, 0, pptHitTest)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_Indeterminate
'------------------------------------------------------------------------------
' Sets or clears the indeterminate state of the specified button in a toolbar.
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION Toolbar_Indeterminate ( hToolBar AS HWND, idButton AS LONG, fIndeterminate AS SHORT) AS BOOL
	FUNCTION = SendMessage(hToolBar, TB_INDETERMINATE, idButton, MAKELONG(fIndeterminate, 0))
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_InsertMarkHitTest
'------------------------------------------------------------------------------
' Retrieves the insertion mark information for a point in a toolbar.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION Toolbar_InsertMarkHitTest (hToolBar AS HWND, lppt AS POINT PTR, lptbim AS TBINSERTMARK PTR) AS BOOL
	FUNCTION = SendMessage(hToolBar, TB_INSERTMARKHITTEST, lppt, lptbim)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_IsButtonChecked
'------------------------------------------------------------------------------
' Determines whether the specified button in a toolbar is checked.
' Returns TRUE if the point is an insertion mark, or FALSE otherwise.
' ========================================================================================
FUNCTION Toolbar_IsButtonChecked (hToolBar AS HWND, idButton AS LONG) AS BOOL
	FUNCTION = SendMessage(hToolBar, TB_ISBUTTONCHECKED, idButton, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_IsButtonEnabled
'------------------------------------------------------------------------------
' Determines whether the specified button in a toolbar is enabled.
' Returns TRUE if the button is enabled, or FALSE otherwise.
' ========================================================================================
FUNCTION Toolbar_IsButtonEnabled ( hToolBar AS HWND, idButton AS LONG) AS BOOL
	FUNCTION = SendMessage(hToolBar, TB_ISBUTTONENABLED, idButton, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_IsButtonHidden
'------------------------------------------------------------------------------
' Determines whether the specified button in a toolbar is hidden.
' Returns TRUE if the button is hidden, or FALSE otherwise.
' ========================================================================================
FUNCTION Toolbar_IsButtonHidden ( hToolBar AS HWND, idButton AS LONG) AS BOOL
	FUNCTION = SendMessage(hToolBar, TB_ISBUTTONHIDDEN, idButton, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_IsButtonHighlighted
'------------------------------------------------------------------------------
' Checks the highlight state of a toolbar button.
' Returns TRUE if the button is highlighted, or FALSE otherwise.
' ========================================================================================
FUNCTION Toolbar_IsButtonHighlighted ( hToolBar AS HWND, idButton AS LONG) AS BOOL
	FUNCTION = SendMessage(hToolBar, TB_ISBUTTONHIGHLIGHTED, idButton, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_IsButtonIndeterminate
'------------------------------------------------------------------------------
' Determines whether the specified button in a toolbar is indeterminate.
' Returns TRUE if the button is in a indetermides state, or FALSE otherwise.
' ========================================================================================
FUNCTION Toolbar_IsButtonIndeterminate ( hToolBar AS HWND, idButton AS LONG) AS BOOL
	FUNCTION = SendMessage(hToolBar, TB_ISBUTTONINDETERMINATE, idButton, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_IsButtonPressed
'------------------------------------------------------------------------------
' Determines whether the specified button in a toolbar is pressed.
' Returns TRUE if the button is pressed, or FALSE otherwise.
' ========================================================================================
FUNCTION Toolbar_IsButtonPressed ( hToolBar AS HWND, idButton AS LONG) AS BOOL
	FUNCTION = SendMessage(hToolBar, TB_ISBUTTONPRESSED, idButton, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_LoadImages
'------------------------------------------------------------------------------
' Loads system-defined button images into a toolbar control's image list.
' The count of images in the image list. Returns zero if the toolbar has no image list or
' if the existing image list is empty.
' ========================================================================================
FUNCTION Toolbar_LoadImages ( hToolBar AS HWND, iBitmapID AS DWORD, hinst AS HINSTANCE) AS LONG
	FUNCTION = SendMessage(hToolBar, TB_LOADIMAGES, iBitmapID,  hinst)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_MapAccelerator
'------------------------------------------------------------------------------
' Determines the ID of the button that corresponds to the specified accelerator character.
' Returns TRUE if one of the buttons has wParam as its accelerator character, or FALSE otherwise.
' ========================================================================================
FUNCTION Toolbar_MapAccelerator ( hToolBar AS HWND, chAccel AS DWORD, pIDBtn AS DWORD PTR) AS BOOL
	FUNCTION = SendMessage(hToolBar, TB_MAPACCELERATOR, chAccel, pIDBtn)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_MarkButton
'------------------------------------------------------------------------------
' Sets the highlight state of a given button in a toolbar control.
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION Toolbar_MarkButton ( hToolBar AS HWND, idButton AS LONG, fHighlight AS SHORT) AS BOOL
	FUNCTION = SendMessage(hToolBar, TB_MARKBUTTON, idButton,  MAKELONG(fHighlight, 0))
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_MoveButton
'------------------------------------------------------------------------------
' Moves a button from one index to another.
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION Toolbar_MoveButton ( hToolBar AS HWND, uOldPos AS DWORD,  uNewPos AS DWORD) AS BOOL
	FUNCTION = SendMessage(hToolBar, TB_MOVEBUTTON, uOldPos, uNewPos)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_PressButton
'------------------------------------------------------------------------------
' Presses or releases the specified button in a toolbar.
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION Toolbar_PressButton ( hToolBar AS HWND, idButton AS LONG, fPress AS SHORT) AS BOOL
	FUNCTION = SendMessage(hToolBar, TB_PRESSBUTTON, idButton,  MAKELONG(fPress, 0))
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_ReplaceBitmap
'------------------------------------------------------------------------------
' Replaces an existing bitmap with a new bitmap.
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION Toolbar_ReplaceBitmap ( hToolBar AS HWND,  ptbrb AS TBREPLACEBITMAP PTR) AS BOOL
	FUNCTION = SendMessage(hToolBar, TB_REPLACEBITMAP, 0, ptbrb)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_SaveRestore
'------------------------------------------------------------------------------
' Send this message to initiate saving or restoring a toolbar state.
' Minimum operating systems Windows NT 3.51, Windows 95
' ========================================================================================
SUB Toolbar_SaveRestore ( hToolBar AS HWND, fSave AS LONG, ptbsp AS TBSAVEPARAMS PTR)
	SendMessage(hToolBar, TB_SAVERESTORE, fSave, ptbsp)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_SetAnchorHighlight
'------------------------------------------------------------------------------
' Sets the anchor highlight setting for a toolbar.
' Returns the previous anchor highlight setting. If this value is nonzero, anchor highlighting
' was enabled. If this value is zero, anchor highlighting was disabled.
' ========================================================================================
FUNCTION Toolbar_SetAnchorHighlight ( hToolBar AS HWND, fAnchor AS BOOL) AS BOOL
	FUNCTION = SendMessage(hToolBar, TB_SETANCHORHIGHLIGHT, fAnchor, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_SetBitmapSize
'------------------------------------------------------------------------------
' Sets the size of the bitmapped images to be added to a toolbar.
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION Toolbar_SetBitmapSize ( hToolBar AS HWND, dxBitmap AS SHORT, dyBitmap AS SHORT) AS BOOL
	FUNCTION = SendMessage(hToolBar, TB_SETBITMAPSIZE, 0, MAKELONG(dxBitmap, dyBitmap))
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_SetButtonInfo
'------------------------------------------------------------------------------
' Sets the information for an existing button in a toolbar.
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION Toolbar_SetButtonInfo ( hToolBar AS HWND, iID AS LONG, lptbbi AS TBBUTTONINFOW PTR) AS BOOL
	FUNCTION = SendMessage(hToolBar, TB_SETBUTTONINFOW, iID, lptbbi)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_SetButtonSize
'------------------------------------------------------------------------------
' Sets the size of the buttons to be added to a toolbar.
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION Toolbar_SetButtonSize ( hToolBar AS HWND, dxButton AS SHORT, dyButton AS SHORT) AS BOOL
	FUNCTION = SendMessage(hToolBar, TB_SETBUTTONSIZE, 0, MAKELONG(dxButton, dyButton))
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_SetButtonWidth
'------------------------------------------------------------------------------
' Sets the minimum and maximum button widths in the toolbar control.
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION Toolbar_SetButtonWidth (hToolBar AS HWND, cxMin AS SHORT, cxMax AS SHORT) AS BOOL
	FUNCTION = SendMessage(hToolBar, TB_SETBUTTONWIDTH, 0, MAKELONG(cxMin, cxMax))
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_SetCmdId
'------------------------------------------------------------------------------
' Sets the command identifier of a toolbar button.
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION Toolbar_SetCmdId ( hToolBar AS HWND, index AS SHORT, cmdid AS SHORT) AS BOOL
	FUNCTION = SendMessage(hToolBar, TB_SETCMDID, index, cmdid)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_SetColorScheme
'------------------------------------------------------------------------------
' Sets the color scheme information for the toolbar control.
' ========================================================================================
SUB Toolbar_SetColorScheme ( hToolBar AS HWND, lpcs AS COLORSCHEME PTR)
	SendMessage(hToolBar, TB_SETCOLORSCHEME, 0, lpcs)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_SetImageList
'------------------------------------------------------------------------------
' Sets the image list that the toolbar will use to display buttons that are in their
' default state. Returns the handle to the image list previously used to display buttons
' in their default state, or NULL if no image list was previously set.
' ========================================================================================
FUNCTION Toolbar_SetImageList ( hToolBar AS HWND, himlNew AS HIMAGELIST) AS HIMAGELIST
	FUNCTION = (HIMAGELIST) SendMessage(hToolBar, TB_SETIMAGELIST, 0, himlNew)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_SetHotImageList
'------------------------------------------------------------------------------
' Sets the image list that the toolbar control will use to display hot buttons.
' Returns the handle to the image list previously used to display hot buttons, or NULL if
' no image list was previously set.
' ========================================================================================
FUNCTION Toolbar_SetHotImageList (hToolBar AS HWND, himlNewHot AS HIMAGELIST) AS HIMAGELIST
	FUNCTION = (HIMAGELIST) SendMessage(hToolBar, TB_SETHOTIMAGELIST, 0, himlNewHot)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_SetDisabledImageList
'------------------------------------------------------------------------------
' Sets the image list that the toolbar control will use to display disabled buttons.
' Returns the handle to the image list previously used to display disabled buttons, or NULL
' if no image list was previously set.
' ========================================================================================
FUNCTION Toolbar_SetDisabledImageList ( hToolBar AS HWND, himlNewDisabled AS HIMAGELIST) AS HIMAGELIST
	FUNCTION = (HIMAGELIST) SendMessage(hToolBar, TB_SETDISABLEDIMAGELIST, 0, himlNewDisabled)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_SetPressedImageList
'------------------------------------------------------------------------------
' Sets the image list that the toolbar uses to display buttons that are in a pressed state.
' Returns the handle to the image list previously used to display buttons in their pressed
' state, or NULL if no such image list was previously set.
' ========================================================================================
FUNCTION Toolbar_SetPressedImageList ( hToolBar AS HWND, iImageID AS DWORD, himlNew AS HIMAGELIST) AS HIMAGELIST
	FUNCTION = (HIMAGELIST) SendMessage(hToolBar, TB_SETPRESSEDIMAGELIST, iImageID, himlNew)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_SetDrawTextFlags
'------------------------------------------------------------------------------
' Sets the text drawing flags for the toolbar.
' Returns the previous text drawing flags.
' ========================================================================================
FUNCTION Toolbar_SetDrawTextFlags ( hToolBar AS HWND, dwMask AS DWORD, dwDTFlags AS DWORD) AS DWORD
	FUNCTION = SendMessage(hToolBar, TB_SETDRAWTEXTFLAGS, dwMask, dwDTFlags)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_SetExtendedStyle
'------------------------------------------------------------------------------
' Sets the extended styles for a toolbar control.
' Returns a DWORD that represents the previous extended styles. This value can be a
' combination of extended styles.
' ========================================================================================
FUNCTION Toolbar_SetExtendedStyle (hToolBar AS HWND, dwExStyle AS DWORD) AS DWORD
	FUNCTION = SendMessage(hToolBar, TB_SETEXTENDEDSTYLE, 0, dwExStyle)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_SetHotItem
'------------------------------------------------------------------------------
' Sets the hot item in a toolbar.
' iHot: Index of the item that will be made hot. If this value is -1, none of the items will be hot.
' Returns the index of the previous hot item, or -1 if there was no hot item.
' ========================================================================================
FUNCTION Toolbar_SetHotItem ( hToolBar AS HWND, iHot AS LONG) AS LONG
	FUNCTION = SendMessage(hToolBar, TB_SETHOTITEM, iHot, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_SetIndent
'------------------------------------------------------------------------------
' Sets the indentation for the first button in a toolbar control.
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION Toolbar_SetIndent ( hToolBar AS HWND, iIndent AS LONG) AS BOOL
	FUNCTION = SendMessage(hToolBar, TB_SETINDENT, iIndent, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_SetInsertMark
'------------------------------------------------------------------------------
' Sets the current insertion mark for the toolbar.
' ========================================================================================
SUB Toolbar_SetInsertMark ( hToolBar AS HWND, lptbim AS TBINSERTMARK PTR)
	SendMessage(hToolBar, TB_SETINSERTMARK, 0, lptbim)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_SetInsertMarkColor
'------------------------------------------------------------------------------
' Sets the color used to draw the insertion mark for the toolbar.
' clrInsertMark: COLORREF value that contains the new insertion mark color.
' Returns a COLORREF value that contains the previous insertion mark color.
' ========================================================================================
FUNCTION Toolbar_SetInsertMarkColor (hToolBar AS HWND, clrInsertMark AS COLORREF) AS COLORREF
	FUNCTION = SendMessage(hToolBar, TB_SETINSERTMARKCOLOR, clrInsertMark, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_SetListGap
'------------------------------------------------------------------------------
' Sets the distance between the toolbar buttons on a specific toolbar.
' ========================================================================================
SUB Toolbar_SetListGap ( hToolBar AS HWND,  gap AS DWORD)
	SendMessage(hToolBar, TB_SETLISTGAP, gap, 0)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_SetMaxTextRows
'------------------------------------------------------------------------------
' Sets the maximum number of text rows displayed on a toolbar button.
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION Toolbar_SetMaxTextRows ( hToolBar AS HWND, iMaxRows AS LONG) AS BOOL
	FUNCTION = SendMessage(hToolBar, TB_SETMAXTEXTROWS, iMaxRows, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_SetMetrics
'------------------------------------------------------------------------------
' Sets the metrics of a toolbar control.
' ptbMetrics: TBMETRICS structure that contains the toolbar metrics to set.
' ========================================================================================
SUB Toolbar_SetMetrics ( hToolBar AS HWND, ptbMetrics AS TBMETRICS PTR)
	SendMessage(hToolBar, TB_SETMETRICS, 0, ptbMetrics)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_SetPadding
'------------------------------------------------------------------------------
' Sets the padding for a toolbar control.
' Returns a DWORD value that contains the previous horizontal padding in the LOWORD and
' the previous vertical padding in the HIWORD, in pixels.
' ========================================================================================
FUNCTION Toolbar_SetPadding ( hToolBar AS HWND, cx AS SHORT, cy AS SHORT) AS DWORD
	FUNCTION = SendMessage(hToolBar, TB_SETPADDING, 0, MAKELONG(cx, cy))
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_SetParent
'------------------------------------------------------------------------------
' Sets the window to which the toolbar control sends notification messages.
' The return value is a handle to the previous notification window, or NULL if there is no
' previous notification window.
' ========================================================================================
FUNCTION Toolbar_SetParent ( hToolBar AS HWND, hwndParent AS HWND) AS HWND
	FUNCTION = (HWND) SendMessage(hToolBar, TB_SETPARENT, hwndParent, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_SetRows
'------------------------------------------------------------------------------
' Sets the number of rows of buttons in a toolbar.
' ========================================================================================
SUB Toolbar_SetRows ( hToolBar AS HWND, cRows AS WORD, fLarger AS BOOL, lprc AS RECT PTR)
	SendMessage(hToolBar, TB_SETROWS, MAKELONG(cRows, fLarger), lprc)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_SetState
'------------------------------------------------------------------------------
' Sets the state for the specified button in a toolbar.
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION Toolbar_SetState (BYVAL hToolBar AS HWND, BYVAL idButton AS LONG, BYVAL fState AS SHORT) AS BOOLEAN
	FUNCTION = SendMessage(hToolBar, TB_SETSTATE, idButton, MAKELONG(fState, 0))
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_SetStyle
'------------------------------------------------------------------------------
' Sets the style for a toolbar control.
' ========================================================================================
SUB Toolbar_SetStyle ( hToolBar AS HWND, dwStyle AS DWORD)
	SendMessage(hToolBar, TB_SETSTYLE, 0, dwStyle)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_SetToolTips
'------------------------------------------------------------------------------
' Associates a ToolTip control with a toolbar.
' ========================================================================================
SUB Toolbar_SetToolTips ( hToolBar AS HWND,  hwndToolTip AS HWND)
	SendMessage(hToolBar, TB_SETTOOLTIPS, hwndToolTip, 0)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_SetUnicodeFormat
'------------------------------------------------------------------------------
' Sets the Unicode character format flag for the control. This message allows you to
' change the character set used by the control at run time rather than having to re-create
' the control. Returns the previous Unicode format flag for the control.
' ========================================================================================
FUNCTION Toolbar_SetUnicodeFormat ( hToolBar AS HWND, fUnicode AS DWORD) AS DWORD
	FUNCTION = SendMessage(hToolBar, TB_SETUNICODEFORMAT, fUnicode, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_SetWindowTheme
'------------------------------------------------------------------------------
' Sets the visual style of a toolbar control.
' Note: To use this API, you must provide a manifest specifying Comclt32.dll version 6.0.
' Minimum Operating System: Windows XP.
' ========================================================================================
SUB Toolbar_SetWindowTheme ( hToolBar AS HWND, pwszTheme AS const char ptr PTR)
	SendMessage(hToolBar, TB_SETWINDOWTHEME, pwszTheme, 0)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_MakeOpaque
'------------------------------------------------------------------------------
' Makes the toolbar opaque by removing the TBSTYLE_TRANSPARENT style.
' ========================================================================================
SUB Toolbar_MakeOpaque ( hToolBar AS HWND)
	SetWindowLongPtr(hToolBar, GWL_STYLE, GetWindowLongPtr(hToolBar, GWL_STYLE) AND NOT TBSTYLE_TRANSPARENT)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_GetObject
'------------------------------------------------------------------------------
' Retrieves the IDropTarget for a toolbar control.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION Toolbar_GetObject ( hToolBar AS HWND) AS IDropTarget PTR
	DIM AS IDropTarget PTR ppvObject 
	Raw AS GUID IID_IDropTarget = {0x00000122, 0x0000, 0x0000, {0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46}}
	DIM AS HRESULT hr  = SendMessage(hToolBar, TB_GETOBJECT, &IID_IDropTarget, ppvObject)
	IF hr <> S_OK THEN 
		FUNCTION = ppvObject
	EndIf
	Function = NULL
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_GetButtonText
'------------------------------------------------------------------------------
' Retrieves the display text of a button on a toolbar.
' Returns the length, in characters, of the string pointed to by lParam. The length does
' not include the terminating null character. If unsuccessful, the return value is -1.
' idButton = Command identifier of the button whose text is to be retrieved.
' pBuffer = Pointer to a buffer that receives the button text.
' Minimum operating systems Windows NT 3.51, Windows 95
' Security Warning: Using this message incorrectly might compromise the security of your
' program. This message does not provide a way for you to know the size of the buffer.
' If you use this message, first call the message passing NULL in the lParam, this returns
' the number of characters, excluding NULL that are required. Then call the message a
' second time to retrieve the string.
' The returned string corresponds to the text that is currently displayed by the button.
' ========================================================================================
FUNCTION Toolbar_GetButtonText (hToolBar AS HWND, idButton AS LONG, pBuffer AS char PTR) AS LONG
	FUNCTION = SendMessage(hToolBar, TB_GETBUTTONTEXTW, idButton, pBuffer)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Toolbar_GetTextLength
'------------------------------------------------------------------------------
' Retrieves the length of the display text of a button on a toolbar.
' Returns the length, in characters, of the string pointed to by lParam. The length does
' not include the terminating null character. If unsuccessful, the return value is -1.
' ========================================================================================
FUNCTION Toolbar_GetTextLength ( hToolBar AS HWND, idButton AS LONG) AS LONG
	FUNCTION = SendMessage(hToolBar, TB_GETBUTTONTEXTW, idButton, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE

' ########################################################################################
'                                   *** TREEVIEW ***
' ########################################################################################

'==============================================================================
$IFUSE USE_TreeView_GetItemEx
'------------------------------------------------------------------------------
' Retrieves some or all of a tree-view item's attributes.
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION TreeView_GetItemEx (hwndTV AS HWND, pitem AS TVITEMEXW PTR) AS BOOL
	FUNCTION = SendMessage(hwndTV, TVM_GETITEMW, 0, &pitem)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TreeView_AddItem
'------------------------------------------------------------------------------
' Inserts a new item in a tree-view control.
' Note: It should have been named TreeView_InsertItem, but this name is already been used by a macro.
' ========================================================================================
FUNCTION TreeView_AddItem ( hwndTV AS HWND, hParent AS HTREEITEM, hInsertAfter AS HTREEITEM, _
                            pwszText AS const char PTR, lParam AS LPARAM = 0, iImage AS LONG = 0, _
                            iSelectedImage AS LONG = 0) AS HTREEITEM
	DIM AS TVINSERTSTRUCTW tvinsert 
	tvinsert.hParent             = hParent
	tvinsert.hInsertAfter        = hInsertAfter
	tvinsert.item.iImage         = iImage
	tvinsert.item.iSelectedImage = iSelectedImage
	tvinsert.item.lParam         = lParam
	tvinsert.item.mask           = TVIF_TEXT bOR TVIF_IMAGE bOR TVIF_SELECTEDIMAGE
	tvinsert.item.pszText        = (LPTSTR)pwszText
	tvinsert.item.cchTextMax     = LEN(pwszText)
	FUNCTION = (HTREEITEM) SendMessage(hwndTV, TVM_INSERTITEMW, 0, &tvinsert)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TreeView_AppendItem
'------------------------------------------------------------------------------
' Inserts the item at the end of the list in a tree-view control.
' ========================================================================================
FUNCTION TreeView_AppendItem (hwndTV AS HWND, hParent AS HTREEITEM, _
                              pwszText AS const char  PTR, lParam AS LPARAM = 0, _
                              iImage AS LONG = 0, iSelectedImage AS LONG = 0) AS HTREEITEM
	FUNCTION = TreeView_AddItem(hwndTV, hParent, TVI_LAST, pwszText, lParam, iImage, iSelectedImage)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TreeView_InsertFirstItem
'------------------------------------------------------------------------------
' Inserts the item at the beginning of the list in a tree-view control.
' ========================================================================================
FUNCTION TreeView_InsertFirstItem (hwndTV AS HWND, hParent AS HTREEITEM, pwszText AS const char PTR, _
	                               lParam AS LPARAM = 0,iImage AS LONG = 0, iSelectedImage AS LONG = 0) AS HTREEITEM
	FUNCTION = TreeView_AddItem(hwndTV, hParent, TVI_FIRST, pwszText, lParam, iImage, iSelectedImage)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TreeView_AddRootItem
'------------------------------------------------------------------------------
' Add the item as the root item in a tree-view control.
' ========================================================================================
FUNCTION TreeView_AddRootItem ( hwndTV AS HWND, pwszText AS const char PTR, _
	                            lParam AS LPARAM = 0, iImage AS LONG = 0, iSelectedImage AS LONG = 0) AS HTREEITEM
	FUNCTION = TreeView_AddItem(hwndTV, NULL, TVI_ROOT, pwszText, lParam, iImage, iSelectedImage)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TreeView_InsertSortedItem
'------------------------------------------------------------------------------
' Inserts the item into the list in alphabetical order.
' ========================================================================================
FUNCTION TreeView_InsertSortedItem ( hwndTV AS HWND, hParent AS HTREEITEM, pwszText AS const char  PTR, _
	                                 lParam AS LPARAM = 0,iImage AS LONG = 0, iSelectedImage AS LONG = 0) AS HTREEITEM
	FUNCTION = TreeView_AddItem(hwndTV, hParent, TVI_SORT, pwszText, lParam, iImage, iSelectedImage)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TreeView_GetBold
'------------------------------------------------------------------------------
' Returns TRUE if the bold attribute is set, or FALSE otherwise.
' ========================================================================================
FUNCTION TreeView_GetBold ( hwndTV AS HWND, hItem AS HTREEITEM) AS BOOL
	If TreeView_GetItemState(hwndTV, hItem, TVIS_BOLD) BAND TVIS_BOLD = TVIS_BOLD Then
		Function = TRUE
	EndIf
	'FUNCTION = ((TreeView_GetItemState(hwndTV, hItem, TVIS_BOLD) BAND TVIS_BOLD) = TVIS_BOLD)
	Function = FALSE
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TreeView_IsItemChecked
'------------------------------------------------------------------------------
' Returns TRUE if the item is checked, or FALSE otherwise.
' ========================================================================================
FUNCTION TreeView_IsItemChecked ( hwndTV AS HWND, hItem AS HTREEITEM) AS BOOL
	'FUNCTION = (TreeView_GetCheckState(hwndTV, hItem) = 1)
	If TreeView_GetCheckState(hwndTV, hItem) = 1  Then
		Function = TRUE
	EndIf
	Function = FALSE
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TreeView_GetISearchStringLen
'------------------------------------------------------------------------------
' Returns the number of characters in the incremental search string.
' If the tree-view control is not in incremental search mode, the return value is zero.
' ========================================================================================
FUNCTION TreeView_GetISearchStringLen ( hwndTV AS HWND) AS LONG
	FUNCTION = SendMessage(hwndTV, TVM_GETISEARCHSTRING, 0, NULL)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TreeView_GetlParam
'------------------------------------------------------------------------------
' Retrieve the lParam value from a Treeview
' ========================================================================================
FUNCTION TreeView_GetlParam (hwndTV AS HWND,  hItem AS HTREEITEM) AS LPARAM
	DIM AS TVITEMW tvi 
	tvi.hItem = hItem
	tvi.mask  = TVIF_HANDLE BOR TVIF_PARAM
	TreeView_GetItem(hwndTV, &tvi)
	FUNCTION = tvi.lParam
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TreeView_SetBold
'------------------------------------------------------------------------------
' Sets/unsets the bold attribute of the specified item.
' ========================================================================================
SUB TreeView_SetBold ( hwndTV AS HWND, hItem AS HTREEITEM, fBold AS BOOL)
	'TreeView_SetItemState(hwndTV, hItem, IIF&(fBold = 0, 0, TVIS_BOLD), TVIS_BOLD)
	TreeView_SetItemState(hwndTV, hItem, iif(fBold = 0, 0, TVIS_BOLD), TVIS_BOLD)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TreeView_SetItemEx
'------------------------------------------------------------------------------
' Sets some or all of a tree-view item's attributes.
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION TreeView_SetItemEx (hwndTV AS HWND, pitem AS TVITEMEXW PTR) AS BOOL
	FUNCTION = SendMessage(hwndTV, TVM_SETITEMW, 0, pitem)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TreeView_SetItemText
'------------------------------------------------------------------------------
' Sets the text of the specified item.
' ========================================================================================
FUNCTION TreeView_SetItemText (hwndTV AS HWND, hItem AS HTREEITEM, pwszText AS const char PTR) AS BOOL
	DIM AS TVITEMW tvi
	tvi.hItem = hItem
	tvi.mask = TVIF_TEXT
	tvi.pszText = (LPTSTR)pwszText
	tvi.cchTextMax = LEN(pwszText)
	FUNCTION = SendMessage(hwndTV, TVM_SETITEMW, 0, &tvi)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TreeView_ExpandChildItems
'------------------------------------------------------------------------------
' Expands the list of child items, if any, associated with the specified parent node.
' ========================================================================================
SUB TreeView_ExpandChildItems (hwndTV AS HWND, hNode AS HTREEITEM)
	DIM AS HTREEITEM hChildNode
	DO WHILE hNode
		' // Expand the node
		TreeView_Expand(hwndTV, hNode, TVM_EXPAND)
		' // Get the first child node
		hChildNode = TreeView_GetChild(hwndTV, hNode)
		IF hChildNode THEN 
			TreeView_ExpandChildItems(hwndTV, hChildNode)
		EndIf
		hNode = NULL
	LOOP
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TreeView_ExpandSiblings
'------------------------------------------------------------------------------
' Expands the list of sibling items, if any, associated with the specified parent node.
' ========================================================================================
SUB TreeView_ExpandSiblings ( hwndTV AS HWND, hNode AS HTREEITEM)
	DIM AS HTREEITEM hChildNode
	DO WHILE hNode
		' // Expand the node
		TreeView_Expand(hwndTV, hNode, TVM_EXPAND)
		' // Get the next sibling item
		hNode = TreeView_GetNextSibling(hwndTV, hNode)
	LOOP
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TreeView_ExpandAllChildItems
'------------------------------------------------------------------------------
' Expands the list of child items, if any, associated with the specified parent node and
' the sibling nodes below it.
' ========================================================================================
SUB TreeView_ExpandAllChildItems ( hwndTV AS HWND, hNode AS HTREEITEM)
	DIM AS HTREEITEM hChildNode
	DO WHILE hNode
		' // Expand the node
		TreeView_Expand(hwndTV, hNode, TVM_EXPAND)
		' // Get the first child node
		hChildNode = TreeView_GetChild(hwndTV, hNode)
		IF hChildNode THEN 
			TreeView_ExpandAllChildItems(hwndTV, hChildNode)
		EndIf
		' // Get the next sibling item
		hNode = TreeView_GetNextSibling(hwndTV, hNode)
	LOOP
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TreeView_ExpandAllItems
'------------------------------------------------------------------------------
' Expands all the list of items.
' Note: This is a very slow process if the control has many items because of the continuous
' redrawing; therefore, disable redrawing before calling it with
'   SendMessage(hwndTV, WM_SETREDRAW, FALSE, 0)
' and reenable drawing once it has ended with
'   SendMessage(hwndTV, WM_SETREDRAW, TRUE, 0)
' followed by a redrawing of the control
'   InvalidateRect hwndTV, NULL, CTRUE
'   UpdateWindow hwndTV
' ========================================================================================
SUB TreeView_ExpandAllItems ( hwndTV AS HWND)
	Raw AS HTREEITEM hNode = TreeView_GetRoot(hwndTV)
	IF hNode THEN 
		TreeView_ExpandAllChildItems(hwndTV, hNode)
	EndIf
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TreeView_CollapseChildItems
'------------------------------------------------------------------------------
' Collapses the list of child items, if any, associated with the specified parent node.
' ========================================================================================
SUB TreeView_CollapseChildItems ( hwndTV AS HWND, hNode AS HTREEITEM)
	DIM AS HTREEITEM hChildNode
	DO WHILE hNode
		' // Collapse the node
		TreeView_Expand(hwndTV, hNode, TVE_COLLAPSE)
		' // Get the first child node
		hChildNode = TreeView_GetChild(hwndTV, hNode)
		IF hChildNode THEN 
			TreeView_CollapseChildItems(hwndTV, hChildNode)
		EndIf
		hNode = NULL
	LOOP
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TreeView_CollapseSiblings
'------------------------------------------------------------------------------
' Collapses the list of sibling items, if any, associated with the specified parent node.
' ========================================================================================
SUB TreeView_CollapseSiblings ( hwndTV AS HWND, hNode AS HTREEITEM)
	DIM AS HTREEITEM hChildNode
	DO WHILE hNode
		' // Collapse the node
		TreeView_Expand(hwndTV, hNode, TVE_COLLAPSE)
		' // Get the next sibling item
		hNode = TreeView_GetNextSibling(hwndTV, hNode)
	LOOP
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TreeView_CollapseAllChildItems
'------------------------------------------------------------------------------
' Collapses the list of child items, if any, associated with the specified parent node and
' the sibling nodes below it.
' ========================================================================================
SUB TreeView_CollapseAllChildItems ( hwndTV AS HWND, hNode AS HTREEITEM)
	DIM AS HTREEITEM hChildNode
	DO WHILE hNode
		' // Collapse the node
		TreeView_Expand(hwndTV, hNode, TVE_COLLAPSE)
		' // Get the first child node
		hChildNode = TreeView_GetChild(hwndTV, hNode)
		IF hChildNode THEN 
			TreeView_CollapseAllChildItems(hwndTV, hChildNode)
		EndIf
		' // Get the next sibling item
		hNode = TreeView_GetNextSibling(hwndTV, hNode)
	LOOP
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TreeView_CollapseAllItems
'------------------------------------------------------------------------------
' Collapses all the list of items.
' ========================================================================================
SUB TreeView_CollapseAllItems ( hwndTV AS HWND)
	Raw AS HTREEITEM hNode = TreeView_GetRoot(hwndTV)
	IF hNode THEN
		TreeView_CollapseAllChildItems(hwndTV, hNode)
	EndIf
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TreeView_GetItemText
'------------------------------------------------------------------------------
' Retrieves the text of the specified item.
' Returns TRUE if successful, or FALSE otherwise.
' Usage example:
' DIM wszText AS WSTRING * 260
' TreeView_GetItemText(hTreeView, hItem, @wszText, 260)
' AfxMsg(wszText)
' ========================================================================================
FUNCTION TreeView_GetItemText (hwndTV AS HWND, hItem AS HTREEITEM, pwszText AS char PTR, cchtextmax AS LONG) AS BOOL
	IF pwszText = NULL THEN
		EXIT FUNCTION
	EndIf
	DIM AS TVITEMW tvi
	tvi.hItem = hItem
	tvi.mask = TVIF_TEXT
	tvi.pszText = pwszText
	tvi.cchTextMax = cchtextmax
	FUNCTION = SendMessage(hwndTV, TVM_GETITEMW, 0, &tvi)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TreeView_GetParentText
'------------------------------------------------------------------------------
' Retrieves the text of the parent item of the specified tree-view item.
' Usage example:
' DIM wszText AS WSTRING * 260
' TreeView_GetParentText(hTreeView, hItem, @wszText, 260)
' AfxMsg(wszText)
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION TreeView_GetParentText (hwndTV AS HWND, hItem AS HTREEITEM, pwszText AS char PTR, cchTextMax AS LONG) AS BOOL
	IF pwszText = NULL THEN 
		EXIT FUNCTION
	EndIf
	Raw AS HTREEITEM hNode = TreeView_GetNextItem(hwndTV, hItem, TVGN_PARENT)
	IF hNode THEN 
		FUNCTION = TreeView_GetItemText(hwndTV, hNode, pwszText, cchTextMax)
	EndIf
	Function = FALSE
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TreeView_ItemExists
'------------------------------------------------------------------------------
' Searches for an exact string in a tree view node. Search is case sensitive.
' Returns TRUE or FALSE.
' ========================================================================================
FUNCTION TreeView_ItemExists (hTreeView AS HWND, hNode AS HTREEITEM, pwszText AS char PTR) AS BOOL
	IF pwszText = NULL THEN 
		EXIT FUNCTION
	EndIf
	Raw AS LONG cbLen = LEN(pwszText)
	IF cbLen = 0 THEN 
		EXIT FUNCTION
	EndIf
	Dim pwszItemText$ * cbLen+1 
	Raw AS HTREEITEM hItem = TreeView_GetChild(hTreeView, hNode)
	DO
		IF hItem = NULL THEN 
			EXIT FUNCTION
		EndIf
		IF TreeView_GetItemText(hTreeView, hItem, pwszItemText, cbLen) = FALSE THEN 
			Function = FALSE
		EndIf
		IF *pwszItemText = *pwszText THEN
			FUNCTION = TRUE
		END IF
		hItem = TreeView_GetNextSibling(hTreeView, hItem)
	LOOP
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TreeView_ItemExistsIgnoreCase
'------------------------------------------------------------------------------
' Searches for an exact string in a tree view node. Search is case insensitive.
' Returns TRUE or FALSE.
' ========================================================================================
FUNCTION TreeView_ItemExistsIgnoreCase (hTreeView AS HWND, hNode AS HTREEITEM, pwszText AS const char PTR) AS BOOL
	IF pwszText = NULL THEN 
		EXIT FUNCTION
	EndIf
	Raw AS LONG cbLen = LEN(pwszText)
	IF cbLen = 0 THEN 
		EXIT FUNCTION
	EndIf
	DIM pwszItemText$ *(cbLen + 1)
	Raw AS HTREEITEM hItem = TreeView_GetChild(hTreeView, hNode)
	DO
		IF hItem = NULL THEN 
			EXIT FUNCTION
		EndIf
		IF TreeView_GetItemText(hTreeView, hItem, pwszItemText, cbLen) = FALSE THEN 
			Function = FALSE
		EndIf
		IF UCASE$(pwszItemText) = UCASE$(pwszText) THEN
			FUNCTION = TRUE
		END IF
		hItem = TreeView_GetNextSibling(hTreeView, hItem)
	LOOP
END FUNCTION
' ========================================================================================
'------------------------------------------------------------------------------
$ENDUSE

' ########################################################################################
'                                   *** TASK DIALOG ***
' ########################################################################################

'==============================================================================
$IFUSE USE_TaskDialog_ClickButton
'------------------------------------------------------------------------------
' Simulates the action of a button click in the Task Dialog.
' ========================================================================================
SUB TaskDialog_ClickButton ( hTaskDlg AS HWND, nButton AS DWORD)
	SendMessage(hTaskDlg, TDM_CLICK_BUTTON, nButton, 0)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TaskDialog_ClickRadioButton
'------------------------------------------------------------------------------
' Simulates the action of a radio button click in the TaskDialog.
' ========================================================================================
SUB TaskDialog_ClickRadioButton ( hTaskDlg AS HWND, nRadioButton AS DWORD)
	SendMessage(hTaskDlg, TDM_CLICK_RADIO_BUTTON, nRadioButton, 0)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TaskDialog_ClickVerification
'------------------------------------------------------------------------------
' Simulates a click on the verification checkbox of the Task Dialog, if it exists.
' ========================================================================================
SUB TaskDialog_ClickVerification ( hTaskDlg AS HWND, fChecked AS LONG, fFocused AS LONG)
	SendMessage(hTaskDlg, TDM_CLICK_VERIFICATION, fChecked, fFocused)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TaskDialog_EnableButton
'------------------------------------------------------------------------------
' Enables or disables a push button in the TaskDialog.
' ========================================================================================
SUB TaskDialog_EnableButton ( hTaskDlg AS HWND, nButton AS LONG, fEnable AS LONG)
	SendMessage(hTaskDlg, TDM_ENABLE_BUTTON, nButton, fEnable)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TaskDialog_EnableRadioButton
'------------------------------------------------------------------------------
' Enables or disables a radio button in the TaskDialog.
' ========================================================================================
SUB TaskDialog_EnableRadioButton ( hTaskDlg AS HWND, nRadioButton AS LONG, fEnable AS LONG)
	SendMessage(hTaskDlg, TDM_ENABLE_RADIO_BUTTON, nRadioButton, fEnable)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TaskDialog_NavigatePage
'------------------------------------------------------------------------------
' Refreshes the contents of the Task Dialog.
' ========================================================================================
SUB TaskDialog_NavigatePage ( hTaskDlg AS HWND, pTaskConfig AS TASKDIALOGCONFIG PTR)
	SendMessage(hTaskDlg, TDM_NAVIGATE_PAGE, 0, pTaskConfig)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TaskDialog_SetButtonElevationRequiredState
'------------------------------------------------------------------------------
' Used by clients to designate whether a given Task Dialog button or command link should
' have a User Account Control (UAC) shield icon (in other words, whether the action
' invoked by the button requires elevation).
' ========================================================================================
SUB TaskDialog_SetButtonElevationRequiredState ( hTaskDlg AS HWND, nButton AS LONG,fElevation AS LONG)
	SendMessage(hTaskDlg, TDM_SET_BUTTON_ELEVATION_REQUIRED_STATE, nButton, fElevation)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TaskDialog_SetElementText
'------------------------------------------------------------------------------
' Used by clients to update a text element on the Task Dialog.
' ========================================================================================
SUB TaskDialog_SetElementText (hTaskDlg AS HWND, eElement AS LONG, pszNewText AS const char PTR)
	SendMessage(hTaskDlg, TDM_SET_ELEMENT_TEXT, eElement, pszNewText)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TaskDialog_SetMarqueeProgressBar
'------------------------------------------------------------------------------
' Indicates whether the hosted progress bar should be displayed in marquee mode.
' ========================================================================================
SUB TaskDialog_SetMarqueeProgressBar ( hTaskDlg AS HWND, fMarquee AS BOOL)
	SendMessage(hTaskDlg, TDM_SET_MARQUEE_PROGRESS_BAR, fMarquee, 0)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TaskDialog_SetProgressBarMarquee
'------------------------------------------------------------------------------
' Starts and stops the marquee display of the progress bar, and sets the speed of the marquee.
' ========================================================================================
SUB TaskDialog_SetProgressBarMarquee ( hTaskDlg AS HWND, fMarquee AS LONG, nSpeed AS LONG)
	SendMessage(hTaskDlg, TDM_SET_PROGRESS_BAR_MARQUEE, fMarquee, nSpeed)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TaskDialog_SetProgressBarPos
'------------------------------------------------------------------------------
' The TDM_SET_PROGRESS_BAR_POS message is used set the current position for a progress bar.
' Returns the previous position.
' ========================================================================================
FUNCTION TaskDialog_SetProgressBarPos (hTaskDlg AS HWND, nNewPos AS LONG) AS LONG
	FUNCTION = SendMessage(hTaskDlg, TDM_SET_PROGRESS_BAR_POS, nNewPos, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TaskDialog_SetProgressBarRange
'------------------------------------------------------------------------------
' The TDM_SET_PROGRESS_BAR_RANGE message is used set the minimum and maximum values for
' the hosted progress bar. Returns the previous minimum and maximum values, if successful,
' or zero otherwise. The LOWORD contains the minimum value, and the HIWORD contains the
' maximum value.
' ========================================================================================
FUNCTION TaskDialog_SetProgressBarRange ( hTaskDlg AS HWND, nMinRange AS SHORT, nMaxRange AS SHORT) AS DWORD
	FUNCTION = SendMessage(hTaskDlg, TDM_SET_PROGRESS_BAR_RANGE, 0, MAKELONG(nMinRange, nMaxRange))
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TaskDialog_SetProgressBarState
'------------------------------------------------------------------------------
' The TDM_SET_PROGRESS_BAR_POS message is used set the current position for a progress bar.
' If the function succeeds, the return value is non zero. If the function fails, the return
' value is zero. To get extended error information call GetLastError.
' ========================================================================================
FUNCTION TaskDialog_SetProgressBarState (hTaskDlg AS HWND, nNewState AS LONG) AS LONG
	FUNCTION = SendMessage(hTaskDlg, TDM_SET_PROGRESS_BAR_STATE, nNewState, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TaskDialog_UpdateElementText
'------------------------------------------------------------------------------
' The TDM_UPDATE_ELEMENT_TEXT message is available for use by clients to update a text
' element on the Task Dialog.
' ========================================================================================
SUB TaskDialog_UpdateElementText ( hTaskDlg AS HWND, eElement AS LONG, pszNewText AS const char PTR)
	SendMessage(hTaskDlg, TDM_UPDATE_ELEMENT_TEXT, eElement, pszNewText)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TaskDialog_UpdateIcon
'------------------------------------------------------------------------------
' Refreshes the icon of a task dialog. A window receives this message through its
' WindowProc function.
' ========================================================================================
SUB TaskDialog_UpdateIcon ( hTaskDlg AS HWND, nIconElement AS LONG, idResource AS DWORD)
	SendMessage(hTaskDlg, TDM_UPDATE_ICON, nIconElement, idResource)
END SUB
'------------------------------------------------------------------------------
$ENDUSE

' ########################################################################################
'                                   *** IP ADDRESS ***
' ########################################################################################

'==============================================================================
$IFUSE USE_IPAddress_ClearAddress
'------------------------------------------------------------------------------
' Clears the contents of the IP address control.
' ========================================================================================
SUB IPAddress_ClearAddress ( hIPM AS HWND)
	SendMessage(hIPM, IPM_CLEARADDRESS, 0, 0)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_IPAddress_GetAddress
'------------------------------------------------------------------------------
' Gets the address values for all four fields in the IP address control.
' Returns the number of nonblank fields.
' ========================================================================================
FUNCTION IPAddress_GetAddress (hIPM AS HWND, pdwAddr AS DWORD PTR) AS LONG
	FUNCTION = SendMessage(hIPM, IPM_GETADDRESS, 0, pdwAddr)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_IPAddress_IsBlank
'------------------------------------------------------------------------------
' Determines if all fields in the IP address control are blank.
' ========================================================================================
SUB IPAddress_IsBlank (hIPM AS HWND)
	SendMessage(hIPM, IPM_ISBLANK, 0, 0)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_IPAddress_SetAddress
'------------------------------------------------------------------------------
' Sets the address values for all four fields in the IP address control.
' ========================================================================================
SUB IPAddress_SetAddress ( hIPM AS HWND, dwAddr AS DWORD)
	SendMessage(hIPM, IPM_SETADDRESS, 0, dwAddr)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_IPAddress_SetFocus
'------------------------------------------------------------------------------
' Sets the keyboard focus to the specified field in the IP address control.
' All of the text in that field will be selected.
' ========================================================================================
SUB IPAddress_SetFocus ( hIPM AS HWND,  nField AS LONG)
	SendMessage(hIPM, IPM_SETFOCUS, nField, 0)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_IPAddress_SetRange
'------------------------------------------------------------------------------
' Sets the valid range for the specified field in the IP address control.
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION IPAddress_SetRange (hIPM AS HWND, nField AS LONG, loRange AS BYTE, hiRange AS BYTE) AS BOOL
	FUNCTION = SendMessage(hIPM, IPM_SETRANGE, nField, MAKEIPRANGE(loRange, hiRange))
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE

' ########################################################################################
'                                  *** PROGRESS BAR ***
' ########################################################################################

'==============================================================================
$IFUSE USE_ProgressBar_DeltaPos
'------------------------------------------------------------------------------
' Advances the current position of a progress bar by a specified increment and redraws the
' bar to reflect the new position. Returns the previous position.
' ========================================================================================
FUNCTION ProgressBar_DeltaPos (hProgress AS HWND, nIncrement AS LONG) AS LONG
	FUNCTION = SendMessage(hProgress, PBM_DELTAPOS, nIncrement, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ProgressBar_GetHighLimit
'------------------------------------------------------------------------------
' Retrieves the current high limit of a given progress bar control.
' ========================================================================================
FUNCTION ProgressBar_GetHighLimit ( hProgress AS HWND) AS LONG
	FUNCTION = SendMessage(hProgress, PBM_GETRANGE, FALSE, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ProgressBar_GetLowLimit
'------------------------------------------------------------------------------
' Retrieves the current low limit of a given progress bar control.
' ========================================================================================
FUNCTION ProgressBar_GetLowLimit (hProgress AS HWND) AS LONG
	FUNCTION = SendMessage(hProgress, PBM_GETRANGE, TRUE, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ProgressBar_GetMaxRange
'------------------------------------------------------------------------------
' Retrieves the current maximum range of a given progress bar control.
' ========================================================================================
FUNCTION ProgressBar_GetMaxRange (hProgress AS HWND) AS LONG
	FUNCTION = SendMessage(hProgress, PBM_GETRANGE, FALSE, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ProgressBar_GetMinRange
'------------------------------------------------------------------------------
' Retrieves the current minimum range of a given progress bar control.
' ========================================================================================
FUNCTION ProgressBar_GetMinRange ( hProgress AS HWND) AS LONG
	FUNCTION = SendMessage(hProgress, PBM_GETRANGE, TRUE, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ProgressBar_GetPos
'------------------------------------------------------------------------------
' Retrieves the current position of the progress bar.
' ========================================================================================
FUNCTION ProgressBar_GetPos ( hProgress AS HWND) AS DWORD
	FUNCTION = SendMessageW(hProgress, PBM_GETPOS, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ProgressBar_GetRange
'------------------------------------------------------------------------------
' Retrieves information about the current high and low limits of a given progress bar control.
' - fWhichLimit: Flag value specifying which limit value is to be used as the message's return
'   value. This parameter can be one of the following values: TRUE (return the low limit),
'   FALSE (return the high limit).
' - ppBRange: Pointer to a PBRANGE structure that is to be filled with both limit values.
' Returns an INT that represents the limit value specified by fWhichLimit
' ========================================================================================
FUNCTION ProgressBar_GetRange (hProgress AS HWND, fWhichLimit AS DWORD, ppBRange AS PBRANGE PTR) AS LONG
	FUNCTION = SendMessage(hProgress, PBM_GETRANGE, fWhichLimit, ppBRange)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ProgressBar_IncPos
'------------------------------------------------------------------------------
' Advances the current position for a progress bar by the specified increment and redraws
' the bar to reflect the new position. nIncVaL: Signed integer that becomes the new position.
' If nIncVal is outside the range of the control, the position is set to the closest boundary.
' Do not send this message to a control that has the PBS_MARQUEE style.
' ========================================================================================
FUNCTION ProgressBar_IncPos ( hProgress AS HWND, nIncVal AS LONG) AS LONG
	Raw AS LONG nPos = SendMessage(hProgress, PBM_GETPOS, 0, 0)
	FUNCTION = SendMessage(hProgress, PBM_SETPOS, nPos + nIncVal, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ProgressBar_SetBarColor
'------------------------------------------------------------------------------
' Sets the color of the progress indicator bar in the progress bar control.
' - clrBar: The COLORREF value that specifies the new progress indicator bar color.
'   Specifying the CLR_DEFAULT value causes the progress bar to use its default progress
'   indicator bar color.
' Returns the previous progress indicator bar color, or CLR_DEFAULT if the progress
' indicator bar color is the default color.
' ========================================================================================
FUNCTION ProgressBar_SetBarColor (hProgress AS HWND, clrBar AS COLORREF) AS COLORREF
	FUNCTION = SendMessage(hProgress, PBM_SETBARCOLOR, 0, clrBar)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ProgressBar_SetBkColor
'------------------------------------------------------------------------------
' Sets the background color in the progress bar.
' - clrBk: COLORREF value that specifies the new background color. Specify the CLR_DEFAULT
'   value to cause the progress bar to use its default background color.
' Returns the previous background color, or CLR_DEFAULT if the background color is the default color.
' ========================================================================================
FUNCTION ProgressBar_SetBkColor ( hProgress AS HWND, clrBk AS COLORREF) AS COLORREF
	FUNCTION = SendMessage(hProgress, PBM_SETBKCOLOR, 0, clrBk)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ProgressBar_SetMarquee
'------------------------------------------------------------------------------
' Sets the progress bar to marquee mode. This causes the progress bar to move like a marquee.
' - fOn: Indicates whether to turn the marquee mode on or off.
' - dwAnimationSpeed: Time, in milliseconds, between marquee animation updates. If this
'   parameter is zero, the marquee animation is updated every 30 milliseconds.
' Return value: Always returns TRUE.
' ========================================================================================
FUNCTION ProgressBar_SetMarquee (hProgress AS HWND, fOn AS LONG, dwAnimationSpeed AS DWORD) AS LONG
	FUNCTION = SendMessage(hProgress, PBM_SETMARQUEE, fOn, dwAnimationSpeed)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ProgressBar_SetMarqueeOff
'------------------------------------------------------------------------------
' Sets the progress bar marquee mode to off.
' Return value: Always returns TRUE.
' ========================================================================================
FUNCTION ProgressBar_SetMarqueeOff (hProgress AS HWND) AS LONG
	FUNCTION = SendMessage(hProgress, PBM_SETMARQUEE, FALSE, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ProgressBar_SetMarqueeOn
'------------------------------------------------------------------------------
' Sets the progress bar to marquee mode. This causes the progress bar to move like a marquee.
' Return value: Always returns TRUE.
' ========================================================================================
FUNCTION ProgressBar_SetMarqueeOn (hProgress AS HWND, dwAnimationSpeed AS DWORD) AS LONG
	FUNCTION = SendMessage(hProgress, PBM_SETMARQUEE, TRUE, dwAnimationSpeed)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ProgressBar_SetPos
'------------------------------------------------------------------------------
' Sets the current position for a progress bar and redraws the bar to reflect the new position.
' - nNewPos: Signed integer that becomes the new position.
' Returns the previous position.
' ========================================================================================
FUNCTION ProgressBar_SetPos (hProgress AS HWND, nNewPos AS LONG) AS LONG
	FUNCTION = SendMessage(hProgress, PBM_SETPOS, nNewPos, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ProgressBar_SetRange
'------------------------------------------------------------------------------
' Sets the current position for a progress bar and redraws the bar to reflect the new position.
' The minimum range value must not be negative. By default, the minimum value is zero.
' The maximum range value must be greater than the minimum range value. By default, the
' maximum range value is 100.
' Returns the previous range values if successful, or zero otherwise. The LOWORD specifies
' the previous minimum value, and the HIWORD specifies the previous maximum value.
' ========================================================================================
FUNCTION ProgressBar_SetRange (hProgress AS HWND, nMinRange AS WORD, nMaxRange AS WORD) AS DWORD
	FUNCTION = SendMessage(hProgress, PBM_SETRANGE, 0, MAKELONG(nMinRange, nMaxRange))
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ProgressBar_SetRange32
'------------------------------------------------------------------------------
' Sets the minimum and maximum values for a progress bar to 32-bit values, and redraws the
' bar to reflect the new range. Returns a DWORD value that holds the previous 16-bit low
' limit in its LOWORD and the previous 16-bit high limit in its HIWORD. If the previous
' ranges were 32-bit values, the return value consists of the LOWORDs of both 32-bit limits.
' To retrieve the entire high and low 32-bit values, use the PBM_GETRANGE message.
' ========================================================================================
FUNCTION ProgressBar_SetRange32 (hProgress AS HWND, nMinRange AS LONG, nMaxRange AS LONG) AS DWORD
	FUNCTION = SendMessage(hProgress, PBM_SETRANGE32, nMinRange, nMaxRange)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ProgressBar_SetStep
'------------------------------------------------------------------------------
' Specifies the step increment for a progress bar. The step increment is the amount by
' which the progress bar increases its current position whenever it receives a PBM_STEPIT
' message. By default, the step increment is set to 10.
' Return value: Returns the previous step increment.
' ========================================================================================
FUNCTION ProgressBar_SetStep (hProgress AS HWND, nStepInc AS LONG) AS LONG
	FUNCTION = SendMessage(hProgress, PBM_SETSTEP, nStepInc, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ProgressBar_StepIt
'------------------------------------------------------------------------------
' Advances the current position for a progress bar by the step increment and redraws the
' bar to reflect the new position. An application sets the step increment by sending the
' PBM_SETSTEP message. Return value: Returns the previous position.
' Remarks: When the position exceeds the maximum range value, this message resets the
' current position so that the progress indicator starts over again from the beginning.
' ========================================================================================
FUNCTION ProgressBar_StepIt ( hProgress AS HWND) AS LONG
	FUNCTION = SendMessage(hProgress, PBM_STEPIT, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ProgressBar_GetBarColor
'------------------------------------------------------------------------------
' Returns the color of the progress bar.
' ========================================================================================
FUNCTION ProgressBar_GetBarColor ( hProgress AS HWND) AS COLORREF
	FUNCTION = SendMessage(hProgress, PBM_GETBARCOLOR, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ProgressBar_GetBkColor
'------------------------------------------------------------------------------
' Returns the color of the progress bar.
' ========================================================================================
FUNCTION ProgressBar_GetBkColor ( hProgress AS HWND) AS COLORREF
	FUNCTION = SendMessage(hProgress, PBM_GETBKCOLOR, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ProgressBar_GetState
'------------------------------------------------------------------------------
' Returns the current state of the progress bar. One of the following values.
' - PBST_NORMAL: In progress
' - PBST_ERROR: Error
' - PBST_PAUSED: Paused
' ========================================================================================
FUNCTION ProgressBar_GetState (hProgress AS HWND) AS LONG
	FUNCTION = SendMessageW(hProgress, PBM_GETSTATE, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_ProgressBar_SetState
'------------------------------------------------------------------------------
' Sets the state of the progress bar. Can be one of the following values:
' PBST_NORMAL (in progress), PBST_ERROR (error), PBST_PAUSED (paused).
' Return value: Returns the previous state.
' ========================================================================================
FUNCTION ProgressBar_SetState (hProgress AS HWND, iState AS LONG) AS LONG
	FUNCTION = SendMessage(hProgress, PBM_SETSTATE, iState, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE

' ########################################################################################
'                                  *** STATUS BAR ***
' ########################################################################################

'==============================================================================
$IFUSE USE_StatusBar_GetBorders
'------------------------------------------------------------------------------
' Retrieves the current widths of the horizontal, and vertical borders of a status window,
' and the width of the border between rectangles. Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION StatusBar_GetBorders ( hStatusBar AS HWND, rgBorders AS LONG PTR) AS LONG
	FUNCTION = SendMessage(hStatusBar, SB_GETBORDERS, 0, rgBorders)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_StatusBar_GetHeight
'------------------------------------------------------------------------------
' Returns the height of the status bar.
' ========================================================================================
FUNCTION StatusBar_GetHeight (hStatusBar AS HWND) AS LONG
	DIM AS RECT rc
	GetWindowRect(hStatusBar, &rc)
	FUNCTION = rc.bottom - rc.top
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_StatusBar_GetIcon
'------------------------------------------------------------------------------
' Retrieves the icon for a part in a status bar.
' Returns the handle to the icon if successful, or NULL otherwise.
' ========================================================================================
FUNCTION StatusBar_GetIcon (hStatusBar AS HWND,  nPart AS DWORD) AS HICON
	FUNCTION = (HICON) SendMessage(hStatusBar, SB_GETICON, nPart, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_StatusBar_GetParts
'------------------------------------------------------------------------------
' Retrieves a count of the parts in a status window. The message also retrieves the
' coordinate of the right edge of the specified number of parts.
' - nParts: Number of parts for which to retrieve coordinates. If this parameter is greater
'   than the number of parts in the window, the message retrieves coordinates for existing
'   parts only.
' - rgRightCoords: Pointer to an integer array that has the same number of elements as parts
'   specified by wParam. Each element in the array receives the client coordinate of the
'   right edge of the corresponding part. If an element is set to -1, the position of the
'   right edge for that part extends to the right edge of the window. To retrieve the current
'   number of parts, set this parameter to zero.
' This message always returns the number of parts in the status bar.
' ========================================================================================
FUNCTION StatusBar_GetParts (hStatusBar AS HWND, nParts AS DWORD, rgRightCoords AS LONG PTR) AS LONG
	FUNCTION = SendMessage(hStatusBar, SB_GETPARTS, nParts, rgRightCoords)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_StatusBar_GetPartsCount
'------------------------------------------------------------------------------
' Retrieves a count of the parts in a status window.
' ========================================================================================
FUNCTION StatusBar_GetPartsCount (hStatusBar AS HWND) AS DWORD
	FUNCTION = SendMessage(hStatusBar, SB_GETPARTS, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_StatusBar_GetRect
'------------------------------------------------------------------------------
' Retrieves the bounding rectangle of a part in a status window.
' - nPart: Zero-based index of the part whose bounding rectangle is to be retrieved.
' - lprc: Pointer to a RECT structure that receives the bounding rectangle.
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION StatusBar_GetRect (hStatusBar AS HWND, nPart AS DWORD, lprc AS RECT PTR) AS LONG
	FUNCTION = SendMessage(hStatusBar, SB_GETRECT, nPart, lprc)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_StatusBar_GetTextDrawingMode
'------------------------------------------------------------------------------
' Retrieves the type of operation used to draw the text.
' ========================================================================================
FUNCTION StatusBar_GetTextDrawingMode ( hStatusBar AS HWND, nPart AS DWORD) AS LONG
	Raw AS DWORD dwResult = SendMessage(hStatusBar, SB_GETTEXTLENGTH, nPart, 0)
	FUNCTION = HIWORD(dwResult)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_StatusBar_GetTextLength
'------------------------------------------------------------------------------
' Retrieves the length, in characters, of the text from the specified part of a status window.
' ========================================================================================
FUNCTION StatusBar_GetTextLength (hStatusBar AS HWND, nPart AS DWORD) AS LONG
	Raw AS DWORD dwResult = SendMessage(hStatusBar, SB_GETTEXTLENGTH, nPart, 0)
	FUNCTION = LOWORD(dwResult)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_StatusBar_GetTipText
'------------------------------------------------------------------------------
' Retrieves the tooltip text for a part in a status bar. The status bar must have been
' created with the SBT_TOOLTIPS style to enable tooltips.
' Using this message incorrectly can cause problems for your application. For example, if
' the text is too large for the pwszText buffer, it could cause a buffer overflow.
' ========================================================================================
SUB StatusBar_GetTipText ( hStatusBar AS HWND, nPart AS WORD, pwszText AS char PTR, wMaxLen AS WORD)
	IF pwszText = NULL THEN 
		EXIT SUB
	EndIf
	SendMessage(hStatusBar, SB_GETTIPTEXTW, MAKELONG(nPart, wMaxLen), pwszText)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_StatusBar_GetUnicodeFormat
'------------------------------------------------------------------------------
' Returns the Unicode format flag for the control. If this value is nonzero, the control
' is using Unicode characters. If this value is zero, the control is using ANSI characters.
' ========================================================================================
FUNCTION StatusBar_GetUnicodeFormat ( hStatusBar AS HWND) AS DWORD
	FUNCTION = SendMessage(hStatusBar, SB_GETUNICODEFORMAT, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_StatusBar_IsSimple
'------------------------------------------------------------------------------
' Checks a status bar control to determine if it is in simple mode.
' Returns TRUE if the status bar control is in simple mode, or FALSE otherwise.
' ========================================================================================
FUNCTION StatusBar_IsSimple (hStatusBar AS HWND) AS BOOL
	FUNCTION = SendMessage(hStatusBar, SB_ISSIMPLE, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_StatusBar_SetBkColor
'------------------------------------------------------------------------------
' Sets the background color in a status bar.
' - clrBk: COLORREF value that specifies the new background color. Specify the CLR_DEFAULT
'   value to cause the status bar to use its default background color.
' Returns the previous background color, or CLR_DEFAULT if the background color is the default color.
' ========================================================================================
FUNCTION StatusBar_SetBkColor ( hStatusBar AS HWND,  clrBk AS COLORREF) AS COLORREF
	FUNCTION = SendMessage(hStatusBar, SB_SETBKCOLOR, 0, clrBk)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_StatusBar_SetFont
'------------------------------------------------------------------------------
'  Sets the font that the status bar is to use when drawing text.
' ========================================================================================
SUB StatusBar_SetFont ( hStatusBar AS HWND, hFont AS DWORD, fRedraw AS LONG = FALSE)
	SendMessage(hStatusBar, WM_SETFONT, hFont, fRedraw)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_StatusBar_SetIcon
'------------------------------------------------------------------------------
' Sets the icon for a part in a status bar.
' - nPart: Zero-based index of the part that will receive the icon. If this parameter is -1,
'   the status bar is assumed to be a simple status bar.
' - hIcon: Handle to the icon to be set. If this value is NULL, the icon is removed from the part.
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION StatusBar_SetIcon (hStatusBar AS HWND, nPart AS LONG, hIcon AS DWORD) AS BOOL
	FUNCTION = SendMessage(hStatusBar, SB_SETICON, nPart, hIcon)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_StatusBar_SetMinHeight
'------------------------------------------------------------------------------
' Sets the minimum length, in pixels, of a status window's drawing area.
' The minimum height is the sum of minHeight and twice the width, in pixels, of the vertical
' border of the status window. An application must send the WM_SIZE message to the status
' window to redraw the window.
' ========================================================================================
SUB StatusBar_SetMinHeight ( hStatusBar AS HWND, BYVAL minHeight AS DWORD)
	SendMessage(hStatusBar, SB_SETMINHEIGHT, minHeight, 0)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_StatusBar_SetParts
'------------------------------------------------------------------------------
' Sets the number of parts in a status window and the coordinate of the right edge of each part.
' - dwParts: Number of parts to set (cannot be greater than 256).
' - rgWidths: Pointer to an integer array. The number of elements is specified in dwParts.
'   Each element specifies the position, in client coordinates, of the right edge of the
'   corresponding part. If an element is -1, the right edge of the corresponding part extends
'   to the border of the window.
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION StatusBar_SetParts (hStatusBar AS HWND, dwParts AS DWORD, rgWidths AS LONG PTR) AS BOOL
	FUNCTION = SendMessage(hStatusBar, SB_SETPARTS, dwParts, rgWidths)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_StatusBar_SetText
'------------------------------------------------------------------------------
' Sets the text in the specified part of a status window.
' - nPart: The zero-based index of the part to set. If it is set to SB_SIMPLEID, the status
'   window is assumed to be a simple mode status bar; that is, a status bar with only one part.
' - pwszText: Pointer to a null-terminated string that specifies the text to set. If nPart is
'   SBT_OWNERDRAW, this parameter represents 32 bits of data. The parent window must interpret
'   the data and draw the text when it receives the WM_DRAWITEM message.
' - uType:
'   0	: The text is drawn with a border to appear lower than the plane of the window.
'   SBT_NOBORDERS    : The text is drawn without borders.
'   SBT_OWNERDRAW    : The text is drawn by the parent window.
'                      Note  A simple mode status bar does not support owner drawing.
'   SBT_POPOUT       : The text is drawn with a border to appear higher than the plane of the window.
'   SBT_RTLREADING   : The text will be displayed in the opposite direction to the text in the parent window.
'   SBT_NOTABPARSING : Tab characters are ignored.
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION StatusBar_SetText (hStatusBar AS HWND, nPart AS LONG, pwszText AS const char PTR, uType AS DWORD = 0) AS BOOL
	FUNCTION = SendMessage(hStatusBar, SB_SETTEXTW, (nPart BOR uType), pwszText)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_StatusBar_SetTipText
'------------------------------------------------------------------------------
' Sets the tooltip text for a part in a status bar. The status bar must have been created
' with the SBT_TOOLTIPS style to enable tooltips.
' - nPart: Zero-based index of the part that will receive the tooltip text.
' - pwszText: Pointer to a character buffer that contains the new tooltip text.
' ========================================================================================
SUB StatusBar_SetTipText ( hStatusBar AS HWND, nPart AS LONG, pwszTipText AS const char PTR)
	SendMessage(hStatusBar, SB_SETTIPTEXTW, nPart, pwszTipText)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_StatusBar_SetUnicodeFormat
'------------------------------------------------------------------------------
' Sets the Unicode character format flag for the control. This message allows you to
' change the character set used by the control at run time rather than having to re-create
' the control. Returns the previous Unicode format flag for the control.
' ========================================================================================
FUNCTION StatusBar_SetUnicodeFormat (hStatusBar AS HWND, fUnicode AS DWORD) AS DWORD
	FUNCTION = SendMessage(hStatusBar, SB_SETUNICODEFORMAT, fUnicode, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_StatusBar_Simple
'------------------------------------------------------------------------------
' Specifies whether a status window displays simple text or displays all window parts set
' by a previous SB_SETPARTS message.
' - fSimple: Display type flag. If this parameter is TRUE, the window displays simple text.
'   If it is FALSE, it displays multiple parts.
' ========================================================================================
SUB StatusBar_Simple ( hStatusBar AS HWND, fSimple AS BOOL)
	SendMessage(hStatusBar, SB_SIMPLE, fSimple, 0)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_StatusBar_GetText
'------------------------------------------------------------------------------
' Retrieves the text from the specified part of a status window.
' - nPart: Zero-based index of the part from which to retrieve text.
' - pwszText: Pointer to the buffer that receives the text as a null-terminated string.
'   Use the SB_GETTEXTLENGTH message to determine the required size of the buffer.
' Returns a 32-bit value that consists of two 16-bit values. The low word specifies the
' length, in characters, of the text. The high word specifies the type of operation used
' to draw the text.
' ========================================================================================
FUNCTION StatusBar_GetText ( hStatusBar AS HWND, nPart AS DWORD, pwszText AS char PTR) AS DWORD
	IF pwszText = NULL THEN 
		EXIT FUNCTION
	EndIf
	FUNCTION = SendMessage(hStatusBar, SB_GETTEXTW, nPart,  pwszText)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE

' ########################################################################################
'                                      *** TAB ***
' ########################################################################################

'==============================================================================
$IFUSE USE_TabCtrl_InsertTab
'------------------------------------------------------------------------------
' Inserts a new tab in a tab control.
' - hTab: Handle to the tab control.
' - nTabInxex = Zero-based index of the tab
' - iImage = Zero-based index of the image in the image list or -1 for no image.
' - pwszText = Pointer to a null-terminated string that contains the tab text when item
'     information is being set.
' - lParam: Application-defined data associated with the tab control item.
' Returns the index of the new tab if successful, or -1 otherwise.
' ========================================================================================
FUNCTION TabCtrl_InsertTab (hwndTab AS HWND, nTabIndex AS DWORD, iImage AS LONG,  pwszText AS const char PTR, lParam AS LPARAM = 0) AS LONG
	IF IsWindow(hwndTab) = FALSE THEN 
		Function = -1
	EndIf
	IF pwszText = NULL THEN 
		Function = -1
	EndIf
	Raw AS TCITEMW ttc_item
	ttc_item.mask = TCIF_TEXT BOR TCIF_IMAGE BOR TCIF_RTLREADING BOR TCIF_PARAM BOR TCIF_STATE BOR TCIS_BUTTONPRESSED BOR TCIS_HIGHLIGHTED
	ttc_item.pszText = (LPWSTR)pwszText
	ttc_item.cchTextMax = LEN(pwszText)
	ttc_item.iImage = iImage
	ttc_item.lParam = lParam
	FUNCTION = SendMessage(hwndTab, TCM_INSERTITEMW, nTabIndex, &ttc_item)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TabCtrl_AddTab
'------------------------------------------------------------------------------
' Retrieves the number of tabs and calls TabCtrl_InsertTab to add a new tab.
' ========================================================================================
FUNCTION TabCtrl_AddTab ( hwndTab AS HWND, iImage AS LONG, pwszText AS const char PTR, lParam AS LPARAM = 0) AS LONG
	IF IsWindow(hwndTab) = FALSE THEN 
		Function =  -1
	EndIf
	IF pwszText = NULL THEN 
		Function =  -1
	EndIf
	Raw AS LONG nTabIndex = SendMessage(hwndTab, TCM_GETITEMCOUNT, 0, 0)
	FUNCTION = TabCtrl_InsertTab(hwndTab, nTabIndex, iImage, pwszText, lParam)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TabCtrl_GetText
'------------------------------------------------------------------------------
' Gets the name of a tab in a Tab control.
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION TabCtrl_GetText (hwndTab AS HWND, nTabIndex AS DWORD, pwszText AS char PTR, cchTextMax AS LONG) AS BOOL
	Raw AS TCITEMW ttc_item
	ttc_item.mask = TCIF_TEXT
	ttc_item.pszText = pwszText
	ttc_item.cchTextMax = cchTextMax
	FUNCTION = SendMessage(hwndTab, TCM_GETITEMW, nTabIndex, &ttc_item)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TabCtrl_SetText
'------------------------------------------------------------------------------
' Sets the name of a tab in a Tab control.
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION TabCtrl_SetText ( hwndTab AS HWND, nTabIndex AS DWORD, pwszText AS const char PTR) AS BOOL
	Raw AS TCITEMW ttc_item
	ttc_item.mask = TCIF_TEXT
	ttc_item.pszText = (LPWSTR)pwszText
	ttc_item.cchTextMax = LEN(pwszText)
	FUNCTION = SendMessage(hwndTab, TCM_SETITEMW, nTabIndex, &ttc_item)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TabCtrl_GetImageIndex
'------------------------------------------------------------------------------
' Gets the 0-based index in the tab control's image list.
' Returns the index of the image or -1 if not found.
' ========================================================================================
FUNCTION TabCtrl_GetImageIndex (hwndTab AS HWND,  iItem AS DWORD) AS LONG
	Raw AS TCITEMW ttc_item
	ttc_item.mask = TCIF_IMAGE
	IF SendMessage(hwndTab, TCM_GETITEMW, iItem, &ttc_item) THEN
		FUNCTION = ttc_item.iImage	
	END IF
	FUNCTION = -1
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_TabCtrl_SetImageIndex
'------------------------------------------------------------------------------
' Sets the zero-based index in the tab control's image list.
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION TabCtrl_SetImageIndex (hwndTab AS HWND, iItem AS DWORD, iImage AS LONG) AS BOOL
	Raw AS TCITEMW ttc_item
	ttc_item.mask = TCIF_IMAGE
	ttc_item.iImage = iImage
	FUNCTION = SendMessage(hwndTab, TCM_SETITEMW, iItem, &ttc_item)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE

' ########################################################################################
'                                     *** TRACKBAR ***
' ########################################################################################

'==============================================================================
$IFUSE USE_Trackbar_ClearSel
'------------------------------------------------------------------------------
' Clears the current selection range in a trackbar.
' ========================================================================================
SUB Trackbar_ClearSel ( hTrackbar AS HWND, fRedraw AS BOOLEAN = FALSE)
	SendMessage(hTrackbar, TBM_CLEARSEL, fRedraw, 0)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Trackbar_ClearTics
'------------------------------------------------------------------------------
' Removes the current tick marks from a trackbar. This message does not remove the first
' and last tick marks, which are created automatically by the trackbar.
' ========================================================================================
SUB Trackbar_ClearTics ( hTrackbar AS HWND, fRedraw AS BOOLEAN = FALSE)
	SendMessage(hTrackbar, TBM_CLEARTICS, fRedraw, 0)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Trackbar_GetBuddy
'------------------------------------------------------------------------------
' Retrieves the handle to a trackbar control buddy window at a given location.
' Value indicating which buddy window handle will be retrieved, by relative location.
' This value can be one of the following:
' - TRUE : Retrieves the handle to the buddy to the left of the trackbar. If the trackbar
'   control uses the TBS_VERT style, the message will retrieve the buddy above the trackbar.
' - FALSE : Retrieves the handle to the buddy to the right of the trackbar. If the trackbar
'   control uses the TBS_VERT style, the message will retrieve the buddy below the trackbar.
' Returns the handle to the buddy window at the location specified by wParam, or NULL if no buddy window exists at that location.
' ========================================================================================
FUNCTION Trackbar_GetBuddy (hTrackbar AS HWND, fLocation AS LONG) AS HWND
	FUNCTION = (HWND) SendMessage(hTrackbar, TBM_GETBUDDY, fLocation, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Trackbar_GetChannelRect
'------------------------------------------------------------------------------
' Retrieves the size and position of the bounding rectangle for a trackbar's channel.
' (The channel is the area over which the slider moves. It contains the highlight when a
' range is selected.)
' ========================================================================================
SUB Trackbar_GetChannelRect ( hTrackbar AS HWND, lprc AS RECT PTR)
	SendMessage(hTrackbar, TBM_GETCHANNELRECT, 0, lprc)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Trackbar_GetLineSize
'------------------------------------------------------------------------------
' Retrieves the number of logical positions the trackbar's slider moves in response to
' keyboard input from the arrow keys, such as the or keys. The logical positions are the
' integer increments in the trackbar's range of minimum to maximum slider positions.
' ========================================================================================
FUNCTION Trackbar_GetLineSize (hTrackbar AS HWND) AS LONG
	FUNCTION = SendMessage(hTrackbar, TBM_GETLINESIZE, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Trackbar_GetNumTics
'------------------------------------------------------------------------------
' Retrieves the number of tick marks in a trackbar.
' ========================================================================================
FUNCTION Trackbar_GetNumTics ( hTrackbar AS HWND) AS LONG
	FUNCTION = SendMessage(hTrackbar, TBM_GETNUMTICS, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Trackbar_GetPageSize
'------------------------------------------------------------------------------
' Retrieves the number of logical positions the trackbar's slider moves in response to
' keyboard input, such as the or keys, or mouse input, such as clicks in the trackbar's
' channel. The logical positions are the integer increments in the trackbar's range of
' minimum to maximum slider positions.
' ========================================================================================
FUNCTION Trackbar_GetPageSize ( hTrackbar AS HWND) AS LONG
	FUNCTION = SendMessage(hTrackbar, TBM_GETPAGESIZE, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Trackbar_GetPos
'------------------------------------------------------------------------------
' Retrieves the current logical position of the slider in a trackbar. The logical positions
' are the integer values in the trackbar's range of minimum to maximum slider positions.
' ========================================================================================
FUNCTION Trackbar_GetPos ( hTrackbar AS HWND) AS LONG
	FUNCTION = SendMessage(hTrackbar, TBM_GETPOS, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Trackbar_GetPTics
'------------------------------------------------------------------------------
' Retrieves the address of an array that contains the positions of the tick marks for a trackbar.
' ========================================================================================
FUNCTION Trackbar_GetPTics ( hTrackbar AS HWND) AS DWORD
	FUNCTION = SendMessage(hTrackbar, TBM_GETPTICS, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Trackbar_GetRangeMax
'------------------------------------------------------------------------------
' Retrieves the maximum position for the slider in a trackbar.
' ========================================================================================
FUNCTION Trackbar_GetRangeMax (hTrackbar AS HWND) AS LONG
	FUNCTION = SendMessage(hTrackbar, TBM_GETRANGEMAX, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Trackbar_GetRangeMin
'------------------------------------------------------------------------------
' Retrieves the maximum position for the slider in a trackbar.
' ========================================================================================
FUNCTION Trackbar_GetRangeMin ( hTrackbar AS HWND) AS LONG
	FUNCTION = SendMessage(hTrackbar, TBM_GETRANGEMIN, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Trackbar_GetSelEnd
'------------------------------------------------------------------------------
' Retrieves the ending position of the current selection range in a trackbar.
' ========================================================================================
FUNCTION Trackbar_GetSelEnd ( hTrackbar AS HWND) AS LONG
	FUNCTION = SendMessageW(hTrackbar, TBM_GETSELEND, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Trackbar_GetSelStart
'------------------------------------------------------------------------------
' Retrieves the starting position of the current selection range in a trackbar.
' ========================================================================================
FUNCTION Trackbar_GetSelStart ( hTrackbar AS HWND) AS LONG
	FUNCTION = SendMessage(hTrackbar, TBM_GETSELSTART, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Trackbar_GetThumbLength
'------------------------------------------------------------------------------
' Retrieves the length of the slider in a trackbar.
' ========================================================================================
FUNCTION Trackbar_GetThumbLength ( hTrackbar AS HWND) AS LONG
	FUNCTION = SendMessage(hTrackbar, TBM_GETTHUMBLENGTH, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Trackbar_GetThumbRect
'------------------------------------------------------------------------------
' Retrieves the length of the slider in a trackbar.
' ========================================================================================
SUB Trackbar_GetThumbRect ( hTrackbar AS HWND, lprc AS RECT PTR)
	SendMessage(hTrackbar, TBM_GETTHUMBRECT, 0, lprc)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Trackbar_GetTic
'------------------------------------------------------------------------------
' Retrieves the length of the slider in a trackbar.
' ========================================================================================
FUNCTION Trackbar_GetTic ( hTrackbar AS HWND, iTic AS DWORD) AS LONG
	FUNCTION = SendMessage(hTrackbar, TBM_GETTIC, iTic, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Trackbar_GetTicPos
'------------------------------------------------------------------------------
' Retrieves the length of the slider in a trackbar.
' ========================================================================================
FUNCTION Trackbar_GetTicPos ( hTrackbar AS HWND, iTic AS DWORD) AS LONG
	FUNCTION = SendMessage(hTrackbar, TBM_GETTICPOS, iTic, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Trackbar_GetTooltips
'------------------------------------------------------------------------------
' Retrieves the handle to the ToolTip control assigned to the trackbar, if any.
' ========================================================================================
FUNCTION Trackbar_GetTooltips ( hTrackbar AS HWND) AS HWND
	FUNCTION = (HWND) SendMessage(hTrackbar, TBM_GETTOOLTIPS, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Trackbar_GetUnicodeFormat
'------------------------------------------------------------------------------
' Retrieves the Unicode character format flag for the control.
' ========================================================================================
FUNCTION Trackbar_GetUnicodeFormat ( hTrackbar AS HWND) AS DWORD
	FUNCTION = SendMessage(hTrackbar, TBM_GETUNICODEFORMAT, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Trackbar_SetBuddy
'------------------------------------------------------------------------------
' Assigns a window as the buddy window for a trackbar control. Trackbar buddy windows are
' automatically displayed in a location relative to the control's orientation (horizontal
' or vertical).
' Returns the handle to the window that was previously assigned to the control at that location.
' ========================================================================================
FUNCTION Trackbar_SetBuddy ( hTrackbar AS HWND, fLocation AS LONG, hwndBuddy AS HWND) AS HWND
	FUNCTION = (HWND) SendMessage(hTrackbar, TBM_SETBUDDY, fLocation, hwndBuddy)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Trackbar_SetLineSize
'------------------------------------------------------------------------------
' Sets the number of logical positions the trackbar's slider moves in response to keyboard
' input from the arrow keys, such as the or keys. The logical positions are the integer
' increments in the trackbar's range of minimum to maximum slider positions.
' Returns a 32-bit value that specifies the previous line size.
' Remarks: The default setting for the line size is 1.
' ========================================================================================
FUNCTION Trackbar_SetLineSize ( hTrackbar AS HWND, lLineSize AS LONG) AS LONG
	FUNCTION = SendMessage(hTrackbar, TBM_SETLINESIZE, 0, lLineSize)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Trackbar_SetPageSize
'------------------------------------------------------------------------------
' Sets the number of logical positions the trackbar's slider moves in response to keyboard
' input, such as the or keys, or mouse input, such as clicks in the trackbar's channel.
' The logical positions are the integer increments in the trackbar's range of minimum to
' maximum slider positions.
' Returns a 32-bit value that specifies the previous page size.
' ========================================================================================
FUNCTION Trackbar_SetPageSize ( hTrackbar AS HWND, lPageSize AS LONG) AS LONG
	FUNCTION = SendMessage(hTrackbar, TBM_SETPAGESIZE, 0, lPageSize)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Trackbar_SetPos
'------------------------------------------------------------------------------
' Sets the current logical position of the slider in a trackbar.
' ========================================================================================
SUB Trackbar_SetPos ( hTrackbar AS HWND, fPosition AS LONG, lPosition AS LONG)
	SendMessage(hTrackbar, TBM_SETPOS, fPosition, lPosition)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Trackbar_SetRange
'------------------------------------------------------------------------------
' Sets the range of minimum and maximum logical positions for the slider in a trackbar.
' ========================================================================================
SUB Trackbar_SetRange ( hTrackbar AS HWND, lMinimum AS LONG, lMaximum AS LONG, fRedraw AS BOOL = FALSE)
	SendMessage(hTrackbar, TBM_SETRANGE, fRedraw, MAKELONG(lMinimum, lMaximum))
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Trackbar_SetRangeMax
'------------------------------------------------------------------------------
' Sets the maximum logical position for the slider in a trackbar.
' ========================================================================================
SUB Trackbar_SetRangeMax ( hTrackbar AS HWND, lMaximum AS LONG, fRedraw AS BOOL = FALSE)
	SendMessage(hTrackbar, TBM_SETRANGEMAX, fRedraw, lMaximum)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Trackbar_SetRangeMin
'------------------------------------------------------------------------------
' Sets the minimum logical position for the slider in a trackbar.
' ========================================================================================
SUB Trackbar_SetRangeMin ( hTrackbar AS HWND, lMinimum AS LONG, fRedraw AS BOOL = FALSE)
	SendMessage(hTrackbar, TBM_SETRANGEMIN, fRedraw, lMinimum)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Trackbar_SetSel
'------------------------------------------------------------------------------
' Sets the starting and ending positions for the available selection range in a trackbar.
' ========================================================================================
SUB Trackbar_SetSel ( hTrackbar AS HWND, lMinimum AS LONG, lMaximum AS LONG, fRedraw AS BOOL = FALSE)
	SendMessage(hTrackbar, TBM_SETSEL, fRedraw, MAKELONG(lMinimum, lMaximum))
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Trackbar_SetSelEnd
'------------------------------------------------------------------------------
' Sets the ending logical position of the current selection range in a trackbar. This
' message is ignored if the trackbar does not have the TBS_ENABLESELRANGE style.
' ========================================================================================
SUB Trackbar_SetSelEnd ( hTrackbar AS HWND, lEnd AS LONG, fRedraw AS BOOL = FALSE)
	SendMessage(hTrackbar, TBM_SETSELEND, fRedraw, lEnd)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Trackbar_SetSelStart
'------------------------------------------------------------------------------
' Sets the starting logical position of the current selection range in a trackbar. This
' message is ignored if the trackbar does not have the BS_ENABLESELRANGE style.
' ========================================================================================
SUB Trackbar_SetSelStart ( hTrackbar AS HWND, lStart AS LONG, fRedraw AS BOOL = FALSE)
	SendMessage(hTrackbar, TBM_SETSELSTART, fRedraw, lStart)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Trackbar_SetThumbLength
'------------------------------------------------------------------------------
' Sets the length of the slider in a trackbar. This message is ignored if the trackbar
' does not have the TBS_FIXEDLENGTH style.
' ========================================================================================
SUB Trackbar_SetThumbLength ( hTrackbar AS HWND, iLength AS LONG)
	SendMessage(hTrackbar, TBM_SETTHUMBLENGTH, iLength, 0)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Trackbar_SetTic
'------------------------------------------------------------------------------
' Sets a tick mark in a trackbar at the specified logical position.
' ========================================================================================
FUNCTION Trackbar_SetTic ( hTrackbar AS HWND, lPosition AS LONG) AS BOOL
	FUNCTION = SendMessage(hTrackbar, TBM_SETTIC, 0, lPosition)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Trackbar_SetTicFreq
'------------------------------------------------------------------------------
' Sets the interval frequency for tick marks in a trackbar.
' ========================================================================================
SUB Trackbar_SetTicFreq ( hTrackbar AS HWND, wFreq AS WORD)
	SendMessage(hTrackbar, TBM_SETTICFREQ, wFreq, 0)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Trackbar_SetTipSide
'------------------------------------------------------------------------------
' Positions a ToolTip control used by a trackbar control. Trackbar controls that use the
' TBS_TOOLTIPS style display ToolTips.
' ========================================================================================
FUNCTION Trackbar_SetTipSide ( hTrackbar AS HWND, fLocation AS LONG) AS LONG
	FUNCTION = SendMessage(hTrackbar, TBM_SETTIPSIDE, fLocation, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Trackbar_SetToolTips
'------------------------------------------------------------------------------
' Assigns a ToolTip control to a trackbar control.
' ========================================================================================
SUB Trackbar_SetToolTips ( hTrackbar AS HWND,  hwndTT AS HWND)
	SendMessage(hTrackbar, TBM_SETTOOLTIPS, hwndTT, 0)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Trackbar_SetUnicodeFormat
'------------------------------------------------------------------------------
' Sets the Unicode character format flag for the control. This message allows you to
' change the character set used by the control at run time rather than having to re-create
' the control. Returns the previous Unicode format flag for the control.
' ========================================================================================
FUNCTION Trackbar_SetUnicodeFormat (hTrackbar AS HWND, fUnicode AS DWORD) AS DWORD
	FUNCTION = SendMessage(hTrackbar, TBM_SETUNICODEFORMAT, fUnicode, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE

' ########################################################################################
'                                     *** UPDOWN ***
' ########################################################################################

'==============================================================================
$IFUSE USE_UpDown_GetAccel
'------------------------------------------------------------------------------
' Retrieves acceleration information for an up-down control.
' The return value is the number of accelerators currently set for the control.
' ========================================================================================
FUNCTION UpDown_GetAccel (hUDM AS HWND, cAccels AS DWORD, paAccels AS UDACCEL PTR) AS LONG
	FUNCTION = SendMessage(hUDM, UDM_GETACCEL, cAccels, paAccels)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_UpDown_GetBase
'------------------------------------------------------------------------------
' Retrieves the current radix base (that is, either base 10 or 16) for an up-down control.
' ========================================================================================
FUNCTION UpDown_GetBase ( hUDM AS HWND) AS LONG
	FUNCTION = SendMessage(hUDM, UDM_GETBASE, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_UpDown_GetBuddy
'------------------------------------------------------------------------------
' Retrieves the handle to the current buddy window.
' ========================================================================================
FUNCTION UpDown_GetBuddy (hUDM AS HWND) AS HWND
	FUNCTION = (HWND) SendMessage(hUDM, UDM_GETBUDDY, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_UpDown_GetPos
'------------------------------------------------------------------------------
' Retrieves the current position of an up-down control with 16-bit precision.
' ========================================================================================
FUNCTION UpDown_GetPos ( hUDM AS HWND) AS LONG
	FUNCTION = SendMessage(hUDM, UDM_GETPOS, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_UpDown_GetPos32
'------------------------------------------------------------------------------
' Returns the 32-bit position of an up-down control.
' ========================================================================================
FUNCTION UpDown_GetPos32 (hUDM AS HWND, pfError AS LONG PTR = NULL) AS LONG
	FUNCTION = SendMessage(hUDM, UDM_GETPOS32, 0, pfError)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_UpDown_GetRange
'------------------------------------------------------------------------------
' Returns the 32-bit position of an up-down control.
' ========================================================================================
FUNCTION UpDown_GetRange ( hUDM AS HWND) AS LONG
	FUNCTION = SendMessage(hUDM, UDM_GETRANGE, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_UpDown_GetRange32
'------------------------------------------------------------------------------
' Returns the 32-bit position of an up-down control.
' ========================================================================================
SUB UpDown_GetRange32 ( hUDM AS HWND, pLow AS WORD PTR, pHigh AS WORD PTR)
	SendMessage(hUDM, UDM_GETRANGE32, pLow, pHigh)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_UpDown_GetUnicodeFormat
'------------------------------------------------------------------------------
' Retrieves the Unicode character format flag for the control.
' ========================================================================================
FUNCTION UpDown_GetUnicodeFormat ( hUDM AS HWND) AS DWORD
	FUNCTION = SendMessage(hUDM, UDM_GETUNICODEFORMAT, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_UpDown_SetAccel
'------------------------------------------------------------------------------
' Sets the acceleration for an up-down control.
' Returns TRUE if successful, or FALSE otherwise.
' ========================================================================================
FUNCTION UpDown_SetAccel (hUDM AS HWND, cAccels AS DWORD, BYREF paAccels AS UDACCEL PTR) AS BOOL
	FUNCTION = SendMessage(hUDM, UDM_SETACCEL, cAccels, paAccels)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_UpDown_SetBase
'------------------------------------------------------------------------------
' Sets the acceleration for an up-down control.
' The return value is the previous base value. If an invalid base is given, the return value is zero.
' ========================================================================================
FUNCTION UpDown_SetBase (hUDM AS HWND,  nBase AS LONG) AS LONG
	FUNCTION = SendMessage(hUDM, UDM_SETBASE, nBase, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_UpDown_SetBuddy
'------------------------------------------------------------------------------
' Sets the buddy window for an up-down control.
' The return value is the handle to the previous buddy window.
' ========================================================================================
FUNCTION UpDown_SetBuddy ( hUDM AS HWND, hwndBuddy AS HWND) AS HWND
	FUNCTION = (HWND) SendMessage(hUDM, UDM_SETBUDDY, hwndBuddy, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_UpDown_SetPos
'------------------------------------------------------------------------------
' Sets the current position for an up-down control with 16-bit precision.
' The return value is the previous position.
' ========================================================================================
FUNCTION UpDown_SetPos (hUDM AS HWND, nPos AS SHORT) AS LONG
	FUNCTION = SendMessage(hUDM, UDM_SETPOS, 0, MAKELONG(nPos, 0))
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_UpDown_SetPos32
'------------------------------------------------------------------------------
' Sets the current position for an up-down control with 32-bit precision.
' The return value is the previous position.
' ========================================================================================
FUNCTION UpDown_SetPos32 (hUDM AS HWND, nPos AS LONG) AS LONG
	FUNCTION = SendMessage(hUDM, UDM_SETPOS32, 0, nPos)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_UpDown_SetRange
'------------------------------------------------------------------------------
' Sets the minimum and maximum positions (range) for an up-down control.
' ========================================================================================
SUB UpDown_SetRange ( hUDM AS HWND, nUpper AS SHORT, nLower AS SHORT)
	SendMessage(hUDM, UDM_SETRANGE, 0, MAKELONG(nUpper, nLower))
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_UpDown_SetRange32
'------------------------------------------------------------------------------
' Sets the minimum and maximum positions (range) for an up-down control.
' ========================================================================================
SUB UpDown_SetRange32 ( hUDM AS HWND, iLow AS LONG, iHigh AS LONG)
	SendMessage(hUDM, UDM_SETRANGE32, iLow, iHigh)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_UpDown_SetUnicodeFormat
'------------------------------------------------------------------------------
' Sets the Unicode character format flag for the control.
' Returns the previous Unicode format flag for the control.
' ========================================================================================
FUNCTION UpDown_SetUnicodeFormat ( hUDM AS HWND, fUnicode AS DWORD) AS DWORD
	FUNCTION = SendMessage(hUDM, UDM_SETUNICODEFORMAT, fUnicode, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE

' ########################################################################################
'                                   *** TOOLTIPS ***
' ########################################################################################

'==============================================================================
$IFUSE USE_Tooltip_Activate
'------------------------------------------------------------------------------
' Activates or deactivates a ToolTip control.
' ========================================================================================
SUB Tooltip_Activate ( hTooltip AS HWND, fActivate AS BOOL)
	SendMessage(hTooltip, TTM_ACTIVATE, fActivate, 0)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Tooltip_AddTool
'------------------------------------------------------------------------------
' Registers a tool with a ToolTip control.
' ========================================================================================
FUNCTION Tooltip_AddTool (hTooltip AS HWND, lpti AS TOOLINFO PTR) AS BOOL
	FUNCTION = SendMessage(hTooltip, TTM_ADDTOOL, 0, lpti)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Tooltip_AdjustRect
'------------------------------------------------------------------------------
' Calculates a ToolTip control's text display rectangle from its window rectangle, or the
' ToolTip window rectangle needed to display a specified text display rectangle.
' ========================================================================================
FUNCTION Tooltip_AdjustRect ( hTooltip AS HWND, fLarger AS BOOL,  lprc AS RECT PTR) AS BOOL
	FUNCTION = SendMessage(hTooltip, TTM_ADJUSTRECT, fLarger, lprc)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Tooltip_DelTool
'------------------------------------------------------------------------------
' Removes a tool from a ToolTip control.
' ========================================================================================
SUB Tooltip_DelTool ( hTooltip AS HWND, lpti AS TOOLINFO PTR)
	SendMessage(hTooltip, TTM_DELTOOL, 0, lpti)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Tooltip_EnumTools
'------------------------------------------------------------------------------
' Retrieves the information that a ToolTip control maintains about the current tool--that
' is, the tool for which the ToolTip is currently displaying text.
' ========================================================================================
FUNCTION Tooltip_EnumTools ( hTooltip AS HWND, iTool AS DWORD, lpti AS TOOLINFO PTR) AS BOOL
	FUNCTION = SendMessage(hTooltip, TTM_ENUMTOOLS, iTool, lpti)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Tooltip_GetBubbleSize
'------------------------------------------------------------------------------
' Returns the width and height of a ToolTip control.
' ========================================================================================
FUNCTION Tooltip_GetBubbleSize ( hTooltip AS HWND, lpTtm AS TOOLINFO PTR) AS DWORD
	FUNCTION = SendMessage(hTooltip, TTM_GETBUBBLESIZE, 0, lpTtm)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Tooltip_GetCurrentTool
'------------------------------------------------------------------------------
' Retrieves the information for the current tool in a ToolTip control.
' ========================================================================================
FUNCTION Tooltip_GetCurrentTool (hTooltip AS HWND, lpti AS TOOLINFO PTR) AS BOOL
	FUNCTION = SendMessage(hTooltip, TTM_GETCURRENTTOOL, 0, lpti)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Tooltip_GetDelayTime
'------------------------------------------------------------------------------
' Retrieves the information for the current tool in a ToolTip control.
' ========================================================================================
FUNCTION Tooltip_GetDelayTime (hTooltip AS HWND, dwDuration AS DWORD) AS LONG
	FUNCTION = SendMessage(hTooltip, TTM_GETDELAYTIME, dwDuration, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Tooltip_GetFont
'------------------------------------------------------------------------------
' Retrieves the handle of the font used by the ToolTip control.
' ========================================================================================
FUNCTION Tooltip_GetFont (hTooltip AS HWND) AS HFONT
	FUNCTION = (HFONT) SendMessage(hTooltip, WM_GETFONT, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Tooltip_GetMargin
'------------------------------------------------------------------------------
' Retrieves the top, left, bottom, and right margins set for a ToolTip window. A margin is
' the distance, in pixels, between the ToolTip window border and the text contained within
' the ToolTip window.
' ========================================================================================
SUB Tooltip_GetMargin ( hTooltip AS HWND, lprc AS RECT PTR)
	SendMessage(hTooltip, TTM_GETMARGIN, 0, lprc)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Tooltip_GetMaxTipWidth
'------------------------------------------------------------------------------
' Retrieves the maximum width for a ToolTip window.
' ========================================================================================
FUNCTION Tooltip_GetMaxTipWidth (hTooltip AS HWND) AS LONG
	FUNCTION = SendMessage(hTooltip, TTM_GETMAXTIPWIDTH, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Tooltip_GetText
'------------------------------------------------------------------------------
' Retrieves the information a ToolTip control maintains about a tool.
' ========================================================================================
SUB Tooltip_GetText ( hTooltip AS HWND, numChars AS DWORD, lpti AS TOOLINFO PTR)
	SendMessage(hTooltip, TTM_GETTEXT, numChars, lpti)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Tooltip_GetTipBkColor
'------------------------------------------------------------------------------
' Retrieves the background color in a ToolTip window.
' ========================================================================================
FUNCTION Tooltip_GetTipBkColor ( hTooltip AS HWND) AS COLORREF
	FUNCTION = SendMessage(hTooltip, TTM_GETTIPBKCOLOR, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Tooltip_GetTipTextColor
'------------------------------------------------------------------------------
' Retrieves the text color in a ToolTip window.
' ========================================================================================
FUNCTION Tooltip_GetTipTextColor (hTooltip AS HWND) AS COLORREF
	FUNCTION = SendMessage(hTooltip, TTM_GETTIPTEXTCOLOR, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Tooltip_GetTitle
'------------------------------------------------------------------------------
' Retrieves information concerning the title of a tooltip control.
' ========================================================================================
SUB Tooltip_GetTitle ( hTooltip AS HWND, pTTGetTitle AS TTGETTITLE PTR)
	SendMessage(hTooltip, TTM_GETTITLE, 0, pTTGetTitle)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Tooltip_GetToolCount
'------------------------------------------------------------------------------
' Retrieves a count of the tools maintained by a ToolTip control.
' ========================================================================================
FUNCTION Tooltip_GetToolCount (hTooltip AS HWND) AS LONG
	FUNCTION = SendMessage(hTooltip, TTM_GETTOOLCOUNT, 0, 0)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Tooltip_GetToolInfo
'------------------------------------------------------------------------------
' Retrieves the information that a ToolTip control maintains about a tool.
' ========================================================================================
FUNCTION Tooltip_GetToolInfo (hTooltip AS HWND, lpti AS TOOLINFO PTR) AS BOOL
	FUNCTION = SendMessage(hTooltip, TTM_GETTOOLINFO, 0, lpti)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Tooltip_HitTest
'------------------------------------------------------------------------------
' Tests a point to determine whether it is within the bounding rectangle of the specified
' tool and, if it is, retrieves information about the tool.
' ========================================================================================
FUNCTION Tooltip_HitTest ( hTooltip AS HWND, lphti AS TTHITTESTINFO PTR) AS BOOL
	FUNCTION = SendMessage(hTooltip, TTM_HITTEST, 0, lphti)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Tooltip_NewToolRect
'------------------------------------------------------------------------------
' Sets a new bounding rectangle for a tool.
' ========================================================================================
SUB Tooltip_NewToolRect ( hTooltip AS HWND, lpti AS TOOLINFO PTR)
	SendMessage(hTooltip, TTM_NEWTOOLRECT, 0, lpti)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Tooltip_Pop
'------------------------------------------------------------------------------
' Removes a displayed ToolTip window from view.
' ========================================================================================
SUB Tooltip_Pop ( hTooltip AS HWND)
	SendMessage(hTooltip, TTM_POP, 0, 0)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Tooltip_Popup
'------------------------------------------------------------------------------
' Causes the ToolTip to display at the coordinates of the last mouse message.
' ========================================================================================
SUB Tooltip_Popup ( hTooltip AS HWND)
	SendMessage(hTooltip, TTM_POPUP, 0, 0)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Tooltip_RelayEvent
'------------------------------------------------------------------------------
' Passes a mouse message to a ToolTip control for processing.
' ========================================================================================
FUNCTION Tooltip_RelayEvent ( hTooltip AS HWND, lpmsg AS tagMSG PTR) AS LONG
	FUNCTION = SendMessage(hTooltip, TTM_RELAYEVENT, 0, lpmsg)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Tooltip_SetDelayTime
'------------------------------------------------------------------------------
' Sets the initial, pop-up, and reshow durations for a ToolTip control.
' ========================================================================================
SUB Tooltip_SetDelayTime ( hTooltip AS HWND, dwDuration AS DWORD, iTime AS SHORT)
	SendMessage(hTooltip, TTM_SETDELAYTIME, dwDuration, MAKELONG(iTime, 0))
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Tooltip_SetFont
'------------------------------------------------------------------------------
' Sets the font used by the ToolTip control.
' Parameters:
' - hTooltip  = Handle to the ToolTip control.
' - hFont     = Handle to the font. If this parameter is NULL, the control uses the default
'               system font to draw text.
' - fRedraw   = Specifies whether the control should be redrawn immediately upon setting the font.
'               If this parameter is TRUE, the control redraws itself.
' ========================================================================================
SUB Tooltip_SetFont ( hTooltip AS HWND, hFont AS HFONT = NULL, fRedraw AS BOOL = FALSE)
	SendMessage(hTooltip, WM_SETFONT, hFont, fRedraw)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Tooltip_SetMargin
'------------------------------------------------------------------------------
' Sets the top, left, bottom, and right margins for a ToolTip window. A margin is the
' distance, in pixels, between the ToolTip window border and the text contained within the
' ToolTip window.
' ========================================================================================
SUB Tooltip_SetMargin ( hTooltip AS HWND, lprc AS RECT PTR)
	SendMessage(hTooltip, TTM_SETMARGIN, 0, lprc)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Tooltip_SetMaxTipWidth
'------------------------------------------------------------------------------
' Sets the maximum width for a ToolTip window.
' ========================================================================================
FUNCTION Tooltip_SetMaxTipWidth (hTooltip AS HWND, iWidth AS LONG) AS LONG
	FUNCTION = SendMessage(hTooltip, TTM_SETMAXTIPWIDTH, 0, iWidth)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Tooltip_SetTipBkColor
'------------------------------------------------------------------------------
' Sets the background color in a ToolTip window.
' ========================================================================================
SUB Tooltip_SetTipBkColor ( hTooltip AS HWND, clr AS COLORREF)
	SendMessage(hTooltip, TTM_SETTIPBKCOLOR, clr, 0)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Tooltip_SetTipTextColor
'------------------------------------------------------------------------------
' Sets the text color in a ToolTip window.
' ========================================================================================
SUB Tooltip_SetTipTextColor ( hTooltip AS HWND, clr AS COLORREF)
	SendMessage(hTooltip, TTM_SETTIPTEXTCOLOR, clr, 0)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Tooltip_SetTitle
'------------------------------------------------------------------------------
' Adds a standard icon and title string to a ToolTip.
' ========================================================================================
FUNCTION Tooltip_SetTitle (hTooltip AS HWND, nIcon AS LONG, pwszTitle AS const char PTR) AS BOOL
	FUNCTION = SendMessage(hTooltip, TTM_SETTITLEW, nIcon, pwszTitle)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Tooltip_SetToolInfo
'------------------------------------------------------------------------------
' Sets the information that a ToolTip control maintains for a tool.
' ========================================================================================
SUB Tooltip_SetToolInfo ( hTooltip AS HWND, lpti AS TOOLINFO PTR)
	SendMessage(hTooltip, TTM_SETTOOLINFO, 0, lpti)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Tooltip_SetWindowTheme
'------------------------------------------------------------------------------
' Sets the visual style of a ToolTip control.
' ========================================================================================
SUB Tooltip_SetWindowTheme ( hTooltip AS HWND, pwszTheme AS const char PTR)
	SendMessage(hTooltip, TTM_SETWINDOWTHEME, 0, pwszTheme)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Tooltip_TrackActivate
'------------------------------------------------------------------------------
' Activates or deactivates a tracking ToolTip.
' ========================================================================================
SUB Tooltip_TrackActivate ( hTooltip AS HWND, bActivate AS BOOL, lpti AS TOOLINFO PTR)
	SendMessage(hTooltip, TTM_TRACKACTIVATE, bActivate, lpti)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Tooltip_TrackPosition
'------------------------------------------------------------------------------
' Activates or deactivates a tracking ToolTip.
' ========================================================================================
SUB Tooltip_TrackPosition ( hTooltip AS HWND, xPos AS LONG, yPos AS LONG)
	SendMessage(hTooltip, TTM_TRACKPOSITION, 0, MAKELONG(xPos, yPos))
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Tooltip_Update
'------------------------------------------------------------------------------
' Activates or deactivates a tracking ToolTip.
' ========================================================================================
SUB Tooltip_Update ( hTooltip AS HWND)
	SendMessage(hTooltip, TTM_UPDATE, 0, 0)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Tooltip_UpdateTipText
'------------------------------------------------------------------------------
' Sets the ToolTip text for a tool.
' ========================================================================================
SUB Tooltip_UpdateTipText ( hTooltip AS HWND, lpti AS TOOLINFO PTR)
	SendMessage(hTooltip, TTM_UPDATETIPTEXT, 0, lpti)
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_Tooltip_WindowFromPoint
'------------------------------------------------------------------------------
' Allows a subclass procedure to cause a ToolTip to display text for a window other than
' the one beneath the mouse cursor.
' ========================================================================================
FUNCTION Tooltip_WindowFromPoint ( hTooltip AS HWND, lppt AS POINT PTR) AS HWND
	FUNCTION = (HWND) SendMessage(hTooltip, TTM_WINDOWFROMPOINT, 0, lppt)
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxAddTooltip
'------------------------------------------------------------------------------
' Creates a tooltip for a control.
' Parameters:
' - hwndCtrl  = Handle of the control
' - wszText   = Tooltip text
' - bBalloon  = Ballon tip (TRUE or FALSE)
' - bCentered = Centered (TRUE or FALSE)
' Return Value:
'   The handle of the tooltip control
' ========================================================================================
FUNCTION AfxAddTooltip ( hwndCtrl AS HWND,  wszText AS CONST char ptr = "",  bBalloon AS BOOL = FALSE, bCentered AS BOOL = FALSE) AS HWND
	IF IsWindow(hwndCtrl) = 0 THEN 
		EXIT FUNCTION
	EndIf
	' // Creates the tooltip control
	Raw AS DWORD dwStyle = WS_POPUP BOR TTS_ALWAYSTIP
	IF bBalloon THEN 
		dwStyle = dwStyle BOR TTS_BALLOON
	EndIf
	DIM AS HWND hTooltip
	hTooltip = CreateWindowEx(0, "tooltips_class32", "", dwStyle, 0, 0, 0, 0, NULL, NULL, NULL, NULL)
	IF hTooltip = NULL THEN 
		EXIT FUNCTION
	EndIf
	' // Registers the window with the tooltip control
	' // 32-bit: The size of the TOOLINFO structure is 48 bytes in
	'    version 6 of comctl32.dll, and 44 bytes in lower versions.
	' // 64-bit: The size of the TOOLINFO structure is 72 bytes in
	'    version 6 of comctl32.dll, and 64 bytes in lower versions.
	DIM AS TOOLINFOW tti
	tti.cbSize = 72

	tti.uFlags = TTF_IDISHWND OR TTF_SUBCLASS
	IF bCentered THEN tti.uFlags = tti.uFlags OR TTF_CENTERTIP
	tti.hwnd = GetParent(hwndCtrl)
	tti.uId = (UINT_PTR) hwndCtrl
	tti.hinst = GetModuleHandleW(NULL)
	' // The length of the string must not exceed of 80 characters, including the terminating null
	DIM wszTooltipText$ * 80
	wszTooltipText$ = wszText$
	tti.lpszText = (LPWSTR)wszTooltipText
	SendMessage(hTooltip, TTM_ADDTOOLW, 0, &tti)
	FUNCTION = hTooltip
END FUNCTION
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxSetTooltipText
'------------------------------------------------------------------------------
' Sets/replaces the text of a tooltip control
' Parameters:
' - hTooltip = Handle of the tooltip control
' - hwndCtrl = Handle of the control
' - wszText  = Tooltip text
' ========================================================================================
SUB AfxSetTooltipText ( hTooltip AS HWND, hwndCtrl AS HWND, wszText AS CONST char ptr)
	IF hTooltip = NULL OR hwndCtrl = NULL THEN 
		EXIT SUB
	EndIf
	' // The length of the text must not exceed of 80 characters, including the terminating null.
	DIM wszTooltipText$  * 80
	wszTooltipText$ = wszText$
	' // 32-bit: The size of the TOOLINFO structure is 48 bytes in
	'    version 6 of comctl32.dll, and 44 bytes in lower versions.
	' // 64-bit: The size of the TOOLINFO structure is 72 bytes in
	'    version 6 of comctl32.dll, and 64 bytes in lower versions.
	Raw AS TOOLINFOW tti
	tti.cbSize = 72
	tti.hwnd = GetParent(hwndCtrl)
	tti.uId = (UINT_PTR) hwndCtrl
	' // Retrieve the tooltip information
	SendMessage(hTooltip, TTM_GETTOOLINFOW, 0,  &tti)
	IF SendMessage(hTooltip, TTM_GETTOOLINFOW, 0, &tti) THEN
		tti.lpszText = (LPWSTR)wszTooltipText
		SendMessage(hTooltip, TTM_SETTOOLINFOW, 0, &tti)
	END IF
	' // Note: Windows provides the TTM_UPDATETIPTEXT message, but needs Vista or superior.
END SUB
'------------------------------------------------------------------------------
$ENDUSE
'==============================================================================
$IFUSE USE_AfxDeleteTooltip
'------------------------------------------------------------------------------
' Removes a tool from a tooltip control.
' Parameters:
' - hTooltip = Handle of the tooltip control
' - hwndCtrl = Handle of the control
' ========================================================================================
SUB AfxDeleteTooltip ( hTooltip AS HWND,  hwndCtrl AS HWND)
	IF hTooltip = NULL OR hwndCtrl = NULL THEN 
		EXIT SUB
	EndIf
	' // 32-bit: The size of the TOOLINFO structure is 48 bytes in
	'    version 6 of comctl32.dll, and 44 bytes in lower versions.
	' // 64-bit: The size of the TOOLINFO structure is 72 bytes in
	'    version 6 of comctl32.dll, and 64 bytes in lower versions.
	Raw AS TOOLINFOW tti
	tti.cbSize = 72
	tti.hwnd = GetParent(hwndCtrl)
	tti.uId = (UINT_PTR) hwndCtrl
	' // Remove the tooltip
	SendMessage(hTooltip, TTM_DELTOOL, 0, &tti)
END SUB
'------------------------------------------------------------------------------
$ENDUSE


